#ifndef N_CARAI_H
#define N_CARAI_H
//------------------------------------------------------------------------------
/**
    @class nCarAI

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nCarAI
#include "kernel/ndefdllclass.h"

class nMap;
//------------------------------------------------------------------------------
class nCarAI : public nAI
{
    enum States {
        Drive, Backup
    };
public:
    /// constructor
    nCarAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nCarAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    nAutoRef<nMap> map;
    virtual void Sense();
    nArray<float> rangeSensors;
    var destination;
    var throttle;
    var steering;
    var pos;
    var rot;

    var desiredHeading;
    var wheelDirection;

    var rc_dWheelHeadingToTorque;
    var rc_dWheelHeadingToForce;
    var rc_rangeToHeading[8];

    var sensorRange;
    var averageSteps;
    
    var leveledSensors;

    var avoidanceBias;

    float time0;
};
//------------------------------------------------------------------------------
#endif

