#ifndef N_PLATFORMAI_H
#define N_PLATFORMAI_H
//------------------------------------------------------------------------------
/**
    @class nPlatformAI

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_FSM_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nPlatformAI
#include "physics/nphysics.h"
#include "kernel/ndefdllclass.h"
#include "mathlib/line.h"

//------------------------------------------------------------------------------
class nPlatformAI : public nAI
{
    enum MY_STATES{
        Startup,
        Circle,
        Move,
    };
public:
    /// constructor
    nPlatformAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nPlatformAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    var target;
    myvar destination;
    float circleRadius;
    float circleTheta;
    vector3 circlePos;
};
//------------------------------------------------------------------------------
#endif
