#ifndef N_ALTLIMITARRAY_H
#define N_ALTLIMITARRAY_H
//------------------------------------------------------------------------------
/**
    @class nAltLimitArray

    @brief keeps an entity above ground
    
    maintains an array of points which are not allowed to go beneath the ground level

    (C)	2005	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAltLimitArray
#include "kernel/ndefdllclass.h"
#include "map/nmap.h"

//------------------------------------------------------------------------------
class nAltLimitArray : public nAspect
{
public:
    /// constructor
    nAltLimitArray();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAltLimitArray();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void AddPoint( vector3 point ) { points.Append( point ); }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var pos;
    var vel;
    var minalt;
    var maxalt;
    nAutoRef<nMap> map;
    nArray<vector3> points;
};
//------------------------------------------------------------------------------
#endif

