#ifndef N_HARDPOINT_H
#define N_HARDPOINT_H
//------------------------------------------------------------------------------
/**
    @class nHardPoint

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_OFFSETASPECT_H
#include "physics/noffsetaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nHardPoint
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nHardPoint : public nOffsetAspect
{
public:
    /// constructor
    nHardPoint();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nHardPoint();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual bool Open(){ return this->open; } //can someone attach to me?
    virtual nEnt* GetAttached(){ 
        n_assert( attached.isvalid() ); 
        return attached.get(); 
    }
    virtual void Attach( const char* s ){
        this->Attach( (nEnt*) kernelServer->Lookup( s ) );
    }
    virtual void Attach( nEnt* e ){
        n_assert( open );
        n_assert( e );
        n_assert( attached.isvalid() == false );
        attached = e;
        this->open = false;
    }
    virtual void UnAttach(){
        this->open = true;
        attached.invalidate();
    }
    vector3 GetVel() { return vel.GetV(); }
    quaternion GetRVel() { return rvel.GetQ(); }
protected:
    var vel;
    var rvel;
    bool open;
    nRef<nEnt> attached;
};
//------------------------------------------------------------------------------
#endif

