#ifndef N_SIDE_H
#define N_SIDE_H
//------------------------------------------------------------------------------
/**
    @class nSide

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nSide
#include "kernel/ndefdllclass.h"

class nSide;
typedef nArray<nSide*> SideArray;


//------------------------------------------------------------------------------
class nTextDisplayer;
class nSide : public nAspect
{
public:
    /// constructor
    nSide();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nSide();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void AddUnit( nEnt* e );
    virtual void RemoveUnit( nEnt* e );
    virtual void SetRelationship( const char* side, const char* relationship);
    virtual const EntArray*  GetUnits()		                                        { return &units; }
    virtual const SideArray* GetNeutrals();
    virtual const EntArray*  GetNeutralUnits();
    virtual const SideArray* GetHostiles() 		{ return &hostiles; } 
    virtual const EntArray*  GetHostileUnits();
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void Display( nGfxServer* gfx );
    virtual void AddResource( const char* name );
protected:
    EntArray units;
    EntArray hostileUnits;
    EntArray neutralUnits;
    SideArray neutrals;
    SideArray hostiles;
    struct Resource {
        nString name;
        var amount;
        float amount0;
        var damount;
        nDynAutoRef<nTextDisplayer> tdName;
        nDynAutoRef<nTextDisplayer> td;
        nDynAutoRef<nTextDisplayer> tdDelta;
    };
    nArray<Resource> resources;

    var playerSide;
    float time;
    float dtimesum;
};
//------------------------------------------------------------------------------
#endif

