#ifndef IPOLVAR_H
#define IPOLVAR_H    
#include "enkiduo/var.h"
#include "mathlib/vector.h"
//------------------------------------------------------------------------------
const float ipolSpeed = .1f;
class ipolvar : public var
{
public:
    ipolvar():var(){
        ipoling = false;
    }
    void SetIpolV( const vector3& v ) {
        //printf("SetIpolV(%i,%s)->", this->ipoling, str(vGoal));
        ipoling = true;
        vGoal = v;
        //printf("(%i,%s)\n", this->ipoling, str(vGoal));
    }
    void ApplyIpol() {
        if(ipoling) {
            switch( nvar->GetType() ) {
                case VARTYPE_VECTOR3:
                    //printf("this->setv(%s + %s)\n", str(GetV() * (1.0f - ipolSpeed)), str(vGoal * ipolSpeed));
                    this->SetV((GetV()*(1.0f-ipolSpeed)) + (vGoal * ipolSpeed));
                    break;
                default:
                    //printf("cannot ipol var of type:%i\n", nvar->GetType() );
                    break;
            }
        } 
    }
protected:
    vector3 vGoal;
    bool ipoling;
};
//------------------------------------------------------------------------------
#endif /* IPOLVAR_H */
