#ifndef MYVAR_H
#define MYVAR_H
//------------------------------------------------------------------------------
/**
    @class myvar

    @brief extended var -> unique to each creator but still managed

    myvar extends var, differening in that each aspect containing a myvar is given a unique nVar under the stackedVar of the same name

    (C)	2004	Chris Miles
*/
#include "enkiduo/var.h"

//------------------------------------------------------------------------------
class myvar : public var
{
public:
    /// constructor
    myvar():
        var()
        { this->eraseParent = true; }
    virtual ~myvar(){
        if( eraseParent && nvar ) {
            nvar->Release();
        }
    }
    virtual void Connect( nEnt* e, const char* varName ){
        ifnonzero( e )
            nvar = e->CreateStackedVar(varName);
        n_assert( nvar != 0 );
    }
    virtual void Connect( var& v, const char* varName ) {
        this->eraseParent = false;
        var::Connect( v, varName );
    }
    ///connect to a myvar ( since they pass by ref we need the 2)
    virtual void Connect( myvar& v, const char* varName ){
        this->eraseParent = false;
        n_assert( parentVar == 0 );
        if( v.nvar == 0 )  n_error( "trying to connect to a var that has not been connected\n" );
        v.nvar->AddChildVar( this, varName );
        this->varName = varName;
        if( v.isvalid() ){
            nThing* t = v.GetRef();
            if( t )  {
	this->Connect( (nEnt*)t, varName );
            }
        }
    }
private:
    bool eraseParent;
};
//------------------------------------------------------------------------------
#endif
