#ifndef N_ASTAR_H
#define N_ASTAR_H
//------------------------------------------------------------------------------
/**
        @class nAStar

        @brief a brief description of the class

        a detailed description of the class

        (C)	2005	Chris Miles
    */
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAStar
#include "kernel/ndefdllclass.h"
#include "util/nheap.h"
#include "enkiduo/nprofserver.h"
#include "enkiduo/nastarnode.h"
#include "enkiduo/nastarpath.h"
//-----------------------------------------------------------------------------//
class nAStar : public nAspect {
public:
    /// constructor
    nAStar();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAStar();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void Display( nGfxServer* gfx );

    virtual AStarPath FindPath( AStarNode* start, AStarNode* goal );
    virtual void ResetNodes();
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void AppendNode( AStarNode* node ) { this->nodes.Append(node); }
    virtual int GetPathLength();
    virtual vector3 GetPathNode( int i );
protected:
    nArray<AStarNode*>                  nodes;
    nHeap<AStarNode*>                   open;
    nArray<AStarPath>                   computedPaths;
    var                                 estimatedCostCoef;
    nAutoRef<nProfServer>	prof;
};
//------------------------------------------------------------------------------
#endif
