#ifndef N_COMMANDSERVER_H
#define N_COMMANDSERVER_H
//------------------------------------------------------------------------------
/**
    @class nCommandServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nCommandServer
#include "kernel/ndefdllclass.h"

#include "util/nheap.h"
class nXMLServer;
//------------------------------------------------------------------------------
class nCommandServer : public nThing
{
public:
    /// constructor
    nCommandServer();
    virtual void Initialize();
    /// destructor
    virtual ~nCommandServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void AddCmd( nString command );
    virtual void Tick( float time, float dtime );
    virtual void ExecCmd( nString command );
    virtual void ResetTimeOffset();
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void StartHold();
    virtual void StopHold();
    virtual float GetCommandTime(){ return this->lastTime - timeOffset; }
protected:
    nHeap<nString> commands;
    nDynAutoRef<nXMLServer> xml;
    float timeOffset;
    float lastTime;
    bool held;
};
//------------------------------------------------------------------------------
#endif

