#ifndef N_FSM_H
#define N_FSM_H
//------------------------------------------------------------------------------
/**
    @class nFSM

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#include "node/nvisnode.h"

#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nFSM
#include "kernel/ndefdllclass.h"

#define BeginStateMachine   if( state < 0) { \
    if(0) {
#define EndStateMachine     return(true); }\
} else {\
    n_printf("failed to find state : %i %s\n", state, stateNames[state]);\
    return(false);\
} \
return(false);
#define State(a)            return(true);\
    }\
} else if(a == state) {\
    if(0) {
#define OnEvent(a)          return(true); \
    } else if( a == event ) {
#define OnEnter             OnEvent(EVENT_ENTER);
#define OnTick              OnEvent(EVENT_UPDATE);
#define OnExit              OnEvent(EVENT_EXIT);
#define OnAttach            OnEvent(EVENT_ATTACH);
//------------------------------------------------------------------------------
class nFSM;
struct StateHandle {
public:
    bool local;
    int localState;
    nFSM* externalState;
};
//-----------------------------------------------------------------------------//
class nFSM : public nAspect
{
public:
    enum StateMachineEvent { 
        EVENT_UPDATE,
        EVENT_ENTER,
        EVENT_EXIT,
        EVENT_ATTACH,
    };
    /// constructor
    nFSM();
    virtual void Initialize();
    /// destructor
    virtual ~nFSM();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void Tick( float time, float dtime );

    /// pointer to nKernelServer
    virtual bool SetState( uint localState );
    virtual bool SetState( nString stateName );
    virtual bool SetStateExternal( nString externalStateName );
    virtual bool SetStateLocal( nString stateName );
    virtual const char* GetState(){
        if( currState.local )           return stateNames[currState.localState];
        else                            return currState.externalState->GetName();
    }
    virtual int GetStateI()		{ return currState.localState;          }
    virtual bool GetTriggerSelf()                                               { return this->triggerSelf;             }
    virtual void SetTriggerSelf( bool b )                                       { this->triggerSelf = b;                }
    static nKernelServer* kernelServer;
protected:
    virtual void Process                                                        ( StateMachineEvent event, float time, float dtime );
    virtual void Event                                                          ( StateMachineEvent event, float time, float dtime );
    virtual bool States                                                         ( StateMachineEvent event, uint state, float time, float dtime );
    virtual void AddChildState                                                  ( const char* className, const char* childName );
    void createVisNode                                                          ( const char* path );
    virtual bool Attach(nSceneGraph2* sceneGraph);
    StateHandle currState;
    StateHandle nextState;
    bool changeState;
    bool triggerSelf;
    nArray<const char*> stateNames;
    friend class nFSMGroup;
    friend class nFSMQueue;
    friend class nFSMLink;
    nSceneGraph2* sceneGraph;
    nRef<nVisNode> visNode;

    bool complainAboutDoubleStateSets;
};
//------------------------------------------------------------------------------
#endif
