#ifndef N_FXSERVER_H
#define N_FXSERVER_H
//------------------------------------------------------------------------------
/**
  @class nFXServer

  @brief a brief description of the class

  a detailed description of the class

  (C)	2004	Chris Miles
 */
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nFXServer
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nFXServer : public nThing
{
    public:
        /// constructor
        nFXServer();
        virtual void Initialize();
        /// destructor
        virtual ~nFXServer();
        /// persistency
        virtual bool SaveCmds(nPersistServer* persistServer);

        virtual void Tick( float time, float dtime );
        /// pointer to nKernelServer
        static nKernelServer* kernelServer;
        virtual void Display( nGfxServer* gfx ) {
            gfx->Begin(N_PTYPE_LINE_LIST);
            for( int i = 0; i < lineGroups.Size(); i++ ){
	for( int j = 0; j < lineGroups[i]->lines.Size(); j ++ ){
	    gfx->Coord( lineGroups[i]->lines[j].start() );
	    gfx->Coord( lineGroups[i]->lines[j].end() );
	}
            }
            gfx->End();
        }
        virtual void AddLine( nString group, vector3 start, vector3 stop ){
            int i;
            bool found = false;
            for( i = 0; i < lineGroups.Size(); i ++ ){
	if ( lineGroups[i]->group == group ){
	    found = true;
	    break;
	}
            }
            LineGroup* lg;
            if( !found ){
	lg = new LineGroup();
	lineGroups.Append( lg );
            }
            else
	lg = lineGroups[i];
            lg->lines.Append( line3( start, stop ) );
        }
    protected:
        struct LineGroup {
            nString group;
            nArray<line3> lines;
        };
        nArray<LineGroup*> lineGroups;
};
//------------------------------------------------------------------------------
#endif

