#ifndef N_VARSERVER_H
#define N_VARSERVER_H
//------------------------------------------------------------------------------
/**
    @class nVarServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nVarServer
#include "kernel/ndefdllclass.h"
#include "enkiduo/var.h"

//------------------------------------------------------------------------------
class VarInfo {
  public:
    var* v;
    nString entPath;
    nString varName;
    int id;
    VarInfo():
        v(0),
        id(-1)
    {}
    ~VarInfo(){
        //delete v;
    }
    VarInfo( var* v ) {
        static int id = 0;
        this->v = v;
        char fullname[1024];
        v->GetVar()->GetParent()->GetParent()->GetFullName( fullname, 1024 );
        this->entPath = fullname;
        this->varName = v->GetVar()->GetName();
        this->id = id++;
    }
    nString toString() {
        nString answer;
        answer.PrintF("%s.%s", v->GetVar()->GetParent()->GetParent()->GetName(), v->GetVar()->GetName() );
        return answer;
    }
};
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
class nVarServer : public nThing
{
public:
    /// constructor
    nVarServer();
    virtual void Initialize();
    /// destructor
    virtual ~nVarServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    const char* VarToString( nVar* var );
    virtual void AddVar( nVar* var );
    virtual void AddVar( nEnt* parent, const char* varName );
    virtual void AddVar( const char* parentName, const char* varName );
    virtual void RemoveVar( const nVar* nvar );
    virtual void Tick( float time, float dtime );
    virtual int NumVars(){ return vars.Size(); }
    virtual VarInfo* GetVar( int i ) { return &vars[i]; }
    virtual nString Sum();
    virtual nArray<VarInfo>* GetVars(){ return &vars; }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual int ReleasePriority() { return -20; } //release after vars
protected:
    nArray<VarInfo> vars;
};
//------------------------------------------------------------------------------
#endif

