#ifndef BITTREE_H
#define BITTREE_H
#include "assert.h"
class BitTreeNode{
public:
    union{
        BitTreeNode* kids[2];
        struct {
            float value;
            int gen;
        };
    };
    BitTreeNode(){
        kids[0] = NULL;
        kids[1] = NULL;
    }
    BitTreeNode* createKid( int i ){
        assert( i == 0 || i == 1 );
        if( kids[i] ) 
            return kids[i];
        else{
            BitTreeNode* node = new BitTreeNode();
            if( node == NULL )
                printf("node creation failed\n");
            else
                kids[i] = node;
            return node;
        }
    }
    BitTreeNode* findKid( int i ){
        assert( i == 0 || i == 1 );
        if( kids[i] )
            return kids[i];
        else
            return NULL;
    }
    //cant erase its children cuz of the union
    ~BitTreeNode(){}
};

class BitTree
{
    int depth;
    BitTreeNode* root;
public:
    BitTree(){ root = new BitTreeNode(); }
    BitTree( int i ):
        depth( i ){ 
            printf("build a bitree of size %i\n", i );
            assert( depth >= 0);
            root = new BitTreeNode();
        }
    void ClearTree() {
        return;
		int i;
        nArray<BitTreeNode*> nodes;
        nodes.Append( root );
        for( i = 0; i < nodes; i ++ ) {
            for( int j = 0; j < 2; j ++ )
	if( nodes[i]->kids[j] )
	    nodes.Append( nodes[i]->kids[j] );
        }
        printf("Deleting bittree with %i nodes", nodes.Size() );
        for( i = 0; i < nodes; i ++ )
            delete nodes[i];
    }
    void SetDepth( int i ){ 
        assert( i > 0 );
        depth = i; 
        ClearTree();
        root = new BitTreeNode();
    }
    inline int GetDepth(){ return depth; }
    void Insert( int* bits, float val, int gen ){
        BitTreeNode* node = root;
        int i;
        for( i = 0; i < depth; i ++ ){
            assert( bits[i] == 0 || bits[i] == 1 );
            node = node->createKid( bits[i] );
        }
        node->value = val;
        node->gen = gen;
    }
    bool Find( int* bits, float& val, int& gen ){
        BitTreeNode* node = root;
        for( int i = 0; node && i < depth; i ++ ){
            assert( bits[i] == 0 || bits[i] == 1 );
            if( node != NULL )
                node = node->findKid( bits[i] );
            else
                return false;
        }
        if( node ){
            val = node->value;
            gen = node->gen;
            return true;
        }
        else
            return false;
    }
};

#endif
