#ifndef N_ALLOCATORGA_H
#define N_ALLOCATORGA_H
//------------------------------------------------------------------------------
/**
    @class nAllocatorGA

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_GA_H
#include "ga/nga.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAllocatorGA
#include "kernel/ndefdllclass.h"
#include "im/nallocator.h"

class nAllocatorAStar;
#include "enkiduo/nastar.h"
//------------------------------------------------------------------------------
class nAllocatorGA : public nGA {
public:
    /// constructor
    nAllocatorGA();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAllocatorGA();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Display( nGfxServer* gfx )                                     { 
        for( int i = 0; i < paths; i++ )  {
            paths[i].Display( gfx ); 
        }
    }
    virtual void Tick( float time, float dtime );
    virtual void Run(nAllocator* allocator);
    virtual bool RecordData()           { return false; }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual void CreateGenome( nGenome* g );
    virtual void StartEvaluation( nGenome* g );
    virtual bool EvaluationFinished();
    virtual float GetFitness();
    virtual void StopEvaluation( nGenome* g );
    virtual void InitializeSlave( nGA* slave );
    virtual void InitializeWorld();
    virtual void OnRunDone();
protected:
    virtual int defaultPort()            { return 25733; }
    nDynAutoRef<nAllocator>             allocator;
    //nAllocator*                         allocator;
    //nArray<nAllocator::GroupInfo>       groups;
    //nArray<nAllocator::ObjectiveInfo>   objectives;
    nAllocatorAStar*                    allocatorAStar;
    nArray<AStarPath>                   paths;
    nArray<float>                       cachedSearches;
};
//------------------------------------------------------------------------------
#endif
