#ifndef N_GACAR_H
#define N_GACAR_H
//------------------------------------------------------------------------------
/**
    @class nGACar

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_GAPROBLEM_H
#include "ga/ngaproblem.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGACar
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nGACar : public nGAProblem
{
public:
    /// constructor
    nGACar();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nGACar();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime ) { this->time = time; }
    virtual nGenome* BuildEncoding();   //constructs the encoding
    virtual void StartEvaluation( nGenome* genome );        //starts the evaluation of the specified individual
    virtual void StopEvaluation();


    virtual bool IsEvaluationDone();  		//checks to see if the evaluation is finished every tick
    virtual float ParseFitness();                          	//called when a game is over to parse out the fitness

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nAutoRef<nEnt> car;
    nArray<nString> vars;
    var start;
    var goal;
    float time;
    float startTime;
    bool initialCheck;
    bool disqualified;
};
//------------------------------------------------------------------------------
#endif

