#ifndef N_GARED_H
#define N_GARED_H
//------------------------------------------------------------------------------
/**
    @class nGARed

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_GAPROBLEM_H
#include "ga/ngaproblem.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nGARed
#include "kernel/ndefdllclass.h"
class nInfluenceMap;
class nEnt;
class nThreatAllocator;

//------------------------------------------------------------------------------
class nGARed : public nGAProblem
{
public:
    /// constructor
    nGARed();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nGARed();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);


    virtual void StartEvaluation( nGenome* genome );        //starts the evaluation of the specified individual
        virtual void LoadMission();
        virtual void LoadPlayerParameters( nGenome* g );
        virtual void TriggerPlayer();
        virtual void TriggerBlueGA();
    virtual void StopEvaluation();
    virtual nString GenomeToPlan( nGenome* genome );    	//converts a genome into an XML plan of attack
    virtual void GenerationDone();


    virtual nGenome* BuildEncoding();   //constructs the encoding

    virtual bool IsEvaluationDone();  		//checks to see if the evaluation is finished every tick
    virtual float ParseFitness();                          	//called when a game is over to parse out the fitness

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
//------------------------------------GAME REFERENCES FOR PARSING FITNESS-------
    nAutoRef<nRoot> platformEntRoot,    //the root of the platform tree
                    targetEntRoot,      //root of the target tree
                    threatEntRoot;      //root of the threat tree
    nAutoRef<nEnt> redAI;
    nAutoRef<nInfluenceMap>
        defensability,
        threatRedundance,
        closeness;
    nAutoRef<nThreatAllocator> ta;
};
//------------------------------------------------------------------------------
#endif
