#ifndef N_IMGA_H
#define N_IMGA_H
//------------------------------------------------------------------------------
/**
    @class nIMGA

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_GA_H
#include "ga/nga.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMGA
#include "kernel/ndefdllclass.h"

class nGene;
class nEventServer;
//------------------------------------------------------------------------------
class nIMGA : public nGA {
public:
    /// constructor
    nIMGA();
    virtual void Initialize();
    virtual void InitVars();
    virtual void InitializeWorld();
    /// destructor
    virtual ~nIMGA();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void EvolveIM(const char* imPath);
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual void CreateGenome( nGenome* g );
    virtual void StartEvaluation( nGenome* g );
    virtual bool EvaluationFinished();
    virtual float GetFitness();
    virtual void StopEvaluation( nGenome* g );
    myvar imEvolving;
    virtual void InitializeSlave( nGA* slave );
protected:
    virtual int defaultPort()            { return 25735; }
    void RecursivePullCoefs( nRoot* im, nGene* g );
    void RecursiveGeneParse( nGene* geneRoot, nRoot* imRoot );
    float RecursiveSumCoefficients (nRoot* im );
    float SumDamageValues( const EntArray* ents );

    var evaluationTime;
    var evaluationTimeRemaining;
    var timeEvaluationStarted;
};

//------------------------------------------------------------------------------
#endif

