#ifndef N_ALLOCATOR_H
#define N_ALLOCATOR_H
//------------------------------------------------------------------------------
/**
    @class nAllocator

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAllocator
#include "kernel/ndefdllclass.h"

class nIM;
class nSide;
class nAllocatorGA;
class nIMManager;
//------------------------------------------------------------------------------
class nAllocator : public nAspect {
public:
    struct GroupInfo {
        nString name;
        nString path;
        int numUnits;
        nArray<float> powers;
        nArray<float> values;
        nArray<float> speeds;
        nArray<vector3> positions;
        float powerSum;
        float powerAvg;
        float valueSum;
        float valueAvg;
        float speedSum;
        float speedAvg;
        GroupInfo(){
            name = 0;
            numUnits = 0;
            powerSum = 0;
            powerAvg = 0;
            valueSum = 0;
            valueAvg = 0;
            speedSum = 0;
            speedAvg = 0;
        }
        int assignment;
        vector3 centroid;
    };
    /**
     * okay so what does each objective represent
     * okay
     * it has a detsination point
     * some kind of reward? based on how promising it seems
     * some description of what kind of units it wants
     *
     **/
    struct ObjectiveInfo {
        nString name;
        vector3 point;
        float reward;                   ///what i really want is a resourcesAllocatedToReward function
        float powerCoef;
        float valueCoef;
        float speedCoef;
        int maxUnits;
        int unitsAssigned;
        ObjectiveInfo* rootObjectiveInfo;
        ObjectiveInfo(){
            rootObjectiveInfo = 0;
        }
    };
public:
    /// constructor
    nAllocator();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAllocator();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;

    virtual void Allocate( nIM* imDone );
    virtual void OnAllocationGAFinished();
    nArray<GroupInfo>                   FindMyGroups();
    nArray<ObjectiveInfo>               FindMyObjectives();

    nArray<GroupInfo>                   groups;
    nArray<ObjectiveInfo>               objectives;
protected:
    nSide* side;
    nDynAutoRef<nAllocatorGA>           allocatorGA;
    nDynAutoRef<nIMManager>             imManager;
};
//------------------------------------------------------------------------------
#endif

