#ifndef N_ALLOCATORASTAR_H
#define N_ALLOCATORASTAR_H
//------------------------------------------------------------------------------
/**
    @class nAllocatorAStar

    @brief a brief description of the class

    a detailed description of the class

    (C)	2006	Chris Miles
*/
#ifndef N_ASTAR_H
#include "enkiduo/nastar.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nAllocatorAStar
#include "kernel/ndefdllclass.h"
//-----------------------------------------------------------------------------//
class AllocatorAStarNode : public AStarNode {
public:
    AllocatorAStarNode( nAStar* server ) : AStarNode(server) {}
    virtual ~AllocatorAStarNode(){}
    virtual float CalculateCostTo( AStarNode* neighbor );                    ///Calculate actual cost / fitness for the next node (must be neighbor)
    virtual float CalculateLongCostTo( AStarNode * to); 
    virtual float EstimateCostTo( AStarNode* node );                         ///guess at how much it will cost (not neccessarily neighbor)
    virtual void Display( nGfxServer* gfx );                                    
    virtual nArray<AStarNode*> GetNeighbors();                                
    virtual void Set( vector3 pos );
    virtual AStarNode* clone() { 
        AllocatorAStarNode* newNode = new AllocatorAStarNode( this->server );
        *newNode = *this;
        return (AStarNode*) newNode;
    }
    virtual AStarNode* operator=( const AllocatorAStarNode& rhs ) {
        //n_printf("AllocatorAStarNode(%s)::operator=(%s)\n", str(this), str(&rhs));
        this->pos = rhs.pos;
        this->x = rhs.x;
        this->y = rhs.y;
        AStarNode::operator=( rhs );
        return this;
    }
    virtual const char* toString(){
        //printf("AllocatorAStarNode.toString\n");
        char* c = strGet();
        #ifdef __WIN32__
        _snprintf( c, STRMAX, "%s:%s", AStarNode::toString(), str(this->pos));
        #else
        snprintf( c, STRMAX, "%s:%s", AStarNode::toString(), str(this->pos));
        #endif 
        return c;
    }
    virtual bool operator == ( const AStarNode& rhs );                              //are these two nodes equal -> needed to check for goal state
protected:
    //vector3 pos;                      //FIXME moved to basic astarnode where it should not be
    int x, y;
};
//-----------------------------------------------------------------------------//
class nIM;
class nAllocatorAStar : public nAStar {
public:
    /// constructor
    nAllocatorAStar();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nAllocatorAStar();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual AStarPath FindPath( vector3 startPos, vector3 goalPos );
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    nIM* getRiskynessIM()               { return this->riskynessIM.get(); }
    AllocatorAStarNode*** cachedNodes;
protected:
    float time;
    nDynAutoRef<nIM> riskynessIM;
};
//------------------------------------------------------------------------------
#endif
