#ifndef N_IMRADIAL_H
#define N_IMRADIAL_H
//------------------------------------------------------------------------------
/**
    @class nIMRadial

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_IMENT_H
#include "im/niment.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nIMRadial
#include "kernel/ndefdllclass.h"
//------------------------------------------------------------------------------
enum TOS {
    RELATIVE = numWhoStrings+0,
    ABSOLUTE = numWhoStrings+1,
};
class nIMRadial : public nIMEnt {
public:
    /// constructor
    nIMRadial();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nIMRadial();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    void SetTo( const char* s ) { 
        if( strcmp( s, "RELATIVE") == 0)
            to = (WHO) RELATIVE;
        else if( strcmp( s , "ABSOLUTE" ) == 0) 
            to = (WHO) ABSOLUTE;
        else
            for ( int i = 0; i < numWhoStrings; i ++)
                if (strcmp(whoStrings[i], s) == 0 ) 
                    this->to = (WHO) i; 
        ref_eventServer->pullLater( "updateIMs", str(this));
    }
    void SetTo( int i )                 { this->to   = (WHO) i;                 ref_eventServer->pullLater( "updateIMs", str(this)); }
    const char* GetTo()                 { if ( this->to == (WHO) RELATIVE ) return "RELATIVE"; else if ( this->to == (WHO) ABSOLUTE ) return "ABSOLUTE"; else return whoStrings[this->to]; }
    void  setThetaOffset( float f )     { this->thetaOffset = f;                ref_eventServer->pullLater( "updateIMs", str(this)); }
    void  setThetaWidth ( float f )     { this->thetaWidth = f;                 ref_eventServer->pullLater( "updateIMs", str(this)); }
    float getThetaOffset()              { return this->thetaOffset;             }
    float getThetaWidth ()              { return this->thetaWidth;              }

    virtual void calculateValues(void** const v);
protected:
    WHO   to;
    float thetaOffset;
    float thetaWidth;
};
//------------------------------------------------------------------------------
#endif

