#ifndef N_BOATAI_H
#define N_BOATAI_H
//------------------------------------------------------------------------------
/**
    @class nBoatAI

    @brief Super class for boat behaviors - should include speed/heading, and any sensors that are eventually implemented

    right now just has the outgoing variables - desiredSpeed / heading
    Note: includes all the vars included in nAI, which include pos/rot/rvel/vel/ etc.

    (C)	2005	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nBoatAI
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nBoatAI : public nAI {
public:
    /// constructor
    nBoatAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nBoatAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var desiredSpeed;
    var desiredHeading;
};
//------------------------------------------------------------------------------
#endif

