#ifndef N_BOATASTAR_H
#define N_BOATASTAR_H
//------------------------------------------------------------------------------
/**
    @class nBoatAStar

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_ASTAR_H
#include "enkiduo/nastar.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nBoatAStar
#include "kernel/ndefdllclass.h"
//-----------------------------------------------------------------------------//
class BoatAStarNode : public AStarNode {
public:
    BoatAStarNode( nAStar* server ) : AStarNode(server) {}
    virtual ~BoatAStarNode(){}
    virtual float CalculateCostTo( AStarNode* neighbor );                    ///Calculate actual cost / fitness for the next node (must be neighbor)
    virtual float EstimateCostTo( AStarNode* node );                         ///guess at how much it will cost (not neccessarily neighbor)
    virtual void Display( nGfxServer* gfx );                                    
    virtual nArray<AStarNode*> GetNeighbors();                                
    virtual void Set( vector3 pos, vector3 vel, quaternion rot, quaternion rvel, float time )                    { this->pos = pos; this->vel = vel; this->rot = rot; this->rvel = rvel; this->time = time; }
    virtual bool operator == ( const AStarNode& rhs );                              //are these two nodes equal -> needed to check for goal state
protected:
    vector3 pos;
    vector3 vel;
    quaternion rot;
    quaternion rvel;
    float time;
    float distanceCost;
    float nearOtherBoatsCost;
    friend const char* str(const BoatAStarNode* n);
};
//-----------------------------------------------------------------------------//
inline const char* str( const BoatAStarNode* n ) {
    char* c = strGet();
#ifdef __WIN32__
    _snprintf( c, STRMAX, "%s.%s.%s.%s@%f", str(n->pos), str(n->vel), str(n->rot), str(n->rvel), n->time);
#else
    snprintf( c, STRMAX, "%s.%s.%s.%s@%f", str(n->pos), str(n->vel), str(n->rot), str(n->rvel), n->time);
#endif 
    return c;
}
//-----------------------------------------------------------------------------//
class nBoatAStar : public nAStar {
public:
    /// constructor
    nBoatAStar();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nBoatAStar();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void FindPath( const char* path, vector3 pos, vector3 vel );
    virtual void FindPath( nEnt* e, vector3 pos, vector3 vel );
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    EntArray entsAvoiding;
    nEnt* entDriving;
protected:
    float time;
};
//------------------------------------------------------------------------------
#endif

