#ifndef N_RADARSERVER_H
#define N_RADARSERVER_H
//------------------------------------------------------------------------------
/**
    @class nRadarServer

    @brief a brief description of the class

    a detailed description of the class

    (C)	2006	Chris Miles
*/
#ifndef N_THING_H
#include "enkiduo/nthing.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nRadarServer
#include "kernel/ndefdllclass.h"

class nBoatRadarSensor;
//------------------------------------------------------------------------------
class nRadarServer : public nThing {
public:
    /// constructor
    nRadarServer();
    virtual void Initialize();
    /// destructor
    virtual ~nRadarServer();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);
    virtual void AddRadar    ( nBoatRadarSensor* radar )                        { radars.Append( radar ); }
    virtual void RemoveRadar ( nBoatRadarSensor* radar )                        { 
        nBoatRadarSensor** radarIter = radars.Find(radar);
        if ( radarIter )
            radars.Erase( radarIter );
    }
    virtual int ReleasePriority()                                               { return -20; }
    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nArray<nBoatRadarSensor*> radars;
    int nextRadarToSweep;
};
//------------------------------------------------------------------------------
#endif
