#ifndef N_COLLISIONNODE_H
#define N_COLLISIONNODE_H
//------------------------------------------------------------------------------
/**
    @class nCollisionNode

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nCollisionNode
#include "kernel/ndefdllclass.h"
#include "collide/ncollideserver.h"
#include "enkiduo/ngameserver.h"
#include "physics/ncollisionresponse.h"

//------------------------------------------------------------------------------
class nCollisionNode : public nPhysicalAspect
{
public:
    /// constructor
    nCollisionNode();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nCollisionNode();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void SetCollisionResponse( nCollisionResponse* cr ) { this->collisionResponse = cr; }
    virtual nCollisionResponse* GetCollisionResponse(){ return collisionResponse.get(); }
    virtual bool BlockDeath( bool immed );
    virtual void AddException( nEnt* e ){ exceptions.Append( e ); }
    virtual void AddException( const char* s ) { this->AddException( (nEnt*) kernelServer->Lookup(s) ); }
protected:
    var pos;
    var rot;
    var vel;
    var mass;
    var collideClass;
    var collideShape;
    nCollideObject* collideObject;
    //nDynAutoRef<n3DNode> refVis;
    nAutoRef<nCollideServer> collideServer;
    nAutoRef<nGameServer> gameServer;
    vector3 lastPos;
    nRef<nCollisionResponse> collisionResponse;
    bool classInitialized, shapeInitialized;
    bool collidedLastTick;
    nArray<nEnt*> exceptions;
};
//------------------------------------------------------------------------------
#endif
