#ifndef N_OFFSETASPECT_H
#define N_OFFSETASPECT_H
//------------------------------------------------------------------------------
/**
    @class nOffsetAspect

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nOffsetAspect
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nOffsetAspect : public nPhysicalAspect
{
public:
    /// constructor
    nOffsetAspect();
    /// destructor
    virtual ~nOffsetAspect();
    /// persistency
    virtual void InitVars();
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void ApplyPointForce( vector3 force );
    virtual void Tick( float time, float dtime );

    virtual void SetOffset( vector3 o )	{ offset = o;  }
    virtual vector3 GetOffset()		{ return offset; }

    virtual void SetRotLocal( quaternion q ) 	{ this->rotLocal = q; }
    virtual quaternion GetRotLocal()	{ return rotLocal;    }

    virtual vector3 GetOffsetPos() 	{ return this->offsetPos; }
    virtual quaternion GetOffsetRot() 	{ return this->offsetRot; }

    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var pos;
    var rot;
    var vel;
    ///local offset of the ent
    vector3 offset;
    ///local orientation of the ent
    quaternion rotLocal;

    ///actual position of the ent
    vector3 offsetPos;
    ///the actual orientation - taking the linkage into account
    quaternion offsetRot; 
};
//------------------------------------------------------------------------------
#endif

