#ifndef N_PHYSICS_H
#define N_PHYSICS_H
//------------------------------------------------------------------------------
/**
    @class nPhysics

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nPhysics
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nPhysics : public nAspect
{
public:
    /// constructor
    nPhysics();
    virtual void Initialize();
    /// destructor
    virtual ~nPhysics();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;

    virtual void ApplyForce         ( const vector3& f );
    virtual void ApplyAlignedForce  ( const vector3& f );
    virtual void ApplyTorque        ( const vector3& f );
    virtual void ApplyAlignedTorque ( const vector3& f, bool count = true );
    virtual void nPhysics::DoMath( vector3& t, vector3& dt, const vector3& ddt, quaternion& q, quaternion& dq, vector3 ddq, vector3 addq, const float& m, const float& i, const float& f, const float& rf, float dtime );
protected:
    var pos;
    var rot;

    var vel;
    var force;

    var rvel;
    var torque;
    var alignedTorque;

    var mass;
    var inertia;
    var friction;
    var rfriction;
};
//------------------------------------------------------------------------------
#endif

