#ifndef N_WEAPONCOLLISION_H
#define N_WEAPONCOLLISION_H
//------------------------------------------------------------------------------
/**
    @class nWeaponCollision

    @brief a brief description of the class

    a detailed description of the class

    (C)	2004	Chris Miles
*/
#ifndef N_COLLISIONRESPONSE_H
#include "physics/ncollisionresponse.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nWeaponCollision
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nWeaponCollision : public nCollisionResponse
{
public:
    /// constructor
    nWeaponCollision();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nWeaponCollision();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void Collision( nEnt* other, vector3 contact, vector3 normal, vector3 otherNormal ){
        if( time - timeFired > safetyTime.GetF() )
            ent->Die();
        //else
            //n_printf("ignoring collision time < safety %f < %f\n", time - timeFired, safetyTime.GetF() );
        //n_printf("%s collision with %s at %f,%f,%f %% %f,%f,%f\n", ent->fn, other->fn, contact.x, contact.y, contact.z, normal.x, normal.y, normal.z );
    }
protected:
    var safetyTime;
    float timeFired, time;
};
//------------------------------------------------------------------------------
#endif

