#ifndef N_BUILDAI_H
#define N_BUILDAI_H
//------------------------------------------------------------------------------
/**
    @class nBuildAI

    @brief constructs something - waits for resources then pulls them and begins construction

    (C)	2005	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nBuildAI
#include "kernel/ndefdllclass.h"

class nGameServer;
class nHardPointAttach;
//------------------------------------------------------------------------------
class nBuildAI : public nAI
{

    enum States {
        Idle,
        WaitingForResources,
        WaitingForHardpoint,
        Building,
        Done,
    };
public:
    /// constructor
    nBuildAI();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nBuildAI();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    virtual bool HasResources();
    virtual void TakeResources();
    var side;
    struct Resource {
        var available;
        var cost;
    };
    nArray<Resource> resources;

    myvar building;
    myvar buildtime;
    var timeSpent;
    var progress;
    myvar entBuilding;

    nAutoRef<nGameServer> gameServer;
    nHardPointAttach* entAttachment;
};
//------------------------------------------------------------------------------
#endif

