#ifndef N_HOVERATTACKLEGION_H
#define N_HOVERATTACKLEGION_H
//------------------------------------------------------------------------------
/**
    @class nHoverAttackLegion

    @brief a brief description of the class
    created when an entity is ordered to attack a legion
    it is its job to look at entities in the legion and find individuals to attack

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nHoverAttackLegion
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nHoverAttackLegion : public nAI
{
    enum States {
        Approach,
        Engage,
    };
public:
    /// constructor
    nHoverAttackLegion();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nHoverAttackLegion();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    myvar targetLegion;
    var targetLegionPos;
};
//------------------------------------------------------------------------------
#endif

