#ifndef N_HOVERENGINE_H
#define N_HOVERENGINE_H
//------------------------------------------------------------------------------
/**
    @class nHoverEngine

    @brief abstracts the forces and torques of a hovertank into 2 actuators - veldesired and bearing desired
    based on the desired forces and velocities this class applies forces to the hover vehicle
    the amount of force applied is based on enginepowr and thruster power
    overdrive allows the engine to function at 120% effeciency

    (C)	2005	Chris Miles
*/
#ifndef N_PHYSICALASPECT_H
#include "physics/nphysicalaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nHoverEngine
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nHoverEngine : public nPhysicalAspect
{
public:
    /// constructor
    nHoverEngine();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nHoverEngine();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    var veldesired;
    var bearingdesired;
    var enginepower;
    var thrusterpower;
    var rot;
    var pos;
    var overdrive;
    var overdriveAmount;
};
//------------------------------------------------------------------------------
#endif

