#ifndef N_LEGIONBEHAVIOR_H
#define N_LEGIONBEHAVIOR_H
//------------------------------------------------------------------------------
/**
    @class nLegionBehavior

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_AI_H
#include "ai/nai.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nLegionBehavior
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nLegionBehaviorProxy;
class nLegionBehavior : public nAI
{
public:
    /// constructor
    nLegionBehavior();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nLegionBehavior();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );

    virtual void CreationMessage( nMessage* m );
    virtual void AddProxy	( nLegionBehaviorProxy* proxy );
    virtual void RemoveProxy	( nLegionBehaviorProxy* proxy );

    virtual bool BlockDeath( bool urgent );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nArray<nLegionBehaviorProxy*> proxies;

    var width;
    var depth;
    myvar legionN;
    myvar lnpos;
    myvar lnrot;
    myvar lnwidth;
    myvar lndepth;

    var legion0;
    var l0pos;
    var l0rot;
};
//------------------------------------------------------------------------------
#endif

