#ifndef N_LEGIONLEGIONATTACKLEGION_H
#define N_LEGIONLEGIONATTACKLEGION_H
//------------------------------------------------------------------------------
/**
    @class nLegionLegionAttackLegion

    @brief a proxy behavior for a sublegionf ollowing above order to attack an opposing legion

    keeps its l0 in possition with the fleet 

    (C)	2005	Chris Miles
*/
#ifndef N_LEGIONBEHAVIORPROXY_H
#include "rts/nlegionbehaviorproxy.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nLegionLegionAttackLegion
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nLegionLegionAttackLegion : public nLegionBehaviorProxy
{
    enum States { 
        Moving,
    };
public:
    /// constructor
    nLegionLegionAttackLegion();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nLegionLegionAttackLegion();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual bool BlockDeath( bool urgent );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );

    var parentLegion;
    var formationPos;
    var formationRot;

    var legion0;
    var l0pos;
    var l0rot;
    var legionLocked;
};
//------------------------------------------------------------------------------
#endif

