#ifndef N_LEGIONLEGIONMOVE_H
#define N_LEGIONLEGIONMOVE_H
//------------------------------------------------------------------------------
/**
    @class nLegionLegionMove

    @brief sub legion moving under a parent
    updates its l0 to follow the parent
    also locks itself into place if it is close enough

    (C)	2005	Chris Miles
*/
#ifndef N_LEGIONBEHAVIORPROXY_H
#include "rts/nlegionbehaviorproxy.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nLegionLegionMove
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nLegionLegionMove : public nLegionBehaviorProxy
{
    enum States { 
        Moving,
    };
public:
    /// constructor
    nLegionLegionMove();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nLegionLegionMove();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States( StateMachineEvent event, uint state, float time, float dtime );
    var legionLocked;
};
//------------------------------------------------------------------------------
#endif

