#ifndef N_RTSARMOR_H
#define N_RTSARMOR_H
//------------------------------------------------------------------------------
/**
    @class nRTSArmor

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_ASPECT_H
#include "enkiduo/naspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nRTSArmor
#include "kernel/ndefdllclass.h"
#include "physics/nphysics.h"

//------------------------------------------------------------------------------

////////////////////////////////////////////////////////////////////////////////
///deals with the reception of damage
////////////////////////////////////////////////////////////////////////////////

class nRTSArmor : public nAspect
{
public:
    /// constructor
    nRTSArmor();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nRTSArmor();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
    virtual void Message( nMessage* message );
protected:
    var pos;
    var hp;		///current hp
    var maxhp;		///maximum hp
    var hpRatio;	                                        ///what percentage of our hps are remaining
    var regenerationRate;	                                        ///ratio of hp to heal per second
    nArray<var> deflections;                                                    ///array of how we deflect things
    nString entname;
    nDynAutoRef<nPhysics> physics;
    var damageOn;
};
//------------------------------------------------------------------------------
#endif
