#ifndef NTNLCONNECTION_H
#define NTNLCONNECTION_H    
#include "tnl.h" 
#include "tnlGhostConnection.h" 
#include "tnlNetInterface.h" 
#include "tnlRPC.h" 
#include "tnlSymmetricCipher.h"
#include "tnlAsymmetricKey.h"
#include "tnlCertificate.h"
#include "tnlBitStream.h"
#include "enkiduo/nincludes.h"

class nGA;
class nGenome;
class GANetInterface;
//------------------------------------------------------------------------------
class GAConnection : public TNL::EventConnection, public TNL::NetInterfaceAddConnectionEventHandler
{
    typedef TNL::EventConnection Parent;
public:
    GAConnection();
    ~GAConnection();
    TNL_DECLARE_NETCONNECTION(GAConnection); 

    void SetGA( nGA* ga )                                                       { this->ga = ga; }
    //virtual void setKernelServer( nKernelServer* ks ) 	{ this->kernelServer = ks; }
    virtual void openServer( const char* ip );
    virtual void connectToServer( const char* ip );
    virtual void connectToLocalServer( const char* ip, GAConnection* serverConnection );
    //virtual void connect( const TNL::Address& address );

    virtual void packetDropped		( PacketNotify* notify );
    virtual void packetReceived		( PacketNotify* notify );
    virtual void writePacket		( TNL::BitStream* stream, PacketNotify* notify);
    virtual void readPacket		( TNL::BitStream* stream );
    virtual void processEvent		( TNL::NetEvent* event );
    virtual void writeConnectRequest	                                        ( TNL::BitStream* stream );
    virtual bool readConnectRequest	                                        ( TNL::BitStream* stream, const char** errorString );
    virtual void writeConnectAccept	                                        ( TNL::BitStream* stream );
    virtual bool readConnectAccept	                                        ( TNL::BitStream* stream, const char** errorString);

    virtual void onConnectionEstablished();
    virtual void Tick( float time, float dtime );
    virtual void onAddConnection( NetConnection* connection );
    GANetInterface* getInterface()                                              { return this->myNetInterface; }
    nGA* GetGA()                                                                { return this->ga; }

    /**NETWORKING RPCS*********************************************************************/
    TNL_DECLARE_RPC(rpcInitializeWorldMessage, (TNL::StringTableEntry s)); 
    TNL_DECLARE_RPC(rpcStartEvaluation,        (TNL::Vector<bool> s)); 
    TNL_DECLARE_RPC(rpcSetState,               (TNL::U8 i)); 
    TNL_DECLARE_RPC(rpcSetFitness,             (TNL::F32 f)); 
    TNL_DECLARE_RPC(rpcClearPopulation,        (TNL::U8 i)); 

    //static nKernelServer* kernelServer;
    int getId() { return this->id; }
    int state;
    nGenome* genomeEvaluating;
protected:
    void PingForSlaves( float time );
    GANetInterface* myNetInterface; 
    int id;
    nGA* ga;
};
#endif /* NTNLCONNECTION_H */
