#ifndef NTNLPLAYER_H
#define NTNLPLAYER_H    
#include "tnl.h" 
#include "tnlGhostConnection.h" 
#include "tnlNetInterface.h" 
#include "tnlRPC.h" 
#include "tnlSymmetricCipher.h"
#include "tnlAsymmetricKey.h"
#include "tnlCertificate.h"
#include "tnlBitStream.h"

class nTNL;
class nKernelServer;
//------------------------------------------------------------------------------
///Abstract Representation of each player - mainly for scope queries
///for now just declare everything as in scope
//------------------------------------------------------------------------------
class nTNLPlayer : public TNL::NetObject {
    typedef TNL::NetObject Parent;
public:
    TNL_DECLARE_CLASS(nTNLPlayer);
    enum MaskBits {
        InitialMask 	= (1 << 0), ///< Building's only mask bit is the initial mask, as no other states are ever set.
        MapMask		= (1 << 1),
    };
    /// performScopeQuery is called to determine which objects are "in scope" for the client
    /// that controls this Player instance.  In the TNLTest program, all objects in a circle
    /// of radius 0.25 around the scope object are considered to be in scope.
    nTNLPlayer();
    void performScopeQuery	(TNL::GhostConnection *connection);
    TNL::U32 packUpdate	(TNL::GhostConnection *connection, TNL::U32 updateMask, TNL::BitStream *stream);
    void unpackUpdate	(TNL::GhostConnection *connection, TNL::BitStream *stream);
    void onGhostAvailable	(TNL::GhostConnection *theConnection);
    bool onGhostAdd	(TNL::GhostConnection *theConnection);

    static nKernelServer* kernelServer;
protected:
    nTNL* tnl;
    const char* map;
};

#endif /* NTNLPLAYER_H */
