#ifndef N_TURRET_H
#define N_TURRET_H
//------------------------------------------------------------------------------
/**
    @class nTurret

    @brief represents a weapon firing aspect, is responsible for creating weapon ents and passing damage down the line
    subclassed to provide particular kinds of information

    (C)	2005	Chris Miles
*/
#ifndef N_OFFSETASPECT_H
#include "physics/noffsetaspect.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nTurret
#include "kernel/ndefdllclass.h"

//------------------------------------------------------------------------------
class nSoundEmitter;
class nTurret : public nOffsetAspect {
public:
    /// constructor
    nTurret();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nTurret();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void Fire();
    virtual bool CanFire();
    virtual vector3 GetTargetPoint( nEnt* target );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual void AutoTarget();
    var mother;                         ///who I am attached too
    var side;
    var fires;
    var firing;                         ///should we be actively firing
    myvar cooldown;
    float lastFired;
    float time;
    var target;                         ///who my mother is targetting
    var targetPos;

    var autotarget;
    var firingEnabled;
    var autoTargetFreq;
    float lastAutoTarget;
    nAutoRef<nGameServer> game;
    nDynAutoRef<nSoundEmitter> emitter;
};
//------------------------------------------------------------------------------
#endif
