#ifndef N_BLUEPLANNER_H
#define N_BLUEPLANNER_H
//------------------------------------------------------------------------------
/**
    @class nBluePlanner

    @brief responsible for creating routes for platforms

    
    a left click event -> update who we have selected
    a right click event then has two cases
        a) no object over -> its a move command
            push a new wp unto our list
        b object over
            push an attack command

    (C)	2004	Chris Miles
*/
#ifndef N_PLANNER_H
#include "ui/nplanner.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nBluePlanner
#include "kernel/ndefdllclass.h"

class nGameServer;
//------------------------------------------------------------------------------
class nBluePlanner : public nPlanner
{
public:
    /// constructor
    nBluePlanner();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nBluePlanner();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    virtual void SelectionEvent( EntArray* objectsSelected );
    virtual bool MouseEvent( int button, EntArray* objectsSelected,  EntArray* objectsOver, vector3 mousePos );
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    nRef<nEnt> platformSelected;
    nRef<nEnt> wpSelected;
    static nGameServer* gameServer;
};
//------------------------------------------------------------------------------
#endif

