#ifndef N_BUTTON_H
#define N_BUTTON_H
//------------------------------------------------------------------------------
/**
    @class nRMenuItem

    @brief a brief description of the class

    a detailed description of the class

    (C)	2005	Chris Miles
*/
#ifndef N_FSM_H
#include "enkiduo/nfsm.h"
#endif
#ifndef E_INCLUDES_H
#include "enkiduo/nincludes.h"
#endif

#undef N_DEFINES
#define N_DEFINES nRMenuItem
#include "kernel/ndefdllclass.h"

class nTextDisplayer;
class nGameServer;
class nEventServer;
//------------------------------------------------------------------------------
class nRMenuItem : public nFSM {
    enum States {
        Waiting,
        Expandable,
        Back,
        MouseOver,
        Expanded,
        Passive,
    };
public:
    /// constructor
    nRMenuItem();
    virtual void Initialize();
    virtual void InitVars();
    /// destructor
    virtual ~nRMenuItem();
    /// persistency
    virtual bool SaveCmds(nPersistServer* persistServer);

    virtual void Tick( float time, float dtime );
    void SetString( const char* s )                                             { this->text = s; }
    void SetTheta( float f )                                                    { this->theta = f; }
    void SetWidth( float f )                                                    { this->width = f; }
    void SetEvent( const char* s )                                              { this->eventName = s; eventPtr = 0; }
    void SetBack( bool b )                                                      { this->back = b; }
    void SetButton( int i )                                                     { this->button = i; }
    /// pointer to nKernelServer
    static nKernelServer* kernelServer;
protected:
    virtual bool States ( StateMachineEvent event, uint state, float time, float dtime );
    nEnt* findRMenuRoot();
    //void Draw( nAutoRef<n3DNode>& slice, nAutoRef<n3DNode&> fan, nAutoRef<n3DNode&> backgroundFan ) ;
    void Draw();
    bool CheckMouseLoc();
    vector2 textPosition;
    nString text;
    struct DrawInfo { 
        nAutoRef<n3DNode> ref_slice;
        nAutoRef<n3DNode> ref_fan;
        nAutoRef<n3DNode> ref_backgroundfan;
        bool drawText;
    };
    nArray<DrawInfo> drawInfo;

    /*
    nAutoRef<n3DNode> ref_slice;
    nAutoRef<n3DNode> ref_activeslice;
    nAutoRef<n3DNode> ref_expandedslice;
    nAutoRef<n3DNode> ref_passiveslice;
    nAutoRef<n3DNode> ref_fan;
    nAutoRef<n3DNode> ref_backgroundfan;
    */
    nAutoRef<nTextDisplayer> ref_text;
    nAutoRef<nEventServer> ref_eventServer;
    vector2 menuCenter;
    float width;
    float theta;
    nAutoRef<nGameServer> ref_game;

    var ringRadius;
    var ringCenter;
    var windowSettings;
    var aspectRatio;
    var menuActive;
    float timeMouseOver;
    var expansionTime;
    void* eventPtr;
    nString eventName;

    var rmenuRoot;
    var mousePos;
    var objectsOver;
    var objectsSelected;

    bool back;
    int button;
};
//------------------------------------------------------------------------------
#endif

