#include <stdio.h>
#ifndef NHEAP_H
#define NHEAP_H

template < class T >
class nHeap
{
    struct Node{
        float value;
        T p;
        Node():
            value(-1.0f){}
    };
    public:
    nHeap( ){
        arr = 0;
        size = -1;
        counter = -1;
    }
    nHeap( int i ) {
        arr = 0;
        size = -1;
        counter = -1;
        this->initialize( i );
    }
    ~nHeap(){
        if( arr )
            delete[] arr;
    }
    void initialize( int s ){
        if( s == 0 )
            s = 1;
        if( arr )
            delete[] arr;
        arr = new Node[s];
        n_assert( arr );
        size = s;
        counter = 0;
    }
    void clear(){
        counter = 0;
    }
    void add( float value, T p ){
        //n_assert( counter < size );
        if (counter >= size ){
            Node* tmp = arr;
            int s = size * 2;
            if( s == 0 )
	s = 1;
            arr = new Node[s];
            for( int i = 0; i < size; i ++ )
	arr[i] = tmp[i];
            delete[] tmp;
            this->size = s;
            //printf("Resized array to %i\n", size );
        }
        arr[counter].value = value;
        arr[counter].p     = p;
        heapUp( counter );
        counter++;
    }
    void pop( float& value, T& p ){
        n_assert( counter >= 0 );
        value = arr[0].value;
        p = arr[0].p;
        arr[0] = arr[--counter];
        heapDown(0);
    }
    T pop(){
        T t = arr[0].p;
        arr[0] = arr[--counter];
        heapDown(0);
        return t;
    }
    T& top(){
        return arr[0].p;
    }
    float topValue() {
        return arr[0].value;
    }
    void top( float& value, T& t ){
        value = arr[0].value;
        t = arr[0].p;
    }
    inline int parent( int n ){
        return ( ( n - 1 )/ 2 );
    }
    inline int lchild( int n ){
        return ( n * 2 + 1 );
    }
    inline int rchild( int n ){
        return ( n * 2 + 2 );
    }
    inline void swap( Node& lhs, Node& rhs ){
        Node tmp = lhs;
        lhs = rhs;
        rhs = tmp;
    }
    int length(){ return counter; } 
    void fullHeapify(){
        for( int i = counter -1; i --; i >= 0 )
            heapDown( i );
    }
    void heapUp( int i ){
        if( i == 0 ) 
            return;
        int n = parent( i );
        if( arr[i].value < arr[n].value ){
            swap( arr[i], arr[n] );
            heapUp( n );
        }
    }
    void changeValue( float newValue, const T& t ) {
        for( int i = 0; i < counter; i ++ ) {
            if( arr[i].p == t ) {
                arr[i].value = newValue;
                heapUp( i );
            }
        }
    }
    void heapDown( int i ){
        if( i > parent( counter )) 
            return;
        int l = lchild( i );
        int r = rchild( i );
        if( r >= counter ){
            if( arr[i].value > arr[l].value ){
                swap( arr[i], arr[l] );
            }
        }
        else {
            if( arr[l].value < arr[r].value ){
                if( arr[i].value > arr[l].value ){
                    swap( arr[i], arr[l] );
                    heapDown( l );
                }
            }
            else {
                if( arr[i].value > arr[r].value ){
                    swap ( arr[i], arr[r] );
                    heapDown( r );
                }
            }
        }
    }
    int size;
    int counter;
    Node* arr;
};
#endif
