import wx
import math
from cat.Interface import sensors
from common.defs import *
from common.log import Log
from useful import *
log = Log(tags=['all','sensors'])
#from cat.entity import behaviorset
#from cat.entity import EntityManager
import nEventServer
from common import EventNames

from common import OptionManager
if OptionManager.getOption('map') == 'sandiego':
    MAX_RANGE_SLIDER      = 5000
else:
    MAX_RANGE_SLIDER      = 20000
         
#from primitivebehavior import *

behaviorType = "AVOID LAND"
DEFAULTSIZE = (200,400)
import catBehavior

class CatAvoidLand(catBehavior.CatBehavior):
    def __init__(self,cPanelA, entity=None,bname=None,sensors=None,actuators = None,recorder = None, size=DEFAULTSIZE,show=False):
        catBehavior.CatBehavior.__init__(self,cPanelA,entity=entity,bname=bname, size=size, show=show)
        self.AddFloat("range",1000.0,0.0,10000.0)
        self.AddFloat("speed",0.0,0.0,28.0)
        self.type = behaviorType
        self.sens = sensors
        self.sensors = sensors

    def makeBehaviorPanel(self,panel,size=None,entity=None, bname=None, behavior=None, show=False):
        # SD from cat.Interface import catAvoidLandPanel, catTargetPanel
        from cat.Interface import catStartPanel, catTargetPanel
	from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
        # SD alPanel = catAvoidLandPanel.CatAvoidLandPanel(panel,-1,color=None,size=bsize,behaviorType=bname, entity=entity, behavior=behavior)
        alPanel = catStartPanel.CatStartPanel(panel,-1,color=None,size=bsize,behaviorType=bname, entity=entity, behavior=behavior)
	tsize = panelInfo.TARGETPANEL
        targetPanel = wx.Panel(panel,-1,size=tsize)
        if(show):
            panel.addPanel(alPanel,targetPanel, bname)
        return [alPanel, targetPanel]

    def loop(self,time,dtime):
        if exists(self.entityPath):
            weight = .5
            totalx = totaly = 0
            pushsel(self.entityPath)
            speed = gf('speed')
            heading = gf('heading')
            ox,oz,oy = gv('pos')
            inEffect = False
            longestDist = 0
            longestBear = 0
            longestBearDiff = 0
            newSpeed =0#speed
            newHeading = heading
            fspeed,fheading = self.entity.actuators.getCurrentVec()
            fourMinuteRange = fspeed * 60.0 * 4.0
            timeToCompletion = self.entity.getTTC()
            distToCompletion = fspeed * timeToCompletion
            #print 'timetocompletion',timeToCompletion,'distToCompletion:',distToCompletion,'fourMinuterange:',fourMinuteRange
            shortestBear,shortestDist,shortestBearDiff,inEffect = self.landFollow(distToCompletion,heading,ox,oy)

            if inEffect:
                #print 'avoiding some land'
                newSpeed = shortestDist / (60.0 * 4.0)
                #newHeading = fheading
                #print 'bearing to nearest land: ' , shortestBearDiff ,' degrees'
                #print 'distance to nearest land: ',shortestDist,' m'
                if shortestBearDiff < 0:
                    newHeading = shortestBear + math.pi/2
                else:
                    newHeading = shortestBear - math.pi/2
                    
            else:
                #print 'no land to avoid'
                weight = 0
                newHeading = fheading
                newSpeed = fspeed
                #endifelse
            #endifelse
            popsel()
            return (weight,newHeading,newSpeed*1.7774514)
        else:
            return (0, 0, 0)
    def checkPostconditions(self):
        return False

    def landFollow(self,scanRadius,heading, ox,oy):
        inEffect = False
        shortestDist = 10000
        shortestBear = 0
        shortestBearDiff = 0
        for i in range(181):
            tx = ox + scanRadius*math.sin(heading - math.pi/2 + float(i)*(math.pi/180.0))
            ty = oy + scanRadius*math.cos(heading - math.pi/2 + float(i)*(math.pi/180.0))
            #pass point (tx,ty) to lineIntersect function
            dist = call('/map.getintersect',ox,0,oy,tx,-10,ty)
            
            if(dist[0] != 0 or dist[2] != 0 or dist[1] != 0):
                #print dist
                inEffect = True
                xcoord = dist[0]-ox
                ycoord = dist[2]-oy
                
                mag = math.sqrt(xcoord**2 + ycoord**2)
                
                #print 'dist =',mag
                theta = (heading + (float(i)-90) * math.pi/180.0)
                
                if mag < shortestDist:
                    shortestDist = mag
                    shortestBear = theta
                    shortestBearDiff = i - 90
                    
                    
        return shortestBear,shortestDist,shortestBearDiff,inEffect
                    
def getBehaviorType():
    return behaviorType
