#
# @(#) catBehavior.py 2005/09/29
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
import wx
from xml.sax import saxutils

from common.log import Log
log = Log(tags=['behavior'])
from common.defs import *
from common import behaviorNames
import catPrimitiveBehavior

# TIME_STEP              = 1     # How long between speed/heading updates
# SIGNIFICANT_FRACTION   = 0.25  # What fraction of param range constitutes significant difference
# PARAM_TIME_CHANGE_MIN  = 5
# TIMESEPCHAR            = ":"

class CatBehavior (catPrimitiveBehavior.CatPrimitiveBehavior):
    """Ancestor of all behaviors with panels"""
    def __init__(self, cPanelA, entity=None, bname=None, size = None, show=False):
        catPrimitiveBehavior.CatPrimitiveBehavior.__init__(self, entity, bname)
        self.authWrapper    = cPanelA
        ##Z self.execWrapper    = cPanelE        
        self.size           = size

        self.wrapperSize    = self.authWrapper.GetSize()
        #        print "CatBehavior: Init: sizes: input: %s, wrapper: %s " % (size, self.wrapperSize)
        self.startStop = 'start'
        
        self.authBehaviorPanel, self.tPanelA = self.makeBehaviorPanel(self.authWrapper, entity=self.entity, bname = bname, behavior = self,  size = self.wrapperSize, show=show)
        ##Z self.execBehaviorPanel, self.tPanelE = self.makeBehaviorPanel(self.execWrapper, entity=self.entity, bname = bname, behavior = self, size = self.wrapperSize, show=show)        

    def getPanels(self): 
	##Z
        return self.authBehaviorPanel
    
        
    def makeBehaviorPanel(self, panel, entity=None, bname = None, behavior=None, size = None, show=False):
        """Makes this behavior's default GUI panel"""
        x, y = size
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
        
        bgcolor = panel.GetBackgroundColour()
	emptyPanel = wx.Panel(panel, -1, size=bsize)
        emptyPanel.SetBackgroundColour(bgcolor)

        tsize = panelInfo.TARGETPANEL
	targetPanel = wx.Panel(panel, -1, size=tsize) 

        if(show):
            panel.addPanel(emptyPanel, targetPanel, bname)
#        print "Empty panel for behavior %s in entity %s " % (bname, entity.getEVAPath())
        return [emptyPanel, targetPanel]

    def handleStateSwitch(self):
        if(self.startStop.startswith("start")):
            self.start()
        else:
            self.stop()

    def handlePageChange(self, msg):
        #        print "catBehavior: Handling Page Change for " + self.getName()
        ##Z
	aPanel = self.getPanels()
        aPanel.handlePageChange(msg)
        ##Z ePanel.handlePageChange(msg)        
        

    def updatePanels(self):
        if(self.getName().startswith(behaviorNames.EMPTY)):
            return
	##Z
        aPanel = self.getPanels()
        try:
            #aPanel.updatePanels()
            ##Z ePanel.updatePanels()            
            # simply tell wrapper to redraw in new color
            print "I am not updating panels, shouldn't have to now."
        except:
            printExcept("Something Wrong")
            print "Cannot update start/stop buttons for: ", self.getName()

    def Show(self):
#        print "-------CAT Behavior: Showing:" + self.bname
        self.authWrapper.showPanel(self.bname)
        ##Z self.execWrapper.showPanel(self.bname)        
        
    def Hide(self):
#        print "-------CAT Behavior: Hiding:" + self.bname
        self.authWrapper.hidePanel(self.bname)
        ##Z self.execWrapper.hidePanel(self.bname)

