#
# @(#) catMoveTo.py 2005/11/04
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
import wx
from cat import panelInfo
DEFAULTSIZE = panelInfo.CONTROLWRAPPERPANEL
import catPrimitiveApproach
from common.defs import *

REDUCE_RANGE = 60
RANGE_FACTOR = 5
class CatMoveTo(catPrimitiveApproach.CatPrimitiveApproach):
    def __init__(self, cPanelA, entity=None, bname = None, sensors = None, actuators = None, recorder = None, size=DEFAULTSIZE,  show=False):
        catPrimitiveApproach.CatPrimitiveApproach.__init__(self, cPanelA, entity = entity, bname = bname, sensors = sensors, actuators = actuators, recorder = recorder, size = size,  show=show)
        # global REDUCE_RANGE
        pushsel(entity.getEVAPath())
        x, z, y = gv('dimension')
        REDUCE_RANGE = y * RANGE_FACTOR
        popsel()

    def makeBehaviorPanel(self, wPanel, size = None, entity=None, bname= None, behavior = None,  show=False):
        from cat.Interface import catMovesToPanel, catTargetPanel      
	from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
 	movePanel = catMovesToPanel.CatMovesToPanel(wPanel, -1, color=None, size=bsize, behaviorType=bname, entity=entity, behavior = behavior)
	tsize = panelInfo.TARGETPANEL
	targetPanel = wx.Panel(wPanel, -1, size=tsize) 
        if(show):
            wPanel.addPanel(movePanel, targetPanel, bname)
        return [movePanel, targetPanel]


    def setMoveLocation(self, pos):
        # ap = self.getPanel()
        # ap.desiredX.SetValue(str(pos[0]))
        # ap.desiredY.SetValue(str(pos[2]))

        self.moveLocation = pos

    ## def getPanel(self):
    ## return self.aa
	
    def GetTargetHeading (self):
        return 0

    def GetTargetSpeed(self):
        return 0

    def GetTargetPosition(self):
        if self.getMoveLocation() == None:
            ox = self.GetVar('desiredX')
            oy = self.GetVar('desiredY')
            oz = 0
            if(ox == 0 or oy == 0):                
                return (0, 0, 0)
        else:
            ox, oz, oy = self.getMoveLocation()
        return (ox, oz, oy)

    def GetDesiredRange(self):
        return 0

    def CheckReduceSpeedNeeded(self, rangeDiff, bearingDiff):
        pushsel (self.entity.getEVAPath())
        x, z, y = gv('dimension')
        speed = gf ('speed')
        rangeFactor = (speed*10/self.maxSpeed) + 10;
        REDUCE_RANGE = y * rangeFactor
        popsel()
        
	if rangeDiff < REDUCE_RANGE:
            #print "MoveTo: Reducing speed"
            reduceSpeed = True
        else:
            reduceSpeed = False
        return reduceSpeed
