import wx
from primitivebehavior import *
from common.defs import *
from common.log import Log
log = Log(tags=['all','sensors'])
import math
from cat.Interface.relativepositionsensor import *
from cat.Interface import sensors
from cat.entity import behaviorset
from cat.entity import EntityManager
from cat.Behaviors import inverseCPA
import nEventServer
from common import EventNames
MINOR_RADIUS = 200
MAJOR_RADIUS = 300

from common import OptionManager
if OptionManager.getOption('map') == 'sandiego':
    MAX_RANGE_SLIDER      = 5000
else:
    MAX_RANGE_SLIDER      = 20000

behaviorType = type = "AVOID ENTITY"


class AvoidEntity(PrimitiveBehavior):
    def __init__(self, sens):
        Behavior.__init__(self, sens)
        #self.AddFloat("bearing",0.0, 0.0, 360.0)
        self.AddFloat("panicRange",100.0, 0.0, 10000.0)
        self.AddFloat("effectiveRange",10000.0, 0.0, 10000.0)
        self.AddFloat('Speed',5.0,0.0,28.0)
        self.relpos = RelativePositionSensor(self.sens.GetOwnEntity())
        #log.write(printEnts('/game/ents/',0))
        self.type = type
        self.sens = sens
        import nEventServer
        from common import EventNames
        nEventServer.register(EventNames.CAT_EXCLUSION_EVENT,self.handleExclusionEvent)



    def Tick(self,time,dtime):
        #print "\n\n\nin avoidentity tick"
        if exists(self.sens.GetOwnEntity()):
            pushsel()
            #entInfo = []
            totalx = totaly = 0
            panicRange = self.GetVar('panicRange')
            weight = .5
            panic = False
            effect = False
            eval = False
            speed = self.GetVar('Speed')
            #print self.GetVar('Speed'),self.GetVar('panicRange'),self.GetVar('effectiveRange')
            sel(self.sens.GetOwnEntity())
            y0m,oz,x0m = gv('pos')
            vm = gf('speed')
            thetam = gf('heading')
            maxSpeed = gf('maxSpeed')
            desiredSpeed = gf('desiredSpeed')
            #heading = gf('heading')
            #currentSpeed = gf('speed')
            #print 'myheading:',gf('heading')
            entlist = self.relpos.getRelPos()
            returntuple = (0,0,0)
            leasttime = 3600
            
            
            sel('/game/ents/')
            dir = ndir()
            for subdir in dir:
                sel('/game/ents/'+subdir)
                dir2 = ndir()
                for subdir2 in dir2:
                    xcoord = ycoord = 0
                    sel('/game/ents/'+subdir+'/'+subdir2)
                    if not getselectable() or getfullname() == self.sens.GetOwnEntity():
                        pass
                    else:
                        ab1 = 2*math.pi - entlist[getfullname()][1]
                        ab2 = ab1 - math.pi
                        heading = thetam
                        if ab2 <0:
                            ab2 += 2*math.pi
                        if thetam < 0:
                            heading = thetam + 2*math.pi
                        heading = 2*math.pi - heading
                            
                        rb1 = ab1 - heading
                        if rb1 < 0:
                            rb1 += 2*math.pi
                            
                        heading2 = gf('heading')
                        if heading2 < 0:
                            heading2 += 2*math.pi
                        heading2 = 2*math.pi - heading2
                        
                        rb2 = ab2 - heading2
                        if rb2 < 0:
                            rb2 += 2*math.pi
                        
                        y0t,tz,x0t = gv('pos')
                        vt = gf('speed')
                        thetat = gf('heading')
                        if hasvar('dimension'):
                            g1,g2,length = gv('dimension')
                            posLength = int((float(length)/2.0)+0.5)
                            negLength = length - posLength

                        ## alpha1 = vm * math.cos(thetam) * math.cos(thetat) - vt * math.pow(math.cos(thetat),2) + vm * math.sin(thetam) * math.sin(thetat) - vt * math.pow(math.sin(thetat),2)
##                         alpha2 = x0m * math.cos(thetat) - x0t * math.cos(thetat) + y0m * math.sin(thetat) - y0t * math.sin(thetat)

##                         beta1 = vm * math.sin(thetam) * math.cos(thetat) - vt * math.sin(thetat) * math.cos(thetat) - vm * math.cos(thetam) * math.sin(thetat) + vt * math.cos(thetat) * math.sin(thetat)
##                         beta2 = y0m * math.cos(thetat) - y0t * math.cos(thetat) - x0m * math.sin(thetat) + x0t * math.sin(thetat)

##                         A = math.pow(alpha1,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta1,2) * math.pow(MAJOR_RADIUS,2)
##                         B = 2 * (alpha1 * alpha2 * math.pow(MINOR_RADIUS,2) + beta1 * beta2 * math.pow(MAJOR_RADIUS,2))
##                        C = math.pow(alpha2,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta2,2) * math.pow(MAJOR_RADIUS,2) - math.pow(MAJOR_RADIUS,2) * math.pow(MINOR_RADIUS,2)
                        A,B,C = getCoeffs(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat)         
                        discriminant = B * B - 4 * A * C
                        #print "first discriminant:",discriminant


                        if discriminant > 0 and not (vt == vm and thetat == thetam):
                            #avoid the ship
                            t = getQuadratic(A,B,C)
                            print "times:",t #sol1,sol2
                            if t[0] >=0 and t[1] >= 0 and t[0] < leasttime and (rb2 > math.pi or vt == 0):
                                leasttime = t[0]
                                #print 'need to change course!'
                                Aprime = 4 * math.pow(alpha2 * math.pow(MINOR_RADIUS,2) * math.cos(thetam - thetat) + math.sin(thetam-thetat)*beta2*math.pow(MAJOR_RADIUS,2),2) - \
                                         4 * C * (math.pow(MINOR_RADIUS,2) * math.pow(math.cos(thetam-thetat),2) + math.pow(math.sin(thetam - thetat),2) * math.pow(MAJOR_RADIUS,2))
                                Bprime = -8 * (alpha2 * math.pow(MINOR_RADIUS,2) * math.cos(thetam - thetat) + \
                                               math.sin(thetam-thetat) *  beta2 * math.pow(MAJOR_RADIUS,2)) * vt * alpha2 * math.pow(MINOR_RADIUS,2) + \
                                               8 * C * math.pow(MINOR_RADIUS,2) * math.cos(thetam-thetat) * vt
                                Cprime = 4 * math.pow(vt * alpha2 * math.pow(MINOR_RADIUS,2),2) - 4 * C * math.pow(vt,2) * math.pow(MINOR_RADIUS,2)
                                

                                discriminant2 = Bprime * Bprime - 4 * Aprime * Cprime
                                #print "second discriminant:",discriminant2                                
                                if discriminant2 >= 0:
                                    v = getQuadratic(Aprime,Bprime,Cprime)
                                    #print "speeds:",v
                                    newspeed = 0
                                    numspeeds = 0
                                    
                                    for pspeed in v:
                                        if pspeed >= 0 and pspeed <= maxSpeed:
                                            newspeed = pspeed
                                            numspeeds = numspeeds + 1
                                            

                                    if numspeeds==2:
                                        dspeed = (newspeed - vm) * (newspeed-vm)
                                        if (v[0] - vm) * (v[0] - vm) < dspeed:
                                            returntuple = (.5,thetam,v[0])
                                        else:
                                            returntuple = (.5,thetam,v[1])
                                    elif numspeeds==1:
                                        returntuple = (.5,thetam,newspeed)
                                    elif numspeeds==0:
                                        if vt > 0:
                                            returntuple = (.5,thetam,vt)
                                        else:
                                            newheadings = [0,0]
                                            foundr = 0
                                            foundl = 0
                                            for i in range(0,91,5):
                                                if not foundr:
                                                    A,B,C = getCoeffs(x0m,y0m,vm,thetam - i * (math.pi/180.0),x0t,y0t,vt,thetat)
                                                    if (B * B - 4 * A * C) < 0:
                                                        newheadings[0] = (thetam - i* (math.pi/180.0))
                                                        foundr = 1
                                                if not foundl:
                                                    A,B,C = getCoeffs(x0m,y0m,vm,thetam + i * (math.pi/180.0),x0t,y0t,vt,thetat)
                                                    if (B * B - 4 * A * C) < 0:
                                                        newheadings[1] = (thetam + i * (math.pi/180.0))
                                                        foundl = 1
                                            if (thetam - newheadings[0] < newheadings[1] - thetam):
                                                returntuple = (.5,newheadings[0],desiredSpeed)
                                            else:
                                                returntuple = (.5,newheadings[1],desiredSpeed)
                                    else:
                                        print "Something smells rotten in the avoidentity behavior."                                        
                                else:
                                    #print "negative 2nd discriminant"
                                    newheadings = [0,0]
                                    foundr = 0
                                    foundl = 0
                                    for i in range(0,91,5):
                                        if not foundr:
                                            A,B,C = getCoeffs(x0m,y0m,vm,thetam - i * (math.pi/180.0),x0t,y0t,vt,thetat)
                                            if (B * B - 4 * A * C) < 0:
                                                newheadings[0] = (thetam - i* (math.pi/180.0))
                                                foundr = 1
                                        if not foundl:
                                            A,B,C = getCoeffs(x0m,y0m,vm,thetam + i * (math.pi/180.0),x0t,y0t,vt,thetat)
                                            if (B * B - 4 * A * C) < 0:
                                                newheadings[1] = (thetam + i * (math.pi/180.0))
                                                foundl = 1
                                    if (thetam - newheadings[0] < newheadings[1] - thetam):
                                        returntuple = (.5,newheadings[0],desiredSpeed)
                                    else:
                                        returntuple = (.5,newheadings[1],desiredSpeed)
                            elif t[0] <= 0 and t[1] <= 0:
                                #print 'ignoring ship: behind me'
                                pass
                            elif t[0] > leasttime:
                                #print 'ignoring ship: too far away'
                                pass
                            else:
                                print 'Panicking!  Within avoidance ellipse'
                                panic = True

                                #calculate point on ships centerline @ front of ship.
                                flx,g,fly = gv('flcoord')
                                frx,g,fry = gv('frcoord')
                                dfx = frx - flx
                                dfy = fry - fly
                                dfx = dfx/2.0
                                dfy = dfy/2.0
                                ax0 = flx + dfx
                                ay0 = fly + dfy

                                #calculate point on ship's centerline @ rear of ship.
                                rlx,g,rly = gv('rlcoord')
                                rrx,g,rry = gv('rrcoord')
                                drx = rrx - rlx
                                dry = rry - rly
                                drx = drx/2.0
                                dry = dry/2.0
                                bx0 = rlx + drx
                                by0 = rly + dry

                                #following algorithm from http://mathforum.org/library/drmath/view/54731.html
                                AB = (bx0 - ax0, by0 - ay0, 0)
                                AP = (y0m - ax0, x0m - ay0, 0)
                                #print 'AB',AB
                                #print 'AP',AP
                                
                                ABXAP = (0,0,AB[0] * AP[1] - AP[0] * AB[1])
                                #print 'ABXAP',ABXAP
                                
                                a = math.sqrt(math.pow(ABXAP[2],2))
                                #print 'a',a
                                
                                dist = a / math.sqrt(math.pow(AB[0],2) + math.pow(AB[1],2))
                                #print '|AB|',a/dist
                                
                                    
                                #rb2 is target's relative bearing to me (in clockwise radians)
                                #print 'perpendicular distance', dist
                                if rb2 < math.pi:#if I am on ship's starboard side
                                    bear = thetat - math.pi/2.0
                                else: #if I am on a ship's port side
                                    bear = thetat + math.pi/2.0
                                h = (MINOR_RADIUS - dist) /MINOR_RADIUS
                                xcoord = h * math.cos(bear)
                                ycoord = h * math.sin(bear)
                                
                                totalx += xcoord
                                totaly += ycoord

                                bear = thetat + math.pi
                                h = .5
                                xcoord = h * math.cos(bear)
                                ycoord = h * math.sin(bear)

                                totalx += xcoord
                                totaly += ycoord
                                
                        else:
                            if discriminant == 0:
                                #print 'intersecting at only one point'
                                pass
                            else:
                                #print 'ignoring ship: non=intersecting'
                                pass
        if panic:
            returntuple = (1,math.atan2(totaly,totalx),desiredSpeed)
        popsel()
        return returntuple

    
 

    def handleExclusionEvent(self,msg):
        entityDiBehavior=msg.split(' ',1)[0]
        if entityDiBehavior == self.sens.getOwnship():
            #print "we are of the same entity!"
            bstring = msg.split(' ',1)[1]
            tmplist = bstring[1:-1].split(', ')
            typelist = []
            for i in tmplist:
                typelist.append(i.strip('\''))
            if self.type in typelist:
                self.deActivate()
                #print "Deactivating " + self.type + " for " + self.sens.getOwnship()
        #else:
            #print "I'm not deactivating anything.  I'm not of the same entity!"


behaviorset.register(behaviorType, AvoidEntity)

def getQuadratic(A,B,C):
    
    discriminant = B * B - 4 * A * C
    sol1 = (-B + math.sqrt(discriminant))/ (2 * A)
    sol2 = (-B - math.sqrt(discriminant))/ (2 * A)
    if sol1 >= sol2:
        return [sol2,sol1]
    return [sol1,sol2]

def getCoeffs(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat):
    alpha1 = vm * math.cos(thetam) * math.cos(thetat) - vt * math.pow(math.cos(thetat),2) + vm * math.sin(thetam) * math.sin(thetat) - vt * math.pow(math.sin(thetat),2)
    alpha2 = x0m * math.cos(thetat) - x0t * math.cos(thetat) + y0m * math.sin(thetat) - y0t * math.sin(thetat)
    
    beta1 = vm * math.sin(thetam) * math.cos(thetat) - vt * math.sin(thetat) * math.cos(thetat) - vm * math.cos(thetam) * math.sin(thetat) + vt * math.cos(thetat) * math.sin(thetat)
    beta2 = y0m * math.cos(thetat) - y0t * math.cos(thetat) - x0m * math.sin(thetat) + x0t * math.sin(thetat)
    
    A = math.pow(alpha1,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta1,2) * math.pow(MAJOR_RADIUS,2)
    B = 2 * (alpha1 * alpha2 * math.pow(MINOR_RADIUS,2) + beta1 * beta2 * math.pow(MAJOR_RADIUS,2))
    C = math.pow(alpha2,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta2,2) * math.pow(MAJOR_RADIUS,2) - math.pow(MAJOR_RADIUS,2) * math.pow(MINOR_RADIUS,2)
    return (A,B,C)


def getBehaviorType():
    return behaviorType

class AvoidEntityPanel(wx.Panel):
    def __init__(self, parent, panelID, color, defaultsize,bType = 'AVOID ENTITY'):
        wx.Panel.__init__(self,parent,panelID,size=defaultsize,style=wx.RAISED_BORDER|wx.DOUBLE_BORDER)
        self.behaviorType = bType
        self.SetBackgroundColour(color)
        self.parentPanel = parent
        
        nEventServer.register(EventNames.CAT_SELECT_ENT,      self.handleEntSelection)
        #self.testSensor = RelativePositionSensor('/game/ents/cigarette/cigarette0')

        newSizer = wx.BoxSizer(wx.VERTICAL)
        self.statusMessage = wx.StaticText(self,-1,self.behaviorType)
        newSizer.Add(self.statusMessage,0,wx.ALIGN_LEFT)

        
        panicSizer = wx.BoxSizer(wx.HORIZONTAL)

        effectiveSizer = wx.BoxSizer(wx.HORIZONTAL)

        speedSizer = wx.BoxSizer(wx.HORIZONTAL)

        
        #self.sizer.Add(newSizer,1,border = 10,flag=wx.ALL|wx.EXPAND)
        self.panicSlider = wx.Slider(self,-1,100,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        self.effectiveSlider = wx.Slider(self,-1,150,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        self.speedSlider = wx.Slider(self,-1,0,0,0,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        wx.EVT_SLIDER(self.panicSlider,-1,self.OnPanicChange)
        wx.EVT_SLIDER(self.effectiveSlider,-1,self.OnEffectiveChange)
        wx.EVT_SLIDER(self.speedSlider,-1,self.OnSpeedChange)

        newSizer.Add(wx.StaticText(self,-1,"Panic Range"))
        panicSizer.Add(self.panicSlider, 1, border=5,flag=wx.RIGHT|wx.EXPAND)
        panicSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
        newSizer.Add(panicSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)        
        newSizer.Add(wx.StaticText(self,-1,"Effective Range"))
        effectiveSizer.Add(self.effectiveSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
        effectiveSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
        newSizer.Add(effectiveSizer, 0, border=10,flag=wx.BOTTOM|wx.EXPAND)
        newSizer.Add(wx.StaticText(self,-1,"Speed"))
        speedSizer.Add(self.speedSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
        speedSizer.Add(wx.StaticText(self, -1, "knots"), flag=wx.ALIGN_BOTTOM)        
        newSizer.Add(speedSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)
        
        
        self.startStopButton = wx.Button(self,-1,'Start', style=wx.BU_EXACTFIT)
        self.startStopButtonState = 'start'
        wx.EVT_BUTTON(self.startStopButton,-1,self.OnClick)
        emptySizer = wx.BoxSizer()
        newSizer.Add(emptySizer, 1, flag=wx.EXPAND)
        newSizer.Add(self.startStopButton, 0 , flag=wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
        self.SetSizer(newSizer)
        self.EXCLUSION_LIST = ()
        from cat.entity import EntityManager
        if(EntityManager.currentState):
            entity = EntityManager.currentState.entity
            pushsel()
            sel(entity)
            speedSlider.SetValue(gf('maxSpeed')/2.0)
            popsel()
        
        from common import tickmanager
        tickmanager.register('AvoidEntity',self.Tick)

    def OnPanicChange(self,event):
        behavior = self.getBehavior()
        if(behavior):
            behavior.SetVar('panicRange',self.panicSlider.GetValue())

    def OnEffectiveChange(self,event):
        behavior = self.getBehavior()
        if(behavior):
            behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())

    def OnSpeedChange(self,event):
        behavior = self.getBehavior()
        if(behavior):
            behavior.SetVar('Speed',self.speedSlider.GetValue())

                   
    def OnClick(self,event):
        if(self.startStopButtonState == 'start'):
            self.handleStart(event)
        else:
            self.handleStop(event)

    def handleStart(self,event):
        self.startStopButtonState = 'stop'
        self.startStopButton.SetLabel("Stop")
        behavior = self.getBehavior()
        if(behavior):
            import nEventServer
            from common import EventNames
            nEventServer.pull(EventNames.CAT_EXCLUSION_EVENT,self.getSensors().GetOwnEntity() + ' '+str(self.EXCLUSION_LIST))
            behavior.SetVar('panicRange',self.panicSlider.GetValue())
            behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())
            behavior.SetVar('Speed',self.speedSlider.GetValue())
            behavior.activate()
        else:
            print "no current behavior selected"

    def getBehavior(self):
        from cat.entity import EntityManager
        if(EntityManager.currentState):
            entity = EntityManager.currentState.entity
            entityState = EntityManager.currentState
            behaviorList = entityState.bset.getList(self.behaviorType)
            behavior = behaviorList[0]
            return behavior

    def handleStop(self,event):
        self.startStopButtonState = 'start'
        self.startStopButton.SetLabel("Start")
        behavior = self.getBehavior()
        if(behavior):
            behavior.deActivate()
        else:
            print "no behavior to deactivate"

    def getSensors(self):
        from cat.entity import EntityManager
        if(EntityManager.currentState):
            sensors = EntityManager.currentState.getSensors()
            return sensors
        else:
            return None
        
    def Tick(self,time,dtime):
        #print "in avoidentitypanel tick"
        if EntityManager.currentState:
            if exists(EntityManager.currentState.sensors.GetOwnEntity()):
                try:
                    pushsel()
                    sel(EntityManager.currentState.sensors.GetOwnEntity())
                    max = gf('maxSpeed')
                    self.speedSlider.SetRange(0,max)
                    popsel()
                except:
                    printExcept('cat:AvoidEntityPanel')
            #beh = EntityManager.currentState.bset.getList(type)[0]
            #print 'slider says speed is',self.speedSlider.GetValue()
            #beh.SetVar('Speed',self.speedSlider.GetValue()/100.0)
            #print 'just set speed var to',beh.GetVar('Speed')
            #beh.SetVar('panicRange',self.panicSlider.GetValue())
            #beh.SetVar('effectiveRange',self.effectiveSlider.GetValue())

    def handleEntSelection(self, msg):
        if EntityManager.currentState:
            if exists(EntityManager.currentState.sensors.GetOwnEntity()):
                try:
                    pushsel()
                    sel(EntityManager.currentState.sensors.GetOwnEntity())
                    max = gf('maxSpeed')
                    self.speedSlider.SetRange(0,max)
                    popsel()
                except:
                    printExcept('cat:AvoidEntityPanel')
            beh = EntityManager.currentState.bset.getList(type)[0]
            self.speedSlider.SetValue(beh.GetVar('Speed'))
            self.panicSlider.SetValue(beh.GetVar('panicRange'))
            self.effectiveSlider.SetValue(beh.GetVar('effectiveRange'))
            if beh.isActive():
                self.startStopButtonState = 'stop'
                self.startStopButton.SetLabel('Stop')
            else:
                self.startStopButtonState = 'start'
                self.startStopButton.SetLabel('Start')
  
"""
def printEnts(dirStr,numLvls):
    entlist = []
    sel(dirStr)
    dir = ndir()
    for subdir in dir:
        sel(dirStr+subdir+'/')
        dir = ndir()
        entlist+=dir
    return entlist
"""
