from behavior import *
#from approach import *
#from retreat import *
#from maintain import *
#from moveto import *

class NetworkBehavior(Behavior):
    ORDERING = 1
    ENABLING = 2
    PERMANENT = 3
    def __init__(self, triggerMonitor):
        self.triggerMonitor = triggerMonitor
        self.preconditions = {self.ORDERING:{}, self.ENABLING:{}, self.PERMANENT:{}}
        self.groupCheck = {}
        self.groupID = 0
        self.child = False
        self.inhibited = False
        self.active = False
        self.inhibited = False
        self.behaviorContinue = False
        self.goalsMet = False
        self.child = Behavior()
        self.parent = Behavior()
        self.wasActive = False
        self.postWasTrue = False
        self.activation = 0
        self.tickRan = False
        self.postTrue = False
    
    def addPrecondition(self, predecessor, type):
        self.preconditions[type][predecessor] = False
        self.groupCheck[predecessor.groupID] = False
        
    def checkLinks(self):
        #if self.id == '1':
        #    print self.preconditions[self.ORDERING].values(), \
        #          self.preconditions[self.ENABLING].values()
        if (False not in self.preconditions[self.ORDERING].values()) and \
               (False not in self.preconditions[self.PERMANENT].values()) and \
               (False not in self.preconditions[self.ENABLING].values()):
            return True
        else:
             return False
             
    def checkPreconditions(self):
        rules = {}
        childpre = True
        if self.child and self.id != 'INIT':
            if self.id == 'INIT':
                print self.child, "I REALLY SHOULDN'T BET HERE!"
            rules = self.child.preTriggers
            childpre = self.child.checkPreconditions()
        pre = True
        for id in rules:
            if not self.triggerMonitor.stateMatch(id):
                pre = False
        #    if triggers.get(id) != state:
        #        pre = False
        #if self.id == '1':
        #     print not self.inhibited, self.activation > 0, pre, childpre, self.checkLinks()
        returnval = not self.inhibited and self.activation > 0 and pre and \
                    childpre and self.checkLinks()
        if returnval and self.id != 'INIT':
            for type in self.preconditions.values():
                for beh in type.keys():
                    if beh.child.type in ['approach', 'retreat', 'maintain', 'moveto', "MAINTAIN STATION"] and \
                       self.child.type in ['approach', 'retreat', 'maintain', 'moveto', "MAINTAIN STATION"]:
                        beh.inhibited = True
                    
        return returnval
    
    def checkPostconditions(self):
        rules = {}
        if self.child:
            rules = self.child.postTriggers
        post = False
        #if rules == []:
        #    post = True
        for id in rules:
            #print `state`
            if self.triggerMonitor.stateMatch(id):
                post = True
            #if triggers.get(id) != state:
            #    post = False
        #if self.id =='0':
        #    print "*******", self.child.checkPostconditions()
        returnval = post  #and self.checkLinks()
        if self.id != 'INIT':
            returnval = returnval or self.child.checkPostconditions()
        else:
            self.activation -= 1
            returnval = True
        returnval = returnval and self.activation == 0
        #if self.id == '0':
        #    print returnval, self.activation
        #if self.id == 'INIT':
        #    print "***** INIT return val", returnval
        return returnval
        
    def sendActivation(self, id=None):
        #if self.id == '0':
        #print "^^^^^^^^^", id, '==>', self.id
        if self.activation == 0:
            checkGroup = True
            for beh, state in self.preconditions[self.ORDERING].iteritems():
                groupID = beh.groupID
                #if groupID != 0:
                #    if groupID in self.groupCheck:
                #        self.preconditions[self.ORDERING][beh] = True
                #if self.id == 'INIT':
                #    print "Can I at least get here?"
                if not self.wasActive and checkGroup:
                    check = beh.checkPostconditions()
                    #if self.id == 'INIT':
                    #    print check
                    self.preconditions[self.ORDERING][beh] = check or \
                                                             self.preconditions[self.ORDERING][beh]
                    #if beh.id == '0' and self.id == '1':
                    #    print check, self.preconditions[self.ORDERING][beh]
                    self.groupCheck[beh] = check
                    #print beh.child.__module__ == 'cat.Behaviors.avoidentity'
                    if not self.preconditions[self.ORDERING][beh] or beh.child.__module__ == 'cat.Behaviors.avoidentity':
                        beh.sendActivation(self.id)
            for beh, state in self.preconditions[self.PERMANENT].iteritems():
                check = beh.checkPostconditions()
                self.preconditions[self.PERMANENT][beh] = check
                if not check:
                    beh.sendActivation()
            for beh, state in self.preconditions[self.ENABLING].iteritems():
                enable = self.preconditions[self.ENABLING][beh]
                check = beh.checkPostconditions() or beh.postWasTrue
                #if self.id =='5':
                #    print "check", beh.id
                #if self.id == '5':
                #    print "wa", self.wasActive
                if self.wasActive:
                    #if self.id == '5':
                        #print "en", enable, "ch", check
                    check = enable or check
                self.preconditions[self.ENABLING][beh] = check
                if not check:
                    beh.sendActivation()
        self.activation += 1
                
    def Tick(self, time, dtime):
        self.postTrue = self.child.checkPostconditions()
        self.tickRan = True
        return self.child.Tick(time, dtime)
        
    def reset(self):
        self.activation = 0
        self.active = False
        self.postWasTrue = self.postTrue
        self.wasActive = self.tickRan
        self.evalRan = False
        self.tickRan = False
