import wx

from common.defs import *
from common.log import Log
log = Log(tags=['all','sensors'])
import math
from useful import *
from cat.sensors.relativepositionsensor import *
from cat.Behaviors import inverseCPA
import nEventServer
from common import EventNames
#MINOR_RADIUS = 200
#MAJOR_RADIUS = 300

from common import OptionManager
if OptionManager.getOption('map') == 'sandiego':
    MAX_RANGE_SLIDER      = 5000
else:
    MAX_RANGE_SLIDER      = 20000

behaviorType = type = "AVOID ENTITY"
DEFAULTSIZE = (200, 400)
PANIC_MULTIPLIER = 4
EFF_MULTIPLIER   = 100

import catBehavior

class CatAvoidEntity(catBehavior.CatBehavior):
    def __init__(self, cPanelA, cPanelE, entity=None, bname = None, sensors = None, actuators = None, recorder = None, size=DEFAULTSIZE,  show=False):
        catBehavior.CatBehavior.__init__(self, cPanelA, cPanelE, entity=entity, bname=bname, size = size,  show=show)

        self.sensors = sensors
        

        #         self.AddFloat("panicRange",100.0, 0.0, 10000.0)
        #         self.AddFloat("effectiveRange",10000.0, 0.0, 10000.0)
        #         self.AddFloat('Speed',5.0,0.0,28.0)
        self.relpos = RelativePositionSensor(entity = self.entity, behavior = self)
        self.sens = sensors
        pushsel(self.entityPath)
        self.width, self.height,self.length = gv('dimension')
        self.maxSpeed = gf('maxSpeed')
        popsel()
        pR = self.length * PANIC_MULTIPLIER
        eR = self.length * EFF_MULTIPLIER
        self.AddFloat("panicRange", pR, 0.0, 10000.0)
        self.AddFloat("effectiveRange",10000.0, 0.0, 10000.0)
        self.AddFloat('Speed', self.maxSpeed/2.0, 0.0, self.maxSpeed)
        #print "Entity: %s -- Panic Range: %s, EffectiveRange: %s, maxSpeed: %s, speed: %s" % (self.entity.getName(), str(pR), str(eR), str(self.maxSpeed), str(self.maxSpeed/2))
        
        self.MINOR_RADIUS = 200
        self.MAJOR_RADIUS = 300


    def makeBehaviorPanel(self, panel, size=None, entity = None, bname = None, behavior = None,  show=False):
        #SD from cat.Interface import catAvoidEntityPanel, catTargetPanel
        from cat.Interface import catStartPanel, catTargetPanel
	from common import behaviorNames
        from cat import panelInfo
        bsize = panelInfo.BEHAVIORPANEL
        #SD aePanel = catAvoidEntityPanel.CatAvoidEntityPanel(panel, -1, color=None, size=bsize, behaviorType=bname , entity=entity, behavior = behavior)
        aePanel = catStartPanel.CatStartPanel(panel, -1, color=None, size=bsize, behaviorType=bname , entity=entity, behavior = behavior)
	tsize = panelInfo.TARGETPANEL
	targetPanel = wx.Panel(panel, -1, size=tsize) 
        if(show):
            panel.addPanel(aePanel, targetPanel, bname)
        return [aePanel, targetPanel]
    
    #     def getPanels(self):
    #         return [self.behaviorPanelA, self.behaviorPanelE]
    

    def getMyInfo(self):
        pushsel(self.entityPath)
        y0m,oz,x0m = gv('pos')
        vm = gf('speed')
        thetam = gf('heading')
        maxSpeed = gf('maxSpeed')
        desiredSpeed = gf('desiredSpeed')
        popsel()
        return (y0m, x0m, vm, thetam, maxSpeed, desiredSpeed)

    def computeRelativeBearing(self, absHeading, thetat):
        ab1 = 2*math.pi - absHeading
        ab2 = ab1 - math.pi

        
##         heading = thetam
        if ab2 <0:
            ab2 += 2*math.pi
##         if thetam < 0:
##             heading = thetam + 2*math.pi
##         heading = 2*math.pi - heading

##         rb1 = ab1 - heading
##         if rb1 < 0:
##             rb1 += 2*math.pi

        heading2 = thetat
        if heading2 < 0:
            heading2 += 2*math.pi
        heading2 = 2*math.pi - heading2

        rb2 = ab2 - heading2
        if rb2 < 0:
            rb2 += 2*math.pi

        return rb2

    def perpendicularDistance(self,avoidee,x0m,y0m):
        pushsel(avoidee)
        #calculate point on ships centerline @ front of ship.
        flx,g,fly = gv('flcoord')
        frx,g,fry = gv('frcoord')
        dfx = frx - flx
        dfy = fry - fly
        dfx = dfx/2.0
        dfy = dfy/2.0
        ax0 = flx + dfx
        ay0 = fly + dfy
        
        #calculate point on ship's centerline @ rear of ship.
        rlx,g,rly = gv('rlcoord')
        rrx,g,rry = gv('rrcoord')
        drx = rrx - rlx
        dry = rry - rly
        drx = drx/2.0
        dry = dry/2.0
        bx0 = rlx + drx
        by0 = rly + dry
                
        AB = (bx0 - ax0, by0 - ay0, 0)
        AP = (y0m - ax0, x0m - ay0, 0)
        #print 'AB',AB
        #print 'AP',AP

        #cross-product
        ABXAP = (0,0,AB[0] * AP[1] - AP[0] * AB[1])
        #print 'ABXAP',ABXAP
        
        a = math.sqrt(math.pow(ABXAP[2],2))
        #print 'a',a
        
        dist = a / math.sqrt(math.pow(AB[0],2) + math.pow(AB[1],2))
        #print '|AB|',a/dist
        popsel()
        return dist

    def isGoalInTargetZone(self, x0m,y0m, vm, thetam, x0t,y0t, thetat,timeToCompletion,avoidee):
        pushsel(avoidee)
        width,height,length = gv('dimension')
        dist = vm * timeToCompletion
        xm = x0m + math.cos(thetam) * dist
        ym = y0m + math.sin(thetam) * dist
        xmprime = xm * math.cos(thetat) - ym * math.sin(thetat)
        ymprime = xm * math.sin(thetat) + ym * math.cos(thetat)

        xtprime = x0t * math.cos(thetat) - y0t * math.sin(thetat)
        ytprime = x0t * math.sin(thetat) + y0t * math.cos(thetat)
        #print 'x extrapolation displacement: ',x0m - xm
        #print 'y extrapolation displacement: ',y0m - ym
        #print 'difference in ys:',ytprime - ymprime
        goalInTargetZone = ymprime > ytprime - 2*self.MINOR_RADIUS and ymprime < ytprime + 2*self.MINOR_RADIUS
        #print 'Is goal in target zone? ',goalInTargetZone
        #print 'dist to goal: ',dist
        #print 'pos of goal (rotated): ',xmprime,ymprime
        #print 'pos of target (rotated): ',xtprime,ytprime
        #print 'minor radius: ',self.MINOR_RADIUS
        popsel()
        
        return goalInTargetZone
    

    def amIBehindTarget(self,x0m,y0m,x0t,y0t,thetat,length):
        xmprime = x0m * math.cos(thetat) - y0m * math.sin(thetat)
        ymprime = x0m * math.sin(thetat) + y0m * math.cos(thetat)
        
        xtprime = x0t * math.cos(thetat) - y0t * math.sin(thetat)
        ytprime = x0t * math.sin(thetat) + y0t * math.cos(thetat)

        xtprime = xtprime - .15 * length
        
        imBehindTarget = xmprime < xtprime
        return imBehindTarget



    def getValidHeadings(self,x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius,currentHeading):
        newHeadings = [currentHeading,currentHeading]
        foundr = 0
        foundl = 0
        for i in range(0,91,5):
            if not foundr:
                A,B,C = getCoeffs(x0m,y0m,vm,thetam - i * (math.pi/180.0),x0t,y0t,vt,thetat,minorRadius,majorRadius)
                if (B * B - 4 * A * C) < 0:
                    newHeadings[0] = (thetam - (i+5)* (math.pi/180.0))
                    foundr = 1
            if not foundl:
                A,B,C = getCoeffs(x0m,y0m,vm,thetam + i * (math.pi/180.0),x0t,y0t,vt,thetat,minorRadius,majorRadius)
                if (B * B - 4 * A * C) < 0:
                    newHeadings[1] = (thetam + (i+5) * (math.pi/180.0))
                    foundl = 1
        return newHeadings
        
        
    def smallAvoidSingleEntity(self, avoidee, entlist, fs, fh, totalx, totaly, panic, minorRadius, majorRadius):
        y0m,x0m,vm,thetam,maxSpeed,desiredSpeed = self.getMyInfo()
        
        pushsel(avoidee)
        thetat = gf('heading')
        y0t, tz, x0t = gv('pos')
        vt = gf('speed')
        absHeading = entlist[getfullname()][1]
        rb2 = self.computeRelativeBearing(absHeading, thetat)
        print 'absheading:',absHeading
        
        A,B,C = getCoeffs(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius)         
        discriminant = B * B - 4 * A * C

        sqdist = math.sqrt((x0m - x0t)*(x0m - x0t) + (y0m - y0t) * (y0m - y0t))
        h = 1/sqdist
        xcoord = h * math.cos(absHeading - math.pi)
        ycoord = h * math.sin(absHeading - math.pi)
        totalx += xcoord
        totaly += ycoord

        if False:
            t = getQuadratic(A,B,C)
            if (t[0] > 0 and t[1] < 0) or (t[0] < 0 and t[1] > 0):
                dist = self.perpendicularDistance(avoidee,x0m,y0m)
                #rb2 is target's relative bearing to me (in clockwise radians)
                #print 'perpendicular distance', dist
                if rb2 < math.pi:#if I am on ship's starboard side
                    bear = thetat - math.pi/2.0
                else: #if I am on a ship's port side
                    bear = thetat + math.pi/2.0

                #component of avoidance vector that points away from avoidee
                h = (minorRadius - dist) /minorRadius
                xcoord = h * math.cos(bear)
                ycoord = h * math.sin(bear)

                totalx += xcoord
                totaly += ycoord

                #component of avoidance vector that points behind avoidee
                bear = thetat + math.pi
                h = .5
                xcoord = h * math.cos(bear)
                ycoord = h * math.sin(bear)

                totalx += xcoord
                totaly += ycoord
        
        popsel()
        return totalx,totaly
        
    def largeAvoidSingleEntity(self, avoidee, entlist, fs, fh, leasttime, totalx, totaly, panic, avoidList, minorRadius, majorRadius):
        returntuple = (.5, fh, fs)
        y0m, x0m, vm, thetam, maxSpeed, desiredSpeed = self.getMyInfo()
        vm = fs
        currentheading = thetam
        thetam = fh
        pushsel(avoidee)
        absHeading = entlist[getfullname()][1]
               
        y0t,tz,x0t = gv('pos')
        vt = gf('speed')
        thetat = gf('heading')
        width,height,length = gv('dimension')
        
        rb2 = self.computeRelativeBearing(absHeading, thetat)

        #print 'params:',x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,self.MINOR_RADIUS,self.MAJOR_RADIUS
       
        A,B,C = getCoeffs(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius)         
        discriminant = B * B - 4 * A * C
        #print "first discriminant:",discriminant
        
        if discriminant > 0 and not (vt == vm and thetat == thetam):
            #avoid the ship
            t = getQuadratic(A,B,C)
            #print "times:",t #sol1,sol2

            if t[0] >=0 and t[1] >= 0 and t[0] < leasttime and (rb2 > math.pi or vt <= 0.1 or length > self.length):
                #leasttime = t[0]
                #print 'need to avoid',getname()
                alpha2 = x0m * math.cos(thetat) - x0t * math.cos(thetat) + y0m * math.sin(thetat) - y0t * math.sin(thetat)
                beta2 = y0m * math.cos(thetat) - y0t * math.cos(thetat) - x0m * math.sin(thetat) + x0t * math.sin(thetat)
                Aprime = 4 * math.pow(alpha2 * math.pow(minorRadius,2) * math.cos(thetam - thetat) + math.sin(thetam-thetat)*beta2*math.pow(majorRadius,2),2) - \
                         4 * C * (math.pow(minorRadius,2) * math.pow(math.cos(thetam-thetat),2) + math.pow(math.sin(thetam - thetat),2) * math.pow(majorRadius,2))
                Bprime = -8 * (alpha2 * math.pow(minorRadius,2) * math.cos(thetam - thetat) + \
                               math.sin(thetam-thetat) *  beta2 * math.pow(majorRadius,2)) * vt * alpha2 * math.pow(minorRadius,2) + \
                               8 * C * math.pow(minorRadius,2) * math.cos(thetam-thetat) * vt
                Cprime = 4 * math.pow(vt * alpha2 * math.pow(minorRadius,2),2) - 4 * C * math.pow(vt,2) * math.pow(minorRadius,2)


                discriminant2 = Bprime * Bprime - 4 * Aprime * Cprime
                #print "second discriminant:",discriminant2                                
                if discriminant2 > 0.01 and not self.isGoalInTargetZone(x0m,y0m, vm, thetam, x0t,y0t, thetat,leasttime,avoidee):
                    v = getQuadratic(Aprime,Bprime,Cprime)
                    #print "speeds:",v
                    newspeed = 0
                    numspeeds = 0

                    for pspeed in v:
                        if pspeed > 0.5 and pspeed <= maxSpeed:
                            newspeed = pspeed
                            numspeeds = numspeeds + 1

                    #testing to get it to change course instead of speed 
                    #numspeeds = 0

                    if numspeeds==2:
                        if v[1] < vm: #if I have to slow down, round speed down
                            returntuple = (.5,thetam,int(v[1]*10)/10.0)
                            avoidList.append((int(v[1]*10)/10.0,t[0],'speed'))
                        else: #if I have to speed up, round speed up.
                            returntuple = (.5,thetam,v[1])
                            avoidList.append((v[1],t[0],'speed'))

                        if v[0] < vm:
                            avoidList.append((int(v[0]*10)/10.0,t[0],'speed'))
                        else:
                            avoidList.append((v[0],t[0],'speed'))
                    elif numspeeds==1:
                        if newspeed < vm: #if I have to slow down, round speed down
                            returntuple = (.5,thetam,int(newspeed*10)/10.0)
                            avoidList.append((int(newspeed*10)/10.0,t[0],'speed'))
                        else: #if I have to speed up, round speed up.
                            returntuple = (.5,thetam,newspeed)
                            avoidList.append((newspeed,t[0],'speed'))
                    elif numspeeds==0:
                        if vt < 0.0:
                            #print 'using target speed'
                            returntuple = (.5,thetam,vt)
                            avoidList.append((vt,t[0],'speed'))
                        else:
                            #print 'changing heading'
                            newHeadings = self.getValidHeadings(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius,currentheading)
                            
                            avoidList.append((newHeadings[0],t[0],'heading'))
                            avoidList.append((newHeadings[1],t[0],'heading'))
                            if (thetam - newHeadings[0] < newHeadings[1] - thetam):
                                returntuple = (.5,newHeadings[0],fs)
                            else:
                                returntuple = (.5,newHeadings[1],fs)
                            
                    else:
                        print "AvoidEntity Error: got more than 2 potential speeds"                                        
                else:
                    #print "negative 2nd discriminant"
                    newHeadings = self.getValidHeadings(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius,currentheading)
                    
                    avoidList.append((newHeadings[0],t[0],'heading'))
                    avoidList.append((newHeadings[1],t[0],'heading'))
                    if (thetam - newHeadings[0] < newHeadings[1] - thetam):
                        returntuple = (.5,newHeadings[0],fs)
                    else:
                        returntuple = (.5,newHeadings[1],fs)
            elif t[0] <= 0 and t[1] <= 0:
                #print 'ignoring',getname(),': behind me'
                returntuple = (0,fh,fs)
                pass
            
            elif t[0] > leasttime:
                #print 'ignoring',getname(),': too far away'
                returntuple = (0,fh,fs)
                pass
            
            elif (t[0] > 0 and t[1] < 0) or (t[0] < 0 and t[1] > 0):
                #print 'Panicking!  Within avoidance ellipse of',getname()
              
                behindTarget = self.amIBehindTarget(x0m,y0m,gv('rlcoord')[2],gv('rlcoord')[0],thetat,gv('dimension')[2])
                if behindTarget:
                    returntuple = (0,fh,fs)
                else:
                    panic = True
                    dist = self.perpendicularDistance(avoidee,x0m,y0m)
                    #rb2 is target's relative bearing to me (in clockwise radians)
                    #print 'perpendicular distance', dist
                    if rb2 < math.pi:#if I am on ship's starboard side
                        bear = thetat - math.pi/2.0
                    else: #if I am on a ship's port side
                        bear = thetat + math.pi/2.0
                    h = (self.MINOR_RADIUS - dist) /self.MINOR_RADIUS
                    xcoord = h * math.cos(bear)
                    ycoord = h * math.sin(bear)

                    totalx += xcoord
                    totaly += ycoord

                    bear = thetat + math.pi
                    h = .5
                    xcoord = h * math.cos(bear)
                    ycoord = h * math.sin(bear)

                    totalx += xcoord
                    totaly += ycoord

        else:
            if discriminant == 0:
                #print 'intersecting',getname(),'at only one point'
                returntuple = (0,fh,fs)
                pass
            else:
                #print 'ignoring',getname(),': non-intersecting'
                returntuple = (0,fh,fs)
                pass
        popsel()
        return (returntuple, panic, totalx, totaly, leasttime)


    def loop(self,time,dtime):
        #print "\n\n\nin avoidentity tick"
        pushsel()
        largeShip = True
        if exists(self.entityPath):
            #entInfo = []
            
            
            totalx = totaly = 0
            panicRange = self.GetVar('panicRange')
            weight = .5
            panic = False
            effect = False
            eval = False
            speed = self.GetVar('Speed')
            #print self.GetVar('Speed'),self.GetVar('panicRange'),self.GetVar('effectiveRange')
            vm,thetam = self.entity.actuators.getCurrentVec()
            #print 'Desired speed, heading:',vm,thetam
            sel(self.entityPath)
            largeShip = gi('size')
            ## if largeShip:
##                 print getname(), 'is a large ship!'
##             else:
##                print getname(), 'is a small ship!'
            y0m,oz,x0m = gv('pos')
            # if vm == 0.0:
            #    vm = gf('speed')
            #    thetam = gf('heading')
            maxSpeed = gf('maxSpeed')
            desiredSpeed = gf('desiredSpeed')
            #heading = gf('heading')
            #currentSpeed = gf('speed')
            #print 'myheading:',gf('heading')
            entlist = self.relpos.getRelPos()
            returntuple = (0,thetam,vm)
            
            leasttime = self.entity.getTTC()
            if leasttime > 3600:
                leasttime = 3600
            #print "time to completion: ", leasttime
            avoidList = []
            
            
            sel('/game/ents/')
            dir = ndir()
            for subdir in dir:
                sel('/game/ents/'+subdir)
                dir2 = ndir()
                for subdir2 in dir2:
                    xcoord = ycoord = 0
                    avoidee = '/game/ents/'+subdir+'/'+subdir2
                    sel(avoidee)
                    if not getselectable() or getfullname() == self.entityPath :
                        pass
                    else:
                        width, height,length = gv('dimension')
                        #self.MAJOR_RADIUS = length * 1.5
                        majorRadius = length * 1.5
                        #self.MINOR_RADIUS = self.MAJOR_RADIUS * .66666
                        minorRadius = majorRadius * .66666
                        #print 'avoidList',avoidList
                        if largeShip:
                            returntuple_x, panic, totalx, totaly, leasttime_x = self.largeAvoidSingleEntity(avoidee, entlist, vm, thetam, leasttime, totalx, totaly, panic, avoidList, minorRadius, majorRadius)
                            if leasttime_x < leasttime:
                                returntuple = returntuple_x
                                leasttime = leasttime_x
                                #print 'leasttime is',leasttime,'for entity',getname()
                        else:
                            totalx, totaly = self.smallAvoidSingleEntity(avoidee, entlist, vm, thetam,totalx, totaly, panic, minorRadius*2, majorRadius*2)



        if largeShip:
            returntuple = self.getBestAvoidanceVector(x0m,y0m,vm,thetam,avoidList,leasttime,entlist)
        elif not largeShip:
            h = 1.0/(100.0)
            fx = h * math.cos(thetam)
            fy = h * math.sin(thetam)
            print fx,fy, totalx,totaly,thetam
            returntuple = (.5,math.atan2(totaly+fy,totalx+fx),vm)
        if panic:
            returntuple = (1,math.atan2(totaly,totalx),vm)
        popsel()
        returntupleknots = (returntuple[0],returntuple[1],returntuple[2]*1.7774514)
        return returntupleknots
        #return (1.0,0.0,5.0)

    def getBestAvoidanceVector(self,x0m,y0m,vm,thetam,avoidList,leasttime,entlist):
        avoidList.append((thetam,0,'heading'))
        goodVectors = []
        pushsel()
        sel(self.entityPath)
        currentHeading = gf('heading')
        currentSpeed = gf('speed')
        
        for value,time,type in avoidList:
            
##             if type =='heading':
##                 print value * 180.0/math.pi,time,type
##             else:
##                 print value,time,type
                
            brokenVector = False                
            sel('/game/ents/')
            dir = ndir()
            for subdir in dir:
                sel('/game/ents/' + subdir)
                dir2 = ndir()
                for subdir2 in dir2:
                    sel('/game/ents/' + subdir + '/' + subdir2)
                    if not getselectable() or getfullname() == self.entityPath:
                        pass
                    else:
                        
                        y0t,tz,x0t = gv('pos')
                        vt = gf('speed')
                        thetat = gf('heading')
                        absHeading = entlist[getfullname()][1]
                        rb2 = self.computeRelativeBearing(absHeading,thetat)
                        width, height,length = gv('dimension')
                        #self.MAJOR_RADIUS = length * 1.5
                        majorRadius = length * 1.5
                        #self.MINOR_RADIUS = self.MAJOR_RADIUS * .66666
                        minorRadius = majorRadius * .66666


                        if type == 'speed':
                            A,B,C = getCoeffs(x0m,y0m,value,thetam,x0t,y0t,vt,thetat,minorRadius,majorRadius)
                        elif type == 'heading':
                            A,B,C = getCoeffs(x0m,y0m,vm,value,x0t,y0t,vt,thetat,minorRadius,majorRadius)
                        discriminant = B * B - 4 * A * C
                        if discriminant > 0:
                            t = getQuadratic(A,B,C)
                            if t[0] >= 0 and t[1] >= 0 and t[0] < leasttime and (rb2 > math.pi or vt <= 0.1 or length > self.length):
                                brokenVector = True
            if not brokenVector:
                goodVectors.append((value,time,type))
        #bestValue,bestTime,bestType = goodVectors[0]
        #bestType = 'heading'

        bestSpeed = 99999
        nearestHeading = currentHeading + math.pi
        if nearestHeading > math.pi:
            nearestHeading = nearestHeading - 2*math.pi
        #print currentHeading * 180.0/math.pi, nearestHeading * 180.0/math.pi
        foundSpeed = False
        bestSpeedTime = 0
        bestHeadingTime = 0
        
        #print 'goodVectors' , goodVectors
        for value,time,type in goodVectors:
            
            if type == 'speed':
                if abs(value-currentSpeed) < abs(bestSpeed-currentSpeed):
                    bestSpeedTime = time
                    bestSpeed = value
                    foundSpeed = True
            elif type == 'heading':
                if diffAngle(currentHeading,value) < diffAngle(currentHeading,nearestHeading):
                    nearestHeading = value
                    bestHeadingTime = time
        if foundSpeed:
            bestType = 'speed'
            bestValue = bestSpeed
            bestTime = bestSpeedTime
        else:
            bestType = 'heading'
            bestValue = nearestHeading
            bestTime = bestHeadingTime
        popsel()
        if bestType == 'speed':
            #print 'bestVector: ',thetam * 180.0/math.pi,bestValue
            return (.5, thetam,bestValue)
        else:
            #print 'bestVector: ',bestValue * 180.0/math.pi,vm
            return (.5,bestValue,vm)


    def checkPostconditions(self):
        return False

def getCoeffs(x0m,y0m,vm,thetam,x0t,y0t,vt,thetat,MINOR_RADIUS,MAJOR_RADIUS):
    alpha1 = vm * math.cos(thetam) * math.cos(thetat) - vt * math.pow(math.cos(thetat),2) + vm * math.sin(thetam) * math.sin(thetat) - vt * math.pow(math.sin(thetat),2)
    alpha2 = x0m * math.cos(thetat) - x0t * math.cos(thetat) + y0m * math.sin(thetat) - y0t * math.sin(thetat)
    
    beta1 = vm * math.sin(thetam) * math.cos(thetat) - vt * math.sin(thetat) * math.cos(thetat) - vm * math.cos(thetam) * math.sin(thetat) + vt * math.cos(thetat) * math.sin(thetat)
    beta2 = y0m * math.cos(thetat) - y0t * math.cos(thetat) - x0m * math.sin(thetat) + x0t * math.sin(thetat)
    
    A = math.pow(alpha1,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta1,2) * math.pow(MAJOR_RADIUS,2)
    B = 2 * (alpha1 * alpha2 * math.pow(MINOR_RADIUS,2) + beta1 * beta2 * math.pow(MAJOR_RADIUS,2))
    C = math.pow(alpha2,2) * math.pow(MINOR_RADIUS,2) + math.pow(beta2,2) * math.pow(MAJOR_RADIUS,2) - math.pow(MAJOR_RADIUS,2) * math.pow(MINOR_RADIUS,2)
    return (A,B,C)

def getBehaviorType():
    return behaviorType


