#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Implementation of Approach

Approach works by first moving in a great circle around the target until the
correct bearing is met. The entity will start to move in closer. 
This is bad. It will be made better. Somehow.
"""
#TODO: Fix approach so it actually does what I say above
#TODO: Fix approach so it is actually good.
import wx
from primitivebehavior import *
#from cat import sensors
from common.defs import *
import math
from cat.Interface import important
from cat.entity import behaviorset
from cat.entity import EntityManager

type = "stop"

class Stop(PrimitiveBehavior):
    """
    The Stop Behavior
    """
    def __init__(self, sensors):
        PrimitiveBehavior.__init__(self, sensors)
        self.AddFloat('time', 0.0, 0.0, 1000.0)
        self.start = -1
        self.runningtime = -1
        self.hasrun = False
        self.type = type

    def Tick(self, time, dtime):
        self.hasrun = True
        if self.start == -1:
            self.start = time
        self.runningtime = time
        heading = 0.0
        if exists(self.sens.GetOwnEntity()):
            sel(self.sens.GetOwnEntity())
            heading = gf('desiredHeading')
        else:
            print "In stop, entity doesn't exist"
        return (1, heading, 0)

    def checkPreconditions(self):
        if self.runningtime - self.start <= self.GetVar('time'):
            return True
        else:
            return False

    def checkPostconditions(self):
        if self.runningtime - self.start > self.GetVar('time'):
            return True
        else:
            return False
            
behaviorset.register(type, Stop)    

class StopPanel(wx.Panel):
    def __init__(self, parent, panelID, buttonID):
        wx.Panel.__init__(self, parent, panelID)
        self.ID = buttonID
        self.SetBackgroundColour(wx.SystemSettings.GetColour(wx.SYS_COLOUR_3DLIGHT))
        self.sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(self.sizer)
        self.activate = wx.Button(self, self.ID, "Stop All")
        self.sizer.Add(self.activate, border=5, flag=wx.TOP|wx.LEFT)
        wx.EVT_BUTTON(self.activate, self.ID, self._OnActivate)
        self.beh = Stop()
        self.active = False

    def _OnActivate(self,event):
        """
        Private function for handling activation background work.
        """
        self.activate.SetLabel("Resume")
        wx.EVT_BUTTON(self.activate, self.ID, self._OnDeactivate)
        self.active = True
        self.beh.active = self.active
        self.OnActivate(event)
        important.ImportantEvent()

    def _OnDeactivate(self,event):
        """
        Private function for handing deactivation background work.
        """
        self.activate.SetLabel("Stop All")
        wx.EVT_BUTTON(self.activate, self.ID, self._OnActivate)
        self.active = False
        self.beh.active = self.active
        self.OnDeactivate(event)
        important.ImportantEvent()

    def Tick(self, time, dtime):
        self.time += dtime
        self.beh.SetVar('time', self.time)
        return self.beh.Tick(time, dtime)
                
    def OnActivate(self, event):
        """
        Called when the activate button is pressed.
        
        Turns off other behaviors and changes the parent tab's name.
        """
        self.time = 0
        self.beh.start = -1
        self.stopped = []
        for panel in self.panels:
            if panel.IsActive():
                panel._OnDeactivate(None)
                self.stopped.append(panel)
    
    def OnDeactivate(self, event):
        """
        Called when deactivate button is pressed.
        
        Because of the panel group, this panel is guaranteed to be the only one
        on and simple has to change the parent tab name.
        """
        if event:
            for panel in self.stopped:
                panel._OnActivate(None)
            self.stopped = []
    
    def IsActive(self):
        return self.active
