#
# @(#) xmlWriter.py 2005/11/11
# @author SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

from xml.sax import saxutils
from common import behaviorNames

def makeBehaviorXML(bname, params):
    bs = '<behavior name=%s>\n'% saxutils.quoteattr(bname)
    triggerXml = makeTriggerXML()
    paramXml   = makeParamDictXML(params)
    bs = bs + triggerXml + paramXml
    bs = bs + "</behavior>\n"
#    print bs
    return bs

def makeTriggerXML():
    return '\n'

def makeParamDictXML(params):
    pds = ''
    for key, val in params.iteritems():
        pds = pds + makeParamXML(key, val)
        #        print pds
    return pds
    
def makeParamXML(key, val):
    ps = '\t<parameter name=%s type=%s min=%s max=%s> %s </parameter>\n' % (saxutils.quoteattr(str(key)), saxutils.quoteattr(str(val[1])), saxutils.quoteattr(str(val[2])), saxutils.quoteattr(str(val[3])), str(val[0]) )
    #       print ps
    return ps

def makeSlotsXML():
    return "\n"


