#
# @(#) catAuthorDialog.py 2005/11/12
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#
'''
Defines the GUI and its operations for cat.

'''
import wx
from cat.merge import xmlmerger

from savedialog import SaveDialog

class CatAuthorDialog(wx.Panel):
    '''Behavior Network Management panel abstract class - Authoring only'''

    def __init__(self, parent, panelID, color = "RED", size=None, recType = "Save_recorded", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None):
        
        wx.Panel.__init__(self, parent, -1, size=size, style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
       
	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)

	labelSave = wx.StaticText(self, -1, label1)
	
	labelMsg = wx.StaticText(self, -1, label2)
	 
	l1 	= wx.StaticText (self, -1, text1)
	self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	l2 	= wx.StaticText (self, -1,text2)
	self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
	self.saveCancelButton = wx.Button(self, -1, buttonName1, style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.saveCancelButton, -1, self.onCancel)

	self.saveOKButton = wx.Button(self, -1, buttonName2, style=wx.BU_EXACTFIT)
		
	wx.EVT_BUTTON(self.saveOKButton, -1, self.onOK)

	space 	= 2
	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, self.t1, l2, self.t2, self.saveCancelButton, self.saveOKButton])
	
	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (212, 2), style = wx.ALIGN_RIGHT)
    
	sizerSave = wx.BoxSizer(wx.VERTICAL)
	sizerSave.Add(labelSave)
	sizerSave.Add(spacer1)	
	sizerSave.Add(labelMsg)
	sizerSave.Add(spacer2)	
	sizerSave.Add(sizer)
	sizerSave.Add(spacer3)
	self.SetSizer(sizerSave)

    def getPanel(self):
        return self
        
    def onOK(self, event):
        print "Ok button pressed"

    def onCancel(self, event):
        print "Cancel button pressed"
        

    
class ExistsPanel(CatAuthorDialog):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None):
        
        CatAuthorDialog.__init__(self, parent, -1, color = "ORANGE", size=(212, 210), recType = "File_exists", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None)
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)

# 	labelExists = wx.StaticText(self, -1, "NETWORK FILE ALREADY EXISTS! \n Overwrite existing file?", size = (200, 50), style = wx.ALIGN_CENTER)
	
# 	#labelMsg = wx.StaticText(self, -1, " Please specify: ")
	 
# 	l1 	= wx.StaticText (self, -1,"              ")
# 	#self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
# 	l2 	= wx.StaticText (self, -1,"              ")
# 	#self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
# 	self.existsNoButton = wx.Button(self, -1, "  No  ", style=wx.BU_EXACTFIT)
	
# 	wx.EVT_BUTTON(self.existsNoButton, -1, self.OnNoClick)

# 	self.existsYesButton = wx.Button(self, -1, " Yes ", style=wx.BU_EXACTFIT)
	
# 	wx.EVT_BUTTON(self.existsYesButton, -1, self.OnYesClick)
	
# 	space 	= 2
# 	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
# 	sizer.AddMany ([l1, l2, self.existsNoButton, self.existsYesButton])
	
# 	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
# 	spacer2 = wx.StaticText(self, -1, "", size= (212, 10), style = wx.ALIGN_RIGHT)
# 	spacer3 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
    
# 	sizerExists = wx.BoxSizer(wx.VERTICAL)
# 	sizerExists.Add(spacer1)	
# 	sizerExists.Add(labelExists)
# 	sizerExists.Add(sizer, flag = wx.ALIGN_CENTER)
# 	sizerExists.Add(spacer2)
# 	self.SetSizer(sizerExists)

    
        
    def onOK(self, event):
        print "Ok button pressed"

    def onCancel(self, event):
        print "Cancel button pressed"
        
class EmptyFieldsPanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists",  label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None):
        
        CatAuthorDialog.__init__(self, parent, -1, color = "ORANGE", size=(212, 210), recType = "File_exists", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None)        
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)

# 	labelEmptyFields = wx.StaticText(self, -1, "INCOMPLETE INFORMATION: Empty Field(s) \n Please provide names for network and file", size = (200, 70), style = wx.ALIGN_CENTER)
	
# 	self.emptyOKButton = wx.Button(self, -1, "  OK  ", style=wx.ALIGN_CENTER|wx.BU_EXACTFIT|wx.EXPAND)
# 	wx.EVT_BUTTON(self.emptyOKButton, -1, self.OnEmptyOKClick)
	
# 	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
# 	spacer2 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
# 	spacer3 = wx.StaticText(self, -1, "", size= (212, 6), style = wx.ALIGN_RIGHT)
    
# 	sizerEmptyFields = wx.BoxSizer(wx.VERTICAL)
# 	sizerEmptyFields.Add (spacer1)	
# 	sizerEmptyFields.Add(labelEmptyFields)
# 	sizerEmptyFields.Add(spacer2)
# 	sizerEmptyFields.Add(self.emptyOKButton, flag = wx.ALIGN_CENTER)
# 	sizerEmptyFields.Add(spacer3)
# 	self.SetSizer(sizerEmptyFields)




class DeletePanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None):
        

        CatAuthorDialog.__init__(self, parent, -1, color = "ORANGE", size=(212, 210), recType = "File_exists", label1 = None, label2 = None, text1 = None, text2 = None, buttonName1 = None, buttonName2 = None)
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)

# 	labelExists = wx.StaticText(self, -1, "DELETING FILE! \n Are you sure you want to delete?", size = (200, 50), style = wx.ALIGN_CENTER)
	
# 	#labelMsg = wx.StaticText(self, -1, " Please specify: ")
	 
# 	l1 	= wx.StaticText (self, -1,"              ")
# 	#self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
# 	l2 	= wx.StaticText (self, -1,"              ")
# 	#self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
# 	self.existsNoButton = wx.Button(self, -1, "  No  ", style=wx.BU_EXACTFIT)
	
# 	wx.EVT_BUTTON(self.existsNoButton, -1, self.OnNoClick)

# 	self.existsYesButton = wx.Button(self, -1, " Yes ", style=wx.BU_EXACTFIT)
	
# 	wx.EVT_BUTTON(self.existsYesButton, -1, self.OnYesClick)
	
# 	space 	= 2
# 	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
# 	sizer.AddMany ([l1, l2, self.existsNoButton, self.existsYesButton])
	
# 	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
# 	spacer2 = wx.StaticText(self, -1, "", size= (212, 10), style = wx.ALIGN_RIGHT)
# 	spacer3 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
    
# 	sizerExists = wx.BoxSizer(wx.VERTICAL)
# 	sizerExists.Add(spacer1)	
# 	sizerExists.Add(labelExists)
# 	sizerExists.Add(sizer, flag = wx.ALIGN_CENTER)
# 	sizerExists.Add(spacer2)
# 	self.SetSizer(sizerExists)
    
    
	
