#
# @(#) catAvoidLandPanel.py 2005/10/25
# @author AO and SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Avoid Land Panel
Authoring and Execution UI for Avoid Land
"""
import wx
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames

MAX_RANGE_SLIDER = 20000

class CatAvoidLandPanel(wx.Panel):
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = None, entity = None, behavior=None):    
        wx.Panel.__init__(self, parent, panelID, size=size, style=wx.RAISED_BORDER|wx.DOUBLE_BORDER)

        self.bname = behaviorType        
        self.SetBackgroundColour(color)
        self.parentPanel = parent
        self.entity = entity
        self.behavior = behavior

        newSizer = wx.BoxSizer(wx.VERTICAL)
        self.statusMessage = wx.StaticText(self,-1,self.bname)
        newSizer.Add(self.statusMessage,0,wx.ALIGN_LEFT)
        self.startStopButton = wx.Button(self,-1,'Start',style=wx.BU_EXACTFIT)
        self.startStopButtonState = 'start'
        wx.EVT_BUTTON(self.startStopButton,-1,self.OnClick)
        emptySizer = wx.BoxSizer()
        newSizer.Add(emptySizer,1,flag=wx.EXPAND)
        newSizer.Add(self.startStopButton,0,flag=wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
        self.SetSizer(newSizer)
        self.EXLUSION_LIST = ()

    def OnClick(self,event):
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print 'invalid behavior in avoidlandpanel'

    def handlePageChange(self,msg):
        self.startStopButton.SetLabel(self.behavior.startStop)

    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)

    def updatePanels(self):
        self.SetStartStop()
        self.Layout()
        self.Validate()
        self.Show()
            
