
import wx
from common import behaviorNames
from cat import panelInfo
	
class CatControlWrapper(wx.Panel):
    def __init__(self, parent, id, color, size=None):
	    
        wx.Panel.__init__(self, parent, id, size=size)
	
	self.sizer = wx.BoxSizer(wx.VERTICAL)
	self.SetSizer(self.sizer)
        self.bgcolor = self.GetParent().GetBackgroundColour()

        from cat import panelInfo
	self.emptyPanel = wx.Panel(self, -1, size=panelInfo.BEHAVIORPANEL) #size=(195, 250))

        b = self.bgcolor.Blue()
        if(b > 200):
            self.mode = "AUTHORING"
            self.SetBackgroundColour(panelInfo.ABEHAVIORPANELCOLOR)

        else:
            self.mode = "EXECUTION"
            self.SetBackgroundColour(panelInfo.EBEHAVIORPANELCOLOR)            

	self.targetPanel = wx.Panel(self, -1, size=panelInfo.TARGETPANEL) #size=(195, 250))
	self.panels = {}
        self.addPanel(self.emptyPanel, self.targetPanel, behaviorNames.EMPTY)
        self.currentBehavior = behaviorNames.EMPTY
	self.showPanel(behaviorNames.EMPTY)
        self.sizer.Layout()
        self.Layout()
        self.GetParent().Layout()

    def setMode(self, mode):
        if(mode.startswith(panelInfo.AUTHORING)):
            behaviorColor = panelInfo.ABEHAVIORPANELCOLOR
            targetColor   = panelInfo.ATARGETPANELCOLOR
        elif(mode.startswith(panelInfo.EXECUTION)):
            behaviorColor = panelInfo.EBEHAVIORPANELCOLOR
            targetColor   = panelInfo.ETARGETPANELCOLOR
        else:
            behaviorColor = panelInfo.EBEHAVIORPANELCOLOR
            targetColor   = panelInfo.ETARGETPANELCOLOR
        c, t = self.panels[self.currentBehavior]
        c.SetBackgroundColour(behaviorColor)
        t.SetBackgroundColour(targetColor)
        self.sizer.Layout()
        self.Layout()
            
        
	
    def addPanel(self, panel, tPanel, name):
#        print "Adding panel: ", name
        panel.Hide()
        tPanel.Hide()
        self.panels[name] = [panel, tPanel]
        self.setBGColor(panel, tPanel)

#        self.sizer.Layout()

    def getPanel(self, name):
        print "getting panels: ", name
        if self.panels.has_key(name):
            return self.panels[name]

#        self.sizer.Layout()

    def setBGColor(self, c, t):

        if (self.mode.startswith("AUTHORING")):
            cc = panelInfo.BEHAVIOR_AUTHOR_COLOR
            tc = panelInfo.TARGET_AUTHOR_COLOR
        else:
            cc = panelInfo.BEHAVIOR_EXEC_COLOR
            tc = panelInfo.TARGET_EXEC_COLOR
        #endifelse
        c.SetBackgroundColour(cc)
        t.SetBackgroundColour(tc)

        

    def showPanel(self, bname):
#        print "Showing behavior %s, mode %s: " % (bname, self.mode)
        self.hidePanel(self.currentBehavior)
#        self.hideAll()
        if(self.panels.has_key(bname)):
            c, t = self.panels[bname]
        else:
            c, t = self.panels[behaviorNames.EMPTY]
        #endifelse
#        self.detach()
#        print "Detached old behavior panels"
        self.attach(c, t)
        self.Layout()
        c.Validate()
        t.Validate()        
        self.currentBehavior = bname
#        print "ShowingPanel: %s Behavior panel " % bname


    def attach(self, cont, target):
        self.add(cont, target)
        self.sizer.Layout()
        cont.Show()
        target.Show()

    def add(self, c, t):
#        print "ControlWrapper %s, Show:add: Behavior Panel: size: %s, Target Panel Size: %s" % (self.GetSize(), c.GetSize(), t.GetSize())
        self.sizer.Insert(0, c, 0, flag=wx.FIXED_MINSIZE, border = 0 )
        self.sizer.Insert(1, t, 0, flag=wx.FIXED_MINSIZE, border = 0 )


    def hidePanel(self, bname):
#        print "Hiding panels for ", bname
        c, t = self.panels[bname]
        c.Hide()
        t.Hide()
        if(not self.sizer.Detach(c)):
            pass
#            print "Could NOT detach %s Behavior Panel from controlWrapper" % bname
        if(not self.sizer.Detach(t)):
            pass
#            print "Could NOT detach %s Target   Panel from controlWrapper" % bname
        self.sizer.Layout()


    def hideAll(self):
        for name, panels in self.panels.iteritems():
            self.hidePanel(name)


    def showEmptyPanel(self):
        c, t = self.panels[behaviorNames.EMPTY]
        self.attach(c, t)
        self.Layout()


            
