#
# @(#) catFirePanel.py 2005/10/16
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Fire panel

Authoring and Execution UI for approach
"""
import wx
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames

class CatFirePanel(wx.Panel):
    """
    Sets up the GUI for changing the parameters of approach.
    """
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = "MAPPROACH", entity = None, behavior=None):
        """
        Creates the new panel.
        parentPanel (wx.Panel): Approach, Retreat, and Maintain are mutually
        exclusive. These behaviors are put under one tab and they need this
        parent tab to change its title.
        """
        wx.Panel.__init__(self, parent, panelID, size = size, style = wx.RAISED_BORDER| wx.DOUBLE_BORDER)
        self.entity  = entity
        self.behavior = behavior
        x, y = size

        # print "FirePanel Being created for " + entity.getEVAPath()

        self.EXCLUSION_LIST = ()
            
        self.behaviorType = behaviorType # get rid of this : Sushil
        self.bname = behaviorType
        self.SetBackgroundColour(parent.GetBackgroundColour())
        self.parentPanel = parent
        self.sizer = wx.BoxSizer(wx.VERTICAL)

        self.statusMessage = wx.StaticText(self, -1, self.behaviorType, size = (200, -1))
        self.sizer.Add(self.statusMessage, 0, wx.ALIGN_LEFT)
        self.sizer.Add(wx.BoxSizer(), 1, flag=wx.EXPAND)
        
	
	self.startStopButton = wx.Button(self, -1, "Start", style=wx.BU_EXACTFIT)
	#self.startStopButton.SetSize(wx.Size(self.startStopButton.GetDefaultSize().GetWidth()-5, self.startStopButton.GetDefaultSize().GetHeight()-5))
	self.startStopButtonState = "start"
        wx.EVT_BUTTON(self.startStopButton, -1, self.OnClick)
	
	
	self.sizer.Add(self.startStopButton, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
	spacerX =wx.StaticText(self, -1, "", size=(195,5), style=wx.ALIGN_RIGHT)
	self.sizer.Add(spacerX)
	
	notifLabel = wx.StaticText (self, -1," Status: ")
	self.notifMsg = wx.StaticText (self, -1, "", size = (100, 20), style = wx.TE_READONLY | wx.TE_LEFT)
	space = 2
	notifSizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	notifSizer.AddMany ([notifLabel, self.notifMsg])
	self.sizer.Add(notifSizer)

	self.SetSizer(self.sizer)
        nEventServer.register(EventNames.CAT_PAGE_CHANGED, self.handlePageChange)

#         from common import tickmanager
#         tickmanager.register( 'CatFirePanel', self.Tick ) # should receive and send info every second
    
 
        
    def OnClick(self, event):
        """
        Called when the activate button is pressed.
        Turns off other behaviors and changes the parent tab's name.
        """
#        print "Fire panel size: ", str(self.GetSize())
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print "Fire: I am on a time out due to bad behavior"

    def handlePageChange(self, msg):
        self.startStopButton.SetLabel(self.behavior.getParams()['startStop'])
        
    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)
#         if(self.maneuverValueSlider):
#             val = self.behavior.GetVar('maneuverValue')
#             print "Maneuver Val: " + str(val)
#             self.maneuverValueSlider.SetValue(val)
        

    def updatePanels(self):
#        print "Handling Page change in " + self.behavior.getName()
        self.SetStartStop()
        #if(self.maneuverValueSlider):
        #    val = self.behavior.GetVar('maneuverValue')
#       #     print "Page Changed: Maneuver Val: " + str(val)
        #    self.maneuverValueSlider.SetValue(val)
        #if(self.bearingSlider):
#       #     print "Changeing bearing slider"
        #    self.bearingSlider.SetValue(self.behavior.GetVar('desiredStBearing'))
        #if(self.rangeSlider):
#       #     print "Changeing range slider"            
        #    self.rangeSlider.SetValue(self.behavior.GetVar('desiredStRange'))
        #if(self.rb):
        #    if(self.behavior.GetVar('absoluteBearing')):
        #        val = 0
        #    else:
        #        val = 1
        #    self.rb.SetSelection(val)
        self.Layout()
        self.Validate()
        self.Show()
