#
# @(#) catMovesToPanel 2005/10/17
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

"""
Cat Moves To panel

Authoring and Execution UI for approach
"""
import wx
import catSelectorPanel
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames
from cat.Behaviors import catPrimitiveApproach as mapp

class CatMovesToPanel(catSelectorPanel.CatSelectorPanel):
    """
    Sets up the GUI for changing the parameters of approach.
    """
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = None, entity = None, behavior = None):
         
        catSelectorPanel.CatSelectorPanel.__init__(self, parent, panelID, color, size, behaviorType, entity, behavior)
  	
        desiredXLabel = wx.StaticText (self, -1," Move Coord X:    ")
        self.desiredX = wx.TextCtrl (self, -1, " ", size = (70, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
        desiredYLabel = wx.StaticText (self, -1," Move Coord Y:    ")
        self.desiredY = wx.TextCtrl (self, -1, " ", size = (70, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
        spacerE = wx.StaticText(self, -1, "", size= (180,   15), style = wx.ALIGN_RIGHT)
        self.sizer.Add(spacerE)
        space = 2
        desiredCoordSizer = wx.FlexGridSizer (rows = 2, cols = 2, hgap = space, vgap = space)
        desiredCoordSizer.AddMany ([desiredXLabel, self.desiredX, desiredYLabel, self.desiredY])
        self.sizer.Add(desiredCoordSizer)
        
	spacerX =wx.StaticText(self, -1, "", size=(180,30), style=wx.ALIGN_LEFT)
	self.sizer.Add(spacerX)
	
	self.startStopButton = wx.Button(self, -1, "Start", style=wx.BU_EXACTFIT)
	self.startStopButtonState = "start"
        
	wx.EVT_BUTTON(self.startStopButton, -1, self.OnClick)
	wx.EVT_SET_FOCUS(self, self.handleEvent)
	
	self.sizer.Add(self.startStopButton, 0, wx.ALIGN_CENTER|wx.ALIGN_BOTTOM)
	spacerY =wx.StaticText(self, -1, "", size=(180,10), style=wx.ALIGN_LEFT)
	self.sizer.Add(spacerY)	

    def WriteNotifMsg(self, msg):
        #self.notifMsg.SetLabel (msg)
        print str(msg)
	
#
    def OnClick(self, event):
        """
        Called when the activate button is pressed.
        Turns off other behaviors and changes the parent tab's name.
        """
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print "Move To Type: I am on a time out due to bad behavior"

    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)
#         if(self.maneuverValueSlider):
#             val = self.behavior.GetVar('maneuverValue')
#             print "Maneuver Val: " + str(val)
#             self.maneuverValueSlider.SetValue(val)
        
    def updatePanels(self):
 #       print "Handling Page change in " + self.behavior.getName()
        self.SetStartStop()
        if(self.maneuverTypeList):
            mtype = self.behavior.GetVar('maneuverType')
            if(mtype == mapp.SPEED_CONST_MANEUVER):
                self.maneuverTypeList.SetValue('Maintain speed')
            elif(mtype == mapp.TIME_CONST_MANEUVER):
                self.maneuverTypeList.SetValue('Maintain time')

        if(self.maneuverValueSlider):
            val = self.behavior.GetVar('maneuverValue')
#            print "Page Changed: Maneuver Val: " + str(val)
            self.maneuverValueSlider.SetValue(val)
	self.Layout()
        self.Validate()
        self.Show()

    def handleEvent(self, event):
#        print "Handling window focus Event"
        self.updatePanels()

    def handlePageChange(self, msg):
        self.updatePanels()
