#
# @(#) catRecordWrapper.py 2005/11/11
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


import wx
import catRecordPanel

class CatRecordWrapper(wx.Panel):
    def __init__(self, parent, color=None, size=None, entity=None, recorder=None):
	    
        wx.Panel.__init__(self, parent, -1, size = size)
        self.SetBackgroundColour(color)
	
	self.sizer = wx.BoxSizer(wx.HORIZONTAL)
	self.SetSizer(self.sizer)
	self.entity = entity
        self.recorder = recorder
        # print "catRecordWrapper: Color: " + str(color)
	self.defaultPanel = catRecordPanel.CatRecordPanel (self, -1, size = size, color=color, entity = entity, recorder=recorder)
        self.defaultPanel.SetBackgroundColour(color)
	self.sizer.Add(self.defaultPanel, 1, flag=wx.EXPAND)
	
	self.panels = {}
	self.panels['default'] = self.defaultPanel
	self.showPanel('default')

    #def updateNets(self):
    #    self.defaultPanel.loadNetworks([])
	
    def show(self, name, passthru = {}):
        #print "In recorder wrapper:  ", str(name)
        found = False
        #        self.panels[name].show(passthru)
        for panelName, panel in self.panels.iteritems():
            if panelName != name:
                panel.Hide()
            else:
                panel.show(passthru)
                found = True
        self.sizer.Layout()
            
    def showPanel(self, name):
        #print "In recorder wrapper:  ", str(name)
        self.hideAll()
        if(self.panels.has_key(name)):
            panel = self.panels[name]
            panel.Show()
            self.sizer.Layout()
            
    def hideAll(self):
        for panelName, panel in self.panels.iteritems():
            panel.Hide()
	    self.sizer.Layout()
    
    def addPanel(self, panel, name):
	    panel.Hide()
	    self.sizer.Add(panel, 1, flag=wx.EXPAND)
	    self.panels[name] = panel
	    self.sizer.Layout()
    
    def showEvent(self, event):
	name = event.GetEventObject().GetName()
	self.showPanel(name)

           
    def hide(self):
        for panelName, panel in self.panels.iteritems():
            panel.Hide()
	    self.sizer.Layout()

    def updateRecordPanel(self, cname):
        self.defaultPanel.updatePanel(cname)
