#
# @(#) catSaveRecordPanel.py 2005/11/11
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#
'''
Defines the GUI and its operations for cat.

'''
import wx
from cat.merge import xmlmerger

from savedialog import SaveDialog

class SavePanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''

    ID_PAUSE = 102
    ID_SAVE = 103
    ID_RECORD = 104
    ID_STOP = 105
    ID_PLAY = 106
    ID_START = 107
    ID_QUERY = 108

    def __init__(self, parent, panelID, color = "RED", size=None, recType = "Save_recorded", recorder = None):
        
        wx.Panel.__init__(self, parent, -1, size=size, style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
       
	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)
        self.recorder = recorder

	labelSave = wx.StaticText(self, -1, "SAVE RECORDED ... ")
	
	labelMsg = wx.StaticText(self, -1, " Please specify: ")
	 
	l1 	= wx.StaticText (self, -1," Network name: ")
	self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	l2 	= wx.StaticText (self, -1," File name:     ")
	self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
	self.saveCancelButton = wx.Button(self, -1, "Cancel", style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.saveCancelButton, -1, self.onCancel)

	self.saveOKButton = wx.Button(self, -1, "  OK  ", style=wx.BU_EXACTFIT)
		
	wx.EVT_BUTTON(self.saveOKButton, -1, self.onOK)

	space 	= 2
	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, self.t1, l2, self.t2, self.saveCancelButton, self.saveOKButton])
	
	
	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (212, 2), style = wx.ALIGN_RIGHT)
    
	sizerSave = wx.BoxSizer(wx.VERTICAL)
	sizerSave.Add(labelSave)
	sizerSave.Add(spacer1)	
	sizerSave.Add(labelMsg)
	sizerSave.Add(spacer2)	
	sizerSave.Add(sizer)
	sizerSave.Add(spacer3)
	self.SetSizer(sizerSave)

    def getPanel(self):
        return self

    def check(self):
        filename = self.t2.GetValue().strip()
        netname  = self.t1.GetValue().strip()
        if not filename.endswith('.bn'):
            filename = filename + '.bn'
        if self.recorder.getNetSpecDict().has_key(netname): #filename):
            self.GetParent().show('File_exists')
        elif not filename or not netname or filename == '' or netname == '':
            self.GetParent().show('Empty_fields')
        else:
            returnData = {}
            returnData['state'] = 'ok'
            returnData['filename'] = self.t2.GetValue()
            returnData['netname'] = self.t1.GetValue()
            self.GetParent().show('default', returnData)
        
    def show(self, data={}):
        self.Show()
        if data.get('state') == 'save':
            self.networks = data['networks']
            self.t1.SetValue('')
            self.t2.SetValue('')
        elif data.get('state') == 'yes':
            returnData = {}
            returnData['state'] = 'ok'
            returnData['filename'] = self.t2.GetValue()
            returnData['netname'] = self.t1.GetValue()
            self.GetParent().show('default', returnData)
        elif data.get('state') == 'no':
            pass
        elif data.get('state') == 'ok':
            pass

    def onOK(self, event):
        self.check()

    def onCancel(self, event):
        returnData = {'state':'cancel'}
        self.GetParent().show('default', returnData)
    
class ExistsPanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists", recorder = None):
        
        wx.Panel.__init__(self, parent, -1, (212,210), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)
        self.recorder = recorder

	labelExists = wx.StaticText(self, -1, "NETWORK FILE ALREADY EXISTS! \n Overwrite existing file?", size = (200, 50), style = wx.ALIGN_CENTER)
	
	#labelMsg = wx.StaticText(self, -1, " Please specify: ")
	 
	l1 	= wx.StaticText (self, -1,"              ")
	#self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	l2 	= wx.StaticText (self, -1,"              ")
	#self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
	self.existsNoButton = wx.Button(self, -1, "  No  ", style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.existsNoButton, -1, self.OnNoClick)

	self.existsYesButton = wx.Button(self, -1, " Yes ", style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.existsYesButton, -1, self.OnYesClick)
	
	space 	= 2
	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, l2, self.existsNoButton, self.existsYesButton])
	
	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (212, 10), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
    
	sizerExists = wx.BoxSizer(wx.VERTICAL)
	sizerExists.Add(spacer1)	
	sizerExists.Add(labelExists)
	sizerExists.Add(sizer, flag = wx.ALIGN_CENTER)
	sizerExists.Add(spacer2)
	self.SetSizer(sizerExists)

    def getPanel(self):
        return self
    
    def OnNoClick(self, event):
        self.GetParent().show("Save_recorded", {'state':'no'})
	
    def OnYesClick(self, event):
	self.GetParent().show("Save_recorded", {'state':'yes'})

    def show(self, data={}):
        self.Show()

class EmptyFieldsPanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists", recorder = None):
        
        wx.Panel.__init__(self, parent, -1, (212,210), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)
        self.recorder = recorder

	labelEmptyFields = wx.StaticText(self, -1, "INCOMPLETE INFORMATION: Empty Field(s) \n Please provide names for network and file", size = (200, 70), style = wx.ALIGN_CENTER)
	
	self.emptyOKButton = wx.Button(self, -1, "  OK  ", style=wx.ALIGN_CENTER|wx.BU_EXACTFIT|wx.EXPAND)
	wx.EVT_BUTTON(self.emptyOKButton, -1, self.OnEmptyOKClick)
	
	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (212, 6), style = wx.ALIGN_RIGHT)
    
	sizerEmptyFields = wx.BoxSizer(wx.VERTICAL)
	sizerEmptyFields.Add (spacer1)	
	sizerEmptyFields.Add(labelEmptyFields)
	sizerEmptyFields.Add(spacer2)
	sizerEmptyFields.Add(self.emptyOKButton, flag = wx.ALIGN_CENTER)
	sizerEmptyFields.Add(spacer3)
	self.SetSizer(sizerEmptyFields)

    def getPanel(self):
        return self

    def OnEmptyOKClick(self, event):
	self.GetParent().show("Save_recorded", {'state':'ok'})

    def show(self, data={}):
        self.Show()

class DeletePanel(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
  
    def __init__(self, parent, panelID, color = "ORANGE", size=(212, 210), recType = "File_exists", recorder = None):
        
        wx.Panel.__init__(self, parent, -1, (212,210), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
       
	self.bgcolor = "ORANGE"
        self.SetBackgroundColour(self.bgcolor)
        self.recorder = recorder

	labelExists = wx.StaticText(self, -1, "DELETING FILE! \n Are you sure you want to delete?", size = (200, 50), style = wx.ALIGN_CENTER)
	
	#labelMsg = wx.StaticText(self, -1, " Please specify: ")
	 
	l1 	= wx.StaticText (self, -1,"              ")
	#self.t1 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	l2 	= wx.StaticText (self, -1,"              ")
	#self.t2 = wx.TextCtrl (self, -1, " ", size = (110, 20), style = wx.TE_LEFT)
	
	self.existsNoButton = wx.Button(self, -1, "  No  ", style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.existsNoButton, -1, self.OnNoClick)

	self.existsYesButton = wx.Button(self, -1, " Yes ", style=wx.BU_EXACTFIT)
	
	wx.EVT_BUTTON(self.existsYesButton, -1, self.OnYesClick)
	
	space 	= 2
	sizer 	= wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, l2, self.existsNoButton, self.existsYesButton])
	
	spacer1 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (212, 10), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (212, 3), style = wx.ALIGN_RIGHT)
    
	sizerExists = wx.BoxSizer(wx.VERTICAL)
	sizerExists.Add(spacer1)	
	sizerExists.Add(labelExists)
	sizerExists.Add(sizer, flag = wx.ALIGN_CENTER)
	sizerExists.Add(spacer2)
	self.SetSizer(sizerExists)

    def getPanel(self):
        return self
    
    def OnNoClick(self, event):
        self.GetParent().show("default", {'state':'no'})
	
    def OnYesClick(self, event):
	self.GetParent().show("default", {'state':'yes'})

    def show(self, data={}):
        self.Show()


    
    
	
