#
# @(#) catRecordWrapper.py 2005/11/11
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


import wx
import catRecordPanel

AUTH=0
EXEC=1

class CatSwitchRecordWrapper(wx.Panel):
    '''
    Wrapper to switch between authoring and execution recorder panels.
    '''
    def __init__(self, parent, color="CYAN", size=None, entity = None, authRec=None, execRec=None):
	    
        wx.Panel.__init__(self, parent, -1, size = size)
	self.sizer = wx.BoxSizer(wx.HORIZONTAL)
	self.SetSizer(self.sizer)

	self.entity = entity
	
    def show(self, name):
        '''
        Displays last active recorder panel.
        '''
        if name.startswith("Auth"):
                self.authRec.Show()
                self.execRec.Hide()
                self.active=AUTH
        else:
                self.authRec.Hide()
                self.execRec.Show()
                self.active=EXEC

        self.sizer.Layout()
            
    def showPanel(self, name):
        '''
        Shows the panel.
        '''
        self.hideAll()
        if self.active == AUTH:
                self.authRec.Show()
        else:
                self.execRec.Show()
        self.sizer.Layout()

    def add(self, object, name):
        '''
        Adds the recorder to the panel.
        '''
        self.sizer.Add(object,0)
        if name.startswith("Auth"):
            self.authRec=object
        else:
            self.execRec=object
                
        self.sizer.Layout()
            
    def hideAll(self):
        '''
        Hides auth/exec recorders.
        '''
        self.execRec.Hide()
        self.authRec.Hide()
        self.sizer.Layout()
