from sensors import *
from common.defs import *
import math

class EntityDistanceSensor(Sensors):

    def __init__(self,own=guiSensors.GetOwnEntity(),other = guiSensors.GetTargetEntity(), range=100, calculateDistance = True):
        """
        Creates a new EntityDistance object
        """
        Sensors.__init__(self,own,None)
        self.toEntity = other
        self.fromEntity = own
        self.range = range
        self.parameters = []
        self.calculateDistance = calculateDistance
        if self.calculateDistance:
            self.parameters.append({'name':'From','type':'ent'})
            self.parameters.append({'name':'To','type':'ent'})
        else:
            self.parameters.append({'name':'From','type':'ent'})
            self.parameters.append({'name':'Range','type':'int'})
        self.entsInRange = []

    def setParameters(self,valueList):
        for i in range(len(self.parameters)):
            if self.parameters[i]['name'] == 'From':
                self.fromEntity = str(valueList[i])
            elif self.parameters[i]['name'] == 'To':
                self.toEntity = str(valueList[i])
            elif self.parameters[i]['name'] == 'Range':
                self.range = int(valueList[i])
    def getTriggerState(self):
        outgoingParams = self.parameters
        
        for param in outgoingParams:
            if param['name']=='From':
                param['value']=self.fromEntity
            elif param['name']=='To':
                param['value']=self.toEntity
            elif param['name']=='Range':
                param['value']=int(self.range)

        sensorInfo = {}
        sensorInfo['value'] = self.getValue()
        if self.calculateDistance:
            sensorInfo['type'] = 'float'
            sensorInfo['sensorType'] = 'Distance Between Entities'
        else:
            sensorInfo['type'] = 'entlist'
            sensorInfo['sensorType'] = 'Entities in Range'

        return (sensorInfo,outgoingParams)

            
        
    def Tick(self,time,dtime):
        if self.calculateDistance:
            return self.getDistance()
        else:
            shortlist = []
            list = self.getEntsInRange()
            for ent in list:
                sel(ent)
                shortlist.append(getname())
            return shortlist
    def getValue(self):
        if self.calculateDistance:
            return self.getDistance()
        else:
            return self.getEntsInRange()
        
    def getDistance(self,toEntity=None,fromEntity=None):
        try:
            if toEntity == None:
                toEntity = self.toEntity
            if fromEntity == None:
                fromEntity = self.fromEntity
            if not exists(toEntity) or not exists(fromEntity):
                return 0
            
            sel(toEntity)
            #sel('/game/ents/cigarette/cigarette0')
            ox,oz,oy = gv('pos')
            #sel('/game/ents/ddg51/ddg510')
            sel(fromEntity)
            tx,tz,ty = gv('pos')

            dist = math.sqrt((ox-tx)**2 + (oy-ty)**2)
            self.range = dist
            return dist
        except:
            printExcept('EntityDistanceSensor')
            return 0

    def getEntsInRange(self,range=None,fromEntity=None):
        try:
            self.entsInRange = []
            if range == None:
                range = self.range
            if fromEntity == None:
                fromEntity = self.fromEntity
            if not exists(fromEntity):
                return []
            sel(fromEntity)
            ox,oz,oy = gv('pos')
            sel('/game/ents')
            dir = ndir()
            for subdir in dir:
                sel('/game/ents/'+subdir)
                dir2 = ndir()
                for subdir2 in dir2:
                    sel('/game/ents/'+subdir+'/'+subdir2)
                    if getfullname() == fromEntity or not getselectable():
                        pass
                    else:
                        tx,tz,ty = gv('pos')
                        dist = math.sqrt((ox-tx)**2 + (oy-ty)**2)
                        if dist <= range:
                            self.entsInRange.append(getfullname())
            return self.entsInRange
        except:
            printExcept('EntityDistanceSensor')
            return []
        
