#
# @(#) approachPanelA.py 2005/09/27
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Approach panel

Authoring and Execution UI for approach
"""
import wx
#from primitivebehavior import *
from common.defs import *
#from cat.entity import behaviorset
from common.log import Log
log = Log(tags=['all', 'cat'])

#EXCLUSION_LIST = ("RETREAT", "MOVETO", "MAINTAIN")

## from cat.Behaviors.mapproach import MApproach
## MApproach.SPEED_CONST_MANEUVER

## if EntityManager.currentState:
##     beh = EntityManager.currentState.bset.getList("MAPPROACH")[0]
##     beh.SPEED_CONST_MANEUVER
from cat.entity import EntityManager

from cat.Behaviors import mapproach as mapp
import nEventServer
from common import EventNames

class ApproachPanel(wx.Panel):
    """
    Sets up the GUI for changing the parameters of approach.
    """
    def __init__(self, parent, panelID, color, defaultSize, behaviorType = "MAPPROACH"):
        """
        Creates the new panel.
        parentPanel (wx.Panel): Approach, Retreat, and Maintain are mutually
        exclusive. These behaviors are put under one tab and they need this
        parent tab to change its title.
        """
        wx.Panel.__init__(self, parent, panelID, size = defaultSize, style = wx.RAISED_BORDER| wx.DOUBLE_BORDER)

        from common import behaviorNames
        if(behaviorType == "MAINTAIN STATION"):
            self.EXCLUSION_LIST = ("RAM SHIP", "MOVETO", behaviorNames.APPROACH )
        elif behaviorType == "RAM SHIP":
            self.EXCLUSION_LIST = ("MAINTAIN STATION","MOVETO", behaviorNames.APPROACH)
        elif behaviorType == "MOVETO":
            self.EXCLUSION_LIST = ("MAINTAIN STATION", "RAM SHIP", behaviorNames.APPROACH)
        elif behaviorType.startswith(behaviorNames.APPROACH):
            self.EXCLUSION_LIST = ("MAINTAIN STATION", "RAM SHIP", "MOVETO")
        else:
            print "Unknown behavior Type: ", behaviorType
            
        #EXCLUSION_LIST = ("RETREAT", "MOVETO", "MAINTAIN")
   
#        self.behaviorName = bn
#       sushil
        self.behaviorType = behaviorType
        self.SetBackgroundColour(color)
        self.parentPanel = parent
        self.sizer = wx.BoxSizer(wx.VERTICAL)

        self.statusMessage = wx.StaticText(self, -1, self.behaviorType, size = (200, -1))
        self.sizer.Add(self.statusMessage, 0, wx.ALIGN_LEFT)

        # Initialize maneuver selection combobox
        self.maneuvers = ['Maintain speed', 'Maintain time']
        self.maneuverTypeSelected = False                
        self.maneuverTypeList = wx.ComboBox(self,-1,value=self.maneuvers[0],size=(175,25),choices=self.maneuvers,style=wx.CB_DROPDOWN|wx.CB_READONLY)
        wx.EVT_COMBOBOX(self.maneuverTypeList,-1,self.OnManeuverTypeSelect)
        spacer =wx.StaticText(self, -1, "", size=(195,5), style=wx.ALIGN_RIGHT)
        self.sizer.Add(self.maneuverTypeList)
        self.sizer.Add(spacer)

        # Initialize maneuver slider
	
        #self.sizer.Add(wx.StaticText(self, -1, "Selector"))
	self.selector = wx.StaticText(self, -1, "Selector")
	self.sizer.Add(self.selector)

	self.labelSizer = wx.BoxSizer(wx.HORIZONTAL)
	self.maneuverValueSlider = wx.Slider(self, -1, mapp.DEFAULT_SPEED_MANEUVER, mapp.MIN_SPEED_SLIDER, mapp.MAX_SPEED_SLIDER, style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        self.labelSizer.Add(self.maneuverValueSlider, 1, border=5, flag=wx.RIGHT|wx.EXPAND)
        self.unitsLabel = wx.StaticText(self, -1, 'knots')
        self.labelSizer.Add(self.unitsLabel, flag=wx.ALIGN_BOTTOM)
        wx.EVT_SLIDER(self.maneuverValueSlider, -1, self.OnManeuverValueChange)
        self.sizer.Add(self.labelSizer, 1, flag=wx.EXPAND|wx.RIGHT)
        #self.sizer.Add(wx.StaticText(self, -1, "New station"))

        # Initialize range slider
        
	self.sizer.Add(wx.StaticText(self, -1, "New station range"))
        
        self.labelSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.rangeSlider = wx.Slider(self, -1, mapp.DEFAULT_RANGE_SLIDER, mapp.MIN_RANGE_SLIDER, mapp.MAX_RANGE_SLIDER, style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        self.labelSizer.Add(self.rangeSlider, 1, border=5, flag=wx.RIGHT|wx.EXPAND)
        self.labelSizer.Add(wx.StaticText(self, -1, 'yards'), flag=wx.ALIGN_BOTTOM)
        self.sizer.Add(self.labelSizer, 1, flag=wx.EXPAND)
        wx.EVT_SLIDER(self.rangeSlider, -1, self.OnRangeChange)

        # Initialize bearing slider
        self.sizer.Add(wx.StaticText(self, -1, "New station bearing"))
        self.labelSizer = wx.BoxSizer(wx.HORIZONTAL)
        self.bearingSlider = wx.Slider(self, -1, mapp.DEFAULT_BEARING_SLIDER, mapp.MIN_BEARING_SLIDER, mapp.MAX_BEARING_SLIDER, style=wx.SL_LABELS|wx.SL_HORIZONTAL)
        self.labelSizer.Add(self.bearingSlider, 1, border=5, flag=wx.RIGHT|wx.EXPAND)
        self.labelSizer.Add(wx.StaticText(self, -1, 'degs '), flag=wx.ALIGN_BOTTOM)
        self.sizer.Add(self.labelSizer, 1, flag=wx.EXPAND)
        wx.EVT_SLIDER(self.bearingSlider, -1, self.OnBearingChange)

        
	bearingOptions = ['Absolute', 'Relative']
        bearingSizer = wx.BoxSizer(wx.HORIZONTAL)

        self.rb = wx.RadioBox(
                self, -1, "", wx.DefaultPosition, wx.DefaultSize,
                bearingOptions, 1, wx.RA_SPECIFY_COLS
                )
        
        self.Bind(wx.EVT_RADIOBOX, self.OnEvtRadioBox, self.rb)
        bearingSizer.Add(self.rb, 0)#, wx.ALL, 20)
	
	
	self.startStopButton = wx.Button(self, -1, "Start", style=wx.BU_EXACTFIT)
	#self.startStopButton.SetSize(wx.Size(self.startStopButton.GetDefaultSize().GetWidth()-5, self.startStopButton.GetDefaultSize().GetHeight()-5))
	self.startStopButtonState = "start"
        wx.EVT_BUTTON(self.startStopButton, -1, self.OnClick)
	
	
	spacerY =wx.StaticText(self, -1, "", size=(65, 50), style=wx.ALIGN_BOTTOM)
	bearingSizer.Add(spacerY)
	
	bearingSizer.Add(self.startStopButton, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
        self.sizer.Add(bearingSizer)
	
	spacerX =wx.StaticText(self, -1, "", size=(195,5), style=wx.ALIGN_RIGHT)
	self.sizer.Add(spacerX)
	
	notifLabel = wx.StaticText (self, -1," Status: ")
	self.notifMsg = wx.StaticText (self, -1, "", size = (100, 20), style = wx.TE_READONLY | wx.TE_LEFT)
	space = 2
	notifSizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	notifSizer.AddMany ([notifLabel, self.notifMsg])
	self.sizer.Add(notifSizer)

	self.SetSizer(self.sizer)

        
        nEventServer.register(EventNames.CAT_SELECT_ENT,      self.handleEntSelection)

        from common import tickmanager
        tickmanager.register( 'ApproachPanelB', self.tick ) # should receive and send info every second
    
    def WriteNotifMsg(self, msg):
        #self.notifMsg.SetLabel (msg)
        print str(msg)
	
    def OnEvtRadioBox(self, event):
	behavior = self.getBehavior()
        if(behavior):
	    selection = self.rb.GetSelection()
	    if selection == 0:
	        behavior.SetVar('absoluteBearing', True)
	    else:
		behavior.SetVar('absoluteBearing', False)
		
	print "No behavior in OnEvtRadioBox"
	self.WriteNotifMsg ("no b in EvtRadioBox")
        self.log.WriteText('EvtRadioBox: %d\n' % event.GetInt())
	
    def stop(self):
        print "Stopping panel"
	self.WriteNotifMsg ("Stopping panel")

    def handleEntSelection(self, msg):
        #print 'ApproachPanelA.handleEntSelection', msg
       ##  if msg == None: #we need to unselect
##             self.maneuverValueSlider.SetRange(mapp.MIN_SPEED_SLIDER, mapp.MAX_SPEED_SLIDER)
##             self.maneuverValueSlider.SetValue(mapp.MIN_SPEED_SLIDER)
##             self.rangeSlider.SetValue(mapp.MIN_RANGE_SLIDER)
##             self.bearingSlider.SetValue(mapp.MIN_BEARING_SLIDER)
##             return
             
        behavior = self.getBehavior()
        if behavior:
            if behavior.active:
                self.startStopButtonState = "stop"
                self.startStopButton.SetLabel("Stop")
            else:
                self.startStopButtonState = "start"
                self.startStopButton.SetLabel("Start")
                
            maneuverValue = behavior.GetVar('maneuverValue')
            maneuverType = behavior.GetVar('maneuverType')
            #print "handleEntSelection: maneuverType = ", maneuverType
            self.maneuverTypeList.SetValue(self.maneuvers[maneuverType-1])
            if(maneuverType == mapp.SPEED_CONST_MANEUVER):
                self.maneuverValueSlider.SetRange(mapp.MIN_SPEED_SLIDER, behavior.GetVar('entMaxSpeed'))
                self.maneuverValueSlider.SetValue(behavior.GetVar('maneuverValue'))
                self.unitsLabel.SetLabel('knots')
            #elif(maneuverType == mapp.BEARING_CONST_MANEUVER):
            #    self.maneuverValueSlider.SetRange(mapp.MIN_BEARING_SLIDER, mapp.MAX_BEARING_SLIDER)
            #    self.maneuverValueSlider.SetValue(int(behavior.GetVar('maneuverValue')))
            elif(maneuverType == mapp.TIME_CONST_MANEUVER):
                self.maneuverValueSlider.SetRange(mapp.MIN_TIME_SLIDER, mapp.MAX_TIME_SLIDER)
                self.maneuverValueSlider.SetValue(behavior.GetVar('maneuverValue'))
                self.unitsLabel.SetLabel('min')
            else:
                log.write("Wierd maneuver type obtained, .... don't know what to do")

            rangeSlider = behavior.GetVar('desiredStRange')
            self.rangeSlider.SetValue(rangeSlider)

            bearingSlider = behavior.GetVar('desiredStBearing')
            self.bearingSlider.SetValue(bearingSlider)

            self.OnManeuverValueChange("NoEvent")
            self.OnRangeChange("NoEvent")
            self.OnBearingChange("NoEvent")
            if behavior.GetVar('absoluteBearing'):
                self.rb.SetSelection(0)
            else:
                self.rb.SetSelection(1)
        else:
            print "No behavior in handleEntSelection()"
            self.maneuverValueSlider.SetRange(mapp.MIN_SPEED_SLIDER, mapp.MAX_SPEED_SLIDER)
            self.maneuverValueSlider.SetValue(mapp.MIN_SPEED_SLIDER)
            self.rangeSlider.SetValue(mapp.MIN_RANGE_SLIDER)
            self.bearingSlider.SetValue(mapp.MIN_BEARING_SLIDER)
            self.WriteNotifMsg ("no b in handleEntSel")
	    
    def getMaxSpeed(self):
        sensors = self.getSensors()
        if exists(sensors.GetOwnEntity()):
            sel(sensors.GetOwnEntity())
            if(hasvar('maxSpeed')):
                max = gf('maxSpeed')
            else:
                max = 10
        #print "max speed : " , str(max)
        return max


    def OnManeuverTypeSelect(self, event):
        #print "Maneuver Type selection: ", event
        behavior = self.getBehavior()
        if (not self.maneuverTypeSelected):
            if self.maneuverTypeList.GetValue() != 'Select Type...':
                select = self.maneuverTypeList.GetStringSelection()
                sensors = self.getSensors()
                if select == 'Maintain speed':
                    log.write('Maintain speed maneuver selected')
		    self.selector.SetLabel("Speed")
                    if behavior:
                        behavior.SetVar('maneuverType', mapp.SPEED_CONST_MANEUVER)
                        self.maneuverValueSlider.SetRange(mapp.MIN_SPEED_SLIDER, behavior.GetVar('entMaxSpeed'))
                        self.maneuverValueSlider.SetValue(int(behavior.GetVar('entMaxSpeed')/2))
                    self.unitsLabel.SetLabel('knots')
                    
                #elif select == 'Maintain course':
                #    log.write('Maintain course maneuver selected')
		#    self.selector.SetLabel("Course")
                #    if behavior:
                #        behavior.SetVar('maneuverType', mapp.BEARING_CONST_MANEUVER)
                #        self.maneuverValueSlider.SetRange(mapp.MIN_BEARING_SLIDER, mapp.MAX_BEARING_SLIDER)
                #        self.maneuverValueSlider.SetValue(mapp.DEFAULT_BEARING_MANEUVER)
                #    self.unitsLabel.SetLabel('')
                elif select == 'Maintain time':
                    log.write('Maintain time maneuver selected')
		    self.selector.SetLabel("Time")
                    if behavior:
                        #print "OnManeuverTypeSelect: Time"
                        behavior.SetVar('maneuverType', mapp.TIME_CONST_MANEUVER)
                        self.maneuverValueSlider.SetRange(mapp.MIN_TIME_SLIDER, mapp.MAX_TIME_SLIDER)
                        self.maneuverValueSlider.SetValue(mapp.DEFAULT_TIME_MANEUVER)
                    self.unitsLabel.SetLabel('min')
                self.OnManeuverValueChange(event)
                self.maneuverTypeSelected = True
        else:
            self.maneuverTypeSelected = False
	    self.selector.SetLabel("Selector")
            self.OnManeuverTypeSelect(wx.EVT_COMBOBOX)
        

        
    def OnManeuverValueChange(self, event):
        """
        Called when the maneuver value (time, speed, course) change
        """
        behavior = self.getBehavior()
        if(behavior):
            behavior.SetVar('maneuverChanged', True)
            behavior.SetVar('reachedStation', False)
            behavior.SetVar('maneuverValue', self.maneuverValueSlider.GetValue())
            #print "Maneuver value", self.maneuverValueSlider.GetValue()

        else:
            print "No attached mapproach behavior to maneuver on"
            self.WriteNotifMsg ("no att mappr to maneuver")
        
        
    def OnRangeChange(self, event):
         """
         Called on station range change
         """
#         print "On Range Change: ", event
         behavior = self.getBehavior()
         if(behavior):
             behavior.SetVar('maneuverChanged', True)
             behavior.SetVar('reachedStation', False)
             behavior.SetVar('desiredStRange', self.rangeSlider.GetValue())            
             
         else:
             print "No attached behavior to range change"
             self.WriteNotifMsg ("no att b to range chg")
             
    def OnBearingChange(self, event):
         """
         Called on station bearing change
         """
#         print "On station bearing Change: ", event
         behavior = self.getBehavior()
         if(behavior):
             behavior.SetVar('maneuverChanged', True)
             behavior.SetVar('reachedStation', False)
             behavior.SetVar('desiredStBearing', self.bearingSlider.GetValue())
         else:
             print "No attached behavior to bearing change"
	     self.WriteNotifMsg ("no att b to bearing chg")
             

    def tick(self, time, dtime):
        """
        Runs Approach, gets the actuator values, and passes them up to the GUI
        for fusion.
        """
        #behavior = self.getBehavior()
        #sensors = self.getSensors()
        #if((not behavior) or (not sensors)):
        #    return
        #if exists(sensors.GetOwnEntity()) and exists(sensors.GetTargetEntity()):
        #    sel(sensors.GetOwnEntity())
        #    max = gf('maxSpeed')
#            ox, oz, oy = gv('pos')
#            sel(sensors.GetTargetEntity())
#            tx, tz, ty = gv('pos')
#            dist = math.sqrt((ox-tx)**2 + (oy-ty)**2)
            #self.beh.SetVar('range', dist)
            #self.speedSlider.SetRange(0, int(max*100))
            #behavior.SetVar('desiredStBearing', self.bearingSlider.GetValue())
            #behavior.SetVar('desiredStRange', self.rangeSlider.GetValue())
            #behavior.SetVar('maneuverValue', self.maneuverValueSlider.GetValue())
#            return behavior.Tick(time, dtime)
        
    def OnClick(self, event):
        """
        Called when the activate button is pressed.
        
        Turns off other behaviors and changes the parent tab's name.
        """
        if (self.startStopButtonState == "start"):
            self.handleStart(event)
	    self.WriteNotifMsg ("active")
        else:
            self.handleStop(event)
	    self.WriteNotifMsg ("inactive")

    def handleStart(self, event):
        self.startStopButtonState = "stop"
        self.startStopButton.SetLabel("Stop")
        print "Handle start:" , event
        behavior = self.getBehavior()
        if(behavior):
            import nEventServer
            from common import EventNames
            nEventServer.pull(EventNames.CAT_EXCLUSION_EVENT, self.getSensors().GetOwnEntity() + ' ' + str(self.EXCLUSION_LIST))
            behavior.SetVar('activated', True)
            behavior.activate()
        else:
            print "No current behavior selected"
            self.WriteNotifMsg ("no curr beh sel")
             
    def getBehavior(self):
        if(EntityManager.currentState):
            entity = EntityManager.currentState.entity
            entityState = EntityManager.currentState
            behaviorList = entityState.bset.getList(self.behaviorType)
            #kludge because we do not yet handle multiple behaviors running simultaneously
            behavior = behaviorList[0]
            return behavior
        else:
            return None
        
    def getSensors(self):
        if(EntityManager.currentState):
            sensors = EntityManager.currentState.getSensors()
            return sensors
        else:
            return None
        
    def handleStop(self, event):
        print "handling stop"
        self.startStopButtonState = "start"
        self.startStopButton.SetLabel("Start")
        behavior = self.getBehavior()
        if(behavior):
            behavior.deActivate()
        else:
            print "No behavior to DeActivate"
            self.WriteNotifMsg ("no beh to deactivate")
             
