#
# @(#) catAvoidEntityPanel.py 2005/10/25
# @author AO and SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Avoid Entity Panel
Authoring and Execution UI for Avoid Entity
"""
import wx
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'cat'])

import nEventServer
from common import EventNames

MAX_RANGE_SLIDER = 20000

class CatAvoidEntityPanel(wx.Panel):
    def __init__(self, parent, panelID, color="CYAN", size=None, behaviorType = None, entity = None, behavior=None):    
        wx.Panel.__init__(self, parent, panelID, size=size, style=wx.RAISED_BORDER|wx.DOUBLE_BORDER)

        self.bname = behaviorType        
        self.SetBackgroundColour(color)
        self.parentPanel = parent
        self.entity = entity
        self.behavior = behavior
        
#        nEventServer.register(EventNames.CAT_SELECT_ENT,      self.handleEntSelection)
        #self.testSensor = RelativePositionSensor('/game/ents/cigarette/cigarette0')

        newSizer = wx.BoxSizer(wx.VERTICAL)
        self.statusMessage = wx.StaticText(self,-1,self.bname)
        newSizer.Add(self.statusMessage,0,wx.ALIGN_LEFT)
        
##         panicSizer = wx.BoxSizer(wx.HORIZONTAL)

##         effectiveSizer = wx.BoxSizer(wx.HORIZONTAL)

##         speedSizer = wx.BoxSizer(wx.HORIZONTAL)

        
##         #self.sizer.Add(newSizer,1,border = 10,flag=wx.ALL|wx.EXPAND)
##         self.panicSlider = wx.Slider(self,-1,100,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
##         self.effectiveSlider = wx.Slider(self,-1,150,0,MAX_RANGE_SLIDER,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
##         self.speedSlider = wx.Slider(self,-1,0,0,0,style=wx.SL_LABELS|wx.SL_HORIZONTAL)
##         wx.EVT_SLIDER(self.panicSlider,-1,self.OnPanicChange)
##         wx.EVT_SLIDER(self.effectiveSlider,-1,self.OnEffectiveChange)
##         wx.EVT_SLIDER(self.speedSlider,-1,self.OnSpeedChange)

##         newSizer.Add(wx.StaticText(self,-1,"Panic Range"))
##         panicSizer.Add(self.panicSlider, 1, border=5,flag=wx.RIGHT|wx.EXPAND)
##         panicSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
##         newSizer.Add(panicSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)        
##         newSizer.Add(wx.StaticText(self,-1,"Effective Range"))
##         effectiveSizer.Add(self.effectiveSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
##         effectiveSizer.Add(wx.StaticText(self, -1, "yards"), flag=wx.ALIGN_BOTTOM)
##         newSizer.Add(effectiveSizer, 0, border=10,flag=wx.BOTTOM|wx.EXPAND)
##         newSizer.Add(wx.StaticText(self,-1,"Speed"))
##         speedSizer.Add(self.speedSlider,1,border=5,flag=wx.RIGHT|wx.EXPAND)
##         speedSizer.Add(wx.StaticText(self, -1, "knots"), flag=wx.ALIGN_BOTTOM)        
##         newSizer.Add(speedSizer, 0 ,border=10,flag=wx.BOTTOM|wx.EXPAND)
        
        self.startStopButton = wx.Button(self,-1,'Start', style=wx.BU_EXACTFIT)
        self.startStopButtonState = 'start'
        wx.EVT_BUTTON(self.startStopButton,-1,self.OnClick)
        emptySizer = wx.BoxSizer()
        newSizer.Add(emptySizer, 1, flag=wx.EXPAND)
        newSizer.Add(self.startStopButton, 0 , flag=wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
        self.SetSizer(newSizer)
        self.EXCLUSION_LIST = ()

        pushsel(self.entity.getEVAPath())
        #self.speedSlider.SetValue(gf('maxSpeed')/2.0)
        popsel()
        
        #        from common import tickmanager
        #        tickmanager.register('AvoidEntity', self.Tick)

##     def OnPanicChange(self,event):
##         self.behavior.SetVar('panicRange',self.panicSlider.GetValue())
##         #         behavior = self.getBehavior()
##         #         if(behavior):
##         #             behavior.SetVar('panicRange',self.panicSlider.GetValue())

##     def OnEffectiveChange(self,event):
##         self.behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())        
## #         behavior = self.getBehavior()
## #         if(behavior):
## #             behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())

##     def OnSpeedChange(self,event):
##         self.behavior.SetVar('Speed',self.speedSlider.GetValue())        
## #         behavior = self.getBehavior()
## #         if(behavior):
## #             behavior.SetVar('Speed',self.speedSlider.GetValue())

                   
    def OnClick(self,event):
        if(self.behavior):
            self.behavior.handleStateSwitch()
            self.startStopButton.SetLabel(self.behavior.startStop)
        else:
            print "I am on a time out due to bad behavior"
#         if(self.startStopButtonState == 'start'):
#             self.handleStart(event)
#         else:
#             self.handleStop(event)

    def handlePageChange(self, msg):
        self.startStopButton.SetLabel(self.behavior.startStop)
        

    def SetStartStop(self):
        self.startStopButton.SetLabel(self.behavior.startStop)

    def updatePanels(self):
 #       print "Handling Page change in " + self.behavior.getName()
        self.SetStartStop()
        self.Layout()
        self.Validate()
        self.Show()

        
#     def handleStart(self,event):
#         self.startStopButtonState = 'stop'
#         self.startStopButton.SetLabel("Stop")
#         behavior = self.getBehavior()
#         if(behavior):
#             import nEventServer
#             from common import EventNames
#             nEventServer.pull(EventNames.CAT_EXCLUSION_EVENT,self.getSensors().GetOwnEntity() + ' '+str(self.EXCLUSION_LIST))
#             behavior.SetVar('panicRange',self.panicSlider.GetValue())
#             behavior.SetVar('effectiveRange',self.effectiveSlider.GetValue())
#             behavior.SetVar('Speed',self.speedSlider.GetValue())
#             behavior.activate()
#         else:
#             print "no current behavior selected"

#     def getBehavior(self):
#         from cat.entity import EntityManager
#         if(EntityManager.currentState):
#             entity = EntityManager.currentState.entity
#             entityState = EntityManager.currentState
#             behaviorList = entityState.bset.getList(self.bname)
#             behavior = behaviorList[0]
#             return behavior

#     def handleStop(self,event):
#         self.startStopButtonState = 'start'
#         self.startStopButton.SetLabel("Start")
#         behavior = self.getBehavior()
#         if(behavior):
#             behavior.deActivate()
#         else:
#             print "no behavior to deactivate"

#     def getSensors(self):
#         from cat.entity import EntityManager
#         if(EntityManager.currentState):
#             sensors = EntityManager.currentState.getSensors()
#             return sensors
#         else:
#             return None
        
#     def Tick(self,time,dtime):
#         #print "in avoidentitypanel tick"
#         if EntityManager.currentState:
#             if exists(EntityManager.currentState.sensors.GetOwnEntity()):
#                 try:
#                     sel(EntityManager.currentState.sensors.GetOwnEntity())
#                     max = gf('maxSpeed')
#                     self.speedSlider.SetRange(0,max)
#                 except:
#                     printExcept('cat:AvoidEntityPanel')
#             #beh = EntityManager.currentState.bset.getList(type)[0]
#             #print 'slider says speed is',self.speedSlider.GetValue()
#             #beh.SetVar('Speed',self.speedSlider.GetValue()/100.0)
#             #print 'just set speed var to',beh.GetVar('Speed')
#             #beh.SetVar('panicRange',self.panicSlider.GetValue())
#             #beh.SetVar('effectiveRange',self.effectiveSlider.GetValue())

#     def handleEntSelection(self, msg):
#         if EntityManager.currentState:
#             if exists(EntityManager.currentState.sensors.GetOwnEntity()):
#                 try:
#                     sel(EntityManager.currentState.sensors.GetOwnEntity())
#                     max = gf('maxSpeed')
#                     self.speedSlider.SetRange(0,max)
#                 except:
#                     printExcept('cat:AvoidEntityPanel')
#             beh = EntityManager.currentState.bset.getList(type)[0]
#             self.speedSlider.SetValue(beh.GetVar('Speed'))
#             self.panicSlider.SetValue(beh.GetVar('panicRange'))
#             self.effectiveSlider.SetValue(beh.GetVar('effectiveRange'))
#             if beh.isActive():
#                 self.startStopButtonState = 'stop'
#                 self.startStopButton.SetLabel('Stop')
#             else:
#                 self.startStopButtonState = 'start'
#                 self.startStopButton.SetLabel('Start')
  
"""
def printEnts(dirStr,numLvls):
    entlist = []
    sel(dirStr)
    dir = ndir()
    for subdir in dir:
        sel(dirStr+subdir+'/')
        dir = ndir()
        entlist+=dir
    return entlist
"""
