import wx
from cat.entity import EntityManager
	
class ControlWrapper(wx.Panel):
    def __init__(self, parent, id, color):
	    
        wx.Panel.__init__(self, parent, id)
	
	self.sizer = wx.BoxSizer(wx.VERTICAL)
	self.SetSizer(self.sizer)
	
	self.emptyPanel = wx.Panel(self, -1, size=(195, 305)) #size=(195, 250))
	self.emptyPanel.SetBackgroundColour(self.GetParent().GetBackgroundColour())
	
	self.sizer.Add(self.emptyPanel, 1, flag=wx.EXPAND)
	
	self.panels = {}
	self.panels['empty'] = self.emptyPanel
	self.show('empty')
	
    def show(self, name):
        #print "In control wrapper:", name, self.panels.keys()
        found = False
        for panelName, panel in self.panels.iteritems():
            if panelName != name:
                panel.Hide()
            else:
                #print panel
                panel.Show()
                found = True
        #assert found == True, 'ControlWrapper -- no panel %s to show' % name
        self.sizer.Layout()
            
    def hide(self):
        for panelName, panel in self.panels.iteritems():
            if panelName != 'empty':
		panel.Hide()
	    else:
	       self.show('empty')
	self.sizer.Layout()
    
    def addPanel(self, panel, name):
	    panel.Hide()
	    self.sizer.Add(panel, 1, flag=wx.EXPAND)
	    self.panels[name] = panel
	    self.sizer.Layout()
    
    def showEvent(self, event):
	name = event.GetEventObject().GetName()
	if name == "stop_all":
	    for panelName, panel in self.panels.iteritems():
                panel.Hide()
                if panelName == 'empty':
		    panel.Show()
		else:
		    panel.handleStop(None)
	else:
	    self.show(name)

    def refresh(self):
        if EntityManager.currentState:
            #print EntityManager.currentState.lastviewed
            if len(EntityManager.currentState.lastviewed) > 0:
                toshow = EntityManager.currentState.lastviewed[-1]
                #print "*********", toshow
                self.show(toshow)
            else:
                self.hide()
        else:
            self.hide()

