#
# @(#) approachPanelA.py 2005/09/27
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Fire panel

Authoring and Execution UI for approach
"""
import wx
#from primitivebehavior import *
from common.defs import *
#from cat.entity import behaviorset
from common.log import Log
log = Log(tags=['all', 'cat'])



#EXCLUSION_LIST = ("RETREAT", "MOVETO", "MAINTAIN")

## from cat.Behaviors.mapproach import MApproach
## MApproach.SPEED_CONST_MANEUVER

## if EntityManager.currentState:
##     beh = EntityManager.currentState.bset.getList("MAPPROACH")[0]
##     beh.SPEED_CONST_MANEUVER


from cat.Behaviors import mapproach as mapp
import nEventServer
from common import EventNames

class FirePanel(wx.Panel):
    """
    Sets up the GUI for changing the parameters of approach.
    """
    def __init__(self, parent, panelID, color, defaultSize, behaviorType = "MAPPROACH"):
        """
        Creates the new panel.
        parentPanel (wx.Panel): Approach, Retreat, and Maintain are mutually
        exclusive. These behaviors are put under one tab and they need this
        parent tab to change its title.
        """
        wx.Panel.__init__(self, parent, panelID, size = defaultSize, style = wx.RAISED_BORDER| wx.DOUBLE_BORDER)

        self.EXCLUSION_LIST = ()
            
        self.behaviorType = behaviorType
        self.SetBackgroundColour(color)
        self.parentPanel = parent
        self.sizer = wx.BoxSizer(wx.VERTICAL)

        self.statusMessage = wx.StaticText(self, -1, self.behaviorType, size = (200, -1))
        self.sizer.Add(self.statusMessage, 0, wx.ALIGN_LEFT)

        self.sizer.Add(wx.BoxSizer(), 1, flag=wx.EXPAND)
        
	
	self.startStopButton = wx.Button(self, -1, "Start", style=wx.BU_EXACTFIT)
	#self.startStopButton.SetSize(wx.Size(self.startStopButton.GetDefaultSize().GetWidth()-5, self.startStopButton.GetDefaultSize().GetHeight()-5))
	self.startStopButtonState = "start"
        wx.EVT_BUTTON(self.startStopButton, -1, self.OnClick)
	
	
	self.sizer.Add(self.startStopButton, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM)
	spacerX =wx.StaticText(self, -1, "", size=(195,5), style=wx.ALIGN_RIGHT)
	self.sizer.Add(spacerX)
	
	notifLabel = wx.StaticText (self, -1," Status: ")
	self.notifMsg = wx.StaticText (self, -1, "", size = (100, 20), style = wx.TE_READONLY | wx.TE_LEFT)
	space = 2
	notifSizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	notifSizer.AddMany ([notifLabel, self.notifMsg])
	self.sizer.Add(notifSizer)

	self.SetSizer(self.sizer)

        
        nEventServer.register(EventNames.CAT_SELECT_ENT,      self.handleEntSelection)

        from common import tickmanager
        tickmanager.register( 'FirePanel', self.tick ) # should receive and send info every second
    
    def WriteNotifMsg(self, msg):
        pass
        #self.notifMsg.SetLabel (msg)
        #print str(msg)
	
    def stop(self):
        #print "Stopping panel"
	self.WriteNotifMsg ("Stopping panel")

    def handleEntSelection(self, msg):
             
        behavior = self.getBehavior()
        if behavior:
            pass
            if behavior.active:
                self.startStopButtonState = "stop"
                self.startStopButton.SetLabel("Stop")
            else:
                self.startStopButtonState = "start"
                self.startStopButton.SetLabel("Start")

    def tick(self, time, dtime):
        """
        Runs Approach, gets the actuator values, and passes them up to the GUI
        for fusion.
        """
        pass

        
    def OnClick(self, event):
        """
        Called when the activate button is pressed.
        
        Turns off other behaviors and changes the parent tab's name.
        """
        if (self.startStopButtonState == "start"):
            self.handleStart(event)
	    self.WriteNotifMsg ("active")
        else:
            self.handleStop(event)
	    self.WriteNotifMsg ("inactive")

    def handleStart(self, event):
        self.startStopButtonState = "stop"
        self.startStopButton.SetLabel("Stop")
        #print "Handle start:" , event
        behavior = self.getBehavior()
        if(behavior):
            behavior.activate()
            behavior.SetVar('active', True)
        else:
            #print "No current behavior selected"
            self.WriteNotifMsg ("no curr beh sel")
             
    def getBehavior(self):
        from cat.entity import EntityManager
        if(EntityManager.currentState):
            entity = EntityManager.currentState.entity
            entityState = EntityManager.currentState
            behaviorList = entityState.bset.getList(self.behaviorType)
            #kludge because we do not yet handle multiple behaviors running simultaneously
            behavior = behaviorList[0]
            return behavior
        else:
            return None
        
    def handleStop(self, event):
        #print "handling stop"
        self.startStopButtonState = "start"
        self.startStopButton.SetLabel("Start")
        behavior = self.getBehavior()
        if(behavior):
            behavior.deActivate()
            behavior.SetVar('active', False)
        else:
            #print "No behavior to DeActivate"
            self.WriteNotifMsg ("no beh to deactivate")
             
