# @(#) executive.py 2005/07/06 @author Copyright (c) 2005 The
#University of Nevada, Reno. All rights reserved.  This software is
#provided "AS IS," without a warranty of any kind. ALL EXPRESS OR
#IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY
#IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
#OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. THE UNIVERSITY OF NEVADA,
#RENO AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED
#BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THE
#SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL THE UNIVERSITY OF
#NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT
#OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL
#OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF
#LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE,
#EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN ADVISED OF THE
#POSSIBILITY OF SUCH DAMAGES.  TODO: Fix Header TODO: Look into
#horizontal layout TODO: Set up recorder TODO: Tighten interface '''
#Defines the GUI and its operations for cat.
'''
This is where all the UI elements for CAT are defined as well as
the functions for manipulating that GUI. Ideally, this file should just
be UI elements, but because the behaviors have GUI elements, the code for
behavior fusion and output is also handled here. 
'''
import wx
import wx.lib.fancytext as fancytext
import common.WindowManager as WindowManager
from common.defs import *
import knob
import math
from cat.merge import xmlmerger
import manager
from important import *
from sensors import *
import cat.Behaviors as Behaviors
from cat.BehaviorNetwork.recorder import Recorder


from savedialog import SaveDialog

from cat.entity import EntityManager
#from cat.entity import behaviors as entbeh
# BUTTON Names and default text
SELECTENT      = "Sel"
HITPOINTS      = "Damage: "
POSITION       = "Pos: "
HEADING        = "Head: "
SPEED          = "Speed: "
DESIREDHEADING = "Desired Head"
DESIREDSPEED   = "DesiredSpd"
SELECTTARGET   = "Sel"
TARGET         = "Target"
BEARING        = "Bearing: "
RANGE          = " Range: "
MACHINEGUN     = "MG"
SELECTWEAPON   = "Fire"
WEAPON         = "Weapon"
FORMATE        = "Formate"
FIRE           = "Fire"
MAINTAIN       = "Maintain"
APPROACH       = "Approach"
RETREAT        = "Retreat"
HEADINGSPEEDCONTROLSIZE    = (40, 20)
ENTITYTEXTCONTROLSIZE      = (100, 20)
##**
        
## class CATPanel(wx.Panel):
##     '''
##     The wxFrame that defines the GUI
##     '''
##     ID_PAUSE = 102
##     ID_SAVE = 103
##     ID_RECORD = 104
##     ID_STOP = 105
##     ID_PLAY = 106
##     ID_START = 107
##     ID_QUERY = 108
    
##     def __init__(self, parent, ID=-1, pos = wx.DefaultPosition, size = wx.DefaultSize):
##         '''
##         Creates and layouts the CAT GUI

##         This function is large and messy. The parameters for best with
##         the defaults, so there should be no reason to change them. Different
##         sections of the GUI have been isolated but caution should be used in
##         changing things. Breakage would be easy.
##         '''
##         self.recorder = Recorder()
##         self.netcon = None
##         self.manual = True
##         self.selectingTarget = False
##         self.selectingEntity = False
       
##         self.panelsOn = True
      
##         wx.Panel.__init__(self, parent, ID, size = size)
##         self.bgcolor = wx.SystemSettings.GetColour(wx.SYS_COLOUR_3DLIGHT)
##         self.bgcolor = "MEDIUM GOLDENROD"
##         self.SetBackgroundColour(self.bgcolor)
##         #if manager:
##         #    self.manager = manager
##         #else:
##         #    self.manager = manager.Manager()
##         self.manager = EntityManager
##         #######   Set up the Info section   ####################################
##         self.infoSizer = wx.BoxSizer(wx.VERTICAL)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         #self.entityName = wx.TextCtrl(self, -1, 'None', size=ENTITYTEXTCONTROLSIZE, style=wx.TE_READONLY)
##         #self.entityName.Enable(False)
##         self.entityName = wx.StaticText(self, -1, 'None')
##         tmp.Add(self.entityName, 1, border = 4, flag = wx.LEFT|wx.EXPAND)
##         self.infoSizer.Add(tmp, 1, flag=wx.EXPAND)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         self.selEnt = wx.Button(self, -1, SELECTENT, style=wx.BU_EXACTFIT)
##         prefix = ""
##         if __name__ != '__main__':
##             import os
##             prefix = os.path.dirname(__file__)+"/"
##             del os
##         binoc_bmp =  wx.Bitmap(prefix+"binoc.gif", wx.BITMAP_TYPE_GIF)
##         nobinoc_bmp = wx.Bitmap(prefix+"nobinoc.gif", wx.BITMAP_TYPE_GIF)
##         self.watchEnt = wx.BitmapButton(self, -1, binoc_bmp, \
##                                         size=(binoc_bmp.GetWidth()+10, binoc_bmp.GetHeight()+10))
##         self.stopWatchEnt = wx.BitmapButton(self, -1, nobinoc_bmp, \
##                                         size=(binoc_bmp.GetWidth()+10, binoc_bmp.GetHeight()+10))
##         self.stopWatchEnt.SetBackgroundColour('#00FF00')

##         self.watch = False
##         wx.EVT_BUTTON(self.selEnt, -1, self.SelectEntity)
##         wx.EVT_BUTTON(self.watchEnt, -1, self.WatchEntity)
##         wx.EVT_BUTTON(self.stopWatchEnt, -1, self.StopWatchEntity)
##         tmp.Add(self.selEnt)
##         tmp.Add(self.watchEnt)
##         tmp.Add(self.stopWatchEnt)
##         self.infoSizer.Add(tmp, border=4, flag=wx.TOP)
##         #tmp = wx.BoxSizer(wx.HORIZONTAL)
##         #self.teamName = wx.TextCtrl(self, -1, '')
##         #tmp.Add(wx.StaticText(self, -1, " - "))
##         #tmp.Add(self.teamName)
##         #self.infoSizer.Add(tmp)
##         #self.infoSizer.Add(wx.Size(1, 4))
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
## #        tmp = wx.BoxSizer(wx.VERTICAL)
##         tmp.Add(wx.StaticText(self, -1, HITPOINTS))
##         #tmp.Add(wx.Size(10,1))
##         #self.hpGauge = wx.Gauge(self, -1, 100, size=wx.Size(200,14))
##         #self.hpGauge.SetValue(0)
##         #tmp.Add(self.hpGauge, proportion=1, flag=wx.EXPAND|wx.ALL|wx.ALIGN_CENTER_VERTICAL)
##         #tmp.Add(wx.Size(10,1))
##         self.hitpoints = wx.StaticText(self, -1, '0')
##         tmp.Add(self.hitpoints)
##         #self.infoSizer.Add(tmp, proportion=0, border = 10, flag = wx.EXPAND|wx.LEFT|wx.RIGHT)
##         #self.infoSizer.Add(wx.Size(1, 4))
##         self.infoSizer.Add(tmp, border=4, flag=wx.LEFT|wx.BOTTOM)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         self.positionTxt = wx.StaticText(self, -1, POSITION)
##         self.positionCtrl = wx.StaticText(self, -1, '', size=(100, 15))
##         tmp.Add(self.positionTxt)
##         tmp.Add(self.positionCtrl)
##         self.infoSizer.Add(tmp, border=4, flag=wx.LEFT|wx.BOTTOM)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         self.headingTxt = wx.StaticText(self, -1, HEADING)
##         self.headingCtrl = wx.StaticText(self, -1, '', size=(50, 15))
##         tmp.Add(self.headingTxt)
##         tmp.Add(self.headingCtrl)
##         self.speedTxt = wx.StaticText(self, -1, SPEED)
##         self.speedCtrl = wx.StaticText(self, -1, '', size=(50, 15))
##         tmp.Add(self.speedTxt)
##         tmp.Add(self.speedCtrl)
        
##         self.infoSizer.Add(tmp, border=4, flag=wx.LEFT|wx.BOTTOM)
##         ########################################################################
        
##         #######   Set up the Control section   #################################
##         vert1 = wx.BoxSizer(wx.VERTICAL)
##         vert2 = wx.BoxSizer(wx.VERTICAL)
##         horz1 = wx.BoxSizer(wx.HORIZONTAL)

## #       horz1 = wx.BoxSizer(wx.VERTICAL)        
##         vert1.Add(wx.StaticText(self, -1, DESIREDHEADING), flag=wx.LEFT)
##         self.desiredHeadingCtrl = wx.StaticText(self, -1, "0", size=HEADINGSPEEDCONTROLSIZE,\
##                                                 style=wx.ALIGN_CENTER)
##         vert1.Add(self.desiredHeadingCtrl, flag=wx.CENTER)
##         self.desiredHeadingKnob = knob.Knob(self, -1)
##         vert1.Add(self.desiredHeadingKnob, flag=wx.CENTER)
##         self.Bind(knob.EVT_KNOB, self.OnHeadingKnobChange, id=self.desiredHeadingKnob.GetId())
##         vert2.Add(wx.StaticText(self, -1, DESIREDSPEED), flag=wx.CENTER)
##         self.desiredSpeedCtrl = wx.StaticText(self, -1, "0", size=HEADINGSPEEDCONTROLSIZE,\
##                                               style=wx.ALIGN_CENTER)
##         self.desiredSpeedSlider = wx.Slider(self, -1, 0, 0, 0, style=wx.SL_VERTICAL)
##         wx.EVT_SCROLL(self.desiredSpeedSlider, self.OnSpeedSliderChange)
##         vert2.Add(self.desiredSpeedCtrl, flag=wx.CENTER)
##         vert2.Add(self.desiredSpeedSlider, 1, border=5, flag=wx.EXPAND|wx.CENTER|wx.TOP|wx.BOTTOM)
## #        horz1.Add(vert1, proportion=1, flag=wx.EXPAND)
## #        horz1.Add(vert2, proportion=1, flag=wx.EXPAND)
##         horz1.Add(vert1, 0)#proportion=1, flag=wx.EXPAND)
##         horz1.Add(vert2, proportion=1, flag=wx.EXPAND)
##         ########################################################################
        
##         #######   Set up the target display   ##################################
##         targetSizer = wx.BoxSizer(wx.VERTICAL)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         self.targetName = wx.StaticText(self, -1, "None", size=(50,20))
##         self.targetButton = wx.Button(self, -1, SELECTTARGET, style=wx.BU_EXACTFIT)
##         wx.EVT_BUTTON(self.targetButton, -1, self.SelectTarget)
##         tmp.Add(wx.StaticText(self, -1, 'Target: '))
##         tmp.Add(self.targetName, 1, flag=wx.EXPAND)
##         tmp.Add(self.targetButton, border=5, flag=wx.RIGHT)
##         targetSizer.Add(tmp, 1, flag=wx.EXPAND)
##         tmp = wx.BoxSizer(wx.HORIZONTAL)
##         tmp.Add(wx.StaticText(self, -1, BEARING))
##         self.targetBearing = wx.StaticText(self, -1, "0.0", size=(50, 15))
##         tmp.Add(self.targetBearing)
##         tmp.Add(wx.StaticText(self, -1, RANGE))
##         self.targetRange = wx.StaticText(self, -1, "0.0", size=(50, 15))
##         tmp.Add(self.targetRange)
##         targetSizer.Add(tmp)
##         ########################################################################
        
##         #######   Set up the weapon display   ##################################
##         firePanel = Behaviors.FirePanel(self, -1, 20)
##         ########################################################################
        
##         #######   Set up the behavior pane   ###################################
##         stopSizer = wx.BoxSizer(wx.HORIZONTAL)
##         stopPanel = Behaviors.StopPanel(self, -1, 90)
##         stopSizer.Add(stopPanel, 1, wx.EXPAND)
            
##         behSizer = wx.BoxSizer(wx.HORIZONTAL)
        
##         nb = wx.Choicebook(self, -1)
##         behSizer.Add(nb, 1, wx.EXPAND)
        
##         formatePanel = Behaviors.FormatePanel(nb, -1, 10, FORMATE, stopPanel)
        
##         #firePanel = Behaviors.FirePanel(nb, -1, 20)
        
##         movementPanel = wx.Panel(nb,-1)
##         movementPanel.SetBackgroundColour(self.bgcolor)
##         sizer = wx.BoxSizer(wx.VERTICAL)
##         movementPanel.SetSizer(sizer)
##         movementNB = wx.Choicebook(movementPanel, -1)
##         sizer.Add(movementNB, 1, wx.EXPAND)
##         maintainPanel = Behaviors.MaintainPanel(movementNB,-1, 30, MAINTAIN, stopPanel, movementPanel)
##         approachPanel = Behaviors.ApproachPanel(movementNB, -1, 40, APPROACH, stopPanel, movementPanel)
##         retreatPanel = Behaviors.RetreatPanel(movementNB, -1, 50, RETREAT, stopPanel, movementPanel)
##         movetoPanel = Behaviors.MoveToPanel(movementNB, -1, 55, 'MoveTo', stopPanel, movementPanel)
##         panelGroup = Behaviors.PanelGroup()
##         panelGroup.AddPanel(maintainPanel)
##         panelGroup.AddPanel(approachPanel)
##         panelGroup.AddPanel(retreatPanel)
##         panelGroup.AddPanel(movetoPanel)
##         movementNB.AddPage(maintainPanel, "Maintain [off]")
##         maintainPanel.pageNum = 0
##         movementNB.AddPage(approachPanel, "Approach [off]")
##         approachPanel.pageNum = 1
##         movementNB.AddPage(retreatPanel, "Retreat [off]")
##         retreatPanel.pageNum = 2
##         movementNB.AddPage(movetoPanel, "MoveTo [off]")
##         movetoPanel.pageNum = 3
        
        
##         wanderPanel = Behaviors.WanderPanel(nb, -1, 60, "Wander")
        
##         avoidPanel = wx.Panel(nb,-1)
##         avoidPanel.SetBackgroundColour(self.bgcolor)
##         sizer = wx.BoxSizer(wx.VERTICAL)
##         avoidPanel.SetSizer(sizer)
##         avoidNB = wx.Choicebook(avoidPanel, -1)
##         sizer.Add(avoidNB, 1, wx.EXPAND)
##         landPanel = Behaviors.AvoidLandPanel(avoidNB, -1, 70, "Land", stopPanel)
##         self.entityPanel = Behaviors.AvoidEntityPanel(avoidNB, -1, 80, "Entity", stopPanel)
##         avoidNB.AddPage(landPanel, "Land [off]")
##         landPanel.pageNum = 0
##         avoidNB.AddPage(self.entityPanel, "Entities [off]")
##         self.entityPanel.pageNum = 1
        
##         nb.AddPage(formatePanel, "Formate [off]")
##         formatePanel.pageNum = 0
##         #nb.AddPage(firePanel, "Fire [off]")
##         #firePanel.pageNum = 1
##         nb.AddPage(movementPanel, "Movement [off]")
##         movementPanel.pageNum = 1
##         nb.AddPage(wanderPanel, "Wander [off]")
##         wanderPanel.pageNum = 2
##         nb.AddPage(avoidPanel, "Avoid")

##         self.manager.addPanel(approachPanel)
##         self.manager.addPanel(retreatPanel)
##         self.manager.addPanel(maintainPanel)
##         self.manager.addPanel(movetoPanel)
##         self.manager.addPanel(self.entityPanel)

##         self.behList = [formatePanel, firePanel, maintainPanel, approachPanel, stopPanel, \
##                         retreatPanel, wanderPanel, movetoPanel]
##         self.stopList = [formatePanel, maintainPanel, approachPanel, retreatPanel, \
##                          wanderPanel, movetoPanel, firePanel]
##         #self.recorder.SetBehaviors([b.beh for b in self.behList])
##         stopPanel.panels = self.stopList
##         ########################################################################
        
##         #######   Set up the recording bar   ###################################
##         self.tb = wx.ToolBar(self)
        
##         #self.open_bmp = wx.Bitmap(prefix+"open.gif", wx.BITMAP_TYPE_GIF)
##         self.save_bmp = wx.Bitmap(prefix+"save.gif", wx.BITMAP_TYPE_GIF)
##         self.record_bmp = wx.Bitmap(prefix+"record.gif", wx.BITMAP_TYPE_GIF)
##         self.stop_bmp = wx.Bitmap(prefix+"stop.gif", wx.BITMAP_TYPE_GIF)
##         self.pause_bmp = wx.Bitmap(prefix+"pause.gif", wx.BITMAP_TYPE_GIF)
##         self.play_bmp = wx.Bitmap(prefix+"play.gif", wx.BITMAP_TYPE_GIF)
##         self.tb.AddSeparator()
##         #self.filename = wx.TextCtrl(self.tb, -1, "untitled")
##         #
##         self.tb2 = wx.ToolBar(self)
##         nets = ["< new >"]
##         self.networks, self.networkColor = nm.FindNetworks()
##         nets.extend(self.networks.keys())
##         self.filename = wx.Choice(self.tb2, -1, (100,50), choices = nets )
##         self.filename.SetSelection(0)
##         wx.EVT_CHOICE(self.filename, -1, self.OnSelect)
##         self.tb2.Realize()
##         self.tb2.AddControl(self.filename)
##         self.tb.AddSimpleTool(self.ID_SAVE, self.save_bmp, "Save As...", "Save Behavior Netork")
##         self.tb.AddSimpleTool(self.ID_PLAY, self.play_bmp, "Play", "Play Behavior Network")
##         self.tb.AddSimpleTool(self.ID_RECORD, self.record_bmp, "Record", "Record Behavior Network")
##         self.tb.AddSimpleTool(self.ID_STOP, self.stop_bmp, "Stop", "Stop Recording Behavior Netork")
##         self.tb.AddSimpleTool(self.ID_PAUSE, self.pause_bmp, "Pause", "Pause")
##         self.tb.Realize()
##         wx.EVT_TOOL(self.tb, self.ID_SAVE, self.SaveNetwork)
##         wx.EVT_TOOL(self.tb, self.ID_PLAY, self.PlayNetwork)
##         wx.EVT_TOOL(self.tb, self.ID_RECORD, self.StartRecord)
##         wx.EVT_TOOL(self.tb, self.ID_STOP, self.StopRecord)
##         wx.EVT_TOOL(self.tb, self.ID_PAUSE, self.PauseNetwork)
##         ########################################################################
        
##         #######   Putting it all together   ###################################
##         self.sizer=wx.BoxSizer(wx.VERTICAL)
##         self.sizer.Add(self.tb)
##         self.sizer.Add(self.tb2)
##         self.sizer.Add(self.infoSizer,0,wx.EXPAND)
##         self.sizer.Add(wx.StaticLine(self, -1), 0, wx.EXPAND)
##         self.sizer.Add(horz1, 0, wx.EXPAND)
##         self.sizer.Add(wx.StaticLine(self, -1), 0, wx.EXPAND)
##         self.sizer.Add(firePanel, 0, border=2, flag=wx.EXPAND| wx.TOP|wx.BOTTOM)
##         self.sizer.Add(wx.StaticLine(self, -1), 0, wx.EXPAND)
##         self.sizer.Add(stopSizer)
##         self.sizer.Add(behSizer, 1, wx.EXPAND)
##         self.sizer.Add(wx.StaticLine(self, -1), 0, wx.EXPAND)
##         self.sizer.Add(targetSizer, 0, border=2, flag=wx.EXPAND| wx.TOP|wx.BOTTOM)
##         #Layout sizers
##         self.SetSizer(self.sizer)
##         self.SetAutoLayout(1)
##         self.Show(1)
##         ########################################################################
        
##         nEventServer.register('mouseOverChanged', self.mouseOverChanged)
##         nEventServer.register('selectionChanged', self.selectionChanged)

##     def OnHeadingKnobChange(self, event):
##         '''
##         Handles updating the wxTextCtrl to display the desired heading when set by
##         knob.

##         Don\'t call this function. It is for internal use only.
##         '''
##         ImportantEvent()
##         radians = event.GetAngle()
##         angle = math.degrees(radians)
##         if angle < 0:
##             angle += 360
##         angle = int(angle)
##         angle = 360 - angle #Sushil
##         self.desiredHeadingCtrl.SetLabel(str(angle))
##         actuators = self.manager.getActiveState().getActuators()
##         if not actuators.areLocked():
##             actuators.setDesiredHeading(radians)
        
##     def OnSpeedSliderChange(self, event):
##         """
##         Handles updating the wxTextCtrl to display the desired speed when set by the
##         slider.

##         Don't call this fuction. It is for internal use only.
##         """
##         ImportantEvent()
##         active = self.manager.getActiveState()
##         max = active.actuators.getMaxSpeed()*100.0
##         speed = (max - self.desiredSpeedSlider.GetValue())/100.0
##         self.desiredSpeedCtrl.SetLabel("%.1f"%speed)
##         if not active.actuators.areLocked():
##             active.actuators.setDesiredSpeed(speed)

##     def OnStartFlag(self, event):
##         ImportantEvent()
##         SetStartScenario(not IsStartScenario())

##     def OnQueryFlag(self, event):
##         ImportantEvent()
##         SetTargetQuery(not IsTargetQuery())

##     def WatchEntity(self, event):
##         """
##         Toggles the watching of the selected entity.

##         The button isn't a toggle button because you can't have bitmaps on toggle
##         buttons. I don't know that for certain, but that is what I remember and I
##         am sticking to it. Don't call this functino. It is for internal use only.
##         """
##         ImportantEvent()
##         if not self.watch and self.manager.getActiveState():
##             self.watch = True
##             watch(self.manager.getActiveState().sensors.getOwnship())
##             self.watchEnt.SetBackgroundColour('#00FF00')
##             self.stopWatchEnt.SetBackgroundColour(self.bgcolor)

##     def StopWatchEntity(self, event):
##         """
##         Toggles the watching of the selected entity.

##         The button isn't a toggle button because you can't have bitmaps on toggle
##         buttons. I don't know that for certain, but that is what I remember and I
##         am stickin
##         ImportantEvent()g to it. Don't call this functino. It is for internal use only.
##         """
##         if self.watch:
##             self.watch = False
##             watch(None)
##             self.watchEnt.SetBackgroundColour(self.bgcolor)
##             self.stopWatchEnt.SetBackgroundColour('#00FF00')
            

##     def SelectEntity(self, event):
##         """
##         Displays a dialog for selecting the desired entity to control.

##         """
##         if self.selectingEntity:
##             self.selectingEntity = False
##             self.selEnt.SetBackgroundColour(self.bgcolor)
##         else:
##             self.selectingEntity = True
##             self.selEnt.SetBackgroundColour('#CCFFFF')

##     def SelectTarget(self, event):
##         """
##         Displays a dialog for selecting the desired entity to target.

##         """
##         if self.selectingTarget:
##             self.selectingTarget = False
##             self.targetButton.SetBackgroundColour(self.bgcolor)
##         else:
##             self.selectingTarget = True
##             self.targetButton.SetBackgroundColour('#CCFFFF')

##     def mouseOverChanged(self, objects):
##         pass

##     def selectionChanged(self, objects):
##         ImportantEvent()
##         if self.selectingTarget and self.manager.getActiveState() and exists(objects):
##             self.manager.getActiveState().sensors.setTarget(objects)
##             self.selectingTarget = False
##             self.targetButton.SetBackgroundColour(self.bgcolor)
##             sel(objects)
##             self.targetName.SetLabel(getname())
##             self.RefreshInfo()
##         if self.selectingEntity and exists(objects):
##             self.manager.setActiveEntity(objects)
##             active = self.manager.getActiveState()
##             self.selectingEntity = False
##             self.selEnt.SetBackgroundColour(self.bgcolor)
            
##             val = active.actuators.getDesiredSpeed()*100
##             max = active.actuators.getMaxSpeed()*100
##             self.desiredSpeedSlider.SetRange(0, int(max))
##             self.desiredSpeedSlider.SetValue(max - val)
##             rad = active.actuators.getDesiredHeading()
##             val = math.degrees(rad)
##             if val < 0:
##                 val += 360
##             s = '%.1f' % val
##             self.desiredHeadingCtrl.SetLabel(s)
##             self.desiredHeadingKnob.SetValue(rad)
##             if self.watch:
##                 watch(objects)
                

##     def SetControls(self):
##         if manager.IsRunning(GetOwnEntity()):
##             self.tb.EnableTool(self.ID_RECORD, False)
##             self.tb.EnableTool(self.ID_STOP, True)
##             self.tb.EnableTool(self.ID_PLAY, False)
##             self.tb.EnableTool(self.ID_PAUSE, True)
##             self.tb.EnableTool(self.ID_SAVE, False)
##             self.filename.Enable(False)
##         elif manager.HasAttached(GetOwnEntity()):
##             self.tb.EnableTool(self.ID_RECORD, False)
##             self.tb.EnableTool(self.ID_STOP, True)
##             self.tb.EnableTool(self.ID_PLAY, True)
##             self.tb.EnableTool(self.ID_PAUSE, False)
##             self.tb.EnableTool(self.ID_SAVE, False)
##             self.filename.Enable(False)
##         elif self.recorder.recording:
##             self.tb.EnableTool(self.ID_RECORD, False)
##             self.tb.EnableTool(self.ID_STOP, True)
##             self.tb.EnableTool(self.ID_PLAY, False)
##             self.tb.EnableTool(self.ID_PAUSE, False)
##             self.tb.EnableTool(self.ID_SAVE, True)
##             self.filename.Enable(True)
##         elif self.recorder.hasMaterial:
##             self.tb.EnableTool(self.ID_RECORD, True)
##             self.tb.EnableTool(self.ID_STOP, False)
##             if self.filename.GetStringSelection() == '< new >':
##                 self.tb.EnableTool(self.ID_PLAY, False)
##             else:
##                 self.tb.EnableTool(self.ID_PLAY, True)
##             self.tb.EnableTool(self.ID_PAUSE, False)
##             self.tb.EnableTool(self.ID_SAVE, True)
##             self.filename.Enable(True)
##         else:
##             self.tb.EnableTool(self.ID_RECORD, True)
##             self.tb.EnableTool(self.ID_STOP, False)
##             if self.filename.GetStringSelection() == '< new >':
##                 self.tb.EnableTool(self.ID_PLAY, False)
##             else:
##                 self.tb.EnableTool(self.ID_PLAY, True)
##             self.tb.EnableTool(self.ID_PAUSE, False)
##             self.tb.EnableTool(self.ID_SAVE, False)
##             self.filename.Enable(True)

##     def RefreshInfo(self):
##         """
##         Called every tick to update the GUI information about the entity
##         and it's target.
##         """
##         currentState = self.manager.getActiveState()

##         ox, oy, oz = (0.0, 0.0, 0.0)
##         if currentState != None:
##             own = currentState.sensors.getOwnship()
##             tgt = currentState.sensors.getTarget()
##             if exists(own):
##                 sel(own)
##                 self.entityName.SetLabel(getname())
##                 self.hitpoints.SetLabel(`gf("hp")`)
##                 ox, oz, oy = gv('pos')
##                 self.positionCtrl.SetLabel(`int(ox)`+' '+`int(oy)`)
##                 hd = gf("heading")
##                 val = math.degrees(hd)
##                 if val < 0:
##                     val += math.pi * 2
##                 s = '%5.1f' % val
##                 self.headingCtrl.SetLabel(s)
##                 val = gf("speed")
##                 s = '%5.1f' % val
##                 self.speedCtrl.SetLabel(s)
##                 max = gf("maxSpeed") * 100

##                 if currentState.actuators.areLocked():
##                     rad = currentState.actuators.getDesiredHeading()
##                     if rad < 0:
##                         rad += math.pi*2
##                     val = math.degrees(rad)
##                     s = '%.1f' % val
##                     self.desiredHeadingCtrl.SetLabel(s)
##                     self.desiredHeadingKnob.SetValue(rad)
##                     if self.desiredSpeedSlider.GetMax() == 0:
##                         self.desiredSpeedSlider.SetRange(0, int(max))
##                     ds = currentState.actuators.getDesiredSpeed()
##                     self.desiredSpeedSlider.SetValue(max-int(ds)*100.0)
##                     self.desiredSpeedCtrl.SetLabel("%.1f"%ds)

##             else:
##                 self.entityName.SetLabel("None")
##                 self.hitpoints.SetLabel("0")
##                 self.positionCtrl.SetLabel("0, 0")
##                 self.headingCtrl.SetLabel("0")
##                 self.speedCtrl.SetLabel("0")
##                 self.desiredHeadingCtrl.SetLabel("0")
##                 self.desiredHeadingKnob.SetValue(0)
##                 self.desiredSpeedSlider.SetRange(0, 0)
##                 self.desiredSpeedCtrl.SetLabel("0")

##             if exists(tgt):     
##                 sel(tgt)
##                 tx, tz, ty = gv('pos')
##                 d = math.sqrt((ox-tx)**2 + (oy-ty)**2)
##                 b = hd - math.atan2(tx-ox, ty-oy)
##                 if b < math.pi:
##                     b += 2*math.pi
##                 if b > math.pi:
##                     b -= 2*math.pi
##                 self.targetName.SetLabel(getname())
##                 self.targetRange.SetLabel("%.1f"%d)
##                 self.targetBearing.SetLabel("%.1f"%math.degrees(b))
##             else:
##                 self.targetName.SetLabel("None")
##                 self.targetRange.SetLabel("0")
##                 self.targetBearing.SetLabel("0")
                
## <<<<<<< gui.py
## =======
##             sel(GetTargetEntity())
##             tx, tz, ty = gv('pos')
##             d = math.sqrt((ox-tx)**2 + (oy-ty)**2)
##             b = hd - math.atan2(tx-ox, ty-oy)
##             if b < math.pi:
##                 b += 2*math.pi
##             if b > math.pi:
##                 b -= 2*math.pi
        	
##             self.targetName.SetLabel(getname())
##             self.targetRange.SetLabel("%.1f"%d)
##             self.targetBearing.SetLabel("%.1f"%math.degrees(b))
                    
##     def Tick(self, time, dtime):
##         """
##         Called by the manager to process the current behavior status and output
##         the action specified by the behavior fusion.

##         Behavior fusion is done by vector summing. Each behavior produces a weight,
##         a heading, and a speed. The weights are summed and scaled and used the
##         magnitdues for the heading vectors and as scalers for speed averaging.
##         """
##         self.recorder.Tick(time, dtime)
##         #self.RefreshInfo()
##         actuators = []
##         weightsum = 0
##         theta = 0.0
##         dx = 0.0
##         dy = 0.0
##         r = 0.0
        
## 	own = GetOwnEntity()
## 	if exists(own):
## 	    theta = gf('desiredHeading')
## 	    r = gf('desiredSpeed')
	
##         self.SetControls()
##         if manager.IsRunning(GetOwnEntity()):
##             self.manual = False
##             if self.panelsOn:
##                 for panel in self.behList:
##                     panel.Enable(False)
##                 self.panelsOn = False
##             conn = manager.attachedControllers[GetOwnEntity()]
##             SetTargetEntity(conn.sens.GetTargetEntity())
##             self.filename.SetStringSelection(manager.controllerFilename[GetOwnEntity()])
##         else:
##             if not self.panelsOn:
##                 for panel in self.behList:
##                     panel.Enable(True)
##                 self.panelsOn = True
            
##             activeBeh = False
##             if self.entityPanel.IsActive():
##                 activeBeh = True
##                 action = self.entityPanel.Tick(time, dtime)
##                 weightsum += action[0]
##                 actuators.append(action)
##             epActive = self.entityPanel.IsActive()
##             epPanic = self.entityPanel.beh.GetVar('panicRange')
##             epEffect = self.entityPanel.beh.GetVar('effectiveRange')
##             epSpeed = self.entityPanel.beh.GetVar('desiredSpeed')
##             for beh in self.behList:
##                 if beh.IsActive():
##                     activeBeh = True
##                     action = beh.Tick(time, dtime)
##                     weightsum += action[0]
##                     actuators.append(action)
##                     beh.beh.SetVar('avoidentity', epActive)
##                     beh.beh.SetVar('epPanicRange', epPanic)
##                     beh.beh.SetVar('epEffectiveRange', epEffect)
##                     beh.beh.SetVar('epDesiredSpeed', epSpeed)
##             if activeBeh and weightsum:
##                 self.manual = False
##                 for action in actuators:
##                     dx += float(action[0])/float(weightsum) * math.cos(action[1])
##                     dy += float(action[0])/float(weightsum) * math.sin(action[1])
##                     r += float(action[0])/float(weightsum) * action[2]
##                 theta = math.atan2(dy, dx)
##             else:
##                 #print "Got here"
##                 self.manual = True
##                 #theta = self.desiredHeadingKnob.GetValue()
##                 #if exists(GetOwnEntity()):
##                 #    sel(GetOwnEntity())
##                 #    max = gf("maxSpeed")*100
##                 #    r = float(max - self.desiredSpeedSlider.GetValue())/100.0
##                 #else: r = 0
##         return (theta, r)

## >>>>>>> 1.3
##     def SaveNetwork(self, event):
##         """
##         Tells the recorder to stop recording and process the collected data
##         to make a behavior network. Opens a dialog to prompt for the name
##         of the network.

##         Don't call this fuction. It is for internal use only.
##         """
##         ImportantEvent()
##         #print "Save Network"
##         f = self.filename.GetStringSelection()
##         #print "^^^",file,"^^^"
##         if f == '< new >':
##             validName = False
##             while not validName:
##                 dialog = SaveDialog(self, -1, "Save Network",  \
##                                     pos=(800,100), style=wx.DEFAULT_DIALOG_STYLE)
##                 val = dialog.ShowModal()
##                 if val == wx.ID_OK:
##                     filename = dialog.filename.GetValue()
##                     netname = dialog.netname.GetValue()
##                     if self.networks.has_key(filename):
##                         dlg = wx.MessageDialog(self, 'File already exists.\n' + \
##                                                'Do you want to overwrite the existing network?', \
##                                                'Error', wx.YES_NO|wx.ICON_ERROR, (800, 100))
##                         dlg.Move((800,100))
##                         val = dlg.ShowModal()
##                         dlg.Destroy()
##                         if val == wx.ID_YES:
##                             validName = True
##                         else:
##                             continue
##                     if filename == '' or netname == '':
##                         dlg = wx.MessageDialog(self, 'Empty Values. Please fill in all fields.', \
##                                                'Error', wx.OK|wx.ICON_ERROR, pos=(800, 100))
##                         dlg.ShowModal()
##                         dlg.Destroy()
##                         continue
##                     validName = True
##                     self.recorder.Save(filename, netname)
##                     self.networks[filename] = netname
##                     if not self.networkColor.has_key(filename):
##                         self.networkColor[filename] = 'black'
##                     nm.SaveNetworks(self.networks, self.networkColor)
                    
##                     tmpnetworks, tmpcolors = nm.FindNetworks()
##                     tmpnets = ["< new >"]
##                     tmpnets.extend(tmpnetworks.keys())
##                     self.filename.Clear()
##                     self.filename.AppendItems(tmpnets)
##                     self.filename.SetSelection(0)
##                     #self.filename.Append(filename)
##                 else:
##                     validName = True
##         else:
##             f2 = open("cat/networks/"+f)
##             net1 = f2.read()
##             f2.close()
##             net2 = self.recorder.Save("tmp.bn", "Temp for merging", False)            
##             net3 = xmlmerger.mergeNetworkStrings(net1, net2)
##             f2 = open("cat/networks/"+f, "w")
##             f2.write(net3)
##             dlg = wx.MessageDialog(self, "Network has been merged\nwith recorded material", \
##                                    'File Merged', wx.OK|wx.ICON_INFORMATION, pos=(800, 100))
##             dlg.ShowModal()
##             dlg.Destroy()
##         self.SetControls()

##     def StartRecord(self, event):
##         """
##         Tells the record to begin collecting data for the behavior network.

##         Don't call this fuction. It is for internal use only.
##         """
##         ImportantEvent()
##         #print "Start Record"
##         #wx.EVT_TOOL(self.tb, self.ID_RECORD, self.PauseRecord)
##         self.recorder.SetRecording(True)
##         self.SetControls()

##     def StopRecord(self, event):
##         """
##         Tells the recorded to stop collecting data and close the network.

##         Pressing record at this stages will cause a new network to be recorded
##         and the old one to be discarded.

##         Don't call this fuction. It is for internal use only.
##         """
##         ImportantEvent()
##         #print "Stop Record"
##         if manager.IsRunning(GetOwnEntity()):
##             manager.DetachController(GetOwnEntity())
##             self.SetControls()
##             sel(GetOwnEntity())
##             sf('desiredSpeed', 0.0)
##         elif self.recorder.recording:
##             self.recorder.SetRecording(False)
##             self.recorder.hasMaterial = False
##             self.recorder.out = ''
##             self.SetControls()
##             sel(GetOwnEntity())
##             sf('desiredSpeed', 0.0)

##     def PauseNetwork(self, event):
##         ImportantEvent()
##         if manager.HasAttached(GetOwnEntity()):
##             b = manager.IsRunning(GetOwnEntity())
##             manager.PauseController(GetOwnEntity(), True)
##             self.SetControls()
##             sel(GetOwnEntity())
##             sf('desiredSpeed', 0.0)

##     def PlayNetwork(self, event):
##         ImportantEvent()
##         if manager.HasAttached(GetOwnEntity()):
##             manager.PauseController(GetOwnEntity(), False)
##         else:
##             filepath = "cat/networks/"+self.filename.GetStringSelection()
##             manager.AttachNetwork(GetOwnEntity(), filepath, \
##                                   {'target':GetTargetEntity()})
##         self.SetControls()
        
##     def OnSelect(self, event):
##         ImportantEvent()
##         self.SetControls()
        

##<<<<<<< gui.py
##=======
## def FindNetworks():
##     class networkParser(ContentHandler):
##         def __init__(self):
##             self.inInt = False
##             self.inFloat = False
##             self.inBool = False
##             self.inVector = False
##             self.intval = ''
##             self.floatval = ''
##             self.boolval = ''
##             self.vecval = ''
##             self.getParameter = False
##             self.trigID = ''
            
##         def startElement(self, name, attrs):
##             if name == 'behavior':
##                 self.id = attrs.get('id','')
##             elif name == 'int':
##                 sn('nent', self.id+'_'+attrs.get('name', ''))
##                 ci('min', int(attrs.get('min', '')))
##                 ci('max', int(attrs.get('max', '')))
##                 cs('type', 'int')
##                 self.inInt = True
##                 self.intval = ''
##             elif name == 'float':
##                 sn('nent', self.id+'_'+attrs.get('name', ''))
##                 cf('min', float(attrs.get('min', '')))
##                 cf('max', float(attrs.get('max', '')))
##                 cs('type', 'float')
##                 self.inFloat = True
##                 self.floatval = ''
##             elif name == 'bool':
##                 sn('nent', self.id+'_'+attrs.get('name', ''))
##                 cf('min', 0)
##                 cf('max', 1)
##                 cs('type', 'bool')
##                 self.inBool = True
##                 self.boolvar = ''
##             elif name == 'vector':
##                 sn('nent', self.id+'_'+attrs.get('name', ''))
##                 cf('min', float(attrs.get('min', '')))
##                 cf('max', float(attrs.get('max', '')))
##                 cs('type', 'vector3')
##                 self.inVector = True
##                 self.vecval = ''
##             elif name == 'trigger':
##                 if attrs.get('name','') == 'Distance Between Entities':
##                     self.getParameter = True
##                     self.trigID = attrs.get('id', '')
##                 else:
##                     self.getParameter = False
##             elif name == 'parameter':
##                 if self.getParameter:
##                     type = attrs.get('type', '')
##                     value = attrs.get('value', '')
##                     if type in ['float', 'int']:
##                         value = float(value)
##                         sn('nent', 'triggerParam_'+attrs.get('name','')+'_'+self.trigID)
##                         cf('min', 0.0)
##                         cf('val', value)
##                         cs('type', 'float')
##                         sel('..')
##             elif name == 'entity':
##                 path = attrs.get('name', '')
##                 binding = attrs.get('id', '')
##                 if binding != 'trainee':
##                     sn('nent', binding)
##                     cs('val', str(path))
##                     cs('type', 'string')
##                     sel('..')
                
                
##         def endElement(self, name):
##             if name == 'int':
##                 ci('val', int(self.intval))
##                 sel('..')
##                 self.inInt = False
##             elif name == 'float':
##                 cf('val', float(self.floatval))
##                 sel('..')
##                 self.inFloat = False
##             elif name == 'bool':
##                 ci('val', self.boolval == 'True')
##                 sel('..')
##                 self.inBool = False
##             elif name == 'vector':
##                 x, y, z = vector3(self.vecval[1:-1])
##                 cv('val', x, y, z)
##                 sel('..')
##                 self.inVector = False
##             elif name == 'trigger':
##                 self.getParameter = False
                
##         def characters(self, buf):
##             if self.inInt:
##                 self.intval += buf.strip()
##             if self.inFloat:
##                 self.floatval += buf.strip()
##             if self.inBool:
##                 self.boolval += buf.strip()
##             if self.inVector:
##                 self.vecval += buf.strip()

##     class masterParser(ContentHandler):
        
##         def __init__(self):
##             self.networks = {}
##             self.networkColor = {}
##         def startElement(self, name, attrs):
##             if name == 'network':
##                 filename = attrs.get('file','')
##                 nname = attrs.get('name','')
##                 color = attrs.get('colour', 'black')
##                 nparser = networkParser()
##                 try:                    
##                     nf = open('cat/networks/'+filename)
##                     res = filename.split('.')
##                     sn('nent', res[0])
##                     cs('colour', str(color))
##                     cs('ext', str(res[1]))
##                     #sn('nent', 'target')
##                     #cs('val', '/game/ents/ddg51/ddg510')
##                     #cs('type', 'string')
##                     #sel('..')
##                     xml.sax.parse(nf, nparser)
##                     sel('..')
##                     nf.close()
##                     self.networks[filename] = nname
##                     self.networkColor[filename] = color
##                 except:
##                     printExcept('cat:FindNetorks()')
##     sn('nthing', '/comm/tasks')
##     f = open("cat/networks/master.xml", "r")
##     parser = masterParser()
##     xml.sax.parse(f, parser)
##     from common import EventNames
##     import nEventServer
##     nEventServer.pull(EventNames.TASKS_CHANGED, '')
    
##     f.close()
##     return parser.networks, parser.networkColor

## def SaveNetworks(networks, colors):
##     from cat.BehaviorNetwork.constructor import xml_logger
##     f = open("cat/networks/master.xml", "w")
##     logger = xml_logger(f)
##     logger.OpenTag('networks', {}, True)
##     for fi, name in networks.iteritems():
##         logger.WriteEntry('network', {'name':name, 'file':fi, 'colour':colors[fi]}, '')
##     logger.CloseTag('networks')
##     f.close()

#class CAT(wx.App):
#    def OnInit(self):
#        frame = CATFrame(None, -1, "CAT")
#        frame.Show(True)
#        self.SetTopWindow(frame)
#        return True

#frame = CATFrame(None, -1, "CAT")
#frame.Show(True)
#f = wx.Frame(None, -1, "Tmp")
#p = CATPanel(f)

#if __name__ == '__main__':
#    app = CAT(0)
#    app.MainLoop()

##############################################################################################################

class CATPanel1(wx.Panel):
    '''
    The wxFrame that defines the GUI
    '''
    ID_PAUSE = 102
    ID_SAVE = 103
    ID_RECORD = 104
    ID_STOP = 105
    ID_PLAY = 106
    ID_START = 107
    ID_QUERY = 108

    def __init__(self, parent, ID=-1, pos = wx.DefaultPosition, size = wx.DefaultSize):
        '''
        Creates and layouts the CAT GUI
        '''	
        wx.Panel.__init__(self, parent, ID, size = size)

	from common import EventNames
	import nEventServer

        nEventServer.register(EventNames.RMENU_AUTHORING_MODE,  self.onSetAuthoring)
        nEventServer.register(EventNames.RMENU_EXECUTION_MODE,  self.onSetExecution)
        nEventServer.register(EventNames.CAT_SELECT_ENT, self.onSelectEnt)
	

        self.bgcolor = "CYAN"
    
        color1 = wx.Colour (185, 239, 232)
        color2 = wx.Colour (123, 219, 235)
        color3 = wx.Colour (123, 198, 235)
        color4 = wx.Colour (123, 163, 235)

        color5 = wx.Colour (236, 231, 190)
        color6 = wx.Colour (221, 211, 124)
        color7 = wx.Colour (236, 223,  79)
        color8 = wx.Colour (236, 184,  79)

        self.notebook = wx.Notebook(self, -1) #style =wx.NB_FIXEDWIDTH | wx.RAISED_BORDER | wx.DOUBLE_BORDER)
        wx.EVT_NOTEBOOK_PAGE_CHANGING(self.notebook, -1, self.pageChanging)
    
        self.panelAuthoring = wx.Panel(self.notebook, -1, (200,500), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
        
        self.panelAuthoring.SetBackgroundColour(color1)

        self.notebook.AddPage(self.panelAuthoring, "Authoring")

        self.panelExecution = wx.Panel(self.notebook, -1, (200, 500), style = wx.SUNKEN_BORDER | wx.SIMPLE_BORDER)
        
        self.panelExecution.SetBackgroundColour(color5)
        
        self.notebook.AddPage(self.panelExecution, "Execution")

        #self.oldPanel = wx.Panel(self.notebook, -1, (200, 500), style = wx.SUNKEN_BORDER | wx.SIMPLE_BORDER)
        
        #self.oldPanel.SetBackgroundColour(wx.Colour(199, 142, 235))

        WindowManager.register("TRIGGERS", self)
        ppos, ps = WindowManager.get("TRIGGERS")
        import triggers
        self.triggerPanel = triggers.getGUI(self.notebook, ps)
        self.triggerPanel.tester()

        self.notebook.AddPage(self.triggerPanel, "Triggers")
        
        
        #self.notebook.AddPage(self.oldPanel, "Old GUI")

        #authoring
	
        defaultSize = (-1, -1) #(200, 800)
	
        import entityPanel 
        self.entityPanel = entityPanel.EntityPanel(self.panelAuthoring, defaultSize, color1)

        import targetPanel
        self.targetPanel = targetPanel.TargetPanel(self.panelAuthoring, defaultSize, color2)
        
        import controlPanel
        self.controlPanel = controlPanel.ControlPanel(self.panelAuthoring, defaultSize, color3)
        
        import managePanelA
        
        self.managementPanel = managePanelA.ManagePanelA(self.panelAuthoring, defaultSize, color4)

        #execution
        
        self.entityPanel1 = entityPanel.EntityPanel(self.panelExecution, defaultSize, color5)

        self.targetPanel1 = targetPanel.TargetPanel(self.panelExecution, defaultSize, color6)
        
        self.controlPanel1 = controlPanel.ControlPanel(self.panelExecution, defaultSize, color7)
        
        import managementPanelE
        
        self.managementPanel1 = managementPanelE.ManagementPanelE(self.panelExecution, defaultSize, color8)
        
        #self.oldCATPanel = CATPanel(self.oldPanel) 
        
        #sizing authoring
        
        aSizer = wx.BoxSizer(wx.VERTICAL)
        
        aSizer.Add(self.entityPanel)
        #aSizer.Add(spacer1)
        
        aSizer.Add(self.targetPanel)
        #aSizer.Add(spacer2)
        
        aSizer.Add(self.controlPanel)
        #aSizer.Add(spacer3)
        
        aSizer.Add(self.managementPanel)
        #aSizer.Add(spacer4)
        
        #sizing execution
        
        eSizer = wx.BoxSizer(wx.VERTICAL)
        
        eSizer.Add(self.entityPanel1)
        
        eSizer.Add(self.targetPanel1)
        
        eSizer.Add(self.controlPanel1)
        
        eSizer.Add(self.managementPanel1)
        
        #sizing old GUI
        
        #oSizer = wx.BoxSizer(wx.VERTICAL)
        #oSizer.Add(self.oldCATPanel)
        
        self.panelAuthoring.SetSizer(aSizer)
        self.panelExecution.SetSizer(eSizer)
        #self.oldPanel.SetSizer(oSizer)
        
        self.everythingSizer = wx.BoxSizer(wx.VERTICAL)
        self.everythingSizer.Add(self.notebook)

        self.SetSizer(self.everythingSizer)
        self.SetAutoLayout(1)
        self.Show(1)
        
    def tick(self, time, dtime):
        self.targetPanel.tick(time, dtime)
        self.targetPanel1.tick(time, dtime)
        self.entityPanel.tick(time, dtime)
        self.entityPanel1.tick(time, dtime)
        self.controlPanel.tick(time, dtime)
        self.controlPanel1.tick(time, dtime)

        if EntityManager.currentState and EntityManager.currentState.controller.isActive():
            self.notebook.GetPage(0).Disable()
        else:
            self.notebook.GetPage(0).Enable()
        if EntityManager.currentState and EntityManager.currentState.recorder.isActive():
            self.notebook.GetPage(1).Disable()
        else:
            self.notebook.GetPage(1).Enable()
            
    def onSetAuthoring(self, msg):
        if EntityManager.currentState:
            if not EntityManger.currentState.controller.isActive():
                self.notebook.SetSelection(0)
        else:
            self.notebook.SetSelection(0)
    
    def onSetExecution(self, msg):
        if EntityManager.currentState:
            if not EntityManager.currentState.recorder.isActive():
                self.notebook.SetSelection(1)
        else:
            self.notebook.SetSelection(1)

    def pageChanging(self, event):
        if EntityManager.currentState:
            if (EntityManager.currentState.recorder.isActive() and \
               event.GetSelection() == 1) or \
               (EntityManager.currentState.controller.isActive() and \
                event.GetSelection() == 0):
                event.Veto()
            elif event.GetSelection() == 0:
                EntityManager.currentState.setAuthoringMode()
            elif event.GetSelection() == 1:
                EntityManager.currentState.setExecutionMode()

    def onSelectEnt(self, msg):
        if EntityManager.currentState:
            if EntityManager.currentState.recorder.isActive():
                self.notebook.SetSelection(0)
            if EntityManager.currentState.controller.isActive():
                self.notebook.SetSelection(1)


         
