#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
#TODO: Look into horizontal layout
#TODO: Set up recorder
#TODO: Tighten interface
'''
Defines the GUI and its operations for cat.

'''
import wx
#import wx.lib.fancytext as fancytext
#import common.WindowManager as WindowManager
#from common.defs import *
#import xml.sax
#from xml.sax.handler import ContentHandler
#import knob
#import math
from cat.merge import xmlmerger
#import manager
#from important import *
#import nEventServer
#from sensors import *
#import cat.Behaviors as Behaviors
#from cat.BehaviorNetwork.recorder import Recorder
from cat.entity import EntityManager
from savedialog import SaveDialog
import netmanagement as nm
from common import EventNames
import nEventServer
from cat.merge import xmlmerger
#prefix = "/home/dascalus/work/cadabra/code/scripts/cat/Interface/"
from common.defs import *

class ManagementPanelA(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''
    
    ID_PAUSE = 102
    ID_SAVE = 103
    ID_RECORD = 104
    ID_STOP = 105
    ID_PLAY = 106
    ID_START = 107
    ID_QUERY = 108

    def __init__(self, parent, size, color = "RED"):
        
        wx.Panel.__init__(self, parent, -1, (215,500), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
        
        nEventServer.register(EventNames.CAT_SELECT_ENT,  self.onSelectEnt)
	
	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)

	labelM = wx.StaticText(self, -1, "RECORDER")
	
	spacer1 = wx.StaticText(self, -1, "", size= (215, 5), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 90), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (215, 4), style = wx.ALIGN_RIGHT)
	spacerS = wx.StaticText(self, -1, "", size= (188, 4), style = wx.ALIGN_CENTER)
	
	#self.Pane=wx.Panel(self, -1)
	
	self.tb = wx.ToolBar(self)
        self.tb.SetBackgroundColour(self.GetParent().GetBackgroundColour())
	 
        #self.open_bmp = wx.Bitmap(prefix+"open.gif", wx.BITMAP_TYPE_GIF)
        import os
        prefix = os.path.dirname(__file__)+"/"
        del os
        self.save_bmp = wx.Bitmap(prefix+"save.gif", wx.BITMAP_TYPE_GIF)
        self.record_bmp = wx.Bitmap(prefix+"record.gif", wx.BITMAP_TYPE_GIF)
        self.stop_bmp = wx.Bitmap(prefix+"stop.gif", wx.BITMAP_TYPE_GIF)
        self.pause_bmp = wx.Bitmap(prefix+"pause.gif", wx.BITMAP_TYPE_GIF)
        self.play_bmp = wx.Bitmap(prefix+"play.gif", wx.BITMAP_TYPE_GIF)
        self.tb.AddSeparator()
	self.tb.SetBackgroundColour("RED")
	self.tb.SetForegroundColour("BLUE")

        self.tb2 = wx.ToolBar(self)
        
	
        self.filename = wx.Choice(self.tb2, -1, size=(180, -1))
        #wx.EVT_CHOICE(self.filename, -1, self.OnSelect)

        self.loadNetworks()
        
	self.tb2.AddControl(self.filename)
        self.tb2.Realize()
        
	self.tb.AddSimpleTool(self.ID_SAVE, self.save_bmp, "Save As...", "Save Behavior Network")
        self.tb.AddSimpleTool(self.ID_RECORD, self.record_bmp, "Record", "Record Behavior Network")
        self.tb.AddSimpleTool(self.ID_STOP, self.stop_bmp, "Stop", "Stop Recording Behavior Network")
        self.tb.AddSimpleTool(self.ID_PAUSE, self.pause_bmp, "Pause", "Pause Recording Behavior Network")

        self.tb.EnableTool(self.ID_STOP, False)
        self.tb.EnableTool(self.ID_PAUSE, False)
        self.tb.EnableTool(self.ID_SAVE, False)

        self.tb.Realize()
        wx.EVT_TOOL(self.tb, self.ID_SAVE, self.save)
        wx.EVT_TOOL(self.tb, self.ID_RECORD, self.record)
        wx.EVT_TOOL(self.tb, self.ID_STOP, self.stop)
        wx.EVT_TOOL(self.tb, self.ID_PAUSE, self.pause)
        ########################################################################
        
        
	#self.aPanel = ApproachPanel
	box = wx.StaticBox(self, -1, "", style=wx.SUNKEN_BORDER)
	box.SetBackgroundColour(wx.Colour (185, 239, 232))
        bsizer = wx.StaticBoxSizer(box, wx.VERTICAL)
        bsizer.Add(self.tb, 0, wx.TOP|wx.ALIGN_CENTER, 2)
        
	
	bsizer.Add(spacerS, 0, wx.CENTER|wx.ALIGN_CENTER, 2)
	bsizer.Add(self.tb2, 0, wx.BOTTOM|wx.ALIGN_CENTER, 2)
	border = wx.BoxSizer()
        border.Add(bsizer, 1, wx.EXPAND|wx.ALL, 2)
    
	sizerE = wx.BoxSizer(wx.VERTICAL)
	sizerE.Add(labelM)
	sizerE.Add(spacer1)	
	sizerE.Add(border)
	sizerE.Add(spacer2)
	self.SetSizer(sizerE)

    def save(self, event):
        if EntityManager.currentState:
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, False)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, False)

            f = self.filename.GetStringSelection()
            if f == '< new behavior net >':
                try:
                    validName = False
                    while not validName:
                        dialog = SaveDialog(self, -1, "Save Network",  \
                                            pos=(1026,100), style=wx.DEFAULT_DIALOG_STYLE)
                        val = dialog.ShowModal()
                        if val == wx.ID_OK:
                            filename = dialog.filename.GetValue()
                            netname = dialog.netname.GetValue()
                            if self.networks.has_key(filename):
                                dlg = wx.MessageDialog(self, 'File already exists.\n' + \
                                                       'Do you want to overwrite the existing network?', \
                                                       'Error', wx.YES_NO|wx.ICON_ERROR, (800, 100))
                                dlg.Move((1000,100))
                                val = dlg.ShowModal()
                                dlg.Destroy()
                                if val == wx.ID_NO:
                                    continue
                                if filename == '' or netname == '':
                                    dlg = wx.MessageDialog(self, 'Empty Values. Please fill in all fields.', \
                                                       'Error', wx.OK|wx.ICON_ERROR, pos=(800, 100))
                                    dlg.Move((1000,100))
                                    dlg.ShowModal()
                                    dlg.Destroy()
                                    continue
                            validName = True
                            EntityManager.currentState.recorder.save(filename, netname)
                            self.networks[filename] = netname
                            #use the default set thing here
                            if not self.networkColor.has_key(filename):
                                self.networkColor[filename] = 'black'

                            nm.SaveNetworks(self.networks, self.networkColor)

                        else:
                            validName = True
                except:
                    printExcept('Problem with saving new network')

            else:
                #put merging in here
                f2 = open("cat/networks/"+f)
                net1 = f2.read()
                f2.close()
                try:
                    net2 = self.recorder.Save("tmp.bn", "Temp for merging", False)       
                    try:
                        net3 = xmlmerger.mergeNetworkStrings(net1, net2)
                        f2 = open("cat/networks/"+f, "w")
                        f2.write(net3)
                    except:
                        printExcept('Problem with merging networks')
                except:
                    printExcept('Problem with creating second network')
                    

    def record(self, event):
        if EntityManager.currentState:
            self.tb.EnableTool(self.ID_RECORD, False)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, True)
            self.tb.EnableTool(self.ID_SAVE, True)
            EntityManager.currentState.recorder.start()

    def stop(self, event):
        if EntityManager.currentState:
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, False)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, True)
            EntityManager.currentState.recorder.stop()

    def pause(self, event):
        if EntityManager.currentState:
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, True)
            EntityManager.currentState.recorder.pause()

    def getPanel(self):
        return self

    def loadNetworks(self, msg=None):
        self.networks, self.networkColor = nm.FindNetworks()
        nets = ["< new behavior net >"]
        nets.extend(self.networks.keys())
        self.filename.Clear()
        self.filename.AppendItems(nets)
        self.filename.SetSelection(0)

        
    def onSelectEnt(self, msg):
        if EntityManager.currentState:
            if EntityManager.currentState.recorder.isActive():
                self.tb.EnableTool(self.ID_RECORD, False)
                self.tb.EnableTool(self.ID_STOP, True)
                self.tb.EnableTool(self.ID_PAUSE, True)
                self.tb.EnableTool(self.ID_SAVE, True)
            else:
                if EntityManager.currentState.recorder.hasMaterial == 0:
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, False)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, False)
                elif EntityManager.currentState.recorder.hasMaterial == 1:
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, True)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, True)
                elif EntityManager.currentState.recorder.hasMaterial == 2:
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, False)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, True)
