#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
#TODO: Look into horizontal layout
#TODO: Set up recorder
#TODO: Tighten interface
'''
Defines the GUI and its operations for cat.

'''
import wx
#import wx.lib.fancytext as fancytext
#import common.WindowManager as WindowManager
from common.defs import *
#import xml.sax
#from xml.sax.handler import ContentHandler
#import knob
import math
#from cat.merge import xmlmerger
import manager
#from important import *
import nEventServer
#from sensors import *
#import cat.Behaviors as Behaviors
#from cat.BehaviorNetwork.recorder import Recorder
from common import EventNames

#prefix = "/home/dascalus/work/cadabra/code/scripts/cat/Interface/"
from cat.entity import EntityManager

class ManagementPanelE(wx.Panel):
    '''Behavior Network Management panel class - Execution only'''
    
    ID_PAUSE = 102
    ID_SAVE = 103
    ID_RECORD = 104
    ID_STOP = 105
    ID_PLAY = 106
    ID_START = 107
    ID_QUERY = 108

    def __init__(self, parent, size, color = "RED"):
        
        wx.Panel.__init__(self, parent, -1, (215,500), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
	
        nEventServer.register(EventNames.CAT_TASKS_CHANGED,  self.loadNetworks)
        nEventServer.register(EventNames.CAT_SELECT_ENT, self.onSelectEnt)
        nEventServer.register(EventNames.RMENU_EXECUTION_MODE, self.onSelectEnt)
        nEventServer.register(EventNames.CAT_NETWORK_STOP,  self.onSelectEnt)
        
	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)

	labelME = wx.StaticText(self, -1, "AI MODE")
	
	spacer1 = wx.StaticText(self, -1, "", size= (215, 5), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 90), style = wx.ALIGN_BOTTOM)
	spacer3 = wx.StaticText(self, -1, "", size= (215, 3), style = wx.ALIGN_RIGHT)
	spacerS = wx.StaticText(self, -1, "", size= (188, 2), style = wx.ALIGN_BOTTOM)
		

	#self.Pane=wx.Panel(self, -1)
	
	self.tb = wx.ToolBar(self)
       
        import os
        prefix = os.path.dirname(__file__)+"/"
	
        #self.open_bmp = wx.Bitmap(prefix+"open.gif", wx.BITMAP_TYPE_GIF)
        #self.save_bmp = wx.Bitmap(prefix+"save.gif", wx.BITMAP_TYPE_GIF)
        #self.record_bmp = wx.Bitmap(prefix+"record.gif", wx.BITMAP_TYPE_GIF)
        self.play_bmp = wx.Bitmap(prefix+"play.gif", wx.BITMAP_TYPE_GIF)
	self.pause_bmp = wx.Bitmap(prefix+"pause.gif", wx.BITMAP_TYPE_GIF)
        self.stop_bmp = wx.Bitmap(prefix+"stop.gif", wx.BITMAP_TYPE_GIF)
       
        self.tb.AddSeparator()
        self.filename = wx.TextCtrl(self.tb, -1, "untitled")
        
	self.tb2 = wx.ToolBar(self)
	#nets = ["---------------"]
        #self.networks, self.networkColor = FindNetworks()
        #nets.extend(self.networks.keys())
        self.filename = wx.Choice(self.tb2, -1, size=(180,-1))
        #self.filename.SetSelection(0)
        self.loadNetworks()
        #wx.EVT_CHOICE(self.filename, -1, self.OnSelect)
	self.tb2.AddControl(self.filename)
        self.tb2.Realize()
        
	
        
	#self.tb.AddSimpleTool(self.ID_SAVE, self.save_bmp, "Save As...", "Save Behavior Netork")
        self.tb.AddSimpleTool(self.ID_PLAY, self.play_bmp, "Play", "Play Behavior Network")
        self.tb.AddSimpleTool(self.ID_PAUSE, self.pause_bmp, "Pause", "Pause")
	#self.tb.AddSimpleTool(self.ID_RECORD, self.record_bmp, "Record", "Record Behavior Network")
	self.tb.AddSimpleTool(self.ID_STOP, self.stop_bmp, "Stop", "Stop Recording Behavior Netork")
        self.tb.EnableTool(self.ID_STOP, False)
        self.tb.EnableTool(self.ID_PAUSE, False)
        self.tb.Realize()
        
	#wx.EVT_TOOL(self.tb, self.ID_SAVE, self.SaveNetwork)
        wx.EVT_TOOL(self.tb, self.ID_PLAY, self.play)
        #wx.EVT_TOOL(self.tb, self.ID_RECORD, self.StartRecord)
        wx.EVT_TOOL(self.tb, self.ID_STOP, self.stop)
        wx.EVT_TOOL(self.tb, self.ID_PAUSE, self.pause)
        ########################################################################
        
        
	
	box = wx.StaticBox(self, -1, "", style=wx.SUNKEN_BORDER)
        bsizer = wx.StaticBoxSizer(box, wx.VERTICAL)
        bsizer.Add(self.tb, 0, wx.TOP|wx.ALIGN_CENTER, 2)
        bsizer.Add(spacerS, 0, wx.CENTER|wx.ALIGN_CENTER, 2)
	bsizer.Add(self.tb2, 0, wx.BOTTOM|wx.ALIGN_CENTER, 2)
	border = wx.BoxSizer()
        border.Add(bsizer, 1, wx.EXPAND|wx.ALL, 2)
    
	sizerE = wx.BoxSizer(wx.VERTICAL)
	sizerE.Add(labelME)
	sizerE.Add(spacer1)
	
	#sizer1 = wx.BoxSizer(wx.VERTICAL)
	
	#sizer1.Add(self.tb)
	
	sizerE.Add(border)
	sizerE.Add(spacer2)
	#sizerE.Add(self.tb2)
	#sizerE.Add(spacer3)
	self.SetSizer(sizerE)

	#sizerE = wx.BoxSizer(wx.VERTICAL)
# 	space = 4
# 	sizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
# 	sizer.AddMany ([l1a, t1a, l2a, t2a, l3a, t3a,])
	#sizerE.Add(labelE)
	#sizerE.Add(sizerR)

#	sizerE.Add(spacer1)
	#sizerE.Add (sizer)
	#sizerE.Add(spacer)
        #self.SetSizer(sizerE)

    def getPanel(self):
        return self
    
    def loadNetworks(self, msg=None):
        self.networks, self.networkColor = EntityManager.networks
        self.filename.Clear()
        self.filename.AppendItems(self.networks.keys())
        self.filename.SetSelection(0)

    def play(self, event=None):
        if EntityManager.currentState:
            self.tb.EnableTool(self.ID_PLAY, False)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, True)
            filepath = "cat/networks/"+self.filename.GetStringSelection()
            manager.AttachNetwork(EntityManager.currentState.sensors.GetOwnEntity(), filepath, \
                                  {'target':EntityManager.currentState.sensors.GetTargetEntity()})
            self.filename.Disable()

    def stop(self, event=None):
        if EntityManager.currentState:
            self.filename.Enable()
            self.tb.EnableTool(self.ID_PLAY, True)
            self.tb.EnableTool(self.ID_STOP, False)
            self.tb.EnableTool(self.ID_PAUSE, False)
            EntityManager.currentState.controller.stop()

    def pause(self, event=None):
        if EntityManager.currentState:
            self.filename.Disable()
            self.tb.EnableTool(self.ID_PLAY, True)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, False)
            EntityManager.currentState.controller.pause()

    def onSelectEnt(self, msg):
        if EntityManager.currentState:
            if EntityManager.currentState.controller.isActive():
                self.filename.SetStringSelection(EntityManager.currentState.controller.filename)
                self.filename.Disable()
                self.tb.EnableTool(self.ID_PLAY, False)
                self.tb.EnableTool(self.ID_STOP, True)
                self.tb.EnableTool(self.ID_PAUSE, True)
            else:
                self.filename.Enable()
                self.tb.EnableTool(self.ID_PLAY, True)
                self.tb.EnableTool(self.ID_STOP, False)
                self.tb.EnableTool(self.ID_PAUSE, False)
