#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
"""
Provides the external interface to CAT.

System access to CAT is done through this file. Right now this is
calling Tick() and attaching controllers to entities. In the future,
there will be calls to get information about available controllers
and such.

These methods should be access by importing cat and not through manager
directly.
"""
import gui
import sensors
#from important import *
from common import tickmanager
from common.defs import *
#from cat.Behaviors import maintain
#from cat.Behaviors import approach
#from cat.Controllers import behcontroller
#from cat.Controllers.bnetcontroller import NetworkController
from cat.entity import EntityManager
import wx

startScenario = False
targetQuery = False
startScenarioChange = False
targetQueryChange = False

attachedControllers = {}
controllerFilename = {}
controllerBins = {}
currentBin = 0
binCount = {0:0, 1:0, 2:0}

def getGUI(parentFrame, size):
    global EntityManager
    gui.panel = gui.CATPanel(parentFrame, size=size)
    return gui.panel

def getGUI1(parentFrame, size):
    gui.panel1 = gui.CATPanel1 (parentFrame, size=size)
    return gui.panel1

def getval(name, vars, path):
    val = None
    if not vars.has_key(name):
        if exists(path+'/'+name):
            sel(path+'/'+name)
            type = cs('type')
            if type == 'string':
                val = gs('val')
            elif type == 'float':
                val = gf('val')
            elif type == 'vec':
                val = gv('val')
    else:
        val = vars[name]
        return val

def AttachNetwork(entity, filepath, extvars = {}):
    #print "********", entity, filepath, extvars
    #Get vars
    entState = EntityManager.getEntityState(entity)
    myvars = dict(extvars)
    myvars['trainee'] = entity
    #Set target
    if myvars.has_key('target'):
        entState.sensors.setTarget(myvars['target'])
    #load network
    entState.controller.load(filepath, myvars)
    #set mode
    if entState.recorder.isActive():
        entState.recorder.pause()
    entState.setExecutionMode()
    import nEventServer
    from common import EventNames 
    nEventServer.pull(EventNames.RMENU_EXECUTION_MODE, entity)
    
def AttachController(entity, controller, vars):
    """
    Attaches a controller configured by vars to an entity.

    Right now there are only three controllers, and they are directly based
    on behaviors. Sopn, rather than being a hard-coded switch, this will dynamically
    set up the controllers based on the name and vars... as soon as I figure
    out how.
    """
    sel('/comm/tasks/'+controller)
    ext = gs('ext')
    filepath = 'cat/networks/'+controller+'.'+ext
    #controllerFilename[entity] = controller+'.'+ext
    AttachNetwork(entity, filepath, vars)
    sel(entity)
    if vars.has_key('target'):
        cref('disTarget', vars['target'])
    if vars.has_key('0_desiredX'):
        ci('disX', vars['0_desiredX'])
        ci('disY', vars['0_desiredY'])
    cs('disController', controller[0:10])

def HasAttached(entity):
    return attachedControllers.has_key(entity)

def IsRunning(entity):
    if attachedControllers.has_key(entity):
        con = attachedControllers[entity]
        return con.running
    else:
        return False

def DetachController(entity):
    if HasAttached(entity):
        con = attachedControllers.pop(entity)
        con.running = False
        binnum = controllerBins.pop(entity)
        binCount[binnum] -= 1
        return True
    return False

def PauseController(entity, pause):
    if HasAttached(entity):
        con = attachedControllers[entity]
        con.running = not pause
        return True
    else:
        return False

def SetTargetQuery(event):
    global targetQuery, targetQueryChange
    flag = event.IsChecked()
    if targetQuery != flag:
        targetQueryChange = True
    targetQuery = flag

def IsTargetQuery():
    return targetQuery
    
def HasTargetQueryChanged():
    global targetQueryChange
    if targetQueryChange:
        targetQueryChange = False
        return True
    return False

def SetStartScenario(event):
    global startScenario, startScenarioChange
    flag = event.IsChecked()
    if startScenario != flag:
        startScenarioChange = True
    startScenario = flag
        
def HasStartScenarioChanged():
    global startScenarioChange
    if startScenarioChange:
        startScenarioChange = False
        return True
    return False

def IsStartScenario():
    return startScenario

refreshTime = 0.0

def Tick(time, dtime):
    """
    Processes control for the selected entity via the GUI and for
    all attached controllers.

    Tick is called by the tickmanager.
    """
    global refreshTime, isImportant, currentBin, EntityManager
    refreshTime += dtime
    if refreshTime >= 0.1: # or IsImportant():
#        #ent = sensors.GetOwnEntity()
#=======
#        gui.panel1.oldCATPanel.RefreshInfo()
        EntityManager.tick(time, dtime)
#        #ent = sensors.GetOwnEntity()
#=======
#        gui.panel1.oldCATPanel.RefreshInfo()
	gui.panel1.tick(time, dtime)
#        ent = sensors.GetOwnEntity()
#>>>>>>> 1.2
        #I should really consider seperating the GUI refresh that Tick does out
#<<<<<<< manager.py
        #if currentBin == 0 and exists(ent):
            #heading, speed = gui.panel.Tick(time, dtime)
        #    if not IsRunning(ent):
        #        sel(ent)
        #        sf("desiredHeading", heading)
        #        sf("desiredSpeed", speed)
#=======
##         if currentBin == 0 and exists(ent):
##             heading, speed = gui.panel1.oldCATPanel.Tick(time, dtime)
##             if not IsRunning(ent):
##                 sel(ent)
##                 sf("desiredHeading", heading)
##                 sf("desiredSpeed", speed)
#>>>>>>> 1.2
##         for ent, bin in controllerBins.iteritems():
##             if bin % 3 == currentBin:
##                 conn = attachedControllers[ent]
##                 if conn and IsRunning(ent):
##                     conn.Tick(time, dtime)
##         if refreshTime >= 0.1:
##             refreshTime -= 0.1
##             currentBin += 1
##             if currentBin > 3:
##                 currentBin = 0

tickmanager.register('CATManager', Tick)
