import xml.sax
from xml.sax.handler import ContentHandler

from common.defs import *

def FindNetworks():
    class networkParser(ContentHandler):
        def __init__(self):
            self.inInt = False
            self.inFloat = False
            self.inBool = False
            self.inVector = False
            self.intval = ''
            self.floatval = ''
            self.boolval = ''
            self.vecval = ''
            self.getParameter = False
            self.trigID = ''
            
        def startElement(self, name, attrs):
            if name == 'behavior':
                self.id = attrs.get('id','')
            elif name == 'int':
                sn('nent', self.id+'_'+attrs.get('name', ''))
                ci('min', int(attrs.get('min', '')))
                ci('max', int(attrs.get('max', '')))
                cs('type', 'int')
                self.inInt = True
                self.intval = ''
            elif name == 'float':
                sn('nent', self.id+'_'+attrs.get('name', ''))
                cf('min', float(attrs.get('min', '')))
                cf('max', float(attrs.get('max', '')))
                cs('type', 'float')
                self.inFloat = True
                self.floatval = ''
            elif name == 'bool':
                sn('nent', self.id+'_'+attrs.get('name', ''))
                cf('min', 0)
                cf('max', 1)
                cs('type', 'bool')
                self.inBool = True
                self.boolvar = ''
            elif name == 'vector':
                sn('nent', self.id+'_'+attrs.get('name', ''))
                cf('min', float(attrs.get('min', '')))
                cf('max', float(attrs.get('max', '')))
                cs('type', 'vector3')
                self.inVector = True
                self.vecval = ''
            elif name == 'trigger':
                if attrs.get('name','') == 'Distance Between Entities':
                    self.getParameter = True
                    self.trigID = attrs.get('id', '')
                else:
                    self.getParameter = False
            elif name == 'parameter':
                if self.getParameter:
                    type = attrs.get('type', '')
                    value = attrs.get('value', '')
                    if type in ['float', 'int']:
                        value = float(value)
                        sn('nent', 'triggerParam_'+attrs.get('name','')+'_'+self.trigID)
                        cf('min', 0.0)
                        cf('val', value)
                        cs('type', 'float')
                        sel('..')
            elif name == 'entity':
                path = attrs.get('name', '')
                binding = attrs.get('id', '')
                if binding != 'trainee':
                    sn('nent', binding)
                    cs('val', str(path))
                    cs('type', 'string')
                    sel('..')
                
                
        def endElement(self, name):
            if name == 'int':
                ci('val', int(self.intval))
                sel('..')
                self.inInt = False
            elif name == 'float':
                cf('val', float(self.floatval))
                sel('..')
                self.inFloat = False
            elif name == 'bool':
                ci('val', self.boolval == 'True')
                sel('..')
                self.inBool = False
            elif name == 'vector':
                x, y, z = vector3(self.vecval[1:-1])
                cv('val', x, y, z)
                sel('..')
                self.inVector = False
            elif name == 'trigger':
                self.getParameter = False
                
        def characters(self, buf):
            if self.inInt:
                self.intval += buf.strip()
            if self.inFloat:
                self.floatval += buf.strip()
            if self.inBool:
                self.boolval += buf.strip()
            if self.inVector:
                self.vecval += buf.strip()

    class masterParser(ContentHandler):
        
        def __init__(self):
            self.networks = {}
            self.networkColor = {}
        def startElement(self, name, attrs):
            if name == 'network':
                filename = attrs.get('file','')
                nname = attrs.get('name','')
                color = attrs.get('colour', 'black')
                nparser = networkParser()
                try:                    
                    nf = open('cat/networks/'+filename)
                    res = filename.split('.')
                    sn('nent', res[0])
                    cs('colour', str(color))
                    cs('ext', str(res[1]))
                    #sn('nent', 'target')
                    #cs('val', '/game/ents/ddg51/ddg510')
                    #cs('type', 'string')
                    #sel('..')
                    xml.sax.parse(nf, nparser)
                    sel('..')
                    nf.close()
                    self.networks[filename] = nname
                    self.networkColor[filename] = color
                except:
                    printExcept('cat:FindNetorks()')
    sn('nthing', '/comm/tasks')
    f = open("cat/networks/master.xml", "r")
    parser = masterParser()
    xml.sax.parse(f, parser)
    
    import nEventServer
    from common import EventNames
    nEventServer.pull(EventNames.TASKS_CHANGED, '')
    
    f.close()
    return parser.networks, parser.networkColor

def SaveNetworks(networks, colors):
    from cat.BehaviorNetwork.constructor import xml_logger
    f = open("cat/networks/master.xml", "w")
    logger = xml_logger(f)
    logger.OpenTag('networks', {}, True)
    for fi, name in networks.iteritems():
        logger.WriteEntry('network', {'name':name, 'file':fi, 'colour':colors[fi]}, '')
    logger.CloseTag('networks')
    f.close()
    import nEventServer
    from common import EventNames
    nEventServer.pull(EventNames.CAT_NEW_NETWORK, '')
