#zz
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#
'''
Defines the GUI and its operations for cat.

'''
import wx
from cat.merge import xmlmerger
from cat.entity import EntityManager
from savedialog import SaveDialog
import netmanagement as nm
from common import EventNames
import nEventServer

from common import tickmanager
rootlabel = "RECORDER: "
timeconstant = 0.75

from common.defs import *
class RecordPanelA(wx.Panel):
    '''Behavior Network Management panel class - Authoring only'''

    ID_PAUSE = 102
    ID_SAVE = 103
    ID_RECORD = 104
    ID_STOP = 105
    ID_PLAY = 106
    ID_START = 107
    ID_QUERY = 108
    ID_DELETE = 109

    def __init__(self, parent, panelID, color = "RED", size=(215, 500), recType = "Recording"):
        
        wx.Panel.__init__(self, parent, -1, (215,500), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
        self.dtime = 0.0
        self.dots = 1
        
        nEventServer.register(EventNames.CAT_SELECT_ENT,  self.onSelectEnt)
        nEventServer.register(EventNames.CAT_TASKS_CHANGED,  self.loadNetworks)
	
        tickmanager.register('RecordPanelA', self.tick)
        
	self.bgcolor = color
        self.SetBackgroundColour(self.bgcolor)
	self.labelM = wx.StaticText(self, -1, rootlabel+'Stopped')
	
	spacer1 = wx.StaticText(self, -1, "", size= (215, 5), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 90), style = wx.ALIGN_RIGHT)
	spacer3 = wx.StaticText(self, -1, "", size= (215, 4), style = wx.ALIGN_RIGHT)
	spacerS = wx.StaticText(self, -1, "", size= (188, 4), style = wx.ALIGN_CENTER)
	
	#self.Pane=wx.Panel(self, -1)
	
	self.tb = wx.ToolBar(self)
        self.tb.SetBackgroundColour(self.GetParent().GetBackgroundColour())
	 
        #self.open_bmp = wx.Bitmap(prefix+"open.gif", wx.BITMAP_TYPE_GIF)
        
	import os
        prefix = os.path.dirname(__file__)+"/"
        
	del os
        self.save_bmp = wx.Bitmap(prefix+"save.gif", wx.BITMAP_TYPE_GIF)
        self.record_bmp = wx.Bitmap(prefix+"record.gif", wx.BITMAP_TYPE_GIF)
        self.stop_bmp = wx.Bitmap(prefix+"stop.gif", wx.BITMAP_TYPE_GIF)
        self.pause_bmp = wx.Bitmap(prefix+"pause.gif", wx.BITMAP_TYPE_GIF)
        self.play_bmp = wx.Bitmap(prefix+"play.gif", wx.BITMAP_TYPE_GIF)
        self.delete_bmp = wx.Bitmap(prefix+"delete.gif", wx.BITMAP_TYPE_GIF)
        self.tb.AddSeparator()
	self.tb.SetBackgroundColour("RED")
	self.tb.SetForegroundColour("BLUE")

        self.tb2 = wx.ToolBar(self)
        
	
        self.filename = wx.Choice(self.tb2, -1, size=(180, -1))
        #wx.EVT_CHOICE(self.filename, -1, self.OnSelect)

        self.loadNetworks()
        
	self.tb2.AddControl(self.filename)
        self.tb2.Realize()
        
	self.tb.AddSimpleTool(self.ID_SAVE, self.save_bmp, "Save As...", "Save Behavior Network")
        self.tb.AddSimpleTool(self.ID_RECORD, self.record_bmp, "Record", "Record Behavior Network")
        self.tb.AddSimpleTool(self.ID_STOP, self.stop_bmp, "Stop", "Stop Recording Behavior Network")
        self.tb.AddSimpleTool(self.ID_PAUSE, self.pause_bmp, "Pause", "Pause Recording Behavior Network")
        self.tb.AddSimpleTool(self.ID_DELETE, self.delete_bmp, "Delete", "Delete Behavior Network")

        self.tb.EnableTool(self.ID_STOP, False)
        self.tb.EnableTool(self.ID_PAUSE, False)
        self.tb.EnableTool(self.ID_SAVE, False)
        self.tb.EnableTool(self.ID_DELETE, True)

        self.tb.Realize()
        
	wx.EVT_TOOL(self.tb, self.ID_SAVE, self.save)
        wx.EVT_TOOL(self.tb, self.ID_RECORD, self.record)
        wx.EVT_TOOL(self.tb, self.ID_STOP, self.stop)
        wx.EVT_TOOL(self.tb, self.ID_PAUSE, self.pause)
        wx.EVT_TOOL(self.tb, self.ID_DELETE, self.delete)
        
	########################################################################
        
	box = wx.StaticBox(self, -1, "", style=wx.NO_BORDER)
	box.SetBackgroundColour(wx.Colour (185, 239, 232))
        bsizer = wx.StaticBoxSizer(box, wx.VERTICAL)
	bsizer.Add(self.tb, 0, wx.TOP|wx.ALIGN_CENTER, 2)
	bsizer.Add(spacerS, 0, wx.CENTER|wx.ALIGN_CENTER, 2)
	bsizer.Add(self.tb2, 0, wx.BOTTOM|wx.ALIGN_CENTER, 2)
	#border = wx.BoxSizer()
        #border.Add(bsizer, 1, wx.EXPAND|wx.ALL, 2)
    
	sizerE = wx.BoxSizer(wx.VERTICAL)
	sizerE.Add(self.labelM)
	sizerE.Add(spacer1)	
	#sizerE.Add(border)
	sizerE.Add(bsizer)
	sizerE.Add(spacer2)
	self.SetSizer(sizerE)

    def save(self, event):
        if EntityManager.currentState:
            self.labelM.SetLabel(rootlabel+'Stopped')
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, False)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, False)
            self.tb.EnableTool(self.ID_DELETE, True)

            f = self.filename.GetStringSelection()
            if f == '< new behavior net >':
                pt = {'state':'save', 'networks':self.networks}
                self.GetParent().show('Save_recorded', pt)
            else:
                #merging
                f2 = open("cat/networks/"+f)
                net1 = f2.read()
                f2.close()
                try:
                    if EntityManager.currentState:
                        net2 = EntityManager.currentState.recorder.save('tmp.bn', 'Temp for merging', False)       
                        try:
                            net3 = xmlmerger.mergeNetworkStrings(net1, net2)
                            f2 = open("cat/networks/"+f, "w")
                            f2.write(net3)
                        except:
                            printExcept('Problem with merging networks')
                except:
                    printExcept('Problem with creating second network')

    def record(self, event):
        if EntityManager.currentState:
            self.labelM.SetLabel(rootlabel+'Recording')
            self.tb.EnableTool(self.ID_RECORD, False)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, True)
            self.tb.EnableTool(self.ID_SAVE, True)
            self.tb.EnableTool(self.ID_DELETE, False)
            EntityManager.currentState.recorder.start()

    def stop(self, event):
        if EntityManager.currentState:
            self.labelM.SetLabel(rootlabel+'Stopped')
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, False)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, True)
            self.tb.EnableTool(self.ID_DELETE, False)
            EntityManager.currentState.recorder.stop()

    def pause(self, event):
        if EntityManager.currentState:
            self.labelM.SetLabel(rootlabel+'Paused')
            self.tb.EnableTool(self.ID_RECORD, True)
            self.tb.EnableTool(self.ID_STOP, True)
            self.tb.EnableTool(self.ID_PAUSE, False)
            self.tb.EnableTool(self.ID_SAVE, True)
            self.tb.EnableTool(self.ID_DELETE, False)
            EntityManager.currentState.recorder.pause()

    def delete(self, event):
        self.GetParent().show('Delete_file')

    def getPanel(self):
        return self

    def loadNetworks(self, msg=None):
        #self.networks, self.networkColor = nm.FindNetworks()
        self.networks, self.networkColor = EntityManager.networks
        nets = ["< new behavior net >"]
        nets.extend(self.networks.keys())
        self.filename.Clear()
        self.filename.AppendItems(nets)
        self.filename.SetSelection(0)

        
    def onSelectEnt(self, msg):
        if EntityManager.currentState:
            if EntityManager.currentState.recorder.isActive():
                self.labelM.SetLabel(rootlabel+'Recording')
                self.tb.EnableTool(self.ID_RECORD, False)
                self.tb.EnableTool(self.ID_STOP, True)
                self.tb.EnableTool(self.ID_PAUSE, True)
                self.tb.EnableTool(self.ID_SAVE, True)
                self.tb.EnableTool(self.ID_DELETE, False)
            else:
                if EntityManager.currentState.recorder.hasMaterial == 0:
                    self.labelM.SetLabel(rootlabel+'Stopped')
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, False)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, False)
                    self.tb.EnableTool(self.ID_DELETE, True)
                elif EntityManager.currentState.recorder.hasMaterial == 1:
                    self.labelM.SetLabel(rootlabel+'Paused')
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, True)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, True)
                    self.tb.EnableTool(self.ID_DELETE, False)
                elif EntityManager.currentState.recorder.hasMaterial == 2:
                    self.labelM.SetLabel(rootlabel+'Stopped')
                    self.tb.EnableTool(self.ID_RECORD, True)
                    self.tb.EnableTool(self.ID_STOP, False)
                    self.tb.EnableTool(self.ID_PAUSE, False)
                    self.tb.EnableTool(self.ID_SAVE, True)
                    self.tb.EnableTool(self.ID_DELETE, False)

    def show(self, data = {}):
        self.Show()
        if data.get('state') == 'ok':
            filename = data['filename']
            netname = data['netname']
            if not filename.endswith('.bn'):
                filename = filename + '.bn'
            EntityManager.currentState.recorder.save(filename, netname)
            self.networks[filename] = netname
            if not self.networkColor.has_key(filename):
                self.networkColor[filename] = 'black'
            nm.SaveNetworks(self.networks, self.networkColor)
        if data.get('state') == 'yes':
            f = self.filename.GetStringSelection()
            if f != '< new behavior net >':
                self.networks.pop(f)
                self.networkColor.pop(f)
                nm.SaveNetworks(self.networks, self.networkColor)

    def tick(self, time, dtime):
        if EntityManager.currentState and EntityManager.currentState.recorder.isActive():
            self.dtime += dtime
            if self.dtime > timeconstant:
                self.dtime -= timeconstant
                self.labelM.SetLabel(rootlabel+'Recording'+'.'*self.dots)
                self.dots += 1
                if self.dots > 3:
                    self.dots = 0
