import wx
import recordPanelA

class RecordWrapper(wx.Panel):
    def __init__(self, parent, id, color):
	    
        wx.Panel.__init__(self, parent, id)
	
	self.sizer = wx.BoxSizer(wx.HORIZONTAL)
	self.SetSizer(self.sizer)
	
	self.defaultPanel = recordPanelA.RecordPanelA (self, -1, size = (210, 210))
	
	self.defaultPanel.SetBackgroundColour(color)
	self.sizer.Add(self.defaultPanel, 1, flag=wx.EXPAND)
	
	self.panels = {}
	self.panels['default'] = self.defaultPanel
	self.show('default')
	
    def show(self, name, passthru = {}):
        #print "In recorder wrapper:  ", str(name)
        found = False
        for panelName, panel in self.panels.iteritems():
            if panelName != name:
                panel.Hide()
            else:
                panel.show(passthru)
                found = True
	self.sizer.Layout()
            
    def hide(self):
        for panelName, panel in self.panels.iteritems():
            panel.Hide()
	    self.sizer.Layout()
    
    def addPanel(self, panel, name):
	    panel.Hide()
	    self.sizer.Add(panel, 1, flag=wx.EXPAND)
	    self.panels[name] = panel
	    self.sizer.Layout()
    
    def showEvent(self, event):
	name = event.GetEventObject().GetName()
	self.show(name)

        
