#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#
#TODO: Fix Header
#TODO: Look into horizontal layout
#TODO: Set up recorder
#TODO: Tighten interface
'''
Defines the GUI and its operations for cat.

'''
import wx
#import wx.lib.fancytext as fancytext
#import common.WindowManager as WindowManager
from common.defs import *
#import xml.sax
#from xml.sax.handler import ContentHandler
#import knob
import math
#from cat.merge import xmlmerger
#import manager
#from important import *
import nEventServer
#from sensors import *
#import cat.Behaviors as Behaviors
#from cat.BehaviorNetwork.recorder import Recorder
from common import EventNames

HITPOINTS      = "Damage: "
POSITION       = "Pos: "
HEADING        = "Head: "
SPEED          = "Speed: "
CURRENTHEADING = "CurrentHeading"
CURRENTSPEED   = "CurrentSpeed"
SELECTTARGET   = "Sel"
TARGET         = "Target"
BEARING        = "Bearing: "
RANGE          = " Range: "
MACHINEGUN     = "MG"
SELECTWEAPON   = "Fire"
WEAPON         = "Weapon"
FORMATE        = "Formate"
FIRE           = "Fire"
MAINTAIN       = "Maintain"
APPROACH       = "Approach"
RETREAT        = "Retreat"
HEADINGSPEEDCONTROLSIZE    = (50, 10)
ENTITYTEXTCONTROLSIZE      = (60, 25)

from cat.entity import EntityManager

class TargetPanel(wx.Panel):
    
    '''Entity panel class'''
    
    def __init__(self, parent, size, color = "CYAN"):
	
        wx.Panel.__init__(self, parent, -1, (215,500), style = wx.RAISED_BORDER | wx.DOUBLE_BORDER)
	
	self.bgcolor 	= color
        self.SetBackgroundColour(self.bgcolor)

	#labelTarget 	= wx.StaticText(self, -1, "TARGET")
	
	spacer1 = wx.StaticText(self, -1, "", size= (215, 2), style = wx.ALIGN_RIGHT)
	spacer2 = wx.StaticText(self, -1, "", size= (215, 2), style = wx.ALIGN_RIGHT)
	
	l1 		= wx.StaticText (self, -1,"TARGET:   ")
	self.t1 	= wx.TextCtrl   (self, -1, "none", size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
	l2 		= wx.StaticText (self, -1," Speed:  ")
	self.t2 	= wx.TextCtrl   (self, -1, "0.0",  size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
	l3 		= wx.StaticText (self, -1," Heading:   ")
	self.t3 	= wx.TextCtrl   (self, -1, "0",    size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
	l6 		= wx.StaticText (self, -1," Bearing:   ")
	self.t6 	= wx.TextCtrl   (self, -1, "0",    size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
	l4 		= wx.StaticText (self, -1," Range:   ")
	self.t4 	= wx.TextCtrl   (self, -1, "0",    size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)
	l5 		= wx.StaticText (self, -1," Position (X,Y):   ")
	self.t5 	= wx.TextCtrl   (self, -1, "00000, 00000", size = (100, 20), style = wx.TE_READONLY | wx.TE_RIGHT)

	space = 2
	sizer = wx.FlexGridSizer (cols = 2, hgap = space, vgap = space)
	sizer.AddMany ([l1, self.t1, l2, self.t2, l3, self.t3, l4, self.t4, l6, self.t6, l5, self.t5])
	
	sizerTarget = wx.BoxSizer(wx.VERTICAL)

	#sizerTarget.Add(labelTarget)
	sizerTarget.Add(spacer1)
	sizerTarget.Add (sizer)
        sizerTarget.Add(spacer2)
	self.SetSizer(sizerTarget)

        #from common import EventNames
        #import nEventServer
        #nEventServer.register(EventNames.CAT_SELECT_TARGET, self.handleTargetSelection)
        #nEventServer.register(EventNames.CAT_SELECT_ENT,    self.handleEntSelection)
	
    def getPanel(self):
        return self
    
    def tick(self, time, dtime):
        if EntityManager.currentState and exists(EntityManager.currentState.sensors.getTarget()):
            sel(EntityManager.currentState.sensors.getTarget())
            if self.t1.GetValue() != getname():
                self.t1.SetValue(getname())
                setTarget(getfullname())
            
	    val = gf("speed")
       	    s = '%5.1f' % val
            self.t2.SetValue(s)
	    
	    ox, oz, oy = gv('pos')
            self.t5.SetValue(`int(ox)`+', '+`int(oy)`)
            
	    hd = gf("heading")
            val = math.degrees(hd)
	    if val < 0:
                val += math.pi * 2
            s = '%5.1f' % val
            self.t3.SetValue(s)

	    sel(EntityManager.currentState.sensors.getOwnship())
	    tx, tz, ty = gv('pos')
	    range = math.sqrt((ox-tx)**2 + (oy-ty)**2)
	    self.t4.SetValue('%.1f'%range)

            hd = gf('heading')
            dy = abs(oy-ty)
            dx = abs(ox-tx)

            bear1 = math.atan2(oy-ty, ox-tx) - math.pi/2

            if bear1 < -math.pi:
                bear1 += math.pi*2

            bear2 = bear1 + hd

            if bear2 < -math.pi:
                bear2 += math.pi*2

            if bear2 < 0:
                sign="L"
            else:
                sign="R"

            valb = abs(math.degrees(bear2))

            s = '%5.1f ' % valb
            self.t6.SetValue(s+sign)
        else:
            self.t1.SetValue('none')
            setTarget('')
            self.t2.SetValue('0.0')
	    self.t3.SetValue('0.0')
	    self.t6.SetValue('0')
	    self.t4.SetValue('0')
	    self.t5.SetValue('00000, 00000')
 

    def handleTargetSelection(self, msg):
        pass
        #print "Target Selected", msg
        #self.refreshTargetInfo(msg)

        

    def handleEntSelection(self, msg):
        pass
        #print "Target Selected", msg
        #from cat.entity import manager
        #if EntityManager.currentState:
        #    target = EntityManager.currentState.entity
        #    if(target):
        #        self.refreshTargetInfo(target)
        

    def refreshTargetInfo(self, msg):
        pass
        #self.t1a.SetValue(msg)    
