import wx
import wx.lib.ogl as ogl

from cat import *
from common import *

class MainMenu(wx.Panel):
    def __init__(self, parent, size, controller, behaviorShapeList, afterNewLink, afterNewBehavior):
        self.controller = controller
        self.behaviorShapeList = behaviorShapeList
        self.afterNewLink = afterNewLink
        self.afterNewBehavior = afterNewBehavior

        wx.Panel.__init__(self,parent,size=size)
        
        self.vsizer = wx.BoxSizer(wx.VERTICAL)

        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        hsizer.Add(wx.StaticText(self,-1,"Controller:"),1,wx.EXPAND)
        if self.controller:
            controllerName = self.controller.name
        else:
            controllerName = "None"
        self.controllerNameBox = wx.TextCtrl(self,-1,controllerName)
        hsizer.Add(self.controllerNameBox,1,wx.EXPAND)

        self.vsizer.Add(hsizer,1,wx.EXPAND)

        newLinkID = 300
        
        self.vsizer.Add(wx.Button(self,newLinkID,"NEW LINK"),1,wx.EXPAND)
        wx.EVT_BUTTON(self,newLinkID,self.onNewLink)

        behaviorNameList = ['New behavior...']
        for name in behaviorNames.BEHAVIOR_NAMES:
            behaviorNameList.append(name)
        self.behaviorNameBox = wx.ComboBox(self,-1,choices=behaviorNameList,style=wx.CB_DROPDOWN|wx.CB_READONLY)
        self.behaviorNameBox.SetSelection(0)
        self.vsizer.Add(self.behaviorNameBox,1,wx.EXPAND)
        wx.EVT_COMBOBOX(self.behaviorNameBox,-1,self.onNewBehavior)

        self.SetSize(size)
        self.SetSizer(self.vsizer)
        self.SetAutoLayout(1)
        self.vsizer.Fit(self)

    def setController(self, controller):
        self.controller = controller
        if self.controller:
            controllerName = self.controller.name
        else:
            controllerName = "None"
        self.controllerNameBox.Clear()
        self.controllerNameBox.WriteText(controllerName)

    def updateBehaviorShapeList(self, behaviorShapeList):
        self.behaviorShapeList = behaviorShapeList

    def onNewLink(self, e):
        fromBehavior = self.behaviorShapeList[0].behavior
        toBehavior = self.behaviorShapeList[1].behavior
        port = ports.port.Port("ordering")
    
        fromBehavior.addRunningPort(port)
        toBehavior.addPreconditionPort(port)
        self.afterNewLink(fromBehavior,toBehavior)

    def onNewBehavior(self, e):
        name = self.behaviorNameBox.GetValue()
        if name == "New behvaior...":
            return
        self.afterNewBehavior(name)
        self.behaviorNameBox.SetSelection(0)

    def getRet():
        return None

