import wx
import wx.lib.ogl as ogl

from cat import *
from common import *

class SaveMenu(wx.Panel):
    def __init__(self, parent, size, netSpecName, onSave, clearBottomWindow):
        self.onSave = onSave
        self.clearBottomWindow = clearBottomWindow

        wx.Panel.__init__(self,parent,size=size)
        self.SetBackgroundColour(parent.GetBackgroundColour())

        self.vsizer = wx.BoxSizer(wx.VERTICAL)

        self.vsizer.Add(wx.StaticText(self,-1,"Save Network:"),1,wx.EXPAND)

        self.fileNameBox = wx.TextCtrl(self,-1)
        self.fileNameBox.AppendText(netSpecName + ".bn")
        self.vsizer.Add(self.fileNameBox,1,wx.EXPAND)

        hsizer = wx.BoxSizer(wx.HORIZONTAL)
        saveID = 500
        cancelID = 501

        hsizer.Add(wx.Button(self,saveID,"Save"),1,wx.EXPAND)
        wx.EVT_BUTTON(self,saveID,self.onSaveButton)
        hsizer.Add(wx.Button(self,cancelID,"Cancel"),1,wx.EXPAND)
        wx.EVT_BUTTON(self,cancelID,self.onCancel)
        
        self.vsizer.Add(hsizer,1,wx.EXPAND)

        self.SetSize((240,100))
        self.SetSizer(self.vsizer)
        self.SetAutoLayout(1)
        self.vsizer.Fit(self)
        self.Layout()
        self.Show()

    def onSaveButton(self, e):
        self.onSave("cat/networks/" + self.fileNameBox.GetValue())
        self.clearBottomWindow()

    def onCancel(self, e):
        self.clearBottomWindow()
        
    def cleanup(self):
        return None
        



