import math
from cat.Interface import sensors
#from cat import gui

triggerList = []
stateChanged = False
#print triggerPanel

def Tick(time, dtime):
    from cat.Interface import gui
    global triggerList, stateChanged
    triggerList = []
    stateChanged = False
    if sensors.HasStartScenarioChanged():
        wrapper = ({'sensorType':'startScenario', \
                    'value':sensors.IsStartScenario(), \
                    'type':'bool'},{})
        triggerList.append(wrapper)
    if sensors.HasTargetQueryChanged():
        wrapper = ({'sensorType':'targetQuery', \
                    'value':sensors.IsTargetQuery(), \
                    'type':'bool'},{})
        triggerList.append(wrapper)
    if gui.panel.triggerPanel.didStateChange() or len(triggerList) > 0:
        stateChanged = True
        triggerList.extend(gui.panel.triggerPanel.getRelevantTriggers())

class CustomTriggerMonitor:
    def __init__(self, customTriggers):
        self.customTriggers = customTriggers
        self.currentStates = {}
        for id in self.customTriggers.keys():
            self.currentStates[id] = False
        
    def Tick(self, time, dtime):
        for id, pair in self.customTriggers.iteritems():
            fingerprint, sensor = pair
            sensor.Tick(time, dtime)
            #This might cause problems allow a sensor to only go true
            self.currentStates[id] = self.currentStates[id] or self.findMatch(fingerprint, sensor)
        
    def stateMatch(self, id):
        return self.currentStates[id]
        
    def findMatch(self, fingerprint, sensor):
        currentprint = sensor.getTriggerState()
        #print currentprint
        state1, list1 = fingerprint
        state2, list2 = currentprint
        if list1 == list2 and state1['sensorType'] == state2['sensorType']:
            if state1['type'] == 'bool':
                if state1['value'] == state2['value']:
                    return True
            elif state1['type'] in ['int', 'float']:
                val = float(state1['value'])
                #high = val * 1.1
                #low = val * 0.9
                val2 = float(state2['value'])
                #if val2 >= low and val2 <= high:
                #    return True
                if val2 <= val:
                    return True
        return False
        
