from sensor import Sensor
from distancesensor import DistanceThreshold
from cat import catInfo
from common.defs import *

class DamageSensor(Sensor):
    def __init__(self, toPath):
        Sensor.__init__(self)
        self.toPath = toPath

    def tick(self, time, dtime):
        Sensor.tick(self, time, dtime)
        self.sensorVal = self.getDamage()

    def getDamage(self):
        if self.toPath == None:
            print "No path in damage sensor"
            return None
        if exists(self.toPath):
            pushsel()
            sel(self.toPath)
            hp = gf('hp')
            popsel()
            return hp

    def handleBindingChange(self, oldPath, newPath):
        if self.toPath == oldPath:
            self.toPath = newPath


class DamageThreshold(DistanceThreshold):
    def __init__(self, type, value=None):
        self.type = type
        self.value = value
        if value == None:
            self.value = 0
            self.set = False
        else:
            self.value = value
            self.set = True

    def isSet(self):
        return self.set

    def fire(self, sensor=None):
        if sensor:
            self.value = sensor.getValue()
            self.set = True

    def check(self, sensor):
        val = sensor.getValue()
        if type == catInfo.LESS_THAN:
            return val < self.value
        elif type == catInfo.GREATER_THAN:
            return val > self.value
        elif type == catInfo.APPROX:
            return val < value*1.05 and val > value * 0.95

    def getValue(self):
        return self.value
