#
# @(#) behaviorSpec.py 2005/11/13
# @author RL, Sushil Louis
# Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

class NetworkSpec:
    def __init__(self, name=None, ownship = None, behaviors=None, slots=None, triggers=None):
        self.name = name
        self.ownship = ownship
        if behaviors:
            self.behaviors = behaviors
        else:
            self.behaviors = []
        #self.slots = slots
        #self.triggers = triggers


class BehaviorSpec:
    def __init__(self, name=None, id=None, group = '0', targets = None,
                 sensors = None, parameters = None, links = None,
                 bindings = None, start = 0, end = 0, triggers = None):
        self.name       = name
        self.id         = id
        self.group      = group
        if targets:
            self.targets = targets
        else:
            self.targets = []
        if sensors:
            self.sensors = sensors
        else:
            self.sensors = BehaviorSensorSpec()
        if parameters:
            self.parameters = parameters
        else:
            self.parameters = []
        if links:
            self.links = links
        else:
            self.links = []
        if bindings:
            self.bindings = bindings
        else:
            self.bindings = []
        self.start      = start
        self.end        = end
        if triggers:
            self.triggers = triggers
        else:
            self.triggers = []

    def __str__(self):
        s1 = "name: %s, id: %s, group: %s" % (self.name, self.id, self.group) 
        s2 = "sensors: %s" % self.sensors
        s3 = "params:  %s" % self.parameters
        s4 = "links:   %s" % self.links
        return '%s %s %s %s'%(s1, s2, s3, s4)

class Binding:
    def __init__(self, name = None, val = None, humanReadable = None):
        self.name = name
        self.val  = val
        self.humanReadable = humanReadable
        

class Parameter:
    def __init__(self, name=None, type = None, val = None, min = None , max = None):
        self.name = name
        self.type = type
        self.val  = val
        self.min  = min
        self.max  = max

class SensorSpec: # this is a single sensor spec
    def __init__(self, name=None, id = None, type = None, params = None):
        self.id = id
        self.type = type
        self.params = params
        self.name = name

class SensorParamSpec:
    def __init__(self, name = None, type = None, value = None):
        self.name  = name
        self.type  = type
        self.value = value

class BehaviorSensorSpec: # this is returned by xmlReader
    def __init__(self, pre = [], post = []):
        self.pre = pre   # a list of SensorSpecs
        self.post = post # a list of SensorSpec

class Link:
    ORDERING = 0
    ENABLING = 1
    PERMANENT = 2
    def __init__(self, dir = None, type = None, dest = None, orig = None, triggerid = None):
        self.dir = dir
        self.type = type
        self.dest = dest
        self.orig = orig
        self.triggerid = triggerid

class TriggerSpec:
    def __init__(self, name, type, subtype=None, threshold=None, toPath=None, fromPath=None, id=0):
        self.name = name
        self.type = type
        self.subtype = subtype
        self.threshold = threshold
        self.toPath = toPath
        self.fromPath = fromPath
        self.id = id


#class Trigger:
#    def __init__(self, name=None, id=None, value=None, type=None, parameters=[], slots = []):
#        self.name = name
#        self.id = id
#        self.criticalValue = value # not used
#        self.type = type
#        self.parameters = parameters
#        self.slots = slots # not used

#class TriggerSpec:
#    def __init__(self, name = None, id = None, triggers = None, slots = None):
#        self.name     = name
#        self.id       = id
#        self.triggers = triggers
#        self.slots    = slots

#class TriggerParameterSpec:
#    def __init__(self, name = None, type = None, val = None):
#        self.name = name
#        self.type = type
#        self.val  = val

#class TriggerSlotSpec:
#    def __init__(self, name = None, id = None):
#        self.name = name
#        self.id   = id
    
#class SlotSpec:
#    def __init__(self, name = None, id = None):
#        self.name = name
#        self.id   = id

        
    
    
