#
# @(#) bindings.py 2005/11/22
# @author SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

BINDING_SEP_CHAR       = ":"

class Bindings:
    """Environment for bindings"""

    def __init__(self, envName = None):
        self.envName = str(envName)
        self.reverseMap = {}
        self.varNameMap = {}
        self.bindingMap = {}
        self.counter = 0

    def addBinding(self, name, path ):
        """ returns the bindingVariable name"""
        mappedNames = ()
        if(self.reverseMap.has_key(path)):
            mappedNames = self.reverseMap[path]
            mappedNames = (name, ) + mappedNames
            bindingVarName = self.varNameMap[path]
        else:
            mappedNames = (name, )
            bindingVarName = self.envName + BINDING_SEP_CHAR + str(self.counter)
            self.counter = self.counter + 1
            self.varNameMap[path] = bindingVarName
        self.reverseMap[path] = mappedNames
        return bindingVarName

    def lookupBinding(self, bindingVarName):
        level1Name = self.reverseLookup(bindingVarName, self.varNameMap)
        if(level1Name):
            val = self.lookup(level1Name, self.bindingMap)
            return val
        else:
            return None

    def lookupPath(self, bindingVarName):
        return self.reverseLookup(bindingVarName, self.varNameMap)


    def reverseLookup(self, name, map):
        for path, bvName in map.iteritems():
            if (bvName == name):
                return path
        return None

    def lookup(self, name, map):
        if(map.has_key(name)):
            return map[name]
        else:
            return None


    def changeBinding(self, oldPath, newPath):
        self.bindingMap[oldPath] = newPath


