#
# @(#) xmlLogger.py 2005/11/11
# @author RL, SJL Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

from xml.sax import saxutils
from common import behaviorNames
from xml.sax.saxutils import XMLGenerator
from xml.sax.xmlreader import AttributesImpl as Att

class xml_logger:
    currentTabs = 0
    def __init__(self, output):
        logger = XMLGenerator(output)
        logger.startDocument()
        self._logger = logger
        self._output = output
        self.output = output
        
    def WriteEntry(self, name, atts, buf):
        attrs = Att(atts)
        print >> self._output, '\t' * (self.currentTabs),
        self._logger.startElement(name, atts)
        self._logger.characters(buf)
        self._logger.endElement(name)
        print >> self._output, '\n',

    def OpenTag(self, name, atts, nl):
        attrs = Att(atts)
        print >> self._output, '\t' * (self.currentTabs),
        self.currentTabs += 1
        self._logger.startElement(name, atts)
        if nl:   
            print >> self._output, '\n',

    def CloseTag(self, name):
        self.currentTabs -= 1
        print >> self._output, '\t' * self.currentTabs,
        self._logger.endElement(name)
        print >> self._output, '\n',
        
    def Close(self):
        pass
        self._logger.endDocument()
