import wx
import sys
import OptionManager
filepath = 'common/xml/%s.xml' % OptionManager.getOption('windowsettings')
#/-----------------------------------------------------------------------------//
class WindowInfo:
    def __init__(self,name, ptr=None, position=wx.DefaultPosition, size=wx.DefaultSize):
        self.name                       = name
        self.ptr                        = ptr
        self.position                   = position
        self.size                       = size
    def __str__(self):
        return '%s %s, %s' % (self.name, self.size, self.position)
    def __repr__(self):
        return str(self)
#/-----------------------------------------------------------------------------//
def register(name,ptr):
    if name in windows: 
        windows[name].ptr = ptr
    else:
        windows[name] = WindowInfo(name, ptr=ptr)
#/-----------------------------------------------------------------------------//
def show(*args):
    global frame 
    if frame:                  
        frame.Destroy()

    update()
    frame = wx.Frame(None,-1, 'Window Settings')
    panel = wx.Panel(frame, -1)
    gbs = wx.GridBagSizer(1,1)
    list = wx.ListCtrl(panel, -1, style=wx.LC_REPORT) 
    list.InsertColumn(0, 'Name')
    list.InsertColumn(1, 'Position')
    list.InsertColumn(2, 'Size')

    gbs.Add( list, (0,0), flag=wx.EXPAND)
    gbs.AddGrowableRow(0)
    gbs.AddGrowableCol(0)

    panel.SetSizer(gbs)

    for window in windows:
        index = list.InsertStringItem   (sys.maxint, window)
        list.SetStringItem              (index, 1, str(windows[window].position))
        list.SetStringItem              (index, 2, str(windows[window].size))

    frame.Show()
#/-----------------------------------------------------------------------------//
def update():
    for window in windows:
        try:
            windows[window].position        = windows[window].ptr.GetPosition()
            windows[window].size            = windows[window].ptr.GetSize()
        except AttributeError:
            print 'failed to get properties for window', window
#/-----------------------------------------------------------------------------//
def save(*args):
    import xml.dom.minidom
    update()
    doc                                 = xml.dom.minidom.Document()
    root                                = doc.createElement('windowsettings')
    doc.appendChild                     (root)
    for window in windows:
        node                            = doc.createElement('window')
        root.appendChild                (node)
        node.setAttribute               ('name', window )
        node.setAttribute               ('positionx', str(windows[window].position[0]))
        node.setAttribute               ('positiony', str(windows[window].position[1]))
        node.setAttribute               ('sizex', str(windows[window].size[0]))
        node.setAttribute               ('sizey', str(windows[window].size[1]))

    text = doc.toprettyxml('    ')
    try:
        file                                = open(filepath, 'w')
        file.write(text)
        file.close()
    except IOError:
        #print 'could not open', filepath, 'to save window settings too'
        pass
#/-----------------------------------------------------------------------------//
def load(*args):
    global windows
    from xml.dom import minidom
    windows = {}
    try:
        file                                = open(filepath)
        doc                                 = minidom.parse(file)
        file.close()
    except IOError:
        print 'could not open window settings file:', filepath 
        return
    for window in doc.getElementsByTagName('window'):
        name                            = str(window.getAttribute('name'))
        position                        = (int(window.getAttribute('positionx')),                                       int(window.getAttribute('positiony')))
        size                            = (int(window.getAttribute('sizex')),                                           int(window.getAttribute('sizey')))
        windows[name]                   = WindowInfo(name,position=position,size=size)
#/-----------------------------------------------------------------------------//
def get(windowName):
    global windows
    return (windows[windowName].position, windows[windowName].size)
#/-----------------------------------------------------------------------------//
frame = None
load()
