from npython import *
from xml.dom import minidom
from xml.dom.minidom import getDOMImplementation
import os
logDefs = False
from struct import struct

#/-----------------------------------------------------------------------------//
def sn(classname, path):
    new(classname, path)
    sel(path)
    return True
#/-----------------------------------------------------------------------------//
def runTclScript( filename ):
    set('/sys/servers/game.runtclscript', filename )
#/-----------------------------------------------------------------------------//
def printlb():
    print '--------------------------------------------------------------------------------'
#/-----------------------------------------------------------------------------//
def getText(root):
    nodelist = root.childNodes
    rc = ""
    for node in nodelist:
        if node.nodeType == node.TEXT_NODE:
            rc = rc + node.data
    return str(rc.strip())
#/-----------------------------------------------------------------------------//
def xmlToDict(root):
    if logDefs: print 'xmlToDict', root
    nodelist = root.childNodes
    dict = {}
    dict['text'] = getText(root)
    for node in nodelist:
        if node.nodeType == node.ELEMENT_NODE:
            dict[str(node.tagName).lower()] = getText(node)
    return dict
#/-----------------------------------------------------------------------------//
def parseXML(filepath):
    if logDefs: print 'parseXML', filepath
    file = open( filepath )
    document = minidom.parse( file )
    file.close()
    return document
#/-----------------------------------------------------------------------------//
def genTex (*arguments):
    from common import FileManager
    if logDefs: print 'genTexNode', arguments
    new('ntexarraynode', 'tex')
    for i, arg in enumerate(arguments):
        filepath = FileManager.find( 'tex', arg )
        if not filepath:
            print 'failed to find texture', arg
            filepath = FileManager.find('tex', 'default')
        alphapath = FileManager.find( 'tex', arg + 'alpha' )
        if not alphapath:
            alphapath = 'none'
        set('tex.settexture', i, filepath, alphapath)
#/-----------------------------------------------------------------------------//
def genShader ( shadername ):
    if logDefs: print 'genShader', shadername
    set('/lib/shaders/%s.clone' % shadername, 'shader' )
#/-----------------------------------------------------------------------------//
def genMesh ( meshname ):
    from common import FileManager
    if logDefs: print 'genMesh', meshname
    meshpath = FileManager.find('mesh', meshname)
    if meshpath:
        new('nmeshnode', 'mesh')
        set('mesh.setfilename', meshpath )
    else:
        print 'could not find meshfile', meshname
#/-----------------------------------------------------------------------------//
def genLink(targetPath):
    new ('nlinknode', 'link')
    call('link.settarget', targetPath)
#/-----------------------------------------------------------------------------//
def genEnt ( type=None, label='default', side='neutral' ):
    #print 'genEnt', type, side, label
    assert type, 'cannot generate an entity without the type'
    ent = set('/sys/servers/game.genent', type, 'default', 'default') 
    if ent and ent != 'none':
        set('%s.cs' % ent,              'label',     label)
        set('%s.cref' % ent,            'side',     '/game/sides/' + side)
        return ent
    return None
#/-----------------------------------------------------------------------------//
# wrappers around the most common nebula functions - reduces excessives call calls
#/-----------------------------------------------------------------------------//
def getname(path=''):                   return call('%s.getname' % path)
def getfullname(path=''):               return call('%s.getfullname' % path)
def hasvar(path, name = None):          
    #print 'hasvar', path, name, type(path), type(name)
    if name == None: 
        return call('hasvar', path) 
    else:
        return call('%s.hasvar' % path, name) 
def varexists(path, name, type):
    if call('%s.hasvar' % path, name):
        if call('%s/vars/%s.gettype' % (path, name)) == type:
            return True
    return False
def gi(name):                           return call('gi',   name)
def gf(name):                           return call('gf',   name)
def gs(name):                           return call('gs',   name)
def gv(name):                           return call('gv',   name)
def gq(name):                           return call('gq',   name)
def grot(name):                         return call('grot', name)
def gref(name):                         return call('gref', name)

def si(name, val):                      return call('si',   name, val)
def sf(name, val):                      return call('sf',   name, val)
def ss(name, val):                      return call('ss',   name, val)
def sv(name, x,y=0,z=0):                    
    if type(x) == list:                 return call('cv',   name, x[0], x[1], x[2])
    else:                               return call('cv',   name, x,y,z)
def sq(name, x,y,z,w):                  return call('sq',   name, x,y,z,w)
def srot(name, rx, ry, rz):             return call('sr', name, rx,ry,rz)
def sref(name, target):                 return call('sref', name, target)

def ci(name, val):                      return call('ci',   name, val)
def cf(name, val):                      return call('cf',   name, val)
def cs(name, val):                      return call('cs',   name, val)
def cv(name, x, y=0, z=0):
    if type(x) == list:                 return call('cv',   name, x[0], x[1], x[2])
    else:                               return call('cv',   name, x,y,z)
def cq(name, x,y,z,w):                  return call('cq',   name, x,y,z,w)
def crot(name, x, y=0, z=0):             
    if type(x) == list:                 return call('cr',   name, x[0], x[1], x[2])
    else:                               return call('cr',   name, x,y,z)
def cref(name, target):                 return call('cref', name, target)
def getselectable(path=''):             return call('%s.getselectable' % path)
def watch(target):                      
    if logDefs: print 'watch', target
    if target:
        call('/game/camera.cref', 'attachedto', target)
    else:
        call('/game/camera.cref', 'attachedto', "none")
def die(path=''):                       return call('%s.die' % path)

#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
def printExcept(module=None):
    import sys
    print '--------------------------------------------------------------------------------'
    if module:
        print 'Exception thrown in module:', module
        print '--------------------------------------------------------------------------------'
    sys.excepthook(sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2])
    print '--------------------------------------------------------------------------------'
#/-----------------------------------------------------------------------------//
def roll(prob):
    import random
    if random.uniform(0,1) <= prob:     
        return True
    return False
#/-----------------------------------------------------------------------------//
def pushsel(path=None):
    if path:
        call('/sys/servers/game.pushsel', path)
    else:
        call('/sys/servers/game.pushsel', psel() )
#/-----------------------------------------------------------------------------//
def popsel():
    return call('/sys/servers/game.popsel')
    
#/-----------------------------------------------------------------------------//
import re
stvreg = re.compile(r'[ ,]+')
#/-----------------------------------------------------------------------------//
def vector3(string):
    groups = stvreg.split(string.strip('[]()'))
    if groups and len(groups) == 3:
        groups = map(float, groups) #convert them all to floats
        return groups
    else:
        print 'error parsing vector value |%s|' % string
        raise IOError, 'error parsing vector value'
#/-----------------------------------------------------------------------------//
def quaternion(string):
    groups = stvreg.split(string.strip('[]()'))
    if groups and len(groups) == 4:
        groups = map(float, groups) #convert them all to floats
        return groups
    else:
        print 'error parsing quaternion value |%s|' % string
        raise IOError, 'error quaternion vector value'
#/-----------------------------------------------------------------------------//
def newUnique(className):
    counter = 0
    while True:
        path = '%s%i' % (className, counter)
        if logDefs: print 'type', type(path)
        val = call('find', path )
        if logDefs: print 'checking', path, '?=', val
        if val != None:
            counter += 1
        else:
            if logDefs: print 'path', path
            new(className, path)
            return path
#/-----------------------------------------------------------------------------//
def snUnique(className):
    sel(newUnique(className))
#/-----------------------------------------------------------------------------//
def ndel(path):
    try:
        path = str(path)
        call('/sys/servers/release.quiterelease', path)
    except:
        printExcept('ndel %s' % path)
#/-----------------------------------------------------------------------------//
def exists(path):
    if not path:
        return False
    return call('/sys/servers/game.exists', str(path))
#/-----------------------------------------------------------------------------//
def ndirin(path=None):
    if path:
        if not exists(path): 
            return []
        else:
            pushsel(path)
    d = ndir()
    try:
        d.remove('vars')
    except:
        pass
    if path:
        popsel()
    return d
#/-----------------------------------------------------------------------------//
def findAvailableFilename(dir, name):
    """Find an available filename to print too"""
    files = os.listdir(dir)
    for i in range(0,1000):
        filename = name % i
        if filename not in files:
            return '%s/%s' % (dir,filename)
#/-----------------------------------------------------------------------------//
def loadBMP(filename):
    import FileManager
    import wx
    path                                = FileManager.find('tex', filename)
    assert path,                        'failed to find bmp: %s' % filename
    bmp                                 = wx.Bitmap(path, wx.BITMAP_TYPE_BMP)
    return bmp
#/-----------------------------------------------------------------------------//
def getTime():
    return call('/sys/servers/channel.getchannel1f', 'time') 
#/-----------------------------------------------------------------------------//
def getTimeScale():
    return call('/sys/servers/trigger.gettimescale')
#/-----------------------------------------------------------------------------//
def setTimeScale( timescale ):
    """set the time scale -> should also change the timestep as the time scale increases"""
    call('/sys/servers/trigger.settimescale', timescale)
    if timescale > 4:
        call('/sys/servers/trigger.settimestep', .1 )
    else:
        call('/sys/servers/trigger.settimestep', .01 )
    #call('/sys/servers/trigger.settimescale', timescale)
#/-----------------------------------------------------------------------------//
def parseRMenuMsg(msg):
    text, menuItem, path, mousePos, objectsOver, objectsSelected = msg.split(';')
    mousePos                            = vector3(mousePos)
    if objectsOver == '()':             objectsOver     = []
    else:                               objectsOver     = objectsOver.strip('()').split(' ')
    if objectsSelected == '()':         objectsSelected = []
    else:                               objectsSelected = objectsSelected.strip('()').split(' ')
    args = struct(text=text, menuItem = menuItem, path=path, mousePos=mousePos, objectsOver=objectsOver, objectsSelected=objectsSelected)
    return args
#/-----------------------------------------------------------------------------//
def panToPoint(x, y=0, z=0):
    print 'panToPoint', x, y, z, type(x)
    if type(x) == list or type(x) == tuple:
        return call('/game/camera/controller.pantopoint', x[0], x[1], x[2] )
    else:
        call('/game/camera/controller.pantopoint', x, y, z )
#/-----------------------------------------------------------------------------//
def panToEnts(ents):
    print 'panToEnts', ents
    entsString = ' '.join(ents)
    return call('/game/camera/controller.pantoents', entsString )
#/-----------------------------------------------------------------------------//
def setTarget(path):
    call('/ui/planner.cleartargettedentities')
    if path:
        call('/ui/planner.addtarget', path)
#/-----------------------------------------------------------------------------//
def quit(event):
    call('/sys/servers/game.stop')
#/-----------------------------------------------------------------------------//
def begin(name):
    call('/sys/servers/prof.begin', name)
    return True
#/-----------------------------------------------------------------------------//
def end(name):
    call('/sys/servers/prof.end', name)
    return True
#/-----------------------------------------------------------------------------//

