import wx

#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class DictTreeCtrl(wx.TreeCtrl):
#/-----------------------------------------------------------------------------//
    def __init__(self,parent,id,pos,size,style):
        wx.TreeCtrl.__init__(self,parent,id,pos,size,style)
        #print 'size', size
#/-----------------------------------------------------------------------------//
    def OnCompareItems(self, item1, item2):
        print 'DictTreeCtrl.OnCompareItems', item1, item2

#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class DictTree(wx.Panel):
    """Displays a dictionary / heirarchy of dicts in a treeview"""
    #/-----------------------------------------------------------------------------//
    def __init__(self,parent, id, data, rootName):
        from FileManager import projects
        self.dict = dict
        #print 'dict', data
        #print 'keys', data.keys()
        wx.Panel.__init__(self,parent,wx.NewId(),style=wx.WANTS_CHARS)
        self.Bind(wx.EVT_SIZE, self.OnSize)
        #self.SetDefaultSize(100,100)

        self.tree = DictTreeCtrl(self,wx.ID_ANY, wx.DefaultPosition, wx.DefaultSize, wx.TR_HAS_BUTTONS | wx.TR_EDIT_LABELS )

        isz = (16,16)
        il = wx.ImageList(isz[0], isz[1])
        fldridx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FOLDER,      wx.ART_OTHER, isz))
        fldropenidx = il.Add(wx.ArtProvider_GetBitmap(wx.ART_FILE_OPEN,   wx.ART_OTHER, isz))
        fileidx     = il.Add(wx.ArtProvider_GetBitmap(wx.ART_NORMAL_FILE, wx.ART_OTHER, isz))

        self.tree.SetImageList(il)
        self.il = il

        self.root = self.tree.AddRoot(rootName)
        self.tree.SetPyData(self.root, None)

        self.ParseTree( self.root, data )
    #/-----------------------------------------------------------------------------//
    def OnSize(self,event):
        w,h = self.GetClientSizeTuple()
        self.tree.SetDimensions(0,0,w,h)
        #print 'DictTree:', w, h, self.GetSize()
    #/-----------------------------------------------------------------------------//
    def ParseTree( self, root, data ):
        #print 'ParseTree', 'root', root, 'dict', data, 'type', type(data)
        if type(data) == dict:
            for key in data:
                value = data[key]
                node = self.tree.AppendItem(root, key)
                self.ParseTree( node, value )
        else:
            pass
        return
