from common.defs import *
sn('n3dnode', '/lib/node/overVis')
genMesh('plane')
genTex('overVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
sn('n3dnode', '/lib/node/selectedVis')
genMesh('plane')
genTex('selectedVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
sn('n3dnode', '/lib/node/overGroupVis')
genMesh('plane')
genTex('overGroupVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
sn('n3dnode', '/lib/node/selectedGroupVis')
genMesh('plane')
genTex('selectedGroupVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
sn('n3dnode', '/lib/node/catSelectedVis')
genMesh('plane')
genTex('catSelectedVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
sn('n3dnode', '/lib/node/targettedVis')
genMesh('plane')
genTex('targettedVis')
genShader('overlay')
#/-----------------------------------------------------------------------------//
overlayActivationDistance = 100
overlayFullBrightDistance = 1000
#/-----------------------------------------------------------------------------//
def genOverlay(name):
    sn('n3dnode', '/lib/node/overlay%s' % name)
    call('.sxyz', 100,100,100)
    sn('nflipflop','flipflop')
    new('n3dnode', 'inactive')
    if sn('n3dnode', 'active'):
        genMesh('plane')
        genTex('overlay%s' % name)
        genShader('overlay')
        sel('shader')
        if sn('nipol', 'setconst0'):
            call('.connect', 'setconst0')
            call('.setchannel', 'cameraDist')
            call('.addkey4f', 0, 1,1,1, 0)
            call('.addkey4f', overlayActivationDistance, 1,1,1, 0.0)
            call('.addkey4f', overlayFullBrightDistance, 1,1,1, 1.0)
            call('.addkey4f', 1000000, 1,1,1, 1.0)
            sel('..')
        sel('..')
        if sn('nipol', 'sxyz'):
            call('.connect', 'sxyz')
            call('.setchannel', 'cameraDist')
            call('.addkey3f', 0, 1,1,1)
            call('.addkey3f', 10000, 10,10,10)
            call('.addkey3f', 10000000, 10,10,10)
            sel('..')
        sel('..')
    call('.setchannel', 'cameraDist')
    call('.addkey', 0, 'inactive')
    call('.addkey', overlayActivationDistance, 'active')
    call('.addkey', 100000000, 'active')
#/-----------------------------------------------------------------------------//
genOverlay('Pentagon')
genOverlay('Hexagon')
genOverlay('Square')
genOverlay('Triangle')
genOverlay('Circle')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlayWeaponRadius'):
    genMesh('plane')
    genTex('circle')
    genShader('overlay')
    if sn('nipol', 'sxyz'):
        call('.connect', 'sxyz')
        call('.setchannel', 'imWeaponRadius')
        call('.addkey3f', 0, 1,1,1)
        call('.addkey3f', 100000, 100000,100000,100000)
        sel('..')
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/overlayConstructionBar'):
    genMesh('splitring')
    genTex('constructionBar')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    #call('.setcolorop', 1, 'mul const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'constrRatio')
        call('.addkey4f',    0,   1,   0,   0,   1)
        call('.addkey4f',  .50,   1, .75, .25,   1)
        call('.addkey4f',    1,   0,  .9,   0,   1) 
    sel('..')
    call('.begintunit', 0)
    call('.setaddress', 'clamp', 'clamp')
    call('.setenabletransform', True)
    call('.endtunit')
    if sn('nipol', 'sxyz0'):
        call('.connect', 'txyz0')
        call('.setchannel', 'constrRatio')
        call('.addkey3f',  0, -1,  0,  0)
        call('.addkey3f',  1, 2/32.0,  0,  0) #need to go 1/32 too far to get past the black line / and avoid bleeding
        call('.addkey3f',  2,  0,  0,  0)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/hpBar'):
    genMesh('splitring')
    genTex('constructionBar')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    #call('.setcolorop', 1, 'mul const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'constrRatio')
        call('.addkey4f',    0,   1,   0,   1,   1)
        call('.addkey4f',  .50, .75,  .5, .25,   1)
        call('.addkey4f',    1,   0,   1,   1,   1) 
    sel('..')
    call('.begintunit', 0)
    call('.setaddress', 'clamp', 'clamp')
    call('.setenabletransform', True)
    call('.endtunit')
    if sn('nipol', 'sxyz0'):
        call('.connect', 'txyz0')
        call('.setchannel', 'constrRatio')
        call('.addkey3f',  0, -1,  0,  0)
        call('.addkey3f',  1, 2/32.0,  0,  0) #need to go 1/32 too far to get past the black line / and avoid bleeding
        call('.addkey3f',  2,  0,  0,  0)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
if sn('n3dnode', '/lib/node/enemyHpBar'):
    genMesh('splitring')
    genTex('constructionBar')
    genShader('overlay')
    sel('shader')
    call('.setcullmode', 'ccw')
    call('.setcolorop', 0, 'mul tex const')
    #call('.setcolorop', 1, 'mul const')
    call('.setconst0', 0, 0, 1, 1 )
    if sn('nipol', 'setconst0'):
        call('.connect', 'setconst0')
        call('.setchannel', 'constrRatio')
        call('.addkey4f',    0,   1,   0,   1,   1)
        call('.addkey4f',  .50,  .5,  .1,  .7,   1)
        call('.addkey4f',    1,   0,  .8,  .9,   1) 
    sel('..')
    call('.begintunit', 0)
    call('.setaddress', 'clamp', 'clamp')
    call('.setenabletransform', True)
    call('.endtunit')
    if sn('nipol', 'sxyz0'):
        call('.connect', 'txyz0')
        call('.setchannel', 'constrRatio')
        call('.addkey3f',  0, -1,  0,  0)
        call('.addkey3f',  1, 2/32.0,  0,  0) #need to go 1/32 too far to get past the black line / and avoid bleeding
        call('.addkey3f',  2,  0,  0,  0)
    sel('..')
sel('..')
#/-----------------------------------------------------------------------------//
