from npython import *
from common.defs import *
from common.EventNames import *
from common.widgets.unitinfo import *
import OptionManager
ITEM = 0
MENU = 1
ROOT = 2
RING_RADIUS = .3
class RMenuItem:
    """wraps the nrmenuitem class
    the rmenuitem class implements all the nitty gritty of the menu, displaying it, checking the mouse and calling stuff
    mufch of the work howvere is in setting it up nicely, keeping track of theta etc... 
    this class is responsible for that as well as to provide the best possible interface to creating the menu
    """
    autoAddStack = []
    #/-----------------------------------------------------------------------------//
    def __init__(self, string='RMenuItem', event=None, path=None, back=False, button=2, autoadd=True):
        """create a new item, passing it a string and a theta, and an optional path (neccessary for the root node)"""
        self.children                   = []
        self.ent                        = None
        self.rmenu                      = None
        self.state                      = ITEM
        self.setString                  (string)
        self.theta                      = 0
        self.width                      = 60
        self.event                      = event
        self.back                       = False
        self.button                     = button
        #we have been given a path create a new ent at that node and link to it
        if path:
            self.state                   = ROOT
            self.ent                    = path
            new                         ('nbasicent', self.ent)
            call                        ('%s.inheritfrom' % (self.ent) , '/ui/rmenus')
        if back:
            self.back                   = True
        if autoadd and len(self.autoAddStack) > 0:
            self.autoAddStack[-1].append(self)
    #/-----------------------------------------------------------------------------//
    def append(self, item):
        """add a child item, this needs to shift us into menu state and out of item state"""
        #first time a child is added we need to initialize a child entity
        if self.state == ITEM:
            self.state                  = MENU
            self.ent                    = self.rmenu + '/ent'
            new                         ('nbasicent', self.ent)
            call                        ('%s.inheritfrom' % (self.ent) , '/ui/rmenus')
            backItem                    = RMenuItem(self.string, back=True)

        self.children.append(item)
        self.alignChildren()

        childEntName                    = item.string.replace(' ', '')                             #name the new ent whatever the child was called - except with whitespace stripped
        childPath                       = '%s/%s' % (self.ent, childEntName)
        item.parent                     = self
        item.button                     = self.button
        item.createNRMenu(childPath)
    #/-----------------------------------------------------------------------------//
    def alignChildren(self):
        """go through all my children and set there theta values"""
        l = len(self.children)
        if l == 0: return
        startTheta = 0
        stopTheta = 360
        if l <= 2:     #align 2 or less left / right
            startTheta = 90
            stopTheta = 450
        if self.state == ROOT and l == 3: l = 4
        if self.state == MENU and l == 3: l = 4

        if self.state != ROOT:
            assert self.state == MENU
            invTheta                    = self.theta + 180
            startTheta                  = invTheta
            stopTheta                   = invTheta 
            while startTheta < 0:                                               startTheta += 360
            while stopTheta <= startTheta:                                      stopTheta += 360
        #print 'startTheta', startTheta, 'stopTheta', stopTheta
        for index, child in enumerate(self.children):
            #if l == 2 and self.state == MENU and index == 0 and self.theta > 180:                    index = 2 #trying to get the a pair on the left to draw up and left versus down and left
            theta                       = startTheta + index * (stopTheta - startTheta) / l
            child.setTheta              (theta)
            width                       = (stopTheta - startTheta) / l * .666
            if width > 60:              width = 60
            child.setWidth              (width)
    #/-----------------------------------------------------------------------------//
    def setTheta(self, theta):
        self.theta = theta
        self.updateNRMenu()
        self.alignChildren()
    #/-----------------------------------------------------------------------------//
    def setWidth(self, width):
        self.width = width
        self.updateNRMenu()
    #/-----------------------------------------------------------------------------//
    def setString(self, string):
        self.string = string
        self.updateNRMenu()
    #/-----------------------------------------------------------------------------//
    def __str__(self):
        #return '"%s"[%f]->%s @%s' % (self.string, self.theta, self.children, self.path)
        return self.string
    #/-----------------------------------------------------------------------------//
    def createNRMenu(self, path):
        self.rmenu                      = path
        new                             ('nrmenuitem', self.rmenu)
        self.updateNRMenu()
    #/-----------------------------------------------------------------------------//
    def updateNRMenu(self):
        if not self.rmenu: return
        pushsel(self.rmenu)
        call('.settheta', self.theta)
        call('.setwidth', self.width)
        call('.setstring', self.string)
        if self.event:
            call('.setevent', self.event)
        call('.setback', self.back)
        call('.setbutton', self.button)
        popsel()
    #/-----------------------------------------------------------------------------//
    def add(self):
        self.autoAddStack.append(self)
        return self
    #/-----------------------------------------------------------------------------//
    def done(self):
        item = self.autoAddStack.pop() 
        assert item == self, 'problems with the autoadd stack for rmenu items item %s, %s' %(self, item)
#/-----------------------------------------------------------------------------//
def setupVisNodes():
    def gen(name, tex):
        sn('n3dnode', '/lib/node/%s' % name)
        call('.setviewspace', True)
        genMesh('slice')
        genTex(tex)
        genShader('ui')
        
    new('n3dnode', '/lib/node/text')
    new('ntextdisplayer', '/lib/node/text/text')
    sn('n3dnode', '/game/vis/popupmenu')
    call('.setviewspace', True)

    gen('slice', 'slice')
    gen('activeslice', 'activeslice')
    gen('expandableslice', 'expandableslice')
    gen('backslice', 'backslice')
    #gen('expandedslice', 'expandedslice')
    #gen('passiveslice', 'passiveslice')

    def gen(name, tex):
        sn('n3dnode', '/lib/node/%s' % name)
        call('.setviewspace', True)
        genMesh('fan')
        genTex(tex)
        genShader('ui')

    gen('fan', 'fan')
    gen('activefan', 'activefan')
    gen('expandablefan', 'expandablefan')
    gen('backfan', 'backfan')
    gen('passivefan', 'passivefan')

    def gen(name, tex):
        sn('n3dnode', '/lib/node/%s' % name)
        call('.setviewspace', True)
        genMesh('plane')
        genTex(tex)
        genShader('uibackground')
    gen('backgroundfan', 'backgroundfan')
    gen('passivebackgroundfan', 'passivebackgroundfan')
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//

setupVisNodes()
sn('nbasicent', '/ui/rmenus')
cf('ringRadius', RING_RADIUS)
#/-----------------------------------------------------------------------------//
unit                                    = RMenuItem(path='/ui/rmenus/command/unit', button = 2)                                     #should create it as a proxy
if unit.add():
    attach                              = RMenuItem('Attach Camera',            RMENU_ATTACH_CAMERA)
    watch                               = RMenuItem('Watch',                    RMENU_WATCH_CAMERA)
    setSide                             = RMenuItem('Set Side')
    delete                              = RMenuItem('Delete',                   RMENU_DELETE_ENT)
    stop                                = RMenuItem('Stop')
    groups                              = RMenuItem('Groups')
    info                                = RMenuItem('Info',                     RMENU_UNIT_INFO)
    if setSide.add():
        import sides
        for sideName in sides.sides:
            if sideName != 'bm' and sideName != 'observer':
                side                        = RMenuItem(sideName,                   RMENU_SET_SIDE)
        setSide.done()
    if groups.add():
        ungroup                         = RMenuItem('Remove From Group')
        assignToGroup                   = RMenuItem('Assign To Group')
        if assignToGroup.add():
            for i in range(10):
                group                   = RMenuItem('%i' % i)
            assignToGroup.done()
        groups.done()
    unit.done()
#/-----------------------------------------------------------------------------//
world                                   = RMenuItem(path='/ui/rmenus/command/world', button = 2)                                    #should create it as a proxy
if world.add():
    if OptionManager.getOption('net') == 'server':
        bm                                  = RMenuItem('Battle Master')
    camera                              = RMenuItem('Camera Controls')
    time                                = RMenuItem('Time Controls')
    if OptionManager.getOption('net') == 'server' and bm.add():
        createGallery                       = RMenuItem('Create Gallery',           RMENU_CREATE_GALLERY)
        createEnt                           = RMenuItem('Create Ent')
        if createEnt.add():
            categories                  = ['large', 'medium', 'small', 'misc']
            entTypes                    = ndirin('/lib/ents')
            for entType in entTypes:
                if call('/lib/ents/%s.hasvar' % entType, 'category') == False:
                    call('/lib/ents/%s.cs' % entType, 'category', 'misc')
                category = call('/lib/ents/%s.gs' % entType, 'category')
                if category not in categories:
                    categories.append(category)
            print 'ent categories', categories
            for category in categories:
                if category == 'misc':
                    createEnt.done()
                categoryRMenuItem       = RMenuItem(category)
                if categoryRMenuItem.add():
                    for entType in entTypes:
                        if call('/lib/ents/%s.gs' % entType, 'category') == category:
                            entRMenuItem = RMenuItem(entType,                   RMENU_CREATE_ENT)
                    categoryRMenuItem.done()

            #large                           = RMenuItem('Large')
            #medium                          = RMenuItem('Medium')
            #small                           = RMenuItem('Small')
            #if large.add():
                #carrier                     = RMenuItem('carrier',                  RMENU_CREATE_ENT)
                #cg47                        = RMenuItem('cg47',                     RMENU_CREATE_ENT)
                #container                   = RMenuItem('container',                RMENU_CREATE_ENT)
                #ffg                          = RMenuItem('ffg',                      RMENU_CREATE_ENT)
                #ddg51                        = RMenuItem('ddg51',                    RMENU_CREATE_ENT)
                #cg52                         = RMenuItem('cg52',                     RMENU_CREATE_ENT)
                #oilplatform                 = RMenuItem('oilplatform',              RMENU_CREATE_ENT)
                #roro                        = RMenuItem('roro',                     RMENU_CREATE_ENT)
                #large.done()
            #if medium.add():
                #ctractortug                 = RMenuItem('ctractortug',              RMENU_CREATE_ENT)
                #fishingboat                 = RMenuItem('fishingboat',              RMENU_CREATE_ENT)
                #medium.done()
            #if small.add():
                #cigarette                   = RMenuItem('cigarette',                RMENU_CREATE_ENT)
                #cigar                       = RMenuItem('cigar',                    RMENU_CREATE_ENT)
                #launch                      = RMenuItem('launch',                   RMENU_CREATE_ENT)
                #lifeboat                    = RMenuItem('lifeboat',                 RMENU_CREATE_ENT)
                #f18                         = RMenuItem('f18',                      RMENU_CREATE_ENT)
                #buoy                        = RMenuItem('buoy',                     RMENU_CREATE_ENT)
                #oilbeacon                   = RMenuItem('oilbeacon',                RMENU_CREATE_ENT)
                #small.done()
            #createEnt.done()
        bm.done()
    if camera.add():
        faster                          = RMenuItem('Faster [t]', RMENU_FASTER_CAMERA)
        unattach                        = RMenuItem('UnAttach [l]', RMENU_UNATTACH_CAMERA)
        slower                          = RMenuItem('Slower [g]', RMENU_SLOWER_CAMERA)
        camera.done()
    if time.add():
        slower                          = RMenuItem('Slower [r]', RMENU_SLOWTIME)
        pause                           = RMenuItem('Pause [p]',  RMENU_PAUSETIME)
        faster                          = RMenuItem('Faster [g]', RMENU_SPEEDTIME)
        time.done()
    world.done()
#/-----------------------------------------------------------------------------//
unitToUnit                              = RMenuItem(path='/ui/rmenus/command/unitToUnit', button = 2)                             #should create it as a proxy
if unitToUnit.add():
    spCommand                           = RMenuItem('Group')
    if spCommand.add():
        attack                          = RMenuItem('attack',                   RMENU_ASSIGN_OBJECTIVE)
        ram                             = RMenuItem('ram',                      RMENU_ASSIGN_OBJECTIVE)
    spCommand.done()

    from behaviorNames import *
    catTarget                           = RMenuItem('Select Target',            RMENU_CAT_SELECT_TARGET)
    catApproach                         = RMenuItem(MAINTAIN,                   RMENU_BEHAVIOR_CHANGE)
    catRam                              = RMenuItem(RAM,                        RMENU_BEHAVIOR_CHANGE)
    catMove                             = RMenuItem(MOVETO,                     RMENU_BEHAVIOR_CHANGE)
    catFire                             = RMenuItem(FIRE,                       RMENU_BEHAVIOR_CHANGE)
    unitToUnit.done()
#/-----------------------------------------------------------------------------//
unitToWorld                             = RMenuItem(path='/ui/rmenus/command/unitToWorld', button = 2)                              #should create it as a proxy
if unitToWorld.add():
    move                                = RMenuItem('move',                     RMENU_ASSIGN_OBJECTIVE)
    catMove                             = RMenuItem(MOVETO,                     RMENU_BEHAVIOR_CHANGE)
    plotCourse                          = RMenuItem('Plot Course - Physics',    RMENU_PLOT_COURSE)
    plotCourse                          = RMenuItem('Plot Course - IM',         RMENU_PLOT_COURSE_SIMPLE)
    unitToWorld.done()
#/-----------------------------------------------------------------------------//
tugToOilBeacon                          = RMenuItem(path='/ui/rmenus/command/tugtooilbeacon', button = 2)
if tugToOilBeacon.add():
    oilPlatform                         = RMenuItem('build oilplatform',        RMENU_BUILD)
    tugToOilBeacon.done()
#/-----------------------------------------------------------------------------//
# sushil
#/-----------------------------------------------------------------------------//
#catunit                                 = RMenuItem(path='/ui/rmenus/command/catUnit', button = 1)
#if catunit.add():
    #cunitMode                           = RMenuItem('Mode')
    #if OptionManager.getOption('stickyselect'):
        #cuentity                        = RMenuItem('CAT Unselect',             RMENU_CAT_UNSELECT_ENT)
    #if cunitMode.add():
        #cauthorMode                     = RMenuItem('Authoring',                 RMENU_AUTHORING_MODE)
    #cexecMode                           = RMenuItem('Execution',                 RMENU_EXECUTION_MODE)
    #cunitMode.done()
    #catunit.done()
#/-----------------------------------------------------------------------------//
#catworld                                 = RMenuItem(path='/ui/rmenus/command/catWorld', button = 1)
#if catworld.add():
    #if OptionManager.getOption('stickyselect'):
        #cuentity                              = RMenuItem('CAT Unselect',             RMENU_CAT_UNSELECT_ENT)
    #catworld.done()
#/-----------------------------------------------------------------------------//
#catunitToUnit                           = RMenuItem(path='/ui/rmenus/command/catUnitToUnit', button = 1) 
#if catunitToUnit.add():
    #from behaviorNames import *
    #catTarget                           = RMenuItem('Select Target',            RMENU_CAT_SELECT_TARGET)
    #catApproach                         = RMenuItem(MAINTAIN,                   RMENU_BEHAVIOR_CHANGE)
    #catRam                              = RMenuItem(RAM,                        RMENU_BEHAVIOR_CHANGE)
    #catMove                             = RMenuItem(MOVETO,                     RMENU_BEHAVIOR_CHANGE)
    #catFire                             = RMenuItem(FIRE,                       RMENU_BEHAVIOR_CHANGE)
    #catunitToUnit.done()

#/-----------------------------------------------------------------------------//
#catunitToWorld                          = RMenuItem(path='/ui/rmenus/command/catUnitToWorld', button = 1)
#if catunitToWorld.add():
    #from behaviorNames import *    
    #catMove                             = RMenuItem(MOVETO,                      RMENU_BEHAVIOR_CHANGE)
    #if OptionManager.getOption('stickyselect'):
        #cuentity                              = RMenuItem('CAT Unselect',             RMENU_CAT_UNSELECT_ENT)
    #catunitToWorld.done()
#/-----------------------------------------------------------------------------//
