from npython import *
from defs import *
#open the gfx server
def openGfxServer():
    """create the graphics server and set display parameters"""
    sn('nglserver', 'gfx')
    import WindowManager
    pos, size                           = WindowManager.get('3d')
    width 	= size[0]
    height 	= size[1]
    culldepth                           = 50000
    type                                = 'win'
    aspectRatio                         = float(width) / height
    #aspectRatio 		= .866
    #fieldOfView = 30
    #import math
    #fieldOfView = abs(math.atan(math.tan(fieldOfView)))
    #fieldOfView                         = .5773
    fieldOfView                         = 1.0
    set('setdisplaymode', 'w(%f)-h(%f)-type(%s)-zbuf(64)' % (width, height, type))
    minDist = .1
    set('setviewvolume',-minDist * aspectRatio * fieldOfView, +minDist * aspectRatio * fieldOfView, -minDist * fieldOfView, +minDist * fieldOfView, +minDist, culldepth)
    set('setclearcolor',0,0,0,0)
    set('opendisplay')
    sel('..')

    #save a copy of this info into the eva tree
    sn('nent', '/sys/share/windowsettings')
    cf('width', width)
    cf('height', height)
    cf('culldepth', culldepth)
    cs('type', type)
    cf('aspectRatio', aspectRatio)
    sel('/sys/servers/')
    #/-----------------------------------------------------------------------------//
def openTriggerServer():
    """open the trigger server and set default time parameters"""
    sn('ntriggerserver', 'trigger')
    set('settimestep', .01)
    set('settimescale', 1.0)
    set('setmaxtimesteps', 100)
    sel('..')
    #/-----------------------------------------------------------------------------//
def openGameServer():
    """create the game server and set default options"""
    sn('ngameserver','game')
    set('setdrawaxis', 	False)
    set('setdrawgrid', 	False)
    set('setdrawscreengrid',	False)
    set('setvisualizecollision', 	False)
    sel('..')
#/-----------------------------------------------------------------------------//
def openServers():
    """create all the other servers"""
    new('nparticleserver',	'particle')
    new('nspecialfxserver', 	'specialfx')
    new('nshadowserver', 	'shadow')
    new('nfileserver2', 	'file2')
    new('nlxinputserver', 	'input')
    new('nscenegraph2', 	'sgraph2')
    new('nchannelserver',	'channel')
    new('nconserver',	'console')
    call('console.watch', 	'nothing')
    new('nmathserver',	'math')
    new('noctree',	'octree')
    new('nopcodeserver',	'collide')
    new('nmessageserver',	'message')
    new('nprimitiveserver',	'primitive')

    #new('nrcserver',	'rc')
    #new('nfxserver',	'fx')
    new('nprofserver',	'prof')
    call('prof.undisplay')
    new('nreleaseserver',	'release')
    new('nxmlserver',	'xml')
    #new('ncommandserver',	'command')
    new('nvarserver',	'var')
    new('nodeserver',	'ode')
    new('nopenalserver',	'audio')
    call('audio.setcameravelcoef',      0)
    new('neventserver',	'event')

#/-----------------------------------------------------------------------------//
"""setup the engine"""
sn ('nroot', '/sys/servers')
import OptionManager
if OptionManager.getOption('gfx'):
    openGfxServer()
openTriggerServer()
openGameServer()
openServers()

sel('/game/ents')
