#
# @(#) coveDOMParser.py 2005/07/25
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

import sys
from xml.dom import minidom, Node
import string
from stringnames import *


def walk(parent, outFile, level, result):                               # [1]
    for node in parent.childNodes:
        if node.nodeType == Node.ELEMENT_NODE:
            # Walk over any text nodes in the current node.
            content = []                                        # [3]
            for child in node.childNodes:
                if child.nodeType == Node.TEXT_NODE:
                    content.append(child.nodeValue)
            if content:
                strContent = string.join(content)
                strContent = str(strContent)
            addToResult(node.nodeName, strContent.strip("\'\""), result)
            # Walk the child nodes.
            walk(node, outFile, level+1, result)

def addToResult(name, cont, result):
    content = cont.replace('\'', '')
#    print "stripped content: " + content
    if (compare(name, LABELSTRING)):
        item = (LABELSTRING, content)
        result.append(item)
    elif (compare(name, TYPESTRING)):
        item = (TYPESTRING, content)
        result.append(item)
    elif (compare(name, LOCATIONSTRING)):
        item = (LOCATIONSTRING, content)
        result.append(item)
    elif (compare(name, SPEEDSTRING)):
        item = (SPEEDSTRING, content)
        result.append(item)
    elif (compare(name, HEADINGSTRING)):
        item = (HEADINGSTRING, content)
        result.append(item)
    elif (compare(name, VELOCITYSTRING)):
        item = (VELOCITYSTRING, content)
        result.append(item)
    elif (compare(name, ACCELERATIONSTRING)):
        item = (ACCELERATIONSTRING, content)
        result.append(item)
    elif (compare(name, LTLNSTRING)):
        item = (LTLNSTRING, content)
        result.append(item)

def compare(cont, str):
    return cont.strip().lower().startswith(str)

def printLevel(outFile, level):
    for idx in range(level):
        outFile.write('    ')
