import socket
import wx
import sys
import os
import pickle
import wx
from common.defs import *
from wxPython.wx import *
from common import OptionManager
packetSize = 1024 * 1024
#/-----------------------------------------------------------------------------//
class HarborClient:
    #/-----------------------------------------------------------------------------//
    gridsize                            = 369
    harborPort                          = 23573
    harborHost                          = OptionManager.getOption('covehost')
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        pass
    #/-----------------------------------------------------------------------------//
    def createMenu(self, panel, parent):
        """setup the menubar"""
        print 'harborClient.createMenu'
        menu = wx.Menu()
        if self.getHarborsAvailable():
            for i, harbor in enumerate(self.harborsAvailable):
                menu.Append(i, harbor, 'Download %s' % harbor)
                EVT_MENU(parent, i, self.downloadHarborButton)
        return menu
    #/-----------------------------------------------------------------------------//
    def getHarborsAvailable(self):
        """connect to cove and get a list of the available maps"""
        if self.connect():
            harborsAvailableStringLength                                        = int(self.socket.recv(20))
            print 'harborsAvailableStringLength',                               harborsAvailableStringLength
            harborsAvailableString                                              = self.socket.recv(harborsAvailableStringLength)
            print 'harborsAvailableString',                                     harborsAvailableString
            self.harborsAvailable                                               = pickle.loads( harborsAvailableString )
            print 'harborsAvailable',                                           self.harborsAvailable
            return True
        else:
            return False
    #/-----------------------------------------------------------------------------//
    def connect(self):
        """setup the connection to cove"""
        try:
            self.socket = socket.socket( socket.AF_INET, socket.SOCK_STREAM )
            self.socket.connect( (self.harborHost, self.harborPort) )
        except socket.error:
            print 'HarborClient Failed to connect to cove'
            #printExcept('Failed to Connect to Cove')
            return False
        return True
    #/-----------------------------------------------------------------------------//
    def downloadHarborButton( self, event ):
        harborName                      = self.harborsAvailable[event.GetId()]
        self.getHarbor                  (harborName)
    #/-----------------------------------------------------------------------------//
    def getHarbor( self, harborName ):
        print 'HarborClient:getHarbor(%s)' % harborName
        #tell it what i want
        self.socket.send                ('%08i' % len(harborName))
        self.socket.send                (harborName)

        #get back the length of the thing
        lenHarborString                 = self.socket.recv(20)
        lenHarborString                 = int(lenHarborString)
        print 'HarborClient:lenHarborString',        lenHarborString

        harborString                    = ''
        progressbar                     = 0
        print 'HarborClient:Downloading --- ', 
        #harborString = self.socket.recv(lenHarborString, socket.MSG_WAITALL)
        while len(harborString) < lenHarborString:
            #print '%i / %i' % (len(harborString), lenHarborString)
            bytesToReceive = lenHarborString - len(harborString)
            #print 'bytesToReceive', bytesToReceive
            #newInfo = self.socket.recv(lenHarborString - len(harborString))
            newInfo = self.socket.recv(packetSize)
            #print 'newInfo', len(newInfo)
            if newInfo and len(newInfo) > 0:
                while len(harborString) * 80 / lenHarborString > progressbar:
                    progressbar += 1
                    sys.stdout.write('*')
                harborString += newInfo
        print '--- done'

        harbor = pickle.loads(harborString)
        self.saveToFile(harbor['map'], harbor['filename'], harbor['worldMin'], harbor['worldMax'])
        self.socket.close()
        print 'HarborClient:processing', harbor['filename']
        from common import MapManager
        MapManager.setHeightRange       ( -self.maxDepth, -self.minDepth)
        MapManager.changeHeightmap      ( harbor['filename'] )
    #/-----------------------------------------------------------------------------//
    def saveToFile( self, map, filename, worldMin, worldMax):
        print 'HarborClient:saveToFile', filename
        image = wx.EmptyImage(self.gridsize,self.gridsize,True)
        first = True
        minDepth = maxDepth = 0

        #calc min/max depth
        for depth in map.values():
            if depth == 999999 or depth < 0:
                continue
            if first:
                minDepth = maxDepth = depth
                first = False
            else:
                if depth < minDepth:
                    minDepth = depth
                if depth > maxDepth:
                    maxDepth = depth
        print 'HarborClient:minDepth', minDepth
        print 'HarborClient:maxDepth', maxDepth
        self.minDepth = minDepth
        self.maxDepth = maxDepth
        num = 0
        #set pixels
        for (x,y), depth in map.items():
            if depth == 999999:
                depth = maxDepth
            if num % self.gridsize == 0:
                sys.stdout.write('*')
                #sys.stdout.flush()
            num += 1
            x = float(x)
            y = float(y)
            pixelx = ((x - worldMin[0]) * 368 )/ (worldMax[0] - worldMin[0])
            pixely = ((y - worldMin[1]) * 368 )/ (worldMax[1] - worldMin[1])
            pixelx = int(pixelx)
            pixely = int(pixely)
            colour = (depth - minDepth) / float(maxDepth - minDepth)
            colour = 1.0 - colour
            colour = colour * 255.0
            colour = int(colour)
            #print x, y, depth, pixelx, pixely, colour
            image.SetRGB( 368 - pixelx, 368 - pixely, colour, colour, colour)   #have to flip the pixels to get them to line up right

        print 'HarborClient:saving as png'
        image.SaveFile('coveheightmaps/%s.png' % filename, wx.BITMAP_TYPE_PNG)
        print 'HarborClient:converting to bmp'
        os.system('convert coveheightmaps/%s.png coveheightmaps/%s.bmp' % (filename, filename))    #wx refuses to save to bmps under linux for some reason, but the heightmaps have to be bmps, so we just convert them
        print 'HarborClient:loading'
        from common import FileManager
        FileManager.load('coveheightmaps')
    #/-----------------------------------------------------------------------------//
harborClient = HarborClient()
