import os
import sys
import socket
import re
import pickle
vms.cls()
#/-----------------------------------------------------------------------------//
def frange(start, end=None, inc=None):
    "A range function, that accepts float increments..."
    if end == None:
        end = start + 0.0
        start = 0.0
    if inc == None:
        inc = 1.0
    L = []
    while 1:
        next = start + len(L) * inc
        if inc > 0 and next >= end:
            break
        elif inc < 0 and next <= end:
            break
        L.append(next)
    return L
#/-----------------------------------------------------------------------------//
harborPort = 23573
packetSize = 1024 * 1024
min = (-30000,-30000)
print 'min', min
max = (30000,30000)
print 'max', max
gridsize = 369
print 'gridsize', gridsize
blockSize = (max[0] - min[0]) / gridsize, (max[0] - min[0]) / gridsize
print 'blockSize', blockSize
xrange = frange(min[0], max[0], blockSize[0])
yrange = frange(min[1], max[1], blockSize[1])
print 'number of blocks', len(xrange), len(yrange)
#/-----------------------------------------------------------------------------//
def sendHarborsAvailable (toClientSocket):
    """send a list of the available harbor files to a client"""
    print 'sendHarborsAvailable'
    harborsAvailable = []
    for root, dir, files in os.walk('C:\VShip2000\DataFiles\Harbors'):
        for file in files:
            path = root + os.path.sep + file
            filename, ext = os.path.splitext( file )
            regex = re.compile('WaterDepth')
            if regex.search(filename) and ext == '.obj':
                harborsAvailable.append( filename )
    print 'harborsAvailable', harborsAvailable
    harborsAvailableString = pickle.dumps( harborsAvailable )
    toClientSocket.send('%020i' % len( harborsAvailableString ))
    toClientSocket.send( harborsAvailableString )
#/-----------------------------------------------------------------------------//
def sendHarbor ( desiredHarbor, toClientSocket ):
    """send the info for a harbor to a client"""
    print 'sendHarbor', desiredHarbor, toClientSocket
    harbor = {}
    for root, dir, files in os.walk('C:\VShip2000\DataFiles\Harbors'):
        for file in files:
            path = root + os.path.sep + file
            filename, ext = os.path.splitext( file )
            regex = re.compile('WaterDepth')
            if regex.search(filename) and ext == '.obj' and filename == desiredHarbor:
                print 'found harbor obj', filename
                harbor['map'] = {}
                harbor['filename'] = filename
                harbor['worldMin'] = min
                harbor['worldMax'] = max

                obj = vms.EnviromentQuery()
                obj.Initialize( path )
                for x in xrange:
                    print '%i / %i' % (x, max[0])
                    #sys.stdout.write('*')
                    for y in yrange:
                        depth = obj.DepthQuery(( x,y ))
                        harbor['map'][x,y] = depth

    print 'pickling'
    harborString = pickle.dumps(harbor)
    print 'done pickling'
    toClientSocket.send('%020i' % len(harborString))
    print 'sending harborString'    
    mini = 0
    done = False
    progressBar = 0
    while not done:            
        maxi = mini + packetSize
        if maxi > len(harborString):
            maxi = len(harborString)
            done = True	
        print 'sending %i - %i / %i' % (mini, maxi, len(harborString)) 
        substring = harborString[mini:maxi]
        bytesSent = toClientSocket.send(substring)
        mini += packetSize
    print 'bytesSent', bytesSent
    print 'done sending harborString'
#/-----------------------------------------------------------------------------//
def openServerSocket():
    """initialize my server socket to receive client connections"""
    print 'openServerSocket'
    serverSocket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    serverSocket.bind((socket.gethostname(), harborPort));
    serverSocket.listen(5)
    return serverSocket
#/-----------------------------------------------------------------------------/
def handleServerSocket(serverSocket):
    """sit in a loop in the server socket - waiting for a client to connect to me"""
    print 'handleServerSocket'
    while True:
        clientSocket, address = serverSocket.accept()
        print 'client', address, 'has requested harbor information'
        sendHarborsAvailable(clientSocket)
        lenHarborString = int(clientSocket.recv(8))
        harborDesired = clientSocket.recv(lenHarborString)
        print 'harborDesired', harborDesired
        sendHarbor( harborDesired, clientSocket )
        clientSocket.close()
        print 'done with client', address
        break
#/-----------------------------------------------------------------------------//
try:
    serverSocket = openServerSocket()
    handleServerSocket( serverSocket )
except:
    print 'harborServer failed'
    sys.excepthook(sys.exc_info()[0], sys.exc_info()[1], sys.exc_info()[2])
serverSocket.close()
#/-----------------------------------------------------------------------------//
