import socket
import threading
import sys
import time
import types
# constants to be used later

sendPort = 4000;      # port to which to send on host above
commandPort = 4001;   # port from which to get controller commands
sleepTime = 1;
numSeconds = 500;
setquit = 0

fconsole = open("output.txt", "w");  #log file to deal with COVE

###################################

def log(data):
    if data == None:
        return
    if type(data) is types.StringType:
        fconsole.write(data)
        sys.stdout.write(data)
    else:
        fconsole.write(`data`)
        sys.stdout.write(`data`)

    sys.stdout.flush()
    fconsole.flush()

###################################

log("Hello world \n" );

# setHeading or Speed
def applyCommand(data):
    log("Got Command: " + `data` + "\n");
    
    try:
        dataString = ''  
        for c in data:
            dataString += str(c);
        if (dataString.find('quit') >= 0):
            return ''
        items = dataString.split("_");
        log("Items: " + `items` + "\n");
        log("Trying to find: " + `items[1]`);
        obj = vms.object (items[1]);
        if obj.type == 'LowFidelityShip':
            if(items[0].find("heading") != -1):
                obj.setHeading(float(items[2]));
            if(items[0].find("speed") != -1):
                obj.setSpeed(float(items[2]));
                log("End Processing: Items: " + `items` + "\n");
    except Exception, e:
        log("Error in applyCommand: " + `items` + "\n");
        log("Exception: " + `e` + "\n");
        
        return dataString;

def testApplyCommand(data):
    s = ' '
    for c in data:
        s += str(c)
    log("Got Command: " + s + ":\n");
    if (s.find('quit') >= 0):
        return ''
    else:
        return data

def getCommand(con):
    i = 0;
    c = con.recv(1)
    if not c: return '';
#    log("Got character: " + `c` + "\n");
    data = [];
    while(c != "|" and i < 50):
        data.append(c);
        i = i + 1
        c = con.recv(1);
        if not c: break
#        log("Got character: " + `c` + "\n");
#    log("Last character: " + `c` + "\n");
    if c:
#        tmp = applyCommand(data)
        tmp = testApplyCommand(data)
        return tmp
    else:
        return '';





# Put COVE state into a string
def makeStringData():
    x = vms.objects();
#    stringData = '\n<state> ';
    stringData = '';
    for label in x:
        stringData += '\n<entity> ';
	stringData = stringData + '<label> ' + `label` + ' </label>  ';
	obj = vms.object (label);
        stringData = stringData + '<type> ' + `obj.type` + '</type>  ';
	if obj.type == 'LowFidelityShip':
            pos = obj.position();
            stringData += '<pos> ' +  `pos[0]` + ' ' + `pos[2]` + ' ' + `pos[1]` + ' </pos>  ';
            stringData += '<speed> ' + `obj.speed()` + ' </speed> ';
            stringData += '<heading> ' + `obj.heading()` + ' </heading> ';
            vel = obj.velocity();
            stringData += '<vel> ' + `vel[0]` + ' ' + `vel[1]` + ' ' + `vel[2]` + ' </vel>';
            accel = obj.acceleration();
            stringData += '<acceleration> ' + `accel[0]` + ' ' + `accel[1]` + ' ' + `accel[2]` + ' </acceleration> ';
            stringData += '<ltln> ' + `obj.geographicPosition()` + ' </ltln>  ';
        stringData = stringData + '\n </entity> \n';
#    stringData += '\n</state> \n';
    log(stringData);
    
    return stringData;

import random
randomizer = random.Random()
seeker = 0
def makeTestStringData():
    fh = open(sys.argv[1], "r")
    global seeker
    rnd = randomizer.randint(seeker + 1, seeker + 8192) # read random number of bytes from the test file
    diff = rnd - seeker
    print "Sending " + `diff` + ' bytes '
    fh.seek(seeker)
    data = fh.read(diff)
    seeker = seeker + diff
    print "Seeker: " + `seeker` 
    if(data == '' or seeker > 3659592):
        print 'Resetting file pointer'
        seeker = 0
    fh.close()
    return data


# receive commands on a socket and execute them. Commands update
# the speed and heading of a cove entity
class commandThread(threading.Thread):
    def __init__(self, commandSocket):
        threading.Thread.__init__(self);
        self.commandSocket = commandSocket;
    def run(self):
        self.commandSocket.listen(5);
        con, addr = self.commandSocket.accept();
        log('Command client is at ' + `addr` + "\n");
        global setquit
        data = 'stuff';
        while 1: # get command/exec command ...forever
            data = getCommand(con);
            if(data == '' or setquit == 1):
                break
            log("Got Data...\n"); # need to exec the command
#            if(data != None): log(data)

        setquit = 1
        log("Command Thread dieing...\n")        
        self.commandSocket.close(); # should we be closing the socket here?
            

# Send cove state updates to connected receiver
# makeString makes a long string containing cove's state. We use strings
# because the receiver may be a C/java/... application
class sendThread(threading.Thread):
    def __init__(self, sendSocket):
        threading.Thread.__init__(self)
        self.sendSocket = sendSocket;
    def run(self):
        self.sendSocket.listen(5);
        sendCon, addr = self.sendSocket.accept();
        log( 'client is at address' + `addr` +  '\n');
        global setquit
        i = 0;
        while 1:
            data = makeTestStringData(); # get COVE state as string
            if (data == '' or setquit == 1): break
#            log(data);
            sendCon.send(data);      # send COVE state 
            i = i + 1;
            log( '*Sent packet number ' + `i` + '\n\n');
            if(i > numSeconds): break     # This is simply for testing
            time.sleep(sleepTime)
        setquit = 1
        log("Send Thread dieing...\n")
        self.sendSocket.close();

# start main
# write some output so we know python is up inside COVE
log( "hello world \n" );

#log( vms.scriptEngineVersion() );
log( "\n");
log("begin\n");


log( "Initializing Command Socket...\n");

commandSocket = socket.socket(socket.AF_INET,socket.SOCK_STREAM);
commandSocket.bind(('', commandPort));

log( "Initializing Send Socket...\n");

sendSocket  = socket.socket(socket.AF_INET,socket.SOCK_STREAM);
sendSocket.bind(('', sendPort));

log("Starting Command Thread...\n");

command = commandThread(commandSocket);
command.start();
log( "Command Listener Running...\n");


log("Starting Sender Thread...\n");

sender = sendThread(sendSocket);
sender.start();
log( "Sender Running...\n");


command.join();
sender.join();

log( "Done...Exiting\n");

fconsole.close();

