#
# @(#) translate.py 2005/07/26
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

class Translator:
    """translates between two 3D coordinate systems"""
    def __init__(self, p1):
        self.world1Point = p1
        self.world2Point = (0, 0, 0) # Point(0,0,0)

    def setLagoonPoint(self, p1):
        self.world1Point = p1          

    def setCovePoint(self, p2):
        self.world2Point = (p2[0],p2[1],p2[2]) #note that cove uses x,z,y
        
    def LagoonToCove(self, p1):
        diffP = diff(p1, self.world1Point)
        return sum (self.world2Point, diffP)

    def CoveToLagoon(self, p2):
        diffP = diff(self.world2Point, p2)
        return sum (self.world1Point, diffP)


def diff(p1, p2):
    return (p1[0] - p2[0], p1[1] - p2[1], p1[2] - p2[2])

def sum (p1, p2):
#    return (p1[0] + p2[2], p1[1] + p2[1], p1[2] - p2[0])
    return (p1[0] + p2[0], p1[1] + p2[1], p1[2] + p2[2])

