from npython import *
from common.defs import *
import wx
import evaexplorer
class nhardpointPanel(wx.Panel):
    def __init__(self, parent, id, log, path):
        print 'nhardpointPanel().init'
        self.path = path
        wx.Panel.__init__(self,parent, id, style = wx.TAB_TRAVERSAL | wx.CLIP_CHILDREN | wx.FULL_REPAINT_ON_RESIZE)

        self.log = log
        gbs = self.gbs = wx.GridBagSizer(5, 5)

        name = call('%s.getname' % path)
        offset = call('%s.getoffset' % path)
        gbs.Add(wx.StaticText(self, -1, 'Offset'), (0,0) )
        xSlider = wx.Slider(self,-1,offset[0],-100,100,(30,60),(400,-1),wx.SL_HORIZONTAL | wx.SL_AUTOTICKS | wx.SL_LABELS)
        ySlider = wx.Slider(self,-1,offset[1],-100,100,(30,60),(400,-1),wx.SL_HORIZONTAL | wx.SL_AUTOTICKS | wx.SL_LABELS)
        zSlider = wx.Slider(self,-1,offset[2],-100,100,(30,60),(400,-1),wx.SL_HORIZONTAL | wx.SL_AUTOTICKS | wx.SL_LABELS)
        gbs.Add(wx.StaticText(self,-1,'X:'), (1,1))
        gbs.Add(xSlider, (1,2))
        gbs.Add(wx.StaticText(self,-1,'Y:'), (2,1))
        gbs.Add(ySlider, (2,2))
        gbs.Add(wx.StaticText(self,-1,'Z:'), (3,1))
        gbs.Add(zSlider, (3,2))

        self.Bind(wx.EVT_SCROLL, self.changeOffsetX, xSlider)
        self.Bind(wx.EVT_SCROLL, self.changeOffsetY, ySlider) 
        self.Bind(wx.EVT_SCROLL, self.changeOffsetZ, zSlider) 

        self.SetSizerAndFit( gbs )
    def changeOffset(self, index, event):
        assert index >= 0 and index < 3
        value = event.GetPosition()
        pushsel(self.path)
        offset = list(call('.getoffset'))
        offset[index] = value
        call('.setoffset', offset[0], offset[1], offset[2])
        popsel()
        print 'offset', offset

    def changeOffsetX(self, event):     self.changeOffset( 0, event )
    def changeOffsetY(self, event):     self.changeOffset( 1, event )
    def changeOffsetZ(self, event):     self.changeOffset( 2, event )
