#
# @(#) executive.py 2005/07/06
# @author Copyright (c) 2005 The University of Nevada, Reno. All
# rights reserved.
#
# This software is provided "AS IS," without a warranty of any
# kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND
# WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY
# EXCLUDED. THE UNIVERSITY OF NEVADA, RENO AND ITS LICENSORS SHALL NOT BE
# LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
# MODIFYING OR DISTRIBUTING THE SOFTWARE OR ITS DERIVATIVES. IN NO
# EVENT WILL THE UNIVERSITY OF NEVADA, RENO OR ITS LICENSORS BE LIABLE FOR
# ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL,
# CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND
# REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR
# INABILITY TO USE SOFTWARE, EVEN IF THE UNIVERSITY OF NEVADA, RENO HAS BEEN
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
#

from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'executive'])
import wx
import sys
import nEventServer
from common import EventNames
import cat
import nEventServer
from wxPython.wx import *

ID_EXEC = 2323101

ID_FORMATE_V      = 2323102
ID_FORMATE_LINE   = 2323103
ID_FORMATE_COLUMN = 2323104

SEPERATION        = 50
ANGLE             = 180

LENGTH_MULTIPLIER = 5

MAINTAINTASK = "maintainAvoid"

#/-----------------------------------------------------------------------------//
class ExecPanel(wx.Panel):
    """The exec menu, to let everyone know that we are here"""

    def __init__(self, parent, s):
        """constuctor - set menu item, initialize things, and register the PLAN_READY event handler"""

#        nEventServer.register(EventNames.PLAN_READY, handlePlanReady)
        nEventServer.register(EventNames.PLAN_READY, handlePlanReady)

        menu = wx.Menu()
        menu.Append(ID_EXEC, '&Execute', 'Execute Default Plan');
        parent.GetMenuBar().Append(menu, 'Exec')
        EVT_MENU(parent, ID_EXEC, self.Execute)

        menu2 = wx.Menu()
        menu2.Append(ID_FORMATE_COLUMN, '&Column Formation', 'Column Formation')
        menu2.Append(ID_FORMATE_V, '&V Formation', 'V Formation')
        menu2.Append(ID_FORMATE_LINE, '&Row Formation', 'Row Formation')
        parent.GetMenuBar().Append(menu2, 'Formations')
        EVT_MENU(parent, ID_FORMATE_V, self.vForm)
        EVT_MENU(parent, ID_FORMATE_LINE, self.lineForm)
        EVT_MENU(parent, ID_FORMATE_COLUMN, self.columnForm)        


    def Execute(parent, event):
        log.write( "Associating entities with controllers")
        nEventServer.event(EventNames.PLAN_READY)

    def vForm(parent, event):
        #print "V Formation"
        global ANGLE, SEPERATION
        ANGLE = 135
        SEPERATION = 50

    def lineForm(parent, event):
        #print "Line Formation"
        global ANGLE, SEPERATION
        ANGLE = 90
        SEPERATION = 50
        
    def columnForm(parent, event):
        #print "Line Formation"
        global ANGLE, SEPERATION
        ANGLE = 180
        SEPERATION = 50
        

#/-----------------------------------------------------------------------------//
def isTask(task):
    if exists('/comm/tasks'):
        taskList = ndirin('/comm/tasks')
        #print "Exec: task list: ", str(taskList)
        if(task in taskList):
            return true
        else:
            return false
    else:
        print "/comm/tasks doesn't exists"

#/-----------------------------------------------------------------------------//

def isObjective(objective):
    if exists('/comm/objectives'):
        objList = ndirin('/comm/objectives')
        #print "Exec: Objective list: ", str(objList)        
        if(objective in objList):
            return true
        else:
            return false
    else:
        print "/comm/objectives doesn't exists"

#/-----------------------------------------------------------------------------//
def handlePlanReady(msg):
    """plan_ready event has fired -> find all the gorups in /comm/plan and attach controllers to them"""
    log.open('Plan is ready, Associate entities with controllers')
    print "+++++++++++++++++++++++++++++++++++++++++++"
    #print 'Plan is ready, Associate entities with controllers'
    pushsel('/comm/plan')
    plan = ndir()
    popsel() 
    print( 'Plan is :', str(plan))
    pushsel()
    try:
        for groupName in plan:
            planPath  = '/comm/plan/%s' % groupName
            groupPath = '/comm/groups/%s' % groupName
            print( 'GroupPath is ' + groupPath)
            print( 'PlanPath is ' + planPath)
            pushsel(planPath)
            print "Path name selected: ", getfullname()
            if (hasvar('objective')):
                obj = gs('objective')
                print '**************************************Executive: obj:', obj
                obj.strip()                #shouldn't be needed
                # if you have a task and objective with the same name (move)
                # the move TASK will be executed
                #pushsel()
                if(isTask(obj)):           
                    handleObjective(obj, groupName, groupPath)
                elif (isObjective(obj)):
                    handleObjective(obj, groupName, groupPath)
                else:
                    print("************************************Something wicked this way comes, tis neither a task nor an objective", obj)
                    handleObjective(obj, groupName, groupPath)                    
                    log.write("Something wicked this way comes, tis neither a task nor an objective")
            popsel()
            pushsel(planPath)
            print "Before hasvar task", getfullname()
            if (hasvar('task')):            #sp will not export tasks anymore
                print '*************************************handleTask', task, groupName, groupPath
                task = gs('task')
                handleTask(task, groupName, groupPath)
            else:
                print("Tis not a task, must have been an objective")
            popsel()
    except:
        printExcept("Handle Plan Ready")
    print "+++++++++++++++++++++++++++++++++++++++++++"
    popsel()
    log.close()
#/-----------------------------------------------------------------------------//
def handleObjective(objective, groupName, groupPath):
    """ Handles assigning objectives to multi-units. Objectives deal with boat tuples. Exec's job is to assign the n constituent tasks of an object to n units"""
    '''
    begin('hObjective')
    try:                                #chris: was crashing lagoon 
        #print "handling objective"
        
        #print("EXEC: Handling Objective: (%s, %s, %s)" % (objective, groupName, groupPath))
        args = lookupTaskOrObjective(objective, True, groupName)
        #print("EXEC: Objective Arguments: " + str(args))
        units = ndirin(groupPath)
        #log.write( 'Units are ', units)
        from common import objectiveNames
        if (objective.startswith(objectiveNames.MOVETO)): # move in formation
            handleFormateX(objectiveNames.map[objective], units, args, groupPath)
        elif (objective.startswith(objectiveNames.FORMATEATTACK)):
            handleFormateX(objectiveNames.map[objective], units, args, groupPath)
        elif (objective.startswith(objectiveNames.ATTACKDISTRACT)):
            handleAttackDistract(objective, units, args, groupPath)
        else:
            print "Unknown objective: ", objective
    except:                             #chris
        printExcept('hObjective')       #chris
    end('hObjective')
    '''
    print "handling objective"
    
    print("EXEC: Handling Objective: (%s, %s, %s)" % (objective, groupName, groupPath))
    args = lookupTaskOrObjective(objective, True, groupName)
    print("EXEC: Objective Arguments: " + str(args))
    units = ndirin(groupPath)
    print( 'Units are ', units)
    from common import objectiveNames
    if (objective.startswith(objectiveNames.MOVETO)): # move in formation
        handleFormateX(objectiveNames.map[objective], units, args, groupPath)
    elif (objective.startswith(objectiveNames.FORMATEATTACK)):
        handleFormateX(objectiveNames.map[objective], units, args, groupPath)
    elif (objective.startswith(objectiveNames.RAM)):
        handleFormateX(objectiveNames.map[objective], units, args, groupPath)
    elif (objective.startswith(objectiveNames.DEFEND)):
        handleFormateDefend(objectiveNames.map[objective], units, args, groupPath)
    elif (objective.startswith(objectiveNames.ATTACKDISTRACT)):
        handleAttackDistract(objectiveNames.map[objective], units, args, groupPath)
    else:
        print "Unknown objective: ", objective

#/-----------------------------------------------------------------------------//

def handleFormateDefend(objective, units, args, groupPath):
    """Handle objectives where you maintain state wrt to lead which does the equivalent task"""
    lead = units.pop() # might want to pick one at random
    print "lead Unit is: ", str(lead)
    print "Remaining units are: ", str(units)
    leadRefPath = lookupUnit('%s/%s' %(groupPath, lead))
    #    maintainArgs = makeMaintainArgs(leadRefPath, 0)
    #    referenceUnit = leadRefPath
    from common import objectiveNames
    count = 0
    nUnits = len(units)
    for unit in units:
        unitRefPath = lookupUnit('%s/%s' %(groupPath, unit))
        # maintainArgs['target'] = referenceUnit
        maintainArgs = makeDefendArgs(leadRefPath, unitRefPath, count, nUnits )
        # referenceUnit = unitRefPath
        print("Attaching %s task to %s with % args", (MAINTAINTASK, unitRefPath, str(maintainArgs)))
        cat.AttachController(unitRefPath, MAINTAINTASK, maintainArgs)
        count = count + 1

    print "Lead Unit: Attaching %s task to %s with %s args" % (objectiveNames.newmap[objective], leadRefPath, str(args))
    cat.AttachController(leadRefPath, objectiveNames.newmap[objective], args)
#/-----------------------------------------------------------------------------//

def makeDefendArgs(leadRef, unitRefPath, count, nUnits):
    print "making defender args"
#/-----------------------------------------------------------------------------//

def handleFormateX(objective, units, args, groupPath):
    """Handle objectives where you maintain state wrt to lead which does the equivalent task"""
    '''<<<<<<< executive.py
    try:
        lead = units.pop() # might want to pick one at random
        print "lead Unit is: ", str(lead)
        print "Remaining units are: ", str(units)
        leadRefPath = lookupUnit('%s/%s' %(groupPath, lead))
        #    maintainArgs = makeMaintainArgs(leadRefPath, 0)
        #    referenceUnit = leadRefPath
        from common import objectiveNames
        # MAINTAINTASK = "maintainAvoid"
        count = 0
        for unit in units:
            unitRefPath = lookupUnit('%s/%s' %(groupPath, unit))
            # maintainArgs['target'] = referenceUnit
            maintainArgs = makeMaintainArgs(leadRefPath, unitRefPath, count, objective)
            # referenceUnit = unitRefPath
            print("Attaching %s task to %s with % args", (MAINTAINTASK, unitRefPath, str(maintainArgs)))
            cat.AttachController(unitRefPath, MAINTAINTASK, maintainArgs)
            count = count + 1

        print "Lead Unit: Attaching %s task to %s with %s args" % (objectiveNames.newmap[objective], leadRefPath, str(args))
        cat.AttachController(leadRefPath, objectiveNames.newmap[objective], args)
    except:
        printExcept('handleFormateX')
    ======='''
    lead = units.pop() # might want to pick one at random
    print "lead Unit is: ", str(lead)
    print "Remaining units are: ", str(units)
    leadRefPath = lookupUnit('%s/%s' %(groupPath, lead))
    #    maintainArgs = makeMaintainArgs(leadRefPath, 0)
    #    referenceUnit = leadRefPath
    from common import objectiveNames
    # MAINTAINTASK = "maintainAvoid"
    count = 0
    for unit in units:
        unitRefPath = lookupUnit('%s/%s' %(groupPath, unit))
        # maintainArgs['target'] = referenceUnit
        maintainArgs = makeMaintainArgs(leadRefPath, unitRefPath, count, objective)
        # referenceUnit = unitRefPath
        print("Attaching %s task to %s with % args", (MAINTAINTASK, unitRefPath, str(maintainArgs)))
        cat.AttachController(unitRefPath, MAINTAINTASK, maintainArgs)
        count = count + 1

    print "Lead Unit: Attaching %s task to %s with %s args" % (objectiveNames.newmap[objective], leadRefPath, str(args))
    cat.AttachController(leadRefPath, objectiveNames.newmap[objective], args)
#/-----------------------------------------------------------------------------//

def handleAttackDistract(objective, units, args, groupPath):
    """Handle objectives where you maintain state wrt to lead which does the equivalent task"""
    print "handling Attack Distract"
#/-----------------------------------------------------------------------------//

def merge(dict1, dict2):
    #print "Exec: getting SP's args: ", str(dict1)
    if dict1.has_key('0_desiredX'):
        dict2['0_desiredX'] = dict1['0_desiredX']
        dict2['0_desiredY'] = dict1['0_desiredY']
    if dict1.has_key('target'):
        dict2['target']     = dict1['target'] 
    return dict2

#/-----------------------------------------------------------------------------//
def makeMaintainArgs(leadRefPath, unitRefPath, count, objective):
    #print "Making correct arguments"
    if(count % 2 == 0):
        theAngle = 360 - ANGLE
    else:
        theAngle = ANGLE
    args = {}
    args['target'] = leadRefPath
    args["0_activated"] = True
    args["0_desiredStBearing"] = theAngle
    sep = computeSeperation(leadRefPath, unitRefPath)
    if(ANGLE == 180):
        args["0_desiredStRange"] = sep * (count + 1)
    else:
        args["0_desiredStRange"] = sep * int((count/2)+1)
    #args["0_desiredStRange"] = SEPERATION * int((count/2)+1)    
    args["0_avoidentity"] = False
    #print "Executive.makeMaintainArgs: ", str(args)

    return args
#/-----------------------------------------------------------------------------//

def computeSeperation(leadPath, unitPath):
    pushsel(leadPath)
    leadDim = gv ('dimension')
    #pushsel (unitPath)
    #unitDim = gv('dimension')
    #popsel()
    popsel()
    #print "Lead Unit: dimensions are: ", str(leadDim)
    #print "Follow Unit: dimensions are: ", str(unitDim)
    x, y, len = leadDim
    return len * LENGTH_MULTIPLIER


#/-----------------------------------------------------------------------------//
def handleTask(task, groupName, groupPath):
    """ Handles assigning tasks (cat behavior networks) to units"""
    print('executive.handleTask(%s,%s)' % (groupName, groupPath))
    print( 'executive.task is ' + task)
    print( 'Looking up task: ' + task)

    args = lookupTaskOrObjective(task, True, groupName)
    print( 'Arguments Dictionary: ', args)
    units = ndirin(groupPath)
    print( 'Units are ', units)
    defaultArgs = makeMaintainArgs(lookupUnit('%s/%s' % (groupPath, units[0])))
    for unit in units:
        log.write( 'Start: Associate ' + task + ' with ' + unit)
        unitRefPath = lookupUnit('%s/%s' % (groupPath, unit))
        log.write( 'AttachController(' + unitRefPath + ', ' + task + ', ' + str(args) + ')')
#        mArgs = merge(args, defaultArgs)
        print 'Executive.Task:cat.AttachController(%s,%s,%s)' % (unitRefPath, task, args)
        
        cat.AttachController(unitRefPath, task, args)
        print( 'End: Associated ' + task + ' with ' + unit)
#    log.close()
        
#/-----------------------------------------------------------------------------//

#/-----------------------------------------------------------------------------//
def getVal(name, type):
    if(not hasvar(name)):
        return False
    val = 0
    try:
        if type == 'int':
            val = gi(name)
        elif type == 'float':
            val = gf(name)
        elif type == 'string':
            val = gs(name)
        elif type == 'ref':
            val = gref(name)
        elif type == 'vector3':
            val = gv(name)
        elif type == 'quaternion':
            val = gq(name)
        #elif type == 'rotation':                                               #no such thing
            #val = grot(name)
        else:
            log.write( 'Unknown type of parameter, name: ' + name + ' type' + type)
            return 0
    except:
        log.write( "Type mismatch betweeen plan param types and task param types")

    #print 'val', val
    return val
#/-----------------------------------------------------------------------------//
def lookupUnit(path):
    try:
        #sel(path + '/vars')
        #print "What's in this unit: ", ndir()
        #sel('..')
        ent = call('%s.gs' % path, 'path')
        log.write( "Referencing unit: ", ent)
        #print( "Referencing unit: ", ent)
        return ent
    except:
        print 'lookupUnit: Cannot select: ' + path + '/vars'
#/-----------------------------------------------------------------------------//
def lookupTaskOrObjective(objTask, isTask, groupName):
    """ looks up a task or objective and returns a list of variable names and their values"""
    argslist = []
    if(isTask):
        path = '/comm/tasks/%s' % objTask
    else:
        path = '/comm/objectives/%s' % objTask
    params = None
    try:
        pushsel(path) 
        params = ndirin() 
        log.write( "Parameters: ", params) 
        for name in params:
            sel(name) 
            type = gs('type')
            log.write( "Lookup: Type: " + type + " Name: " + name)
            pushsel('/comm/plan/%s' % groupName)
            if(hasvar(name)):
                value = getVal(name, type) 
                nt = name, value
                print "Exec: Lookup: ", str(nt)
                argslist.append(nt)
            popsel()
            sel('..')
        popsel()
    except:
        printExcept('lookupTaskOrObjective')
        if params:
            log.write( 'lookupTaskObjective: Could not select ', params)
    return dict(argslist)    
#/-----------------------------------------------------------------------------//
def lookupObjective(objective):
    argslist = []
    objPath = '/comm/objectives/' + objective
    params = None
    try:
        pushsel(path)
        params = ndirin()
        log.write( "Parameters: ", params)
        for name in params:
            sel(name)
            type = gs('type')
            log.write( "Type: " + type + " Name: " + name)
            nt = name, type
            argslist.append(nt)
            sel('..')
        popsel()
    except:
        printExcept('lookupObjective')
        if params:
            log.write( 'lookupObjective: Could not select ', params)
    return dict(argslist)

#/-----------------------------------------------------------------------------//
def printVars():
    log.write( "Position: ", gv('pos'))
    log.write( "Rotation: ", gq('rot'))
    log.write( "Side    : ", gref('side'))
    log.write( "ORadius : ", gf('octradius'))
    log.write( "Destinat: ", gs('destination'))
