from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'ga'])
import nEventServer
from common import EventNames
import sys
#/-----------------------------------------------------------------------------//
class GARecorder:
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        print 'GARecorder.init'
        nEventServer.register( EventNames.GA_GENERATION_FINISHED, self.record )
        nEventServer.register( EventNames.CLOSING,                self.closing )
        self.gaToFilesMap = {}
    #/-----------------------------------------------------------------------------//
    def record(self, ga):
        #print 'record', ga
        try:
            if ga not in self.gaToFilesMap:
                self.gaToFilesMap[ga] = s = struct()
                s.gen = -1
                dirname = None
                import os
                for root, dirs, files in os.walk('ga/runs'):
                    #print 'existing', root, dirs, files
                    if root == 'ga/runs':
                        for i in range(1000):
                            dirname = '%s%03i' % (getname(ga), i)
                            if not dirname in dirs:
                                print 'should take new dir name', dirname
                                break
                        break
                assert dirname, 'Failed to find a new directory to save my gun info too'
                dirpath                     = 'ga/runs/' + dirname
                s.dirname                   = dirname
                s.dirpath                   = dirpath
                s.dir                       = os.mkdir(dirpath)
                #print 'logging ga %s to directory %s, %s' % (ga, dirname, dirpath)
                s.minFile                   = file('%s/%s' % (dirpath, 'min'), 'w')
                s.avgFile                   = file('%s/%s' % (dirpath, 'avg'), 'w')
                s.maxFile                   = file('%s/%s' % (dirpath, 'max'), 'w')
                s.fitFile                   = file('%s/%s' % (dirpath, 'fit'), 'w')

            #/-----------------------------------------------------------------------------//
            #now i need to calculate min max avg
            #print 'calculating'
            import random
            numberEvaluated = 0
            min = max = avg = -1
            for genome in ndirin(ga):
                #print 'genome', genome
                state = call('%s/%s.getstate' % (ga,genome) )
                if state != 'EVALUATED':
                    continue
                numberEvaluated += 1
                fit = call('%s/%s.getfitness' % (ga,genome) )
                #print 'fit', fit
                if numberEvaluated == 1 or fit < min:
                    min = fit
                if numberEvaluated == 1 or fit > max:
                    max = fit
                if numberEvaluated == 1:
                    avg = fit
                else:
                    avg = avg * ((numberEvaluated - 1.0) / float(numberEvaluated)) + fit / float(numberEvaluated)
            fit = call('/game/ga.gf', 'mostRecentFitness')
            if self.gaToFilesMap[ga].gen >= 0: #throw away the first gen -> (before anyone has been evaluated
                #print 'min', min
                #print 'max', max
                #print 'avg', avg
                self.gaToFilesMap[ga].minFile.write('%i %f\n' % ( self.gaToFilesMap[ga].gen, min ))
                self.gaToFilesMap[ga].avgFile.write('%i %f\n' % ( self.gaToFilesMap[ga].gen, avg ))
                self.gaToFilesMap[ga].maxFile.write('%i %f\n' % ( self.gaToFilesMap[ga].gen, max ))
                self.gaToFilesMap[ga].fitFile.write('%i %f\n' % ( self.gaToFilesMap[ga].gen, fit ))
                self.gaToFilesMap[ga].minFile.flush()
                self.gaToFilesMap[ga].avgFile.flush()
                self.gaToFilesMap[ga].maxFile.flush()
                self.gaToFilesMap[ga].fitFile.flush()
            self.gaToFilesMap[ga].gen += 1
            #print 'done recording'
        except:
            printExcept('GARecorder.record')
    #/-----------------------------------------------------------------------------//
    def closing(self, why):
        print 'GARecoder.closing'
        for s in self.gaToFilesMap.values():
            s.minFile.close()
            s.avgFile.close()
            s.maxFile.close()

        
gaRecorder = GARecorder()
