from npython import *
from common.defs import *
from nim import *
try:
    print 'Setting up BLUEIM'
    #/-----------------------------------------------------------------------------//
    defend                              = IMObjective('defend', path='defend', powerCoef=1.0, valueCoef=0.0, speedCoef=0.0, maxUnits=0)
    if defend.add():
        mul                             = IMOperator('mul', MUL, NORMAL, behavior='move')
        if mul.add():
            IMEnt('nearPowerfulEnemies', func=VALUE_OVER_THREAT, ipol=LINEAR,                  radius=AREA,             who=ENEMIES,                            radiusCoef=10.0)
            IMEnt('nearValuablefriends', func=POWER,             ipol=LINEAR,                  radius=AREA,             who=FRIENDS,                            radiusCoef=10.0)
            IMEnt('nearValuablefriends2', func=POWER,             ipol=LINEAR,                  radius=AREA,             who=FRIENDS,                            radiusCoef=10.0)
        mul.done()
        mul                             = IMOperator('mul2', MUL, NORMAL, behavior='move')
        if mul.add():
            IMEnt('nearPowerfulEnemies', func=VALUE_OVER_THREAT, ipol=LINEAR,                  radius=AREA,             who=ENEMIES,                            radiusCoef=10.0)
            IMEnt('nearValuablefriends', func=POWER,             ipol=LINEAR,                  radius=AREA,             who=FRIENDS,                            radiusCoef=10.0)
            IMEnt('nearValuablefriends2', func=POWER,             ipol=LINEAR,                  radius=AREA,             who=FRIENDS,                            radiusCoef=10.0)
        mul.done()
    defend.done()
    #/-----------------------------------------------------------------------------//
    riskyness                           = IMObjective('riskyness', path='riskyness', powerCoef = 1.0, valueCoef = 1.0, speedCoef = 1.0, maxUnits = 0)
    if riskyness.add():
        sum                             = IMOperator('sum', SUM, NORMAL, behavior='move')
        if sum.add():
            IMEnt('nearPowerfulEnemies',     func=POWER,               ipol=FLAT,                radius=WEAPON,           who=ENEMIES, coef =  -0.1, radiusCoef = 1.0)
        sum.done()
    riskyness.done()
    #/-----------------------------------------------------------------------------//
    #create a new root node im node, with name = collisionAvoidance, and nebula path=$IMDIR/collisionPath

    collisionAvoidance                  = IMObjective('collisionAvoidance', path='collisionAvoidance')
    if collisionAvoidance.add():                                                                                        #add future nodes as children of this node
        sum                             = IMOperator('sum', SUM, NORMAL)                               #create a summation node which will sum its child values, name=sum, type of operator = SUM (MUL, DIV, SUB), NORMAL is just a regular im, the alternative converts it to binary 0/1s, b
        if sum.add():                   #add children to sum
            #leaf im with negative values near enemies, func -> What variable of those to use
            #func determnies which variable to use
            #ipol=LINEAR -> highest values in the center, lower values near the perimeter (LINEAR, FLAT, INV_LINEAR)
            #radius=AREA -> big circle (WEAPON, AREA), change this to mincpa in the future, some kind of avoidanceness priority value
            #who=(ENEMIES, FRIENDS, NEUTRALS), which units are relavent should craete an ANY enum for this
            #coef=-1 -> we wnat negative values near powerful identified units
            #radiuscoef just scales are the radius
            IMEnt('nearPowerfulEnemies',     func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,           who=ENEMIES, coef =  -1.0, radiusCoef = 1.0)                                
            IMEnt('nearPowerfulFriends',     func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,           who=FRIENDS, coef =  -1.0, radiusCoef = 1.0)                                
            IMEnt('nearPowerfulNeutrals',    func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,           who=NEUTRALS, coef =  -1.0, radiusCoef = 1.0)                                
            IMTerrain('terrain')
        sum.done()
    collisionAvoidance.done()
    #/-----------------------------------------------------------------------------//
except:
    printExcept('BLUEIM')
