from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'im'])
import wx
from sp.recorder                           import recorder
from sp.groupmanager                       import groupManager
try:
    from imtree import IMTree
except:
    printExcept('Importing IMTree')

from nim import *
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class IMManager(wx.Panel):
    """should be responsible for loading the im's from xml, as well as possibly editnig / creating the im files
    now what do we need? well i want a list of ims and the ability to display them all"""
    #/-----------------------------------------------------------------------------//
    def __init__(self,parent,id):
#        print 'loading IMManager'
        wx.Panel.__init__(self,parent,id)
        sizer = wx.GridBagSizer(0,0)
        sizer.AddGrowableRow(0)
        sizer.AddGrowableCol(0)
        #self.imtree                     = IMTree(self,-1, size=(422,450))
        self.imtree                     = IMTree(self,-1)
        sizer.Add                       ( self.imtree, (0,0), flag=wx.EXPAND )
        self.SetSizer( sizer )
        self.imt = {}
        self.initIMS()
        popsel()
        self.Fit()
        call('/game/sides/blue.cf', 'objectivePointDistanceThreshold', 5000)    #so its objective IM dont put to many points in
#        print 'done loading IMManager'
    #/-----------------------------------------------------------------------------//
    def loadFromXML(self):
        log.write('IMManager.loadFromXML')
        return
        from common import FileManager
        filename = FileManager.find('xml', 'im')
        log.write('filename', filename)
        pushsel('/im')
        document = parseXML(filename)
        for ed in document.getElementsByTagName('IMTREE'): #foreach entity definition node
            self.processNode(ed)
        popsel()
        self.imtree.update()
    #/-----------------------------------------------------------------------------//
    def processNode(self,node):
        name = node.getAttribute('name')
        sn('nim', name)
        for childnode in node.childNodes:
            if childnode.nodeType == node.ELEMENT_NODE and childnode.nodeName == 'IM':
                self.processNode(childnode)
        sel('..')
    #/-----------------------------------------------------------------------------//
    def initIMS(self):
        """
        setup the starting ims
        for now just create set trees as children of red/blue
        """
        log.write('IMManager.initIMS')
        #/-----------------------------------------------------------------------------//
        pushsel('/game/sides/red')
        new                             ('nimmanager',   'manager')
        #new                             ('nallocatorga', 'allocatorga')
        new                             ('nallocatorastar', 'allocatorastar')
        ci                              ('popsize', 40)
        ci                              ('maxEvaluations', 60)
        if sn                           ('nallocator',   'allocator'):
            import redim
        popsel()

        pushsel('/game/sides/blue')
        new                             ('nimmanager',   'manager')
        #new                             ('nallocatorga', 'allocatorga')
        ci                              ('popsize', 40)
        ci                              ('maxEvaluations', 60)
        new                             ('nallocatorastar', 'allocatorastar')
        if sn                           ('nallocator',   'allocator'):
            import blueim
        popsel()
        self.imtree.update()
    #/-----------------------------------------------------------------------------//
    def assignIMToEnts(self, im, ents):
        print 'assignIMToEnts', im, ents
        groups = groupManager.findGroupsWithEnts(ents)
        print 'groups', groups
        for group in groups:
            self.assignIMToGroup(im=im, groupName=group)
    #/-----------------------------------------------------------------------------//
    def assignIMToGroup(self, im, groupName):
        """attach an im to a particular group"""
        print 'assigning IM %s to group %s' % (im, groupName)
        recorder.assignIMToGroup(im=im, groupName=groupName)
        #okay so what we want to do is just clone over a tree
        pushsel('/im/%s' % im)
        if hasvar('myGroup') and gref('myGroup') == 'none':
            cref('myGroup', '/comm/groups/%s' % groupName)
        else:
            print 'trying to assign already assigned im'
            #now we need to clone this tree or something
            #how do we do this, well we just find an available name
            for i in range(1000):
                path = '/im/%s%i' % (im,i)
                if not exists(path):
                    print 'cloning to path', path
                    call('/im/%s.clone' % im, path)
                    sel(path)
                    cref('myGroup', '/comm/groups/%s' % groupName)
                    break

        self.imtree.update()
        popsel()
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
    def assignIM(self, ent, im):
        print 'assignIM', ent, im
        print 'imt', self.imt[im]
        group = getname(call('%s.gref' % ent, 'group'))
        print 'group', group
        self.imt[im].assignTo(group)
#/-----------------------------------------------------------------------------//
from common import OptionManager
frame                                   = wx.Frame(None,-1, title='IMExplorer', pos=(1250,523), size=(422,464))
imManager                               = IMManager(frame,-1)
if OptionManager.getOption('imexplorer'):
    frame.Show()
import imga
