from npython import *
from common.defs import *
from nim import *
try:
    print 'Setting up REDIM'
    #/-----------------------------------------------------------------------------//
    attack                              = IMObjective('attack', path='attack', powerCoef=1.0, valueCoef=0.0, speedCoef=0.0, maxUnits=0)
    if attack.add():
        sum                            = IMOperator('sum', SUM, NORMAL, behavior='move')
        if sum.add():
            IMEnt('nearValuableEnemies', func=VALUE_OVER_THREAT, ipol=LINEAR,                  radius=AREA,             who=ENEMIES, coef=20.0)
            IMEnt('awayPowerfulEnemies', func=POWER,             ipol=LINEAR,                  radius=WEAPON,           who=ENEMIES, coef=-10.0)
        sum.done()
    attack.done()
    #/-----------------------------------------------------------------------------//
    distract                            = IMObjective('distract', path='distract', powerCoef=0.0, valueCoef=-1.0, speedCoef=1.0, maxUnits=0)
    if distract.add():
        mul                            = IMOperator('mul', MUL, NORMAL, behavior='move')
        if mul.add():
            sum                            = IMOperator('sum', SUM, NORMAL, behavior='move')
            if sum.add():
                IMEnt('awayPowerfulEnemies', func=POWER,             ipol=FLAT,                    radius=WEAPON,           who=ENEMIES, coef = -1.0, radiusCoef = 1.8)
                IMEnt('nearPowerfulEnemies', func=POWER,             ipol=INV_LINEAR,              radius=WEAPON,           who=ENEMIES, coef =  1.1, radiusCoef = 2.2)
            sum.done()
            mul2                            = IMOperator('mul', MUL, NORMAL, behavior='move')
            if mul2.add():
                #IMEnt('nearSelf',           func=POWER,             ipol=FLAT,                    radius=AREA,          who=MYSELF,   coef = 1.0, radiusCoef = 1.0)
                IMEnt('awayValuabletargets', func=VALUE_OVER_THREAT, ipol=INV_LINEAR,              radius=AREA,          who=ENEMIES,  coef = 1.0, radiusCoef = 10.0)
            mul2.done()
        mul.done()
    distract.done()
    #/-----------------------------------------------------------------------------//
    riskyness                           = IMObjective('riskyness', path='riskyness', powerCoef = 1.0, valueCoef = 1.0, speedCoef = 1.0, maxUnits = 0)
    if riskyness.add():
        sum                             = IMOperator('sum', SUM, NORMAL, behavior='move')
        if sum.add():
            IMEnt('nearPowerfulEnemies',     func=POWER,               ipol=LINEAR,                radius=WEAPON,           who=ENEMIES, coef =  -1.0, radiusCoef = 3.0)
        sum.done()
    riskyness.done()
    #/-----------------------------------------------------------------------------//

    #create a new root node im node, with name = collisionAvoidance, and nebula path=$IMDIR/collisionPath
    collisionAvoidance                  = IMObjective('collisionAvoidance', path='collisionAvoidance')
    if collisionAvoidance.add():                                                                                        #add future nodes as children of this node
        sum                             = IMOperator('sum', SUM, NORMAL)                               #create a summation node which will sum its child values, name=sum, type of operator = SUM (MUL, DIV, SUB), NORMAL is just a regular im, the alternative converts it to binary 0/1s, b
        if sum.add():                   #add children to sum
            #leaf im with negative values near enemies, func -> What variable of those to use
            #func determnies which variable to use
            #ipol=LINEAR -> highest values in the center, lower values near the perimeter (LINEAR, FLAT, INV_LINEAR)
            #radius=AREA -> big circle (WEAPON, AREA), change this to mincpa in the future, some kind of avoidanceness priority value
            #who=(ENEMIES, FRIENDS, NEUTRALS), which units are relavent should craete an ANY enum for this
            #coef=-1 -> we wnat negative values near powerful identified units
            #radiuscoef just scales are the radius
            IMEnt('nearPowerfulEnemies',     func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,           who=ENEMIES, coef =  -1.0, radiusCoef = 1.0)                                
            IMEnt('nearPowerfulFriends',     func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,           who=FRIENDS, coef =  -1.0, radiusCoef = 1.0)                                
            IMEnt('nearPowerfulNeutrals',    func=POWER, ipol=LINEAR,      radius=COLLISION_AVOIDANCE_RADIUS,          who=NEUTRALS, coef =  -1.0, radiusCoef = 1.0)                                
            IMTerrain('terrain')
        sum.done()
    collisionAvoidance.done()
    #/-----------------------------------------------------------------------------//
    #sneak                                = IMObjective('sneak', path='sneak', powerCoef = 1.0, valueCoef = 1.0, speedCoef = 1.0, maxUnits = 0)
    #if sneak.add():
        #mul                             = IMOperator('mul', MUL, NORMAL, behavior='move')
        #if mul.add():
            #IMEnt('nearValueableEnemies',     func=VALUE_OVER_THREAT, ipol=LINEAR,              radius=AREA,           who=ENEMIES, coef =  1.0, radiusCoef = 10.0)
            #IMEnt('awayPowerfulEnemies',      func=POWER,             ipol=INV_LINEAR,          radius=AREA,           who=ENEMIES, coef =  1.0, radiusCoef = 10.0)
            #IMEnt('nearSelf',                 func=POWER,             ipol=LINEAR,              radius=AREA,           who=FRIENDS, coef =  1.0, radiusCoef = 5.0)
            #IMVisibility('hiddenFromEnemies', who=ENEMIES)
        #mul.done()
    #sneak.done()
    #/-----------------------------------------------------------------------------//
except:
    printExcept('REDIM')


