from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sp'])
import nEventServer
from common                             import EventNames
import sys
import xml.dom.minidom
from common                             import FileManager

from entmanager                         import entManager
from groupmanager                       import groupManager
from recorder                           import recorder
from playermanager                      import playerManager
#/-----------------------------------------------------------------------------//
class SP:
    #/-----------------------------------------------------------------------------//
    def __init__(self):
        from im import im
        from common import tickmanager
        tickmanager.register( 'SP', self.tick )
        self.nodeWaitingToBePlaced      = None
        self.assignmentsDirty           = False
        self.openedSideManager          = False

        try:
            from playermanager import playerManager
            playerManager.createLocalPlayer()
        except:
            printExcept('initializing PlayerManager')

    #/-----------------------------------------------------------------------------//
    def tick(self, time, dtime):
        """our tick function (registered in __init__) - called every slice"""
        self.time = time
        if self.assignmentsDirty:
            self.assign()
            self.assignmentsDirty = False
        #if we dont have a side bring up the side manager
        currentSide = playerManager.findLocalSide()
        if self.openedSideManager == False and currentSide == '/game/sides/neutral':
            nEventServer.pull(EventNames.SPWRAPPER_SHOW, 'sideManager')
            #dont have a side yet 
            print 'currentSide', currentSide
            self.openedSideManager = True
    #/-----------------------------------------------------------------------------//
    def assign(self):
        """
        convert the stuff in groups into plan settings in /comm/plans
        todo this -> scan all the existing groups
        if they have an objective + the parameters they need then set them in /comm/plans

        idea -> lets rewrite it so instead of using structs it just straight reads, and it doesn't erase everything anymore
        """
        '''
        if begin('write'):
            pushsel                     ('/comm/plan')
            groups                      = ndirin('/comm/groups')

            dirtyGroups = []
            for group in groups:
                #print 'group', group
                sel('/comm/groups/%s' % group)
                #/-----------------------------------------------------------------------------//
                if not hasvar('objective'):
                    continue
                objective = gs('objective')
                #print 'objective', objective
                #/-----------------------------------------------------------------------------//
                needsPoint              = exists('/comm/tasks/%s/0_desiredX' % objective) and exists('/comm/tasks/%s/0_desiredY' % objective)
                if needsPoint and not hasvar('point'):
                    continue
                point = gv('point')
                point = map(int, point)
                #/-----------------------------------------------------------------------------//
                needsTarget             = exists('/comm/tasks/%s/target' %objective)
                if needsTarget:
                    if not hasvar('target') or gs('target') == '':
                        continue
                    target = gs('target')
                else:
                    target = ''
                #/-----------------------------------------------------------------------------//
                newGroup = False
                if not exists('/comm/plan/%s' % group):
                    sn('nent', '/comm/plan/%s' % group)
                    newGroup = True
                else:
                    sel('/comm/plan/%s' % group)
                    oldObjective = gs('objective')
                    
                    if hasvar('0_desiredX') and hasvar('0_desiredY'):
                        oldPoint = [gi('0_desiredX'), 0, gi('0_desiredY')]
                    else:
                        oldPoint = [0,0,0]
                        
                    if hasvar('target'):
                        oldTarget = gs('target')
                    else:
                        oldTarget = ''
                    #print 'old:', oldObjective, oldPoint, oldTarget

                if not newGroup and objective == oldObjective and point == oldPoint and target == oldTarget:
                    #print 'skipping group', group, 'nothing has changed'
                    continue #skip nothing changed
                else:
                    dirtyGroups.append(group)
                    cs('objective',     objective)
                    ci('0_desiredX',    int(point[0]))
                    ci('0_desiredY',    int(point[2]))
                    cs('target',        target)
                    
            popsel()
            end('write')

        if dirtyGroups and begin('executive'):
            from common import EventNames
            nEventServer.pullLater(EventNames.PLAN_READY,' '.join(dirtyGroups))
            end('planready')
        '''
        """
        convert the stuff in groups into plan settings in /comm/plans
        todo this -> scan all the existing groups
        if they have an objective + the parameters they need then set them in /comm/plans
        """
        if begin('sp.assign'):
            if begin('sp.parsegroups'):
                log.open                        ('sp.assign')
                self.groups = struct()
                self.groups.fromEVA('/comm/groups', True)
                #print 'read groups', self.groups
                ndel                            ('/comm/plan')
                new                             ('nthing', '/comm/plan')
            end('sp.parsegroups')

            if begin('sp.writegroups'):
                pushsel                         ('/comm/plan')
                for groupname, group in self.groups.iteritems():
                    log.write(groupname, group)
                    try:
                        if 'objective' not in group.__dict__:
                            log.write('group %s does not have an objective assigned - skipping' % groupname)
                            continue
                        log.write('objective', group.objective)
                        needsPoint              = exists('/comm/tasks/%s/0_desiredX' % group.objective) and exists('/comm/tasks/%s/0_desiredY' % group.objective)

                        hasPoint                = 'point' in group.__dict__
                        if needsPoint and not hasPoint:                                
                            log.write('skipping %s,%s - missing point variable' % (groupname, group.objective))
                            continue

                        needsTarget             = exists('/comm/tasks/%s/target' %group.objective)
                        if group.objective == 'move': 
                            needsTarget = False                                                       #crap hack 
                        hasTarget               = 'target' in group.__dict__ and group.target != ''
                        if needsTarget and not hasTarget:                               
                            log.write('skipping %s,%s - missing target variable' % (groupname, group.objective))
                            continue

                        log.write       ('saving plan for group', groupname)
                        sn                      ('nent', groupname)
                        cs                      ('objective', group.objective)
                        log.write               ('0_desiredX', group.point[0])
                        ci                      ('0_desiredX', int(group.point[0]))
                        log.write               ('0_desiredY', group.point[2])
                        ci                      ('0_desiredY', int(group.point[2]))
                        if 'target' in group.__dict__ and group.target:
                            cs                  ('target', group.target)
                            log.write           ('target', group.target)
                        sel('..')
                    except:
                        printExcept('assign')
                log.close()
                popsel()
            end('sp.writegroups')

            if begin('planready'):
                from common import EventNames
                nEventServer.pull(EventNames.PLAN_READY,'hsp')
            end('planready')
        end('sp.assign')
    #/-----------------------------------------------------------------------------//
    vectorRE = re.compile(r'(\(.+\))(.*)')
    #/-----------------------------------------------------------------------------//
    def commandGroup(self, groupName, point, targets):
        #log.write( 'sp.commandGroup', groupName, point, targets)
        #make it check to see if i can legally control these ents
        if playerManager.canControlGroup(groupName):
            #just write it too /comm/groups???
            pushsel('/comm/groups/%s' % groupName)
            cv('point', point[0], point[1], point[2])
            if targets:
                cs('targets', ' '.join(targets))
                cs('target', targets[0])
            popsel()
            self.assignmentsDirty = True
            recorder.commandGroup(groupName=groupName, point=point, targets=targets)
    #/-----------------------------------------------------------------------------//
    def commandEnts( self, ents, point, targets):
        #log.write('sp.command', ents, point, targets)
        for group in groupManager.findGroupsWithEnts(ents):
            self.commandGroup(group, point, targets)
        self.assignmentsDirty = True
    #/-----------------------------------------------------------------------------//
    def assignObjectiveToGroup(self, objectiveName, groupName):
        """assign an objective to a group - update its group settings and export the data to exec"""
        #log.write                       ('assignObjectiveToGroup',objectiveName, groupName)
        call                            ('/comm/groups/%s.cs' % groupName, 'objective', objectiveName)
        #self.assign()
        self.assignmentsDirty = True
        recorder.assignObjectiveToGroup(objectiveName=objectiveName, groupName=groupName)
    #/-----------------------------------------------------------------------------//
    def assignObjectiveToEnts( self, objectiveName, ents):
        #log.write('sp.assignObjectiveToEnts', objectiveName, ents)
        #print('sp.assignObjectiveToEnts', objectiveName, ents)
        for group in groupManager.findGroupsWithEnts(ents):
            self.assignObjectiveToGroup(objectiveName, group)
        self.assignmentsDirty = True
    #/-----------------------------------------------------------------------------//
    def quickCommandGroup(self, group, objective, point, targets):
        """directly set destination vars on the entities -> skip the rest of sp/cat"""
        #sp.quickCommandGroup(group, objective, point, targets)
        #print 'quickCommandGroup', self, group, objective, point, targets
        for entProxy in ndirin('/comm/groups/%s' % group):
            path = call('/comm/groups/%s/%s.gs' % (group,entProxy), 'path')
            #print 'path', path
            call('%s.sv' % path, 'destination', point[0], point[1], point[2])
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
sp = SP()
import replayer
