import wx
from sp                                 import SPPanel
from createentpanel                     import CreateEntPanel
from creategrouppanel                   import CreateGroupPanel
from clonegrouppanel                    import CloneGroupPanel
from createobjectivepanel               import CreateObjectivePanel
from saveplanpanel                      import SavePlanPanel
from loadplanpanel                      import LoadPlanPanel
class SPWrapper(wx.Panel):
    def __init__(self, parent, id, size):
        wx.Panel.__init__(self, parent, id, size=size)
        spPanel                         = SPPanel(self, -1, size=size)
        createEntPanel                  = CreateEntPanel                        (self, -1, spPanel)
        createGroupPanel                = CreateGroupPanel                      (self, -1, spPanel)
        cloneGroupPanel                 = CloneGroupPanel                       (self, -1, spPanel)
        createObjectivePanel            = CreateObjectivePanel                  (self, -1, spPanel)
        savePlanPanel                   = SavePlanPanel                         (self, -1, spPanel)
        loadPlanPanel                   = LoadPlanPanel                         (self, -1, spPanel)
        box                             = wx.BoxSizer(wx.HORIZONTAL)
        box.Add                         (spPanel,                               flag=wx.EXPAND)
        box.Add                         (createEntPanel,                        flag=wx.EXPAND)
        box.Add                         (createGroupPanel,                      flag=wx.EXPAND)
        box.Add                         (cloneGroupPanel,                       flag=wx.EXPAND)
        box.Add                         (createObjectivePanel,                  flag=wx.EXPAND)
        box.Add                         (savePlanPanel,                         flag=wx.EXPAND)
        box.Add                         (loadPlanPanel,                         flag=wx.EXPAND)
        self.SetSizer(box)

        self.panels                     = {}
        self.panels['sp']               = spPanel
        self.panels['createEnt']        = createEntPanel
        self.panels['createGroup']      = createGroupPanel
        self.panels['cloneGroup']       = cloneGroupPanel
        self.panels['createObjective']  = createObjectivePanel
        self.panels['savePlan']         = savePlanPanel
        self.panels['loadPlan']         = loadPlanPanel
        self.sizer                      = box
        self.show('sp')
    def show(self, name):
        found = False
        for panelName, panel in self.panels.iteritems():
            if panelName != name:
                panel.Hide()
            else:
                panel.Show()
                found = True
        assert found == True, "SPWrapper --  no panel %s to show" % name
        self.sizer.Layout()
    def showEvent(self, event):
        name = event.GetEventObject().GetName()
        self.show(name)
