from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sp'])
from common import EventNames
import wx
import nEventServer
#/-----------------------------------------------------------------------------//
class CreateObjectivePanel(wx.Panel):
    """Panel for creating an objective"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, spPanel, size=wx.DefaultSize):
        """create all my stuff, align it with a grid bag sizer"""
        self.spPanel                    = spPanel
        wx.Panel.__init__              (self, parent, id, size=size)
        self.createWidgets              ()
        gbs                             = wx.GridBagSizer                       (3,3)
        self.sizeWidgets                (gbs)
        self.SetSizer                   (gbs)
        self.Bind                       (wx.EVT_BUTTON, self.create, self.createButton)
        self.Bind                       (wx.EVT_BUTTON, self.cancel, self.cancelButton)
    #/-----------------------------------------------------------------------------//
    def createWidgets(self):
        self.nameText                   = wx.StaticText                         (self, -1, 'Objective name:')
        self.nameCtrl                   = wx.TextCtrl                           (self, -1, 'WARNING, shouldnt see this')
        self.createButton               = wx.Button                             (self, -1, 'Create')
        self.cancelButton               = wx.Button                             (self, -1, 'Cancel')
    #/-----------------------------------------------------------------------------//
    def sizeWidgets(self, gbs, x=0, y=1):
        gbs.Add                         (self.nameText,                         (0,0))
        gbs.Add                         (self.nameCtrl,                         (0,1))
        gbs.Add                         (self.createButton,                     (0,2))
        gbs.Add                         (self.cancelButton,                     (1,2))
    #/-----------------------------------------------------------------------------//
    def create(self, event):
        """button function - create the objective
        """
        name                            = str(self.nameCtrl.GetLineText(0))
        log.open('CreateObjectivePanel.create', name)
        import sp
        sp.createObjective(name)
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def cancel(self, event):
        """button function - dont create anything just close myself"""
        log.write('CreateObjectivePanel.cancel')
        self.GetParent().show('sp')
    #/-----------------------------------------------------------------------------//
    def findAvailableObjectiveName(self):
        """search for the next available name"""
        for i in range(1,100):
            name = 'objective%i' % i 
            if name not in self.spPanel.objectives:
                break
        return name
    #/-----------------------------------------------------------------------------//
    def Show(self):
        self.nameCtrl.SetValue(self.findAvailableObjectiveName())
        wx.Panel.Show(self)
