import sys
import wx
from npython import *
from common.defs import *
class EntityTypeList(wx.ListCtrl):
    """listbox containing all selectable entity types"""
    def __init__(self, parent, id, size=(300,130)):
        """figure out which entities are available by looking in lib/ents/"""
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.LC_NO_HEADER, size=size) #LC_EDIT_LABELS
        self.InsertColumn(0, 'Entity Types')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, size[0]-20)
        self.SetColumnWidth(1, 0)
        #figure out what the entity types are
        pushsel('/lib/ents')
        self.entityTypes = {}
        for typeName in ndir():
            if getselectable(typeName):                                              #if its not selectable (weapons/turrets) dont put it on the list
                #self.entityTypes.append(type)
                entityType = self.entityTypes[typeName] = struct()
                entityType.name = typeName
                entityType.index = self.InsertStringItem(sys.maxint, typeName)
        popsel()
        #wx.ListBox.__init__(self, parent, id, size=size, choices=self.entityTypes)
    def GetSelection(self):
        #return self.entityTypes[wx.ListBox.GetSelection(self)]
        index = self.GetFirstSelected(self)
        for entityType in self.entityTypes.values():
            if entityType.index == index:
                print 'selectedType', entityType.name
                return entityType.name
        return None
