import sys
import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
#/-----------------------------------------------------------------------------//
class IndividualList(wx.ListCtrl):
    """nice little listbox showing all the individuals belonging to the currently selected group, this should be fairly straightforward"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the groups from /comm/groups and initialize myself"""
        #self.groups = None
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.LC_NO_HEADER, size=size) #LC_EDIT_LABELS
        nEventServer.register(EventNames.GROUPS_CHANGED, self.update)
        nEventServer.register(EventNames.SELECTION_CHANGED, self.selectionChanged)
        #nEventServer.register(EventNames.SELECTION_CHANGED_BOX, self.selectionChanged)
        self.Bind(wx.EVT_LEFT_DCLICK, self.onDClick)
        self.InsertColumn(0, 'Individuals')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, size[0]-20)
        self.SetColumnWidth(1, 0)
        self.groupSelected = None
    #/-----------------------------------------------------------------------------//
    def GetSelection(self):
        index = self.GetFirstSelected(self)
        for ent in ndirin( self.groupSelected):
            if not hasvar('%s/%s' % (self.groupSelected, ent), 'index'): continue
            entindex = call('%s/%s.gi' % (self.groupSelected, ent), 'index')
            if entindex == index:
                return call('%s/%s.gs' % (self.groupSelected, ent), 'path')
        return None
    #/-----------------------------------------------------------------------------//
    def selectGroup(self, groupname):
        self.groupSelected = groupname
        self.update()
    #/-----------------------------------------------------------------------------//
    def update(self, event=None):
        index = self.InsertStringItem(sys.maxint, 'hello')
        self.SetStringItem(index, 0, 'hello')
        self.DeleteAllItems()
        if not self.groupSelected:
            return
        entsSelected = call('/ui/planner.getobjectsselected')
        if entsSelected:
            entsSelected = entsSelected.split(' ')
        for individual in ndirin(self.groupSelected):
            path = call('%s/%s.gs' % (self.groupSelected, individual), 'path')
            index = self.InsertStringItem(sys.maxint, individual)
            call('%s/%s.ci' % (self.groupSelected, individual), 'index', index)
            self.SetStringItem(index, 0, individual)
            if entsSelected and path in entsSelected:
                self.Select(index)
    #/-----------------------------------------------------------------------------//
    def selectionChanged(self,msg):
        ents = call('/ui/planner.getobjectsselected')
        if ents:
            ents = ents.split(' ')
            for ent in ents:
                print 'ent', ent
                group = call('%s.gref' % ent, 'group')
                self.selectGroup(group)
                return
    #/-----------------------------------------------------------------------------//
    def onDClick(self,event):
        try:
            selection = self.GetSelection()
            if selection:
                panToEnts([selection])
        except:
            printExcept('individuallist.onDClick')
