import wx
from createentdialog import CreateEntDialog
from creategroupdialog import CreateGroupDialog
from clonegroupdialog import CloneGroupDialog
from common.log import Log
log = Log(tags=['all', 'sp'])
class InfoPanel(wx.Panel):
    """panel the buttons for controlling/authoring the scenario"""
    def __init__(self, parent, id, spPanel):
        self.spPanel = spPanel
        wx.Panel.__init__               (self, parent, id)
        #text                            = wx.StaticText(self, -1, 'HSP Commands', size=(100,20), style=wx.ALIGN_CENTER)
        gbs                             = wx.GridBagSizer(5,15)
        buttonSize                      = 100, wx.DefaultSize[0]
        createEntButton                 = wx.Button(self, -1, 'Create Ent',   size=buttonSize)
        createGroupButton               = wx.Button(self, -1, 'Create Group', size=buttonSize)
        cloneGroupButton                = wx.Button(self, -1, 'Clone Group',  size=buttonSize)
        self.Bind                       (wx.EVT_BUTTON, self.createEnt,   createEntButton)
        self.Bind                       (wx.EVT_BUTTON, self.createGroup, createGroupButton)
        self.Bind                       (wx.EVT_BUTTON, self.cloneGroup,  cloneGroupButton)
        gbs.Add                         (createEntButton,                       (0,0))
        gbs.Add                         (createGroupButton,                     (1,0))
        gbs.Add                         (cloneGroupButton,                      (2,0))
        self.SetSizer                   (gbs)
        self.SetAutoLayout              (True)

        #initialize my dialogs - instead of creating / destroying them hide/show them (remembers settings + less fuss)
        self.createEntDialog            = CreateEntDialog  (None, -1, spPanel)    
        self.createGroupDialog          = CreateGroupDialog(None, -1, spPanel) 
        self.cloneGroupDialog           = CloneGroupDialog (None, -1, spPanel)
    #/-----------------------------------------------------------------------------//
    def createEnt(self, event):
        """Create a new Entity,
        open a dialog asking for entity type / group to add too
        """
        log.write('createEnt', self, event.__dict__)
        self.createEntDialog.Show()
    #/-----------------------------------------------------------------------------//
    def createGroup(self, event):
        """open createGroup dialog"""
        log.write('createEnt', self, event.__dict__)
        self.createGroupDialog.Show()
    #/-----------------------------------------------------------------------------//
    def cloneGroup(self, event):
        """open cloneGroup dialog"""
        log.write('cloneGroup')
        self.cloneGroupDialog.Show()

