import wx
import nEventServer
from npython import *
from common import EventNames
from common import tickmanager
#/-----------------------------------------------------------------------------//
class EntInfoPanel(wx.Panel):
    """displays a few ctrls with info on an entity"""
    #/-----------------------------------------------------------------------------//
    tickFreq = 0.5 #seconds
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, colour = None):
        wx.Panel.__init__(self, parent, id)
        if not colour:
            colour = parent.GetBackgroundColour()
        else:
            print 'colour', colour
        self.nameCtrl                   = wx.TextCtrl(self, -1 ,size=(80,20))
        self.typeCtrl                   = wx.TextCtrl(self, -1, size=(80,20))
        self.hpCtrl                     = wx.TextCtrl(self, -1, size=(80,20))
        self.labelCtrl                  = wx.TextCtrl(self, -1, size=(80,20))
        gbs                             = wx.GridBagSizer(1,1)
        gbs.Add                         (self.nameCtrl,         (0,0))
        gbs.Add                         (self.typeCtrl,         (1,0))
        gbs.Add                         (self.hpCtrl,           (2,0))
        gbs.Add                         (self.labelCtrl,        (3,0))
        self.SetSizer                   (gbs)
        tickmanager.register            ('EntInfoPanel', self.tick)
        self.path                       = None
        self.lastTicked                 = -1.0
   #/-----------------------------------------------------------------------------// 
    def setEnt(self, path):
        self.path = path
   #/-----------------------------------------------------------------------------// 
    def tick(self, time, dtime):
        if self.lastTicked < 0 or time - self.lastTicked > self.tickFreq:
            self.lastTicked = time
            if self.path:
                if not exists(self.path):
                    print 'EntInfoPanel detaching from non-existant entity', self.path
                    self.path = None
                    return self.tick(time,dtime)
                name = call('%s.getname' % self.path)
                type = call('%s.gs'      % self.path, 'type')
                hp = str(call('%s.gf'        % self.path, 'hp'))
                if exists('%s/vars/label' % self.path):
                    label = str(call('%s.gs'        % self.path, 'label'))
                else:
                    label = ''
            else:
                name = type = hp = label = ''
            if self.nameCtrl. GetLineText(0) != name:                           self.nameCtrl.SetValue(name)
            if self.typeCtrl. GetLineText(0) != type:                           self.typeCtrl.SetValue(type)
            if self.hpCtrl.   GetLineText(0) != hp:                             self.hpCtrl.SetValue(hp)
            if self.labelCtrl.GetLineText(0) != label:                          self.labelCtrl.SetValue(label)
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class MouseInfoPanel(wx.Panel):
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id):
        wx.Panel.__init__               (self, parent, id)
        self.SetBackgroundColour( parent.GetBackgroundColour() )
        gbs                             = wx.GridBagSizer(1,1)
        self.selectedPanel              = EntInfoPanel(self, -1, colour=wx.Colour(50,250,130))
        self.overPanel                  = EntInfoPanel(self, -1, colour=wx.Colour(230,230,100))

        gbs.Add( wx.StaticText(self,-1, 'Over'), (0,0))
        gbs.Add(self.overPanel,         (1,0))
        gbs.Add( wx.StaticText(self,-1, 'Selected'), (0,1))
        gbs.Add(self.selectedPanel,     (1,1))
        self.SetSizer(gbs)

        nEventServer.register(EventNames.MOUSEOVER_CHANGED, self.mouseOverChanged)
        nEventServer.register(EventNames.SELECTION_CHANGED, self.selectionChanged)
    #/-----------------------------------------------------------------------------//
    def mouseOverChanged(self, str):
        if not str: str = ''
        self.overPanel.setEnt(str)
   #/-----------------------------------------------------------------------------// 
    def selectionChanged(self, str):
        if not str: str = ''
        self.selectedPanel.setEnt(str)
    #/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
