import sys
import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------//
class SelectedEntList(wx.ListCtrl):
    """nice little listbox showing all the currently selected ents"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the groups from /comm/groups and initialize myself"""
        self.ents = None
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.LC_NO_HEADER, size=size) #LC_EDIT_LABELS
        #nEventServer.register(EventNames.SELECTION_CHANGED_BOX, self.update)
        self.InsertColumn(0, 'Ents')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, size[0]-20)
        self.SetColumnWidth(1, 0)
        self.ents = {}
        self.update()
    #/-----------------------------------------------------------------------------//
    def GetSelection(self):
        index = self.GetFirstSelected()
        paths = []
        while index != -1:
            for ent in self.ents.itervalues():
                if ent.index == index and ent.path:
                    paths.append(ent.path)
            index = self.GetNextSelected(index)
        return paths
    #/-----------------------------------------------------------------------------//
    def update(self, newGroup=None):
        """update the items in my list"""
        self.DeleteAllItems()
        newents = call('/ui/planner.getobjectsselected')
        newents = newents.strip().split(' ')
        #for ent in self.ents.itervalues():
            #if ent.path not in newents:
                #self.DeleteItem(ent.index)
                #del self.ents[ent.name]

        self.ents = {}
        for entpath in newents:
            #if entpath not in self.ents:
            ent                         = self.ents[entpath]                    = struct(name=call('%s.getname'%entpath), path=entpath)
            ent.index                   = self.InsertStringItem(sys.maxint, ent.name)
            self.Select                 (ent.index)
    #/-----------------------------------------------------------------------------//
