
from npython import *
from common.defs import *
from common.log import Log
log = Log(tags=['all', 'sp'])
from common import EventNames
import wx
import sys
import xml.dom.minidom
import nEventServer
from grouplist                          import GroupList
from individuallist                     import IndividualList
from objectivelist                      import ObjectiveList
from tasklist                           import TaskList
from common.mouseinfopanel              import MouseInfoPanel
import minimap
from common                             import FileManager

from sp.groupmanager                    import groupManager
from sp.sp                              import sp
#/-----------------------------------------------------------------------------//
spPanel = None
#/-----------------------------------------------------------------------------//
class IndividualGroupButtons(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)
        self.assignEntButton            = wx.BitmapButton(self, -1, loadBMP('rightBrackets'),                           size=(30,30))
        self.assignEntButton.SetToolTipString('Add Entities too a Group')
        self.unassignEntButton          = wx.BitmapButton(self, -1, loadBMP('leftBrackets'),                            size=(30,30))
        self.unassignEntButton.SetToolTipString('Remove Entities From a Group')

        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add( self.assignEntButton)
        sizer.Add( self.unassignEntButton)
        self.SetSizer(sizer)
#/-----------------------------------------------------------------------------//
class ObjectiveGroupButtons(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)
        self.assignObjectiveButton      = wx.BitmapButton(self, -1, loadBMP('leftBrackets'),                            size=(30,30))
        gbs                             = wx.GridBagSizer(3,3)
        gbs.Add                         (self.assignObjectiveButton, (1,0))
        self.SetSizer                   (gbs)
#/-----------------------------------------------------------------------------//
class ObjectiveTaskButtons(wx.Panel):
    def __init__(self, parent, id):
        wx.Panel.__init__(self, parent, id)
        self.removeTaskButton           = wx.BitmapButton(self, -1, loadBMP('rightBrackets'),                           size=(30,30))
        self.removeTaskButton.          SetToolTipString('Remove a task from an Objective')
        self.createObjectiveButton      = wx.BitmapButton(self, -1, loadBMP('new'),                                     name='createObjective',                 size=(30,30))
        self.createObjectiveButton.     SetToolTipString('Create a new Objective')

        gbs = wx.GridBagSizer(3,3)
        self.removeTaskButton.Hide()
        self.createObjectiveButton.Hide()
        self.SetSizer(gbs)
#/-----------------------------------------------------------------------------//
class VectorCtrl(wx.Panel):
    def __init__(self,parent,id):
        wx.Panel.__init__(self, parent, id)
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(sizer)
        self.xCtrl              = wx.TextCtrl                           (self, -1, size=(80,20), style=wx.ALIGN_RIGHT)
        self.yCtrl              = wx.TextCtrl                           (self, -1, size=(60,20), style=wx.ALIGN_RIGHT)
        self.zCtrl              = wx.TextCtrl                           (self, -1, size=(80,20), style=wx.ALIGN_RIGHT)
        sizer.Add(self.xCtrl)
        #sizer.Add(self.yCtrl)
        self.yCtrl.Hide()
        sizer.Add(self.zCtrl)
    #/-----------------------------------------------------------------------------//
    def set(self, vec):
        assert len(vec) == 3, 'vector panel.set must be called with a 3 tuple/list type is:%s len:%i' % (type(vec), len(vec))
        self.xCtrl.SetValue(str(vec[0]))
        self.yCtrl.SetValue(str(vec[1]))
        self.zCtrl.SetValue(str(vec[2]))
    #/-----------------------------------------------------------------------------//
    def get(self):
        return self.xCtrl.GetLineText(0), self.yCtrl.GetLineText(0), self.zCtrl.GetLineText(0)
    #/-----------------------------------------------------------------------------//
    def clear(self):
        self.xCtrl.SetValue('')
        self.yCtrl.SetValue('')
        self.zCtrl.SetValue('')
#/-----------------------------------------------------------------------------//
class SPPanel(wx.Panel):
    """ 
    sp panel contains all the information for controlling the sp
    so from left to right we want
    mouse info panel
    list of individuals
    individuals->groups
    list of groups
    groups<->objectives
    list of objectives
    objectives parameters
    list of tasks in objective
    task parameters
    list of available tasks
    
    we also need gneric buttons for newent, newgroup, new objective

    okay so now we need it to be able to switch into another panel so that we can show it
    okay so we have most of the basic elements, but we still have lots of quetsions about how to assign / unassign units
    well what do we need to do now..
    we need to start fleshing out the objective interface

    okay so when you select an objective from the list->
    call a function, which then needs to show objective parameters + fill the objective task list

    add a button to create objective
    then setup the add task to objective stuff

    okay now..assign colours to each objective
    """
    tree = None
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size):
        """constuctor - open the window / initialize things / register our tick function"""
        global spPanel
        spPanel = self

        #nEventServer.register(EventNames.SELECTION_CHANGED,                     self.selIndividual)
        from common import tickmanager
        tickmanager.register( 'SPPanel', self.tick )

        from common import WindowManager 
        windowName                      = 'SP'
        WindowManager.register          (windowName, self)
        position,size                   = WindowManager.get(windowName)

        wx.Panel.__init__(self, parent, id)
        self.SetBackgroundColour(wx.Colour(194,231,186))

        highSizer                       = wx.BoxSizer(wx.VERTICAL)
        self.SetSizer                   (highSizer)
        #highSizer.Add                   (wx.Panel(self, -1, size=(2,2)))

        sizer                           = wx.BoxSizer(wx.HORIZONTAL)
        highSizer.Add                   (sizer)
        #sizer.Add                       (wx.Panel(self, -1, size=(2,2)))

        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        self.saveButton                 = wx.BitmapButton(self, -1, loadBMP('save'),                         name='savePlan',                       size=(25,25))
        self.saveButton.                SetToolTipString('Save the Current Plan to File')
        self.loadButton                 = wx.BitmapButton(self, -1, loadBMP('open'),                         name='loadPlan',                       size=(25,25))
        self.loadButton.                SetToolTipString('Save the Current Plan to File')
        from common.backgroundcolourselectbutton import BackgroundColourSelectButton
        self.colourSelect               = BackgroundColourSelectButton(self)
        vsizer.Add                      (self.saveButton)
        vsizer.Add                      (self.loadButton)
        vsizer.Add                      (self.colourSelect)
        sizer.Add                       (vsizer)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))

        #mouse info panel
        vsizer                          = wx.BoxSizer(wx.VERTICAL)
        sizer.Add                       (vsizer, wx.EXPAND)
        self.mouseInfoPanel             = MouseInfoPanel(self, -1)                                                      #mouse info panel
        vsizer.Add                      (self.mouseInfoPanel)
        #vsizer.Add                      (wx.Panel(self, -1, size=(20,10)))
        self.saveLoadPanel              = wx.Panel(self, -1)
        self.saveLoadPanel.sizer        = wx.BoxSizer(wx.VERTICAL)
        self.saveLoadPanel.SetSizer     (self.saveLoadPanel.sizer)
        self.saveLoadPanel.textCtrl     = wx.TextCtrl(self.saveLoadPanel, -1)
        self.saveLoadPanel.textCtrl2    = wx.TextCtrl(self.saveLoadPanel, -1)
        self.saveLoadPanel.sizer.Add    (self.saveLoadPanel.textCtrl, flag=wx.EXPAND)
        self.saveLoadPanel.sizer.Add    (self.saveLoadPanel.textCtrl2, flag=wx.EXPAND)
        self.saveLoadPanel.SetBackgroundColour(wx.BLACK)
        vsizer.Add                      (self.saveLoadPanel, flag=wx.EXPAND)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))

        self.pointCtrl                  = VectorCtrl(self, -1)
        block2Sizer                     = wx.BoxSizer(wx.VERTICAL)
        sizer.Add                       (block2Sizer)
        paramsSizer                     = wx.BoxSizer(wx.VERTICAL)
        commandButtons                  = wx.BoxSizer(wx.HORIZONTAL)
        block2Sizer.Add                 (paramsSizer,                           wx.EXPAND)
        #block2Sizer.Add                 (wx.Panel(self,-1,                      size=(10,10)))
        block2Sizer.Add                 (commandButtons,                        wx.EXPAND)

        txt                             = wx.StaticText(self,-1, 'Assignment Info')
        paramsSizer                     .Add( txt )
        tempSizer                       = wx.BoxSizer(wx.HORIZONTAL)
        paramsSizer.Add                 (tempSizer,                             wx.EXPAND)
        tempSizer.Add                   (wx.StaticText(self, -1, ' Group',       size=(80,20)))
        self.groupNameCtrl              = wx.TextCtrl(self, -1,                 size=(160,20), style=wx.ALIGN_RIGHT)
        tempSizer.Add                   (self.groupNameCtrl,                    wx.EXPAND)
        tempSizer                       = wx.BoxSizer(wx.HORIZONTAL)
        paramsSizer.Add                 (tempSizer,                             wx.EXPAND)
        tempSizer.Add                   (wx.StaticText(self, -1, ' Objective',   size=(80,20)))
        self.objectiveCtrl              = wx.TextCtrl(self, -1,                 size=(160,20), style=wx.ALIGN_RIGHT)
        tempSizer.Add                   (self.objectiveCtrl,                    wx.EXPAND)
        tempSizer                       = wx.BoxSizer(wx.HORIZONTAL)
        paramsSizer.Add                 (tempSizer,                             wx.EXPAND)
        tempSizer.Add                   (wx.StaticText(self, -1, ' Point',       size=(80,20)))
        tempSizer.Add                   (self.pointCtrl,                        wx.EXPAND)
        tempSizer                       = wx.BoxSizer(wx.HORIZONTAL)
        paramsSizer.Add                 (tempSizer,                             wx.EXPAND)
        tempSizer.Add                   (wx.StaticText(self, -1, ' Target',      size=(80,20)))
        self.targetCtrl                 = wx.TextCtrl(self, -1,                 size=(160,20), style=wx.ALIGN_RIGHT)
        tempSizer.Add                   (self.targetCtrl,                       wx.EXPAND)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))

        #groups
        groupsSizer                     = wx.BoxSizer(wx.VERTICAL)
        buttonSizer                     = wx.BoxSizer(wx.HORIZONTAL)
        st                              = wx.StaticText  (self, -1, 'Groups')
        #self.createGroupButton          = wx.BitmapButton(self, -1, loadBMP('new'),                                     name='createGroup',                     size=(25,25))
        #self.cloneGroupButton           = wx.BitmapButton(self, -1, loadBMP('clone'),                                   name='cloneGroup',                      size=(25,25))
        #self.destroyGroupButton         = wx.BitmapButton(self, -1, loadBMP('destroy'),                                 name='cloneGroup',                      size=(25,25))
        #self.createGroupButton.         SetToolTipString('Create a New Group')
        #self.cloneGroupButton.          SetToolTipString('Duplicate an Existing Group')
        #self.destroyGroupButton.        SetToolTipString('Destroy a Group')
        buttonSizer.Add                 (st, 0, flag=wx.EXPAND)
        #buttonSizer.Add                 (wx.Panel(self,-1,size=(5,25)))
        #buttonSizer.Add                 (self.createGroupButton)
        #buttonSizer.Add                 (self.cloneGroupButton)
        #buttonSizer.Add                 (self.destroyGroupButton)
        groupsSizer.Add                 (buttonSizer)
        self.groupList                  = GroupList(self, -1, size=(174,150))                                                           #list of groups
        self.Bind                       (wx.EVT_LIST_ITEM_SELECTED, self.groupListSelChanged,                           self.groupList)
        groupsSizer.Add                 (self.groupList, flag=wx.EXPAND)
        sizer.Add                       (groupsSizer)

        #group-individual buttons
        #self.individualGroupButtons     = IndividualGroupButtons(self,-1)                                               #individual<->group button
        #sizer.Add                       (self.individualGroupButtons,                                 flag=wx.EXPAND)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))

        individualsSizer                = wx.BoxSizer(wx.VERTICAL)
        buttonSizer                     = wx.BoxSizer(wx.HORIZONTAL)
        st                              = wx.StaticText  (self, -1, 'Individuals')
        #self.createEntButton            = wx.BitmapButton(self, -1, loadBMP('new'),                         name='createEnt',                       size=(25,25))
        #self.createEntButton.           SetToolTipString('Create a New Entity')
        buttonSizer.Add                 (st)
        #buttonSizer.Add                 (wx.Panel(self,-1,size=(25,25)), flag=wx.EXPAND)
        #buttonSizer.Add                 (self.createEntButton)
        self.individualList             = IndividualList(self, -1, size=(130,150))                                       #list of individuals
        self.Bind                       (wx.EVT_LIST_ITEM_SELECTED, self.individualListSelChanged,                      self.individualList)
        individualsSizer.Add            (buttonSizer, flag=wx.EXPAND)
        individualsSizer.Add            (self.individualList, flag=wx.EXPAND)
        sizer.Add                       (individualsSizer)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))


        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))

        tasksSizer                      = wx.BoxSizer(wx.VERTICAL)
        buttonSizer                     = wx.BoxSizer(wx.HORIZONTAL)
        st                              = wx.StaticText  (self, -1, 'Tasks')
        #space                           = wx.Panel(self, -1, size=(25,25))
        buttonSizer.Add                 (st, flag=wx.EXPAND)
        #buttonSizer.Add                 (space)
        tasksSizer.Add                  (buttonSizer)
        self.taskList                   = TaskList(self, -1, size=(116,150))
        #self.Bind                       (wx.EVT_LIST_ITEM_SELECTED, self.taskListSelChanged, self.taskList)
        tasksSizer.Add                  (self.taskList, flag=wx.EXPAND)
        sizer.Add                       (tasksSizer)
        #sizer.Add                       (wx.Panel(self,-1,size=(5,5)))
                
        #the minimap
        self.minimap = minimap.MiniMap(self, -1, size=(175,175))
        sizer.Add( self.minimap,        flag=wx.EXPAND)

        #bind individual group buttons
        #self.Bind                       (wx.EVT_BUTTON, self.assignEntButton,   self.individualGroupButtons.assignEntButton)
        #self.Bind                       (wx.EVT_BUTTON, self.unassignEntButton, self.individualGroupButtons.unassignEntButton)
        #self.Bind                       (wx.EVT_BUTTON, parent.showEvent,       self.createEntButton)
        #self.Bind                       (wx.EVT_BUTTON, parent.showEvent,       self.createGroupButton)
        #self.Bind                       (wx.EVT_BUTTON, parent.showEvent,       self.cloneGroupButton)
        #self.Bind                       (wx.EVT_BUTTON, self.destroyGroupButtonFunc,self.destroyGroupButton)
        self.Bind                       (wx.EVT_BUTTON, parent.showEvent,       self.saveButton)
        self.Bind                       (wx.EVT_BUTTON, parent.showEvent,       self.loadButton)
    #/-----------------------------------------------------------------------------//
    def selIndividual(self, path):
        """user has left clicked in the world somewhere, we should change our currently selected group"""
        print 'selIndividual', path
        #self.selGroup(self.getSelectedGroup())
    #/-----------------------------------------------------------------------------//
    def selIndividualBox(self, path):
        """user has left clicked in the world somewhere, we should change our currently selected group"""
        #print 'selIndividualBox', path
    #/-----------------------------------------------------------------------------//
    def individualListSelChanged(self, event):
        """someone chose something from the indivual menu - pull it up"""
        #print 'individualListSelChanged', self.individualList.GetSelection()
        '''
        selected = self.individualList.GetSelection()
        if selected:
            call('/ui/planner.clearselection')
            call('%s.select' % selected)
            '''
    #/-----------------------------------------------------------------------------//
    def groupListSelChanged(self, event):
        """selected an item from the group list -> pass it on to the group manager"""
        groupName = self.groupList.GetSelection()
        groupManager.selectGroup(groupName=groupName)
    #/-----------------------------------------------------------------------------//
    def taskListSelChanged(self, event):
        """user chose a particular task"""
        #print 'taskListSelChanged'
        '''
        task                            = self.taskList.GetSelection()
        selectedGroup                   = self.getSelectedGroup()
        self.assignTask                 (task, selectedGroup)
        '''
    #/-----------------------------------------------------------------------------//
    def objectiveListSelChanged(self, event):
        """user choose an objectiev
        update our parameter panel
        update the objectivetask-list
        """
        #print 'objectiveListSelChanged'
        '''
        objectiveName                   = event.GetString()
        log.write                       ('objectiveListSelChanged', objectiveName)
        objective                       = self.objectives.__dict__[objectiveName]
        log.write                       ('selected objective', objective)
        self.objectiveParameterList.Clear()
        for param in objective.parameters:
            self.objectiveParameterList.Append(param)
        #self.objectiveParameterList.AppendItems(objective.parameters)
        self.objectiveTaskList.Clear()
        #self.objectiveTaskList.AppendItems(objective.tasks)
        for task in objective.tasks:
            self.objectiveTaskList.Append(task)
            '''
    #/-----------------------------------------------------------------------------//
    def assignEntButton(self, event):
        """figure out what is currently selected and add it to the current group
        now we need to remove it from whatever group it is currently in
        """
        #print 'assignEntButton'
        '''
        selectedGroup = self.groupList.GetSelection()
        selectedEnts = call('/ui/planner.getobjectsselected')
        for selectedEnt in selectedEnts:
            self.assignEntToGroup(selectedEnt, selectedGroup)
        '''
    #/----------------------#-------------------------------------------------------//
    def unassignEntButton(self, event):
        #print 'unassignEntButton'
        '''
        selectedEnts                    = call('/ui/planner.getobjectsselected')
        for selectedEnt in selectedEnts.strip().split(' '):
            entName                     = call('%s.getname' % selectedEnt)
            if selectedEnt and selectedEnt != 'none':
                for group in self.groups.itervalues():
                    if selectedEnt in group.paths.values():
                        #remove it from the old group
                        sidename        = call('/comm/groups/%s.gs' % group.name, 'sidename')
                        ndel            ('/comm/groups/%s/%s' % (group.name, entName))
                        pushsel         ()
                        self.createGroup(entName, sidename, groupType='adhoc')
                        sn              ('nent', '/comm/groups/%s/%s' % (entName, entName))
                        cs              ('path', selectedEnt)
                        popsel          ()
                        #nEventServer.pull(EventNames.GROUPS_CHANGED, '')
                        self.groupsChanged = True
        '''
    #/-----------------------------------------------------------------------------//
    def assignObjectiveButton(self, event):
        #print 'assignObjectiveButton'
        '''
        group                           = self.groupList.GetSelection()
        objective                       = self.objectiveList.GetSelection()
        self.assignObjective(group, objective)
        '''
    #/-----------------------------------------------------------------------------//
    def destroyGroupButtonFunc(self, event):
        #print 'destroyGroupButton', event
        pass
    #/-----------------------------------------------------------------------------//
    def tick(self, time, dtime):
        """our tick function (registered in __init__) - called every slice"""
        self.time = time
        return
        from common import OptionManager
        try:
            selectedGroup = groupManager.getSelectedGroup()
            if selectedGroup != None:
                self.groupNameCtrl.SetValue(groupSelected.name)
                if 'objective' in groupSelected.__dict__:
                    self.objectiveCtrl.SetValue(groupSelected.objective)
                else:
                    self.objectiveCtrl.SetValue('')
                if 'point' in groupSelected.__dict__:
                    self.pointCtrl.set(groupSelected.point)
                else:
                    self.pointCtrl.clear()
                if 'target' in groupSelected.__dict__ and groupSelected.target:
                    if(exists(groupSelected.target)):
                        self.targetCtrl.SetValue(call('%s.getname' % groupSelected.target))
                else:
                    self.targetCtrl.SetValue('')
            else:
                self.groupNameCtrl.SetValue('')
                self.objectiveCtrl.SetValue('')
                self.pointCtrl.clear()
                self.targetCtrl.SetValue('')
        except:
            printExcept('updating parameters panel')
    #/-----------------------------------------------------------------------------//
 
