import sys
import wx
import nEventServer
from npython import *
from common.defs import *
from common import EventNames
#/-----------------------------------------------------------------------------//
#/-----------------------------------------------------------------------------/
#/-----------------------------------------------------------------------------//
class TaskList(wx.ListCtrl):
    """nice little listbox showing available tasks"""
    #/-----------------------------------------------------------------------------//
    def __init__(self, parent, id, size=wx.DefaultSize):
        """pull the groups from /comm/groups and initialize myself"""
        nEventServer.register(EventNames.TASKS_CHANGED, self.update)
        wx.ListCtrl.__init__(self, parent, id, style=wx.LC_REPORT | wx.BORDER_SUNKEN | wx.LC_NO_HEADER, size=size) #LC_EDIT_LABELS
        self.InsertColumn(0, 'Tasks')
        self.InsertColumn(1, 'o2')
        self.SetColumnWidth(0, size[0]-20)
        self.SetColumnWidth(1, 0)
        self.tasks = {}
        self.update()
    #/-----------------------------------------------------------------------------//
    def GetSelection(self):
        index = self.GetFirstSelected(self)
        for task in self.tasks.values():
            if task.index == index:
                return task
        return None
    #/-----------------------------------------------------------------------------//
    def update(self, newTask=None):
        """update the items in my list"""
        if(not exists('/comm/tasks')):
            return
        pushsel('/comm/tasks')
        tasks = ndir()
        print "Tasks: ", tasks
        for taskname in tasks:
            if taskname == 'vars': continue
            if taskname not in self.tasks:
                sel(taskname)
                task                    = self.tasks[taskname]                  = struct(name=taskname)
                task.index              = self.InsertStringItem(sys.maxint, task.name)
                #if hasvar('colour'):    task.colour         = gs('colour')
                task.colour         = 'black'
                try:
                    self.SetItemTextColour  (task.index, getattr(wx, task.colour.upper()))
                except:
                    self.SetItemTextColour  (task.index, task.colour)
                sel('..')
        popsel()
    #/-----------------------------------------------------------------------------//
    def select(self, taskname):
        self.unselect()
        self.Select(self.tasks[taskname].index)
    #/-----------------------------------------------------------------------------//
    def unselect(self):
        for task in self.tasks.itervalues():
            self.Select(task.index, 0)
    #/-----------------------------------------------------------------------------//
