#define N_IMPLEMENTS nController
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/ncontroller.h"
#include "ai/nmoveai.h"
#include "node/nlinknode.h"
nNebulaScriptClass(nController, "nfsmqueue");

//------------------------------------------------------------------------------
/**
 */
nController::nController()
{
}

void nController::Initialize(){
    nFSMQueue::Initialize();
    AddToDisplayList();
}

void nController::InitVars(){
    nFSMQueue::InitVars();
    entname = ent->FullNameString();

}

nController::~nController(){
}
//------------------------------------------------------------------------------
/**
 */
/**
  parses incoming messages
  if messages are sent to the ent, telling it to command (ie from the interface) It creates/queues actions accordingly
 **/
void nController::Message( nMessage* message ){
    if( message->to == entname ){
        if( message->title == "command" ){
            int i = 0;
            char name[1024];
            while(1){
	sprintf( name, "move%i", i );
	if( this->Find(name) )
	    i++;
	else
	    break;
            }
            if( message->data == "none" ) {
	nMoveAI* ai = (nMoveAI*) kernelServer->New("nmoveai", (FullNameString() + "/" + name).Get() );
	ai->InitVars();
	ent->SetStackedVarV("destination", message->v.x, message->v.y, message->v.z );
            } else {
	n_printf("data != none\n");
            }
        }
        //else n_printf("%s title = %s not command\n", fn, message->title.Get() );
    }
    //else n_printf("%s not sent to me\n", fn );
}

void nController::Tick( float time, float dtime ){
    nFSMQueue::Tick( time, dtime );
    /* nRoot* vars = ent->Find("vars");
       n_assert( vars );
       nRoot* destination = vars->Find("destination");
       if( destination == 0 ) 
       return;
       vector3 p0;
       vector3 p;
       bool first = false;
       p0 = ent->GetVarV("pos");
       for( nVar* v = (nVar*) destination->GetHead(); v; v = (nVar*) v->GetSucc() ){
       p = v->GetV();
       if( first )
       first = false;
       else
       DrawLine( p0, p, yellow );
       p0 = p;
       }
     */
    ;
}

/**
  Displays its orders in a pretty way
  parses out destinations	
  and places cylinders (paths) between them
  FIXME 
  should be rehacked to used attach method to do multiple attaches, versus maintaining links, which is WAY expensive
 **/
void nController::Display( nGfxServer* gfx ){
    nRoot* vars = ent->Find("vars");

    int i;
    vector3 start, end;
    bool first = true;
    bool found = false;

    ifnonzero( vars ) {
        nVarStack* destStack = (nVarStack*) vars->Find("destination");
        if( destStack ) {
            gfx->Begin(N_PTYPE_LINE_STRIP);
            gfx->Rgba( 0.0f, 0.0f, 0.75f, .5f );
            for( i = 0; i < paths.Size(); i ++ )
	paths[i]->used = false;
            for( nRoot* r = destStack->GetHead(); r; r = r->GetSucc() ){
	nClass* varclass = kernelServer->FindClass( "nvar" );
	if( r->IsA( varclass ) ){
	    end = ((nVar*)r)->GetV();
	    if(first)
	        first = false;
	    else {

	        //search for existing
	        found = false;
	        for( i = 0; i < paths.Size(); i ++ ){
	            if( paths[i]->end.isequal( start, .1f ) )
		paths[i]->used = true;
	            if( paths[i]->start.isequal( start, .1f ) ){
		if( paths[i]->end.isequal( end, .1f ) ){
		    found = true;
		    paths[i]->used = true;
		    break;
		}
	            }
	        }
	        Path* path;
	        if( found )
	            ;
	        //n_printf("found path from %f,%f,%f -> %f,%f,%f\n", start.x, start.y, start.z, end.x, end.y, end.z );
	        else {
	            //n_printf("creating path from %f,%f,%f -> %f,%f,%f\n", start.x, start.y, start.z, end.x, end.y, end.z );
	            char name[1024];
	            strncpy( name, "", 1024 );
	            static int counter = 0;
	            sprintf( name, "/game/vis/path/path%i\n", counter++ );
	            path = new Path;
	            //n_printf("new node : %s\n", name );
	            path->node = (n3DNode*) kernelServer->New("n3dnode", name );	
	            strcat( name, "/link" );
	            nLinkNode* link = (nLinkNode*) kernelServer->New("nlinknode", name );
	            link->SetTarget("/node/path");

	            path->start = start;
	            path->end = end;
	            paths.Append( path );
	            vector3 d = end - start;
	            float l = d.len();
	            float r = n_rad2deg(d.ToYaw());
	            //float r = (float) atan2( d.x, d.z );
	            //n_printf("t:%.1f,%.1f,%.1f s:%.1f r:%.1f\n", start.x, start.y, start.z, 1.0f, 1.0f, l, 0.0f, r, 0.0f );
	            path->node->Txyz( start.x, start.y, start.z );
	            path->node->Sz( l );
	            path->node->Ry( r );
	        }
	    }
	    start = end;
	    //n_printv( start );
	    //n_printv( end );
	}
            }
            gfx->End();
            for( int i = 0; i < paths.Size(); i ++ ){
	if( paths[i]->used == false ){
	    paths[i]->node->Release();
	    paths.Erase( i );
	}
            }
        }
    }
}
