#define N_IMPLEMENTS nFireflyAI
//------------------------------------------------------------------------------
//  (C) 2004	Jigna Bhatt
//------------------------------------------------------------------------------
#include "ai/nfireflyai.h"

nNebulaScriptClass(nFireflyAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nFireflyAI::nFireflyAI():
    weapon( kernelServer, this )
{
}

void nFireflyAI::Initialize(){
    nAI::Initialize();
}

void nFireflyAI::InitVars(){
    nAI::InitVars();
    //weapon = ent->Find("primaryweapon");

    char fullname[1024];
    ent->GetFullName( fullname, 1024 );
    strcat( fullname, "/primaryweapon");
    weapon = fullname;


    destination.Connect( ent, "destination" );
    destination.DefaultV(0,0,0);
    target.Connect( ent, "target" );
    target.DefaultRef("");
    targetPos.Connect( target, "pos" );
    strafeRadius.Connect( ent, "straferadius");
    strafeRadius.DefaultF( 10 );
    regroupRadius.Connect( ent, "regroupradius" );
    regroupRadius.DefaultF( 20 );

}

nFireflyAI::~nFireflyAI(){
}
//------------------------------------------------------------------------------
/**
*/

void nFireflyAI::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
}

bool nFireflyAI::States( StateMachineEvent event, uint state, float time, float dtime ){
    BeginStateMachine
        State(Stop) 
            OnEnter
	SetState( Strafe );
            OnTick
        State(Strafe)
            OnEnter
                //n_printf("nFighterAI::Strafe");
            OnTick
	//n_printf("nFireFlyAI::Strafe\n");
                float dist = Move3D( targetPos.GetV(), dtime );
                if( dist < strafeRadius.GetF() )
                    SetState( Regroup );
                //DrawLine( pos.GetV(), targetPos.GetV(), red );
                //if( lf > .99f ) {
	if( target.isvalid() )
	    if( weapon.isvalid() )
	        weapon->Fire( target.GetRef()->fn );
	    else
	        n_printf("not a valid weapon\n");
	else
	    n_printf("target invalid\n");
                //}
        State(Regroup)
            OnEnter
                //n_printf("nFighterAI::Regroup");
                float r0 = randF( -N_PI, N_PI );
                float r1 = randF( -N_PI, N_PI );
                //n_printf("r0:%f r1:%f\n", r0, r1 );
                quaternion q;
                q.set_rotate_xyz( r0,r1,0 );
                vector3 dest = targetPos.GetV() + q.rotate(vector3(1,0,0)) * regroupRadius.GetF();
                //n_printv( dest );
                destination.SetV( dest );
            OnTick
                float dist = Move3D( destination.GetV(), dtime );
                if( dist < 10.0f )
                    SetState( Strafe );
                //DrawLine( pos.GetV(), destination.GetV(), white );
    EndStateMachine
}
