#define N_IMPLEMENTS nPlatformAI
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/nplatformai.h"
#include "gfx/ngfxserver.h"
#include "misc/nquickwatch.h"

nNebulaScriptClass(nPlatformAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nPlatformAI::nPlatformAI()
{
}

void nPlatformAI::Initialize(){
    nAI::Initialize();
    circleRadius = 5;
    stateNames.Append("startup");
    stateNames.Append("circle");
    stateNames.Append("move");
}

void nPlatformAI::InitVars(){
    nAI::InitVars();
    target.Connect(ent,"target");
    target.DefaultRef("none");
    destination.Connect(ent,"destination");
    destination.DefaultV( 0,0,0 );
}

nPlatformAI::~nPlatformAI(){
}
//------------------------------------------------------------------------------
/**
*/
bool nPlatformAI::States( StateMachineEvent event, uint state, float time, float dtime ){
    if( ent->Held() ) return true;
    BeginStateMachine
        State(Startup)
            OnEnter
                SetState(Move);
        State(Circle)
            OnTick
                physics->ApplyAlignedTorque(vector3(0, dtime/8, 0));
                physics->ApplyAlignedForce(vector3(0,0,dtime/8));
        State(Move)
            OnTick
                float d = this->MoveTowards( destination.GetV(), dtime ); 
                n_printf("d:%f\n", d );
                if( d < 1.0f ) 
                    this->Die();
    EndStateMachine
}
