#define N_IMPLEMENTS nPlatformAttack
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ai/nplatformattack.h"
#include "aspect/nhardpoint.h"
#include "aspect/nhardpointattach.h"
#include "ai/nmissleai.h"

nNebulaScriptClass(nPlatformAttack, "nai");

//------------------------------------------------------------------------------
/**
*/
nPlatformAttack::nPlatformAttack()
{
}

void nPlatformAttack::Initialize(){
    nAI::Initialize();
    stateNames.Append("init");
    stateNames.Append("attack");
    stateNames.Append("fire");
    stateNames.Append("circlearound");
}

void nPlatformAttack::InitVars(){
    nAI::InitVars();
    target.         	Connect(ent, "target");
    target.         	DefaultRef("none");
    targetPos.      	Connect(target, "pos");
    withasset.      	Connect( ent, "withasset");
    withasset.		DefaultS("unknown asset");
}

nPlatformAttack::~nPlatformAttack(){
}
//------------------------------------------------------------------------------
/**
*/
bool nPlatformAttack::States( StateMachineEvent event, uint state, float time, float dtime ){
    if( ent->Held() ) return true;
    if( withasset.isvalid() && ( withasset.GetS() != "none") && ((withasset.isdirty()==true) || (weapon.isvalid() == false)) ){
        //we have a new weapon to use
        //so identify the appropriate weapon attached to our entity
        nRoot* r = ent->Find("hardpoints");
        n_assert( r && "ent has no hardpoints");
        bool found = false;
        for( nHardPoint* h = (nHardPoint*) r->GetHead(); !found && h; h = (nHardPoint*) h->GetSucc() ){
            if( h->Open() == false ){
	nEnt* e = h->GetAttached();
	if( withasset.isvalid() ){
	    if( withasset.GetS() == e->GetVarS("type") ){
	        //n_printf("%s found %s as our weapon\n", fn, e->fn );
	        this->weapon = e;
	        found = true;
	    } else {
	        //n_printf("%s found %s to be the wrong type %s not %s\n", fn, e->fn, e->GetVarS("type"), withasset.GetS().Get() );
	    }
	}
	else {
	    n_printf("withasset is invalid\n");
	}
            }
        }
        /*if( !found ){
            if ( roll( .01 ) )
               	n_printf("%s failed to find its weapon:%30s \n", fn, withasset.GetS().Get() );
        }
        */
    }
    BeginStateMachine
        State(Init)
        OnEnter
            SetState(Attack);
        State(Attack)
            OnEnter
            OnTick
	bool worked = false;
	if( target.isvalid() )
    	    if( targetPos.isvalid() )
    	        if( weapon.isvalid() ) {
	            worked = true;
    	            SetState( Fire );
	        }
	if( !worked )
	    Die();
        State(Fire)
            OnEnter
                nMessage* m = new nMessage();
                m->time = time;
                m->from = FullNameString();
                m->to = target.GetRef()->FullNameString();
                m->title = "attacking";
                //m->data = ((nEnt*)ent->Find("assets")->Find(withasset.GetS().Get()))->GetVarS("type");
				m->data = weapon->GetVarS("type");
				weapon->SetVarRef("target", m->to.get() );
				((nHardPointAttach*) weapon->Find("hpattach"))->UnAttach();
				((nMissleAI*)weapon->Find("ai"))->SetState( "drop" );
                //n_printf("%-10s->firing on %20s with %5s(%s)\n", ent->GetName(), m->to.Get(), weapon->fn, m->data );
				//n_printf("%-20s firing %s at %s | %s\n", ent->GetName(), m->data.Get(), m->to.Get(), withasset.GetS().Get() );
                m->f0 = 10.0;
                Send( m );
				nRoot* wp = ent->Find("wp");
				if( wp ) {
					nRoot* attached = wp->GetHead();
					if( attached && attached != wp->GetTail()) {
						nRoot* second = attached->GetSucc();
						if( second ) {
							//n_printf("%s telling %s->Release\n", this->fn, second->GetName() );
							((nThing*)second)->Die();
						}
					}
				}
                this->Die();
                //SetState( CircleAround );
            OnTick
        State(CircleAround)
            OnEnter
                //this->attackVector = randomF( -N_PI, N_PI );
            OnTick
	SetState( Fire );
	/*
                quaternion q;
                q.set_rotate_y( this->attackVector );
                //VAR : 10 = regroup distance
                vector3 destination = targetPos.GetV() + q.rotate( vector3(0,0,10));
                float d = MoveTowards( destination, dtime );
                if( d < 20.0f)
                    SetState( Attack );
	*/
    EndStateMachine
}
