#define N_IMPLEMENTS nTankAI
//------------------------------------------------------------------------------
//  (C) 2004	Chris
//------------------------------------------------------------------------------
#include "ai/ntankai.h"

nNebulaScriptClass(nTankAI, "nai");

//------------------------------------------------------------------------------
/**
*/
nTankAI::nTankAI()
{
}

void nTankAI::Initialize(){
    nAI::Initialize();
    //physics = (nPhysics*) ent->Find("physics");
    AddToDisplayList();
}

void nTankAI::InitVars(){
    nAI::InitVars();
    pos.Connect( ent, "pos" );
    rot.Connect( ent, "rot" );
    destination.Connect( ent, "destination" );
    destination.DefaultV( vector3( randF(0,3000), 0, randF(0,3000)));
}

nTankAI::~nTankAI(){
}
//------------------------------------------------------------------------------
/**
*/

void nTankAI::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
    vector3 p = pos.GetV();
    vector3 d = destination.GetV();
    
    float currentRotation = rot.GetV().ToYaw();
    vector3 dx = d - p;
    float angle = (float) -atan2( dx.z, dx.x );
   
    if( currentRotation != angle )
    {
         physics->ApplyAlignedTorque( vector3(0, currentRotation - angle, 0) );
    }
    //physics->ApplyAlignedForce( vector3(0, 0, -dtime) );
    
    DrawLine( p, d, white );
    DrawAngle( p, currentRotation, blue );
    DrawAngle( p, angle, yellow );
}

