#define N_IMPLEMENTS nAltLimit
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/naltlimit.h"

nNebulaScriptClass(nAltLimit, "naspect");

//------------------------------------------------------------------------------
/**
*/
nAltLimit::nAltLimit():
    map( kernelServer, this )
{
}

void nAltLimit::Initialize(){
    nAspect::Initialize();
    map = "/map/map";
}

void nAltLimit::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    vel.Connect( ent, "vel" );
    vel.DefaultV(0,0,0);
    minalt.Connect( ent, "minalt" );
    minalt.DefaultF(0.00001f);
    maxalt.Connect( ent, "maxalt" );
    maxalt.DefaultF(-1.0f);
}

nAltLimit::~nAltLimit(){
}
//------------------------------------------------------------------------------
/**
*/

void nAltLimit::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    vector3 p = pos.GetV();
    float h;
    if( false && map.isvalid() )
        h = map->GetHeight( p.x, p.z );
    else
        h = 0.0f;
    float min = minalt.GetF();
    float max = maxalt.GetF();
    vector3 v = vel.GetV();
    if( min >= 0.0f ) {
        if( h + min > p.y ){
            p.y = h + min;
            if( v.y < 0 )
                v.y = 0;
        }
    }
    if( max >= 0.0f ) {
        if( h + max < p.y ){
            p.y = h + max;
            if( v.y > 0 )
                v.y = 0;
        }
    }
    pos.SetV( p );
    vel.SetV( v );
}
