#define N_IMPLEMENTS nAltLimitArray
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/naltlimitarray.h"

nNebulaScriptClass(nAltLimitArray, "naspect");

//------------------------------------------------------------------------------
/**
*/
nAltLimitArray::nAltLimitArray():
    map( kernelServer, this )
{
}

void nAltLimitArray::Initialize(){
    nAspect::Initialize();
    map = "/map/map";
    //this->AddToDisplayList();
}

void nAltLimitArray::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos" );
    vel.Connect( ent, "vel" );
    vel.DefaultV(0,0,0);
    minalt.Connect( ent, "minalt" );
    minalt.DefaultF(0.0f);
    maxalt.Connect( ent, "maxalt" );
    maxalt.DefaultF(-1.0f);
}

nAltLimitArray::~nAltLimitArray(){
}
//------------------------------------------------------------------------------
/**
*/

void nAltLimitArray::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    matrix44 m = ent->GetM();
    float h;
    float min = minalt.GetF();
    if( min < 0.0f ) 
        return;
    float fix = 0.0f;
    for( int i = 0; i < points; i ++ ) {
        vector3 p = m * points[i];
        //DrawPoint( p, red );
        if( map.isvalid() )
            h = map->GetHeight( p.x, p.z );
        else
            h = 0;
        float alt = p.y - h;
        float fixAmount = min - alt;
        if( fixAmount > 0.0f ) {
            if( fix < fixAmount )
	fix = fixAmount;
        }
    }
    if( fix > 0.0f ) {
        vector3 p = pos.GetV();
        p.y += fix;
        pos.SetV( p );
        vector3 v = vel.GetV();
        v.y = 0.0f;
        vel.SetV( v );
    }
}
