#define N_IMPLEMENTS nArmor
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/narmor.h"
#include "node/nipol.h"

nNebulaScriptClass(nArmor, "naspect");

//------------------------------------------------------------------------------
/**
 */
nArmor::nArmor()
{
}

void nArmor::Initialize(){
    nAspect::Initialize();
    entPath = ent->FullNameString();
}
void nArmor::InitVars(){
    nAspect::InitVars();
    hp.Connect( ent, "hp" );
    hp.DefaultF( 1.0f );
    armorclass.Connect( ent, "armorclass" );
    armorclass.DefaultS("unarmored");
    pos.Connect( ent, "pos" );
}
nArmor::~nArmor(){
}
//------------------------------------------------------------------------------
/**
  if hp < 0 -> die
 */

void nArmor::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if(hp.GetF() < 0)
        ent->Die();
}
/**
  Recieves incoming messages
  Parsing out those which cause me damage
*/
void nArmor::Message( nMessage* m ){
    nAspect::Message( m );
    if( m->to == entPath ){
        if( m->title == "attacking" ) {
            //float d = m->
            const char* weaponClass = m->data.Get();
            //n_printf("weaponClass:%s\n", weaponClass );
            nString armorEffectivenessPath = "/info/armor/" + armorclass.GetS();
            nEnt* armorEffectiveness = (nEnt*)kernelServer->Lookup(armorEffectivenessPath.Get());
            if( armorEffectiveness ) {
	float damage = armorEffectiveness->GetVarF( weaponClass );
	hp.SetF( hp.GetF() * (1.0f - damage) );
            } else {
	n_printf("no match for %s\n", armorEffectivenessPath.Get() );
            }
        }
    }
    if ( m->to == "armors" ){
        if( m->from != entPath) {
            vector3 p = pos.GetV();
            float l = (p - m->v).len();
            float r = m->f1;
            if ( l < r ){
	float d = m->f0 * (1 - (l/r) );
	//n_printf("%s recieved %f damage l:%f\n", fn, d, l );
	hp.SetF( hp.GetF() - d );
            }
        }
    }
}
