#define N_IMPLEMENTS nAttachedWP
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nattachedwp.h"
#include "enkiduo/ngameserver.h"

nNebulaScriptClass(nAttachedWP, "nwpaspect");

//------------------------------------------------------------------------------
/**
*/
nAttachedWP::nAttachedWP()
{
}

void nAttachedWP::Initialize(){
    nWPAspect::Initialize();
}

void nAttachedWP::InitVars(){
    nWPAspect::InitVars();
    pos.Connect( ent, "pos" );
    classVar( nent, entclass );
    for( nRoot* r = ent->GetParent(); r; r = r->GetParent() ) {
        if (r->IsA( entclass ) ) {
            nEnt* e = (nEnt*) r;
            entPos.Connect( e, "pos" );
            break;
        }
    }
    /* okay now we need to create our own visnode whenever we are created */
    nGameServer* game = (nGameServer*) kernelServer->Lookup("/sys/servers/game");
    n3DNode* vis = game->GenVis("wp");
    char name[1024];
    vis->GetFullName( name ,1024 );
    ent->SetVis( name );
}

nAttachedWP::~nAttachedWP(){
}
//------------------------------------------------------------------------------
/**
*/

void nAttachedWP::Tick( float time, float dtime ){
    nWPAspect::Tick( time, dtime );
    ifvalid( entPos ) {
        vector3 ep = entPos.GetV();
        vector3 mp = pos.GetV();
        if( (ep - mp).len() > 1.0f ) {
            pos.SetV( entPos.GetV() );
        }
    }
}
