#define N_IMPLEMENTS nHeading
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nheading.h"

nNebulaScriptClass(nHeading, "naspect");

//------------------------------------------------------------------------------
/**
*/
nHeading::nHeading()
{
}

void nHeading::Initialize(){
    nAspect::Initialize();
}

void nHeading::InitVars(){
    nAspect::InitVars();
    rot.Connect( ent, "rot" );
    heading.Connect( ent, "heading" );
    heading.DefaultF( 1.0f );
}

nHeading::~nHeading(){
}
//------------------------------------------------------------------------------
/**
*/

void nHeading::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    quaternion q = rot.GetQ();
    vector3 forward( 0, 0, -1 );
    forward = q.rotate( forward );
    float h = atan2( forward.x, forward.z );
    heading.SetF( n_rad2deg(h) );
}

