#define N_IMPLEMENTS nHPListAspect
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nhplistaspect.h"
#include "enkiduo/nhplistserver.h"

nNebulaScriptClass(nHPListAspect, "naspect");

//------------------------------------------------------------------------------
/**
*/
nHPListAspect::nHPListAspect():
    linked( false )
{
}

void nHPListAspect::Initialize(){
    nAspect::Initialize();
}

void nHPListAspect::InitVars(){
    nAspect::InitVars();
}

nHPListAspect::~nHPListAspect(){
    this->UnlinkFromServer();
}
//------------------------------------------------------------------------------
/**
*/

void nHPListAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( linked == false )
        LinkToServer();
}

void nHPListAspect::LinkToServer(){
    nHPListServer* server = (nHPListServer*) kernelServer->Lookup("/ui/hplist");
    if( server == 0 ){
        n_printf("cannot find hplistserver\n");
        return;
    } else {
        server->AddEnt( ent );
        this->linked = true;
        //n_printf("%s::linked to hplist\n", fn );
    }
}
void nHPListAspect::UnlinkFromServer(){
    if( this->linked ) {
        nHPListServer* server = (nHPListServer*) kernelServer->Lookup("/ui/hplist");
        server->RemoveEnt( ent );
        this->linked = false;
        //n_printf("%s::Unlinked from hplist\n", fn );
    }
}
