#define N_IMPLEMENTS nResourceProducer
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nresourceproducer.h"

nNebulaScriptClass(nResourceProducer, "naspect");

//------------------------------------------------------------------------------
nResourceProducer::nResourceProducer() {
}
//------------------------------------------------------------------------------
void nResourceProducer::Initialize(){
    nAspect::Initialize();
}
//------------------------------------------------------------------------------
void nResourceProducer::InitVars(){
    nAspect::InitVars();
    side.Connect                        ( ent, "side" );
    resourceProduced.Connect            ( ent, "resourceProduced" );
    resourceProduced.DefaultS           ( "gold" );
    resourceProductionRate.Connect      ( ent, "resourceProductionRate" );
    resourceProductionRate.DefaultF     ( 10.0f );
}
//------------------------------------------------------------------------------
nResourceProducer::~nResourceProducer(){
}
//------------------------------------------------------------------------------
void nResourceProducer::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( resourceProduced.isdirty() ) {
        resources.Connect( side, resourceProduced.GetS() );
        resources.DefaultF( 0.0f );
        n_printf("nResourceProducer(%s).resource = %s\n", str(this), resourceProduced.GetS().Get() );
    }
    ifvalid( resources ) {
        float dResource = resourceProductionRate.GetF() * dtime;
        resources.SetF(resources.GetF() + dResource );
    }
}

