#define N_IMPLEMENTS nSoundEmitter
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nsoundemitter.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nSoundEmitter*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( addpassivesound ) {
    self->AddPassiveSound( ins() );
}
command( setrange ) {
    self->SetRange( inf() );
}
command( getpassivesounds ) {
    const nArray<nString>& sounds = self->GetPassiveSounds();
    nString answer;
    for( int i = 0; i < sounds.Size(); i ++ ) {
        if( i > 0 )
            answer += " ";
        answer += sounds[i];
    }
    outs( answer.Get() );
}
command( setgain ) {
    self->SetGain( inf() );
}
command( setpitch ) {
    self->SetPitch( inf() );
}
command( queue ) {
    self->Queue( ins() );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_addpassivesound_s", 	'APS', 	addpassivesound );
    clazz->AddCmd("v_setrange_f", 	'SR', 	setrange );
    clazz->AddCmd("s_getpassivesounds_v", 	'GPS', 	getpassivesounds );
    clazz->AddCmd("v_setgain_f",	'SG',	setgain );
    clazz->AddCmd("v_setpitch_f",	'SP',	setpitch );
    clazz->AddCmd("v_queue_s", 		'Q', 	queue );
    clazz->EndCmds();
}

bool
nSoundEmitter::SaveCmds(nPersistServer* ps)
{
    if (nOffsetAspect::SaveCmds(ps))
    {
        nCmd* cmd;
        const nArray<nString>& sounds = this->GetPassiveSounds();
        for( int i = 0; i < sounds.Size(); i ++ ) {
            cmd = ps->GetCmd(this, 'APS');
            cmd->In()->SetS( sounds[i].Get() );
            ps->PutCmd( cmd );
        }
        cmd = ps->GetCmd(this, 'SR');
        cmd->In()->SetF( this->GetRange() );
        ps->PutCmd( cmd );
        cmd = ps->GetCmd(this, 'SG');
        cmd->In()->SetF( this->GetGain() );
        ps->PutCmd( cmd );
        cmd = ps->GetCmd(this, 'SP');
        cmd->In()->SetF( this->GetPitch() );
        ps->PutCmd( cmd );
        return true;
    }
    return false;
}

