#define N_IMPLEMENTS nStats
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nstats.h"

nNebulaScriptClass(nStats, "naspect");

//------------------------------------------------------------------------------
/**
*/
nStats::nStats():
    varRoot( 0 ),
    lastChecked(0)
{
    this->AddLogTag("nstats");
}
////////////////////////////////////////////////////////////////////////////////
void nStats::Initialize(){
    nAspect::Initialize();
}
////////////////////////////////////////////////////////////////////////////////
void nStats::InitVars(){
    nAspect::InitVars();
    this->CheckVars();
    this->Tick(0,0);
}
////////////////////////////////////////////////////////////////////////////////
nStats::~nStats(){
}
///////////////////////////////////////////////////////////////////////////////
///if we have new vars -> call check vars
///if any of my vars are dirty then 
///	figure out hwich varialbes they effect
///	change them if we have high enough priority
///////////////////////////////////////////////////////////////////////////////
void nStats::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( varRoot->GetTail() != lastChecked ) //vars have been added/removed -> check them
        this->CheckVars();
    for( int i = 0; i < invars; i ++ ) {
        if( invars[i].v->isdirty() ) {
            //n_printf("invar:%s has changed\n", invars[i].v->GetVarName() );
            nEnt* e;
            nString path;
            path.PrintF("/stats/%s/%s/%i", ent->GetParent()->GetName(), invars[i].v->GetVarName(), invars[i].v->GetI() );
            //n_printf("looking in :%s\n", path.Get() );
            e = (nEnt*) kernelServer->Lookup( path.Get() );
            if( e == 0 ) {	//not found in class specific - check default
                path.PrintF("/stats/default/%s/%i", invars[i].v->GetVarName(), invars[i].v->GetI() );
                e = (nEnt*) kernelServer->Lookup( path.Get() );
            }
            if( e ) {
                nVar* last = (nVar*) e->Find("vars")->GetTail();
                while( nString(last->GetName()) != "octradius") {
                    const char* name = last->GetName();
                    //n_printf("\toutvar:%s\n", name );

                    vector3 v = last->GetV();
                    float priority = v.x;
                    float value = v.y;

                    //figure out which outvar it corresponds too
                    OutVar* ov = 0;
                    bool found = false;
                    for( int j = 0; j < outvars; j ++ )  {
                        if( strcmp( outvars[j].v->GetVarName(), name ) == 0 ) { //found the outvar
                            found = true;
                            ov = &outvars[j];
                            if( ov->priority <= priority ) { //see if new priority is higher
                                ov->v->SetF( value );
                                ov->priority = priority;
                                //n_printf("setting: %s to %f\n", ov->v->GetVarName(), ov->v->GetF() );
                            }
                            break;
                        }
                    }
                    if( !found ) {	//failed to find the outvar - make a new one
                        ov = &outvars.Push();
                        ov->v = new var();
                        ov->v->Connect( ent, name );
                        ov->v->SetF(value);
                        ov->priority = priority;
                        //n_printf("setting: %s to %f\n", ov->v->GetVarName(), ov->v->GetF() );
                    }

                    last = (nVar*) last->GetPred();
                }
            }
            else 
                n_printf("%s not found\n", path.Get());
        }
    }
}
////////////////////////////////////////////////////////////////////////////////
///goes through every var the entity has - looking for vars ending in "level"
////////////////////////////////////////////////////////////////////////////////
    void nStats::CheckVars(){
        //n_printf("nStats::CheckVars()\n");
        if( varRoot == 0 )
            varRoot = ent->Find("vars");
        foreachchild( nVar, v, varRoot ) {
            if( strstr( v->GetName(), "level" ) != 0 ) {
                //n_printf("%s is a level var\n", v->GetName());
                InVar& iv = invars.Push();
                iv.v = new var();
                iv.v->Connect( v );
            }
        }
        lastChecked = varRoot->GetTail();
        //foreachchild( nEnt*, e, threats, nent ) {
    }
