#define N_IMPLEMENTS nUnderConstruction
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "aspect/nunderconstruction.h"

nNebulaScriptClass(nUnderConstruction, "naspect");

//------------------------------------------------------------------------------
nUnderConstruction::nUnderConstruction() {
}
//------------------------------------------------------------------------------
void nUnderConstruction::Initialize(){
    nAspect::Initialize();
}
//------------------------------------------------------------------------------
void nUnderConstruction::InitVars(){
    nAspect::InitVars();
    constructionTime.Connect            ( ent, "constructionTime" );
    constructionTime.DefaultF           ( 10.0f );
    constructionTimeCompleted.Connect   ( ent, "constructionTimeCompleted" );
    constructionTimeCompleted.DefaultF  ( 0.0f );
    constructedRatio.Connect            ( ent, "constrRatio" );
    constructedRatio.SetF               ( 0.0f );
    constructing.Connect                ( ent, "constructing" );
    constructing.SetI                   ( 1 );
}
//------------------------------------------------------------------------------
nUnderConstruction::~nUnderConstruction(){
}
//------------------------------------------------------------------------------
void nUnderConstruction::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    //printf("constructing:%i constructionTime:%f constructionTimeCompleted:%f\n", constructing.GetI(), constructionTime.GetF(), constructionTimeCompleted.GetF());
    if( constructing.GetI() ){
        float ctime                     = constructionTime.GetF();
        float ctimeCompleted            = constructionTimeCompleted.GetF();
        if( ctime == 0.0f || ctimeCompleted >= ctime ) {
            constructing.SetI( 0 );
        } else {
            constructionTimeCompleted.SetF( n_clamp(ctimeCompleted + dtime, 0.0f, ctime) );
            constructedRatio.SetF         ( n_clamp(ctimeCompleted / ctime, 0.0f,1.0f));
        }
    }
}
