#define N_IMPLEMENTS nChannelHolder
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nchannelholder.h"
#include "gfx/nchannelset.h"
#include "gfx/nscenegraph2.h"
#include "gfx/nchannelcontext.h"

nNebulaScriptClass(nChannelHolder, "nvisnode");

//------------------------------------------------------------------------------
/**
*/
nChannelHolder::nChannelHolder()
{
}

/**
  Sets my parent to depend on me - leads to my compute method being called
**/
void nChannelHolder::Initialize(){
    nVisNode::Initialize();
    classVar( nvisnode, visClass );
    if( parent->IsA( visClass ) )
        ((nVisNode*) parent)->DependsOn( this );
    else
        n_printf("nChannelHolder %s descends from non nVisNode : %s\n", this->GetName(), parent->GetName() );
}

nChannelHolder::~nChannelHolder(){
}
//------------------------------------------------------------------------------
/**
*/

///create a new channel with the specified value
int nChannelHolder::Add( const char* name, float* value, int l) {
    ChannelInfo ci;
    ci.name 	= name;
    ci.l 		= l;
    ci.value 	= new float[l];
    for( int i = 0; i < l; i ++ )
        ci.value[i] = value[i];
    channels.Append( ci );
    this->NotifyChannelSetDirty();
    return channels.Size()-1;
}
///set the appropriate channel to a value
void nChannelHolder::Set( int index, float* value, int l){
    for( int i = 0; i < l; i ++ )
        channels[index].value[i] = value[i];
}
/**
  adds the channels it is using to the current list
 **/
void nChannelHolder::AttachChannels( nChannelSet* channelSet ){
    nVisNode::AttachChannels( channelSet );
    n_assert( channelSet );
    for( int i = 0; i < channels.Size(); i ++ ){
        channels[i].handle = channelSet->AddChannel( this->refChannel.get(), channels[i].name.Get() );
    }
}
/**
  Sets all the appropriate channels
 **/
void nChannelHolder::Compute( nSceneGraph2* sceneGraph ) {
    nVisNode::Compute( sceneGraph );
    nChannelContext* chnContext = sceneGraph->GetChannelContext();
    for( int i = 0; i < channels.Size(); i ++ ){

        ChannelInfo& ci = channels[i];
        switch( ci.l ) {
            case 1: chnContext->SetChannel1f( ci.handle, ci.value[0] );
            case 2: chnContext->SetChannel2f( ci.handle, ci.value[0], ci.value[1] );
            case 3: chnContext->SetChannel3f( ci.handle, ci.value[0], ci.value[1], ci.value[2] );
            case 4: chnContext->SetChannel4f( ci.handle, ci.value[0], ci.value[1], ci.value[2], ci.value[3] );
        }
    }
}

nString nChannelHolder::Sum(){
    nString answer;
    nString line;
    nString values;
    for( int i = 0; i < channels; i ++ ) {
        line.PrintF("%3i %10s %i (", channels[i].handle, channels[i].name.Get(), channels[i].l);
        for( int j = 0; j < channels[i].l; j ++ ) {
            if( j > 0 )
	values + ",";
            else
	values = "";
            values.PrintF("%.4f", channels[i].value[j] );
            line += values;
        }
        line += nString(")\n");
        answer += line;
    }
    return answer;
}
