#define N_IMPLEMENTS nDynamicTerrain
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/ndynamicterrain.h"

nNebulaScriptClass(nDynamicTerrain, "nthing");

//------------------------------------------------------------------------------
/**
*/
nDynamicTerrain::nDynamicTerrain()
{
}

inline float normalFF( float mean, float dev ) {
    static const double pii=3.1415927;
    static const double r_max=RAND_MAX+1.0f;
    return dev*sqrt(-2*log( (rand()+1)/r_max )) * sin(2*pii*rand()/r_max)+mean;
}
void nDynamicTerrain::Initialize(){
    nThing::Initialize();
    this->AddToDisplayList();
    for( int i = 0; i < res; i ++ )
        for( int j = 0; j < res; j ++ )
            heights[i][j] = 0;
    for( int z = 0; z < 1; z ++ ) {
        float xc = randF( width, res-width );
        float yc = randF( width, res-width );
        int numTossed = 0;
        for( int i = 0; i < 10000000; i ++ ) {
            float x = normalFF( xc, width );
            float y = normalFF( yc, width );
            //n_printf("x:%f y:%f\n", x, y );
            int xi = (int) x;
            int yi = (int) y;
            if( xi > 0 && xi < res-1 )
	if( yi > 0 && yi < res-1 )
	    heights[xi][yi] += 0.03f;
	else
	    numTossed++;
            else
	numTossed++;
        }
        n_printf("Tossed: %i out of %i\n", numTossed, 500 );
    }
}

nDynamicTerrain::~nDynamicTerrain(){
}
//------------------------------------------------------------------------------
/**
 */

void nDynamicTerrain::Tick( float time, float dtime ){
    nThing::Tick( time, dtime );
}

void nDynamicTerrain::Display( nGfxServer* gfx ) {
    int i, j;
    gfx->Rgba(			0.5f,	0.5f,	0.5f,	0.1f );
    for( i = 0; i < res-1; i ++ ) {
        gfx->Begin( N_PTYPE_TRIANGLE_STRIP );
        for ( j = 0; j < res; j ++ ) {
            vector3 v1(i, heights[i][j],j);
            vector3 v2(i+1, heights[i+1][j],j);
            //n_printf("%s->%s", str(v1), str(v2) );
            gfx->Coord( v1.x, v1.y, v1.z );
            gfx->Coord( v2.x, v2.y, v2.z );
        }
        gfx->End();
    }
    gfx->Rgba(	1.0f, 1.0f, 1.0f, 0.5f );
    for( i = 0; i < res; i += lineRes ) {
        gfx->Begin( N_PTYPE_LINE_LIST );
        for( j = 0; j < res; j +=lineRes ) {
            vector3 v(i, heights[i][j] + .001f, j );
            gfx->Coord( v.x, v.y, v.z );
            if( j != 0 )
	gfx->Coord( v.x, v.y, v.z );
        }
        gfx->End ( );
    }
    for( j = 0; j < res; j += lineRes ) {
        gfx->Begin( N_PTYPE_LINE_LIST );
        for( i = 0; i < res; i += lineRes ) {
            //n_printf("%i %i\n", i, j );
            vector3 v(i, heights[i][j] + .001f, j );
            gfx->Coord( v.x, v.y, v.z );
            if( i != 0 )
	gfx->Coord( v.x, v.y, v.z );
        }
        gfx->End ( );
    }
    for( i = 0; i < res; i += lineRes ) {
        gfx->Begin( N_PTYPE_LINE_LIST );
        for( j = 0; j < res; j += lineRes ) {
            vector3 v1(i, heights[i][j] + .001f, j );
            vector3 v2(i+1, heights[i][j+1] + .001f, j+1 );
            gfx->Coord( v1.x, v1.y, v1.z );
            gfx->Coord( v2.x, v2.y, v2.z );
        }
        gfx->End ( );
    }
    gfx->End();

}
