#define N_IMPLEMENTS nEnt
//------------------------------------------------------------------------------
//  (C) 2004    Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nent.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nEnt*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( var ){
    self->PrintVars();
}
command( hasvar ) {
    outb( self->HasVar(ins()) );
}
command( inheritfrom ){
    self->InheritFrom( ins() );
}
command( parents ){
    nArray<nString> parents = self->GetParentPaths();
    for( int i = 0; i < parents.Size(); i ++ )
        n_printf("%s\n", parents[i].Get() );
}
command( setvis ){
    self->SetVis( ins() );
}
command( getvis ){
    char visPath[1024];
    n3DNode* n = self->GetVis();
    if( n ) { 
        n->GetFullName(visPath, 1024 );
        outs( visPath );
    }
    else
        outs ("vis not set");

}
command( setneedsvis ) {
    self->SetNeedsVis( inb() );
}
command( getneedsvis ) {
    outb( self->GetNeedsVis() );
}
command( setinoctree ) {
    self->SetInOctree( inb() );
}
command( getinoctree) {
    outb( self->GetInOctree() );
}
command( setselectable ) {
    self->SetSelectable( inb() );
}
command( getselectable ) {
    outb( self->GetSelectable() );
}
command( sethasside ) {
    self->SetHasSide( inb() );
}
command( gethasside ) {
    outb( self->GetHasSide() );
}
command( held ) {
    outb( self->Held() );
}
command( setheld ) {
    self->SetHeld( inb() );
}
command( select ) {
    self->Select();
}
command( deselect ) {
    self->Deselect();
}
command( selected ) {
    outb(self->Selected());
}
//************INT INTERFACE
command( ci ){
    const char* s = ins();
    int i = ini();
    self->CreateVar(s)->SetI(i);
}
command( si ){
    const char* s = ins();
    int i = ini();
    self->SetVarI( s, i );
}
command( gi ){
    const char* s = ins();
    outi( self->GetVarI( s ) );
}


    //************FLOAT INTERFACE
command( cf ){
    const char* s = ins();
    float f = inf();
    self->CreateVar(s)->SetF(f);
}
command( sf ){
    const char* s = ins();
    float f = inf();
    self->SetVarF( s, f );
}
command( gf ){
    const char* s = ins();
    outf( self->GetVarF( s ) );
}

//************VECTOR INTERFACE
command( cv ){
    const char* s = ins();
    float x = inf();
    float y = inf();
    float z = inf();
    self->CreateVar(s)->SetV(x,y,z);
}
command( sv ){
    const char* s = ins();
    float x = inf();
    float y = inf();
    float z = inf();
    self->SetVarV( s,x,y,z );
}
command( cvx ){
    const char* s = ins();
    float x = inf();
    nVar* va = self->CreateVar(s);
    va->DefaultV(0,0,0);
    vector3 v = va->GetV();
    v.x = x;
    va->SetV( v.x, v.y, v.z );
}
command( svx ){
    const char* s = ins();
    float x = inf();
    vector3 v = self->GetVarV( s );
    v.x = x;
    self->SetVarV( s, v.x, v.y, v.z );
}
command( cvy ){
    const char* s = ins();
    float y = inf();
    nVar* va = self->CreateVar(s);
    va->DefaultV(0,0,0);
    vector3 v = va->GetV();
    v.y = y;
    va->SetV( v.x, v.y, v.z );
}
command( svy ){
    const char* s = ins();
    float y = inf();
    vector3 v = self->GetVarV( s );
    v.y = y;
    self->SetVarV( s, v.x, v.y, v.z );
}
command( cvz ){
    const char* s = ins();
    float z = inf();
    nVar* va = self->CreateVar(s);
    va->DefaultV(0,0,0);
    vector3 v = va->GetV();
    v.z = z;
    va->SetV( v.x, v.y, v.z );
}
command( svz ){
    const char* s = ins();
    float z = inf();
    vector3 v = self->GetVarV( s );
    v.z = z;
    self->SetVarV( s,v.x,v.y,v.z );
}
command( gv ){
    const char* s = ins();
    vector3 v = self->GetVarV(s);
    outf( v.x );
    outf( v.y );
    outf( v.z );
}
//**************QUATERNION INTERFACE
command( cq ){
    const char* s = ins();
    float x = inf();
    float y = inf();
    float z = inf();
    float w = inf();
    self->CreateVar(s)->SetQ(x,y,z,w);
}
command( sq ){
    const char* s = ins();
    float x = inf();
    float y = inf();
    float z = inf();
    float w = inf();
    self->SetVarQ( s,x,y,z,w );
}
command( sr ){
    const char* s = ins();
    float x = n_deg2rad( inf() );
    float y = n_deg2rad( inf() );
    float z = n_deg2rad( inf() );
    quaternion q;
    q.set_rotate_xyz( x,y,z );
    self->SetVarQ( s, q.x, q.y, q.z, q.w );
}
command( cr ){
    const char* s = ins();
    float x = n_deg2rad( inf() );
    float y = n_deg2rad( inf() );
    float z = n_deg2rad( inf() );
    quaternion q;
    q.set_rotate_xyz( x,y,z );
    self->CreateVar(s)->SetQ(q.x,q.y,q.z,q.w);
}
command( gq ){
    const char* s = ins();
    quaternion q = self->GetVarQ(s);
    outf( q.x );
    outf( q.y );
    outf( q.z );
    outf( q.w );
}

//***********STRING INTERFACE
command( cs ){
    const char* s = ins();
    const char* v = ins();
    self->CreateVar(s)->SetS( v );
}
command( ss ){
    const char * s = ins();
    const char * v = ins();
    self->SetVarS( s,v );
}
command( gs ){
    const char* s = ins();
    const char* v = self->GetVarS(s);
    outs( v );
}
//***********REF INTERFACE
command( cref ){
    const char* s = ins();
    const char* r = ins();
    //n_printf("cref : %s %s\n", s, r );
    self->CreateVar(s)->SetRef(r);
}
command( sref ){
    const char* s = ins();
    const char* r = ins();
    //n_printf("sref : %s %s\n", s, r );
    self->SetVarRef( s, r );
}
command( gref ){
    const char* s = ins();
    outs( self->GetVarRef(s) );
}
//************STACK INTERFACE
command( ssf ){
    const char* s = ins();
    float f = inf();
    self->SetStackedVarF( s, f );
}
command( ssref ){
    const char* s = ins();
    const char* s2 = ins();
    //n_printf("ssref: %s %s\n", s, s2 );
    self->SetStackedVarRef( s, s2 );
}
command( ssv ){
    const char* s = ins();
    float x = inf();
    float y = inf();
    float z = inf();
    //n_printf("svs : %s %f %f %f\n", s, x, y, z );
    self->SetStackedVarV( s, x, y, z );
}
command( sss ){
    const char* s = ins();
    const char* s2 = ins();
    self->SetStackedVarS( s, s2 );
}
//************RC INTERFACE
command( saverc ) {
    const char* s = ins();
    const char* s1 = ins();
    self->SaveRC( s, s1 );
}
command( loadrc ) {
    const char* s = ins();
    const char* s1 = ins();
    self->LoadRC( s, s1 );
}
command( editrc ){
    const char* s = ins();
    self->EditRC(s);
}

command( getsidehandle ) {
    outi( self->GetSideHandle() );
}
//************CHANNEL EXPORTING INTERFACE
command( exportchannel ) {
    const char* s = ins();
    //char s[1024];
    //strncpy( s, ins(), 1024 );
    self->ExportChannel( s );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_var_v", 'VAR', var );
    clazz->AddCmd("b_hasvar_s", 'HVAR', hasvar );
    clazz->AddCmd("v_inheritfrom_s", 'IHRT', inheritfrom );
    clazz->AddCmd("v_parents_v", 'PAR', parents);
    clazz->AddCmd("v_setvis_s", 'SVS', setvis );
    clazz->AddCmd("s_getvis_v", 'GVS', getvis );
    clazz->AddCmd("v_setneedsvis_b", 'SNVS', setneedsvis );
    clazz->AddCmd("b_getneedsvis_v", 'GNVS', getneedsvis );
    clazz->AddCmd("v_setinoctree_b", 'SIO', setinoctree );
    clazz->AddCmd("b_getinoctree_v", 'GIO', getinoctree );
    clazz->AddCmd("v_setselectable_b", 'SSEL', setselectable );
    clazz->AddCmd("b_getselectable_v", 'GSEL', getselectable );
    clazz->AddCmd("v_sethasside_b", 'SHS', sethasside );
    clazz->AddCmd("b_gethasside_v", 'GHS', gethasside );
    clazz->AddCmd("b_held_v", 'H', held );
    clazz->AddCmd("v_setheld_b", 'SH', setheld );
    clazz->AddCmd("v_select_v", 'SEL', select );
    clazz->AddCmd("v_deselect_v", 'DSEL', deselect );
    clazz->AddCmd("b_selected_v", 'SLD', selected );

    clazz->AddCmd("v_ci_si", 'CI', ci );
    clazz->AddCmd("v_si_si", 'SI', si );
    clazz->AddCmd("i_gi_s", 'GI', gi );

    clazz->AddCmd("v_cf_sf", 'CF', cf );
    clazz->AddCmd("v_sf_sf", 'SF', sf );
    clazz->AddCmd("v_ssf_sf", 'SSF', ssf );
    clazz->AddCmd("f_gf_s", 'GF', gf );
    
    clazz->AddCmd("v_cv_sfff", 'CV', cv );
    clazz->AddCmd("v_sv_sfff", 'SV', sv );
    clazz->AddCmd("v_cvx_sf", 'CVX', cvx );
    clazz->AddCmd("v_svx_sf", 'SVX', svx );
    clazz->AddCmd("v_cvy_sf", 'CVY', cvy );
    clazz->AddCmd("v_svy_sf", 'SVY', svy );
    clazz->AddCmd("v_cvz_sf", 'CVZ', cvz );
    clazz->AddCmd("v_svz_sf", 'SVZ', svz );
    clazz->AddCmd("fff_gv_s",  'GV', gv );

    clazz->AddCmd("v_cq_sffff", 'CQ', cq );
    clazz->AddCmd("v_sq_sffff", 'SQ', sq );
    clazz->AddCmd("v_cr_sfff", 'CR', cr );
    clazz->AddCmd("v_sr_sfff", 'SR', sr );
    clazz->AddCmd("ffff_gq_s",  'GQ', gq );

    clazz->AddCmd("v_cs_ss", 'CS', cs );
    clazz->AddCmd("v_ss_ss", 'SS', ss );
    clazz->AddCmd("s_gs_s",  'GS', gs );
    
    clazz->AddCmd("v_cref_ss", 'CRF', cref );
    clazz->AddCmd("v_sref_ss", 'SRF', sref );
    clazz->AddCmd("s_gref_s",  'GRF', gref );
    
    clazz->AddCmd("v_ssv_sfff", 'SSV', ssv );
    clazz->AddCmd("v_sss_ss",   'SSS', sss );
    clazz->AddCmd("v_ssref_ss", 'SSRF', ssref );
    clazz->AddCmd("v_saverc_ss",  'SRC', saverc );
    clazz->AddCmd("v_loadrc_ss",  'LRC', loadrc );
    clazz->AddCmd("v_editrc_s",  'ERC', editrc );

    clazz->AddCmd("i_getsidehandle_v", 'GSH', getsidehandle );
    clazz->AddCmd("v_exportchannel_s", 'EC', exportchannel );

    clazz->EndCmds();
}

bool
nEnt::SaveCmds(nPersistServer* ps)
{
    int i;
    if (nThing::SaveCmds(ps))
    {
        nCmd* cmd;
        cmd = ps->GetCmd( this, 'SNVS');
        cmd->In()->SetB( this->GetNeedsVis() );
        ps->PutCmd( cmd );
        cmd = ps->GetCmd( this, 'SIO');
        cmd->In()->SetB( this->GetInOctree() );
        ps->PutCmd( cmd );
        cmd = ps->GetCmd( this, 'SSEL');
        cmd->In()->SetB( this->GetSelectable() );
        ps->PutCmd( cmd );
        cmd = ps->GetCmd( this, 'SHS' );
        cmd->In()->SetB( this->GetHasSide() );
        ps->PutCmd( cmd );

        for( i = 0; i < varParents.Size(); i ++ ){
            cmd = ps->GetCmd( this, 'IHRT');
            cmd->In()->SetS( varParents[i]->get()->FullNameString().Get() );
            ps->PutCmd( cmd );
        }
        for( i = 0; i < channelsToExport.Size(); i ++ ) {
            cmd = ps->GetCmd( this, 'EC' );
            cmd->In()->SetS( channelsToExport[i].Get() );
            ps->PutCmd( cmd );
        }
        for( i = 0; i < exportedChannels.Size(); i ++ ) {
            cmd = ps->GetCmd( this, 'EC' );
            cmd->In()->SetS( exportedChannels[i].channelName );
            ps->PutCmd( cmd );
        }
        return true;
    }
    return false;
}

