#define N_IMPLEMENTS nGameServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nent.h"
#include "enkiduo/ngameserver.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nGameServer*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( getdrawgrid ){
    outb( self->GetDrawGrid() );
}
command( getdrawaxis){
    outb( self->GetDrawAxis() );
}
command( getdrawscreengrid ){
    outb( self->GetDrawScreenGrid() );
}
command( setdrawgrid ) {
    self->SetDrawGrid( inb() );
}
command( setdrawaxis ){
    self->SetDrawAxis( inb() );
}
command( setdrawscreengrid ) {
    self->SetDrawScreenGrid( inb() );
}
command( settickscript ){
    self->SetTickScript( ins() );
}
command( setvisualizecollision ){
    self->SetVisualizeCollision( inb() );
}
command( getvisualizecollision ){
    outb( self->GetVisualizeCollision() );
}
command( start ){
    self->Start();
}
command( stop ){
    self->Stop();
}
command( genent ) {
    const char* type = ins();
    const char* path = ins();
    if( strcmp( path, "default" ) == 0 )
        path = 0;
    const char* name = ins();
    if( strcmp( name, "default" ) == 0 )
        name = 0;
    nEnt* e = self->GenEnt( type, path, name );
    outs( e?e->fn:"none" );
}
command( addnonbusyscript ) {
    self->AddNonBusyScript( ins() );
}
command( setholdmouse ) {
    self->SetHoldMouse( inb() );
}
command( setsimple ) { 
    self->SetSimple( inb() );
}
command( runtclscript ) {
	self->RunTCLScript( ins() );
}
command( mainloop ) {
	outb( self->MainLoop() );
}
command( pushsel){
    self->PushSel(ins() );
}
command( popsel ){
    outs( self->PopSel() );
}
command( exists){
    outb( self->Exists( ins() ) );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_settickscript_s", 'STS', settickscript );
    clazz->AddCmd( "v_start_v", 'STAR', start );
    clazz->AddCmd( "v_stop_v", 'STOP', stop );
    clazz->AddCmd( "v_setdrawgrid_b", 'SDG', setdrawgrid );
    clazz->AddCmd( "v_setdrawaxis_b", 'SDA', setdrawaxis );
    clazz->AddCmd( "v_setdrawscreengrid_b", 'SDSG', setdrawscreengrid );
    clazz->AddCmd( "b_getdrawgrid_v", 'GDG', getdrawgrid );
    clazz->AddCmd( "b_getdrawaxis_v", 'GDA', getdrawaxis );
    clazz->AddCmd( "b_getdrawscreengrid_v", 'GDSG', getdrawscreengrid );
    clazz->AddCmd( "b_getvisualizecollision_v", 'GVC', getvisualizecollision );
    clazz->AddCmd( "v_setvisualizecollision_b", 'SVC', setvisualizecollision );
    clazz->AddCmd( "s_genent_sss", 'GE', genent );
    clazz->AddCmd( "v_addnonbusyscript_s", 'ANBS', addnonbusyscript );
    clazz->AddCmd( "v_setholdmouse_b", 'SHM', setholdmouse );
    clazz->AddCmd( "v_setsimple_b", 'SS', setsimple );
    clazz->AddCmd( "v_runtclscript_s", 'RTCL', runtclscript );
    clazz->AddCmd( "b_mainloop_v", 'ML', mainloop );
    clazz->AddCmd( "v_pushsel_s", 'PUSS', pushsel );
    clazz->AddCmd( "s_popsel_v", 'POPS', popsel );
    clazz->AddCmd( "b_exists_s", 'EXS', exists );
    clazz->EndCmds();
}

bool
nGameServer::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        //nCmd* cmd;
        return true;
    }
    return false;
}

