#define N_IMPLEMENTS nMessageServer
//------------------------------------------------------------------------------
//  (C) 2003	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nmessageserver.h"
#include "enkiduo/ntriggerserver.h"

nNebulaScriptClass(nMessageServer, "nthing");

//------------------------------------------------------------------------------
/**
*/
nMessageServer::nMessageServer():
    root( kernelServer, this )
{
}

void nMessageServer::Initialize()
{
    nThing::Initialize();
    heap.initialize( 128 );
    root = "/game";
    this->AddToTriggerList();
}
//------------------------------------------------------------------------------
/**
*/
nMessageServer::~nMessageServer()
{
}

void nMessageServer::Send( nMessage* m){
    if( m->time < 0.0f )
        m->time = time;
    heap.add( m->time, m );
}

void nMessageServer::Tick( float time, float dtime ){
    this->time = time;
    prof->Begin("messages");
    ifvalid( root ) {
        while( heap.length() > 0 ){
            nMessage* m;
            m = heap.top();
            if( m->time < time ){
                if( n_fequal( m->time, 0.0f, .001f ) )
                    m->time = time;
                //n_printf("sending message %s\n", m->toString() );
                root->Message( m );
                heap.pop();
                delete m;
            }
            else
                break;
        }
    } 
    prof->End("messages");
}

void nMessageServer::SetTime( float f ){
    time = f;
}
