#define N_IMPLEMENTS nOpenALServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nopenalserver.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nOpenALServer*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( initbuffers ) { 
    self->InitBuffers( ini() );
}
command( loadwav ) { 
    const char* name = ins();
    const char* filename = ins();
    self->LoadWav( name, filename );
}
command( play ) {
    self->Play( ins() );
}
command( stop ) { 
    self->Stop( ins() );
}
command( startloop ) {
    self->StartLoop( ins() );
}
command( setdopplercoef ) {
    self->SetDopplerCoef( inf() );
}
command( getdopplercoef ){
    outf( self->GetDopplerCoef() );
}
command( setcameravelcoef ) {
    self->SetCameraVelCoef( inf() );
}
command( getcameravelcoef ){
    outf( self->GetCameraVelCoef() );
}
command( createEmitter ) {
    outi(self->CreateEmitter(ins()));
}
command( updateEmitter ){
    int handle = ini();

    vector3 pos;
    pos.x = inf();
    pos.y = inf();
    pos.z = inf();

    vector3 vel;
    vel.x = inf();
    vel.y = inf();
    vel.z = inf();

    self->UpdateEmitter( handle, pos, vel );
}
command( queue ) {
    int handle = ini();
    const char* filename = ins();
    self->Queue( handle, filename );
}
command( stopPlaying ) {
    self->StopPlaying( ini() );
}
command( setGain ) {
    int handle = ini();
    float gain = inf();
    self->SetGain( handle, gain );
}
command( setPitch ) {
    int handle = ini();
    float pitch = inf();
    self->SetPitch( handle, pitch );
}
command( setLooping ) {
    int handle = ini();
    bool looping = inb();
    self->SetPitch( handle, looping );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_initbuffers_i", 'IB', initbuffers );
    clazz->AddCmd("v_loadwav_ss", 'LW', loadwav );
    clazz->AddCmd("v_play_s", 'PLAY', play );
    clazz->AddCmd("v_stop_s", 'STOP', stop);
    clazz->AddCmd("v_startloop_s", 'SLOP', startloop );
    clazz->AddCmd("v_setdopplercoef_f", 'SDC', setdopplercoef );
    clazz->AddCmd("f_getdopplercoef_v", 'GDC', getdopplercoef );
    clazz->AddCmd("v_setcameravelcoef_f", 'SCVC', setcameravelcoef );
    clazz->AddCmd("f_getcameravelcoef_v", 'GCVC', getcameravelcoef );
    clazz->AddCmd("i_createEmitter_s", 'CEMI', createEmitter );
    clazz->AddCmd("v_createEmitter_iffffff", 'UEMI', updateEmitter );
    clazz->AddCmd("v_queue_is", 'QUE', queue );
    clazz->AddCmd("v_stopPlaying_i", 'STP', stopPlaying );
    clazz->AddCmd("v_setGain_if", 'STGA', setGain );
    clazz->AddCmd("v_setPitch_if", 'SPTCH', setPitch );
    clazz->AddCmd("v_setLooping_ib", 'SLP', setLooping );
    clazz->EndCmds();
}

bool
nOpenALServer::SaveCmds(nPersistServer* ps)
{
    if (nThing::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}

