#define N_IMPLEMENTS nVarServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nvarserver.h"

nNebulaScriptClass(nVarServer, "nthing");

//------------------------------------------------------------------------------
/**
*/
nVarServer::nVarServer()
{
}

void nVarServer::Initialize(){
    nThing::Initialize();
    AddLogTag("varserver");
}

nVarServer::~nVarServer(){
}
//------------------------------------------------------------------------------
/**
*/

void nVarServer::Tick( float time, float dtime ){
    nThing::Tick( time, dtime );
}


const char* nVarServer::VarToString( nVar* v ){
    int type = v->GetType();
    char* s = new char[1024];
    vector3 vec;
    quaternion q;
    switch( type ) {
        case VARTYPE_VOID:
            s = "";
            break;
        case VARTYPE_INT:
            sprintf( s, "%i", v->GetI() );
            break;
        case VARTYPE_FLOAT:
            sprintf( s, "%f", v->GetF() );
            break;
        case VARTYPE_VECTOR3:
            vec = v->GetV();
            sprintf( s, "%f %f %f", vec.x, vec.y, vec.z );
            break;
        case VARTYPE_QUATERNION:
            q = v->GetQ();
            sprintf( s, "%f %f %f %f", q.x, q.y, q.z, q.w );
            break;
        case VARTYPE_STRING:
            sprintf( s, "%s", v->GetS().Get() );
            break;
    }
    return s;
}

void nVarServer::AddVar( nVar* nvar ) {
    char fullname[1024];
    nvar->GetFullName( fullname, 1024 );
    //log("%s->addvar(%s)", fn, fullname);
    var* v = new var();
    v->Connect( nvar );
    vars.Append( v );
}

void nVarServer::AddVar( const char* parentName, const char* varName ){
    //log("%s->AddVar(%s,%s)", fn, parentName, varName );
    this->AddVar( (nEnt*) kernelServer->Lookup( parentName ), varName );
}

void nVarServer::AddVar( nEnt* parent, const char* varName ){
    if( parent == 0 ) 
        log("could not add server var, parent not found");
    if( varName == 0 ) 
        log("could not add server var, varname bad");
    //log("%s->AddVar(%s, %s)", fn, parent->GetName(), varName );
    n_assert( parent && varName );
    var* v = new var();
    v->Connect( parent, varName );
    vars.Append( v );
}
void nVarServer::RemoveVar( const nVar* nvar ) {
    for( int i = 0; i < vars; i ++ ) {
        if( vars[i].v->GetVar() == nvar ) { //its pointing to this var
            delete vars[i].v;
            vars.Erase( i );
            i--;
        }
    }
}

nString nVarServer::Sum(){
    nString answer;
    for( int i = 0; i < vars; i ++ ) {
        VarInfo& v = vars[i];
        nString line;
        line.PrintF("var[%i]=%s", v.id, v.toString().Get() );
        answer += line;
    }
    return answer;
}
