#define N_IMPLEMENTS nXMLServer
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "enkiduo/nxmlserver.h"

nNebulaScriptClass(nXMLServer, "nthing");

//------------------------------------------------------------------------------
/**
*/
nXMLServer::nXMLServer():
    xml( 0 ),
    ptrptr(0),
	type( 0 ),
	tag( 0 ),
	txt( 0 ),
	reachedEnd( false )
{
}

void nXMLServer::Initialize(){
    nThing::Initialize();
}

nXMLServer::~nXMLServer(){
}
//------------------------------------------------------------------------------
/**
*/


void nXMLServer::ParseXML( const char* s ) {
    n_assert( s && "trying to parse an empty string" );
    if( xml != 0 ) { 
        n_printf ( "trying to do recursive parsing - not fully supported" );
        delete[] xml;
    }
    xml = new char[strlen(s)+1];
    strcpy( xml, s );
}
void nXMLServer::DoneParsing(){
    if( xml ) {
        delete[] xml;
        xml = 0;
        ptrptr = 0;
    }
}
/**
  Parses out the next tag from the xml file
  @return are there pieces left

<GA>
    <POPSIZE> 20 </POPSIZE>
    <NUMGENS> 20 </NUMGENS>
    <MUTATIONPROB> .10 </MUTATIONPROB>
    <CROSSOVERPROB> .75 </CROSSOVERPROB>
</GA>
*/
void strip( char*& s ){
    for( int i = 0; s[i] != '\0'; i ++ ) {
        char c = s[i];
        s[i] = tolower( c );
    }
    while( s[0] == ' ' || s[0] =='\t' || s[0] == '\n' ) {
        s[0] = '\0';
        //printf("stripping from front of |%s|\n", s );
        s++;
    }
    int l = strlen(s)-1;
    while( s[l] == ' ' || s[l] == '\t' || s[l] == '\n') {
        s[l] = '\0';
        l--;
    }
}

bool nXMLServer::Next(){
    /*
       if( reachedEnd ) {
       delete[] xml;
       xml = 0;
       ptrptr = 0;
       reachedEnd = false;
       return false;
       }
       if( ptrptr == 0 ) {
       ptrptr = xml;
       n_assert( ptrptr );
       while( *ptrptr != '\0' && *ptrptr != '<' ) {
       n_printf("skippin g char: %c\n", *ptrptr );
       ptrptr++;
       }
       if( *ptrptr != '<' ) {
       n_printf("failed to find first tag\n");
       return false;
       }
     *ptrptr = '\0';
     ptrptr++;
     n_printf("first next call: aligned too: %c\n", *ptrptr );
     }
     tag = ptrptr;
     while( *ptrptr != '>' ) {
     if( ptrptr == '\0' ) {
     n_printf("failed finding tag closure\n");
     return false;
     }
     ptrptr++;
     }
     *ptrptr = '\0';
     ptrptr++;
     txt = ptrptr;
     while( ptrptr && *ptrptr != '<' && *ptrptr != '\0' ) {
     ptrptr ++;
     if( *ptrptr == '\0' ) {
     reachedEnd = true;
     }
     }
     return true;

     */
    //toss the very first / - setup the strtok
    if( ptrptr == 0 ) {
        if( xml[0] == '<' ) {//starts with the delimiter - which screws up strtok..so hack a lil around it
            ptrptr = xml+1;
        } else {
            strtok_r ( xml, "<", &ptrptr );
        }
    }

    tag = strtok_r( 0, ">", &ptrptr );
    if( tag == 0 ) {
        delete[] xml;
        xml = 0;
        ptrptr = 0;
        return false;
    }
    //check for closing tag
    if( tag[0] == '/' ) {
        type = "close";
        tag++;
    }
    else
        type = "open";
    strip( tag );
    if ( ptrptr[0] == '<' ) {
        txt = 0;
        ptrptr++;
    }
    else
        txt = strtok_r( 0, "<", &ptrptr );
    if( txt )
        strip( txt );
    else
        txt = "";
    return true;
}
