#define N_IMPLEMENTS nGAMimicBlue
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "ga/ngamimicblue.h"

nNebulaScriptClass(nGAMimicBlue, "ngablue");

//------------------------------------------------------------------------------
/**
*/
nGAMimicBlue::nGAMimicBlue()
{
    this->AddLogTag("ngamimicblue");
}

void nGAMimicBlue::Initialize(){
    nGABlue::Initialize();
    this->AddToDisplayList();
    this->AddToTriggerList();
}

void nGAMimicBlue::InitVars(){
    nGABlue::InitVars();
}

nGAMimicBlue::~nGAMimicBlue(){
}
//------------------------------------------------------------------------------
void nGAMimicBlue::Tick( float time, float dtime ){
    nGABlue::Tick( time, dtime );
    for( int i = 0; i < lines; i ++ )
        this->DrawLine( lines[i].x, lines[i].y, blue );
    for( int i = 1; i < gaPath; i +=2 )
        this->DrawLine( gaPath[i-1], gaPath[i], yellow );
    for( int i = 1; i < humanPath; i +=2 )
        this->DrawLine( humanPath[i-1], humanPath[i], white );
}
//-----------------------------------------------------------------------------//
///checks if the evaluation is done - always true in our case
//-----------------------------------------------------------------------------//
///10% of the time just pretend im not done - to keep things from locking too much
bool nGAMimicBlue::IsEvaluationDone(){
    //log("IsEvaluationDone()\n");
    return roll(.3); 
}
//-----------------------------------------------------------------------------//
///All we need to really reset is umm...
///Oh yes..we need to reset the paths for each wp, because that is what we are going to load.
///As a caviat on the first run - we need to run the regular loading so that everything starts off nice and hunky doory
//-----------------------------------------------------------------------------//
void nGAMimicBlue::ResetWorld( nGenome* genome ) {
    static int i = 0;
    log("nGAMimicBlue::ResetWorld()\n");
    //FIXME---why is this neccessary - without it it converges on crap solutions
    //n_sleep(.01);
    if( i++ == 0 )
        nGABlue::ResetWorld( genome );
    else {
        nRoot* platformRoot = kernelServer->Lookup("/game/ents/platform");
        foreachchild( nEnt, platform, platformRoot ) {
            nRoot* ais = platform->Find("ai");
            foreachchild( nThing, ai, ais ) {
	ai->Die();
            }
        }
    }
    //nGABlue::ResetWorld( genome );
}
//-----------------------------------------------------------------------------//
/**
 * Parses out the resulting fitness -> the fun part
 * So how do we do this? hmmm
 * okay so we if look through every wp for every platform and compare its distance to known lines for the human plan
 * then we should get a decent measure of how far away they are from each other
 * total distanceOff = 0
 * foreach platform
 *   foreach wp
 *     distanceOff += distancePointToLine( wp, lines )
 */
//-----------------------------------------------------------------------------//
float nGAMimicBlue::ParseFitness(){                          	//called when a game is over to parse out the fitness
    log("ParseFitness()\n");
    nArray<vector3> destinations = this->GetPlatformDestinations(&gaPath);
    float totalDistance = 0.0f;
    lines.Clear();
    //log("destinations:%i\n", destinations.Size() );
    //log("humanWPs:%i\n" ,humanWPs.Size() );
    for( int i = 0; i < destinations; i ++ ) {
        int minIndex;
        float minLen;
        for( int j = 0; j < humanWPs; j ++ ) {
            float d = (humanWPs[j] - destinations[i]).len();
            if ( j == 0 || d < minLen ) {
	minIndex = j;
	minLen = d;
            }
        }
        //log("minLen:%f\n", minLen );
        totalDistance += minLen * minLen;
        LineInfo li;
        li.x = destinations[i];
        li.y = humanWPs[minIndex];
        lines.Append( li );
    }
    float fitness = -1.0f * totalDistance / pow(destinations.Size(),2.0);
    log("numDestinations: %i humanWPs: %i totalDistance:%f fitness:%f\n", destinations.Size(), humanWPs.Size(), totalDistance, fitness );
    return fitness;
}
//-----------------------------------------------------------------------------//
///the human plan is loaded - parse out the information we need from it
//-----------------------------------------------------------------------------//
void nGAMimicBlue::MarkGoalPlan(){
    log("MarkGoalPlan()\n");
    humanWPs.Clear();
    humanWPs = this->GetPlatformDestinations(&humanPath);
}
//-----------------------------------------------------------------------------//
nArray<vector3> nGAMimicBlue::GetPlatformDestinations(nArray<vector3>* path) {
    nArray<vector3> destinations;
    path->Clear();
    nRoot* platformRoot = kernelServer->Lookup("/game/ents/platform");
    foreachchild( nEnt, platform, platformRoot ) {
        //log("platform:%s\n", platform->fn );
        nRoot* vars = platform->Find( "vars" );
        if( vars == 0 ) continue;
        nRoot* destinationRoot = vars->Find("destination");
        if( destinationRoot == 0 ) continue;
        nVar* lastDestination = 0;
        foreachchild( nVar, destination, destinationRoot ) {
            if( lastDestination )
	path->Append( lastDestination->GetV() );
            //log("  destination:%s\n", str( destination->GetV()) );
            destinations.Append( destination->GetV() );
            path->Append( destination->GetV() );
        }
    }
    return destinations;
}
