#define N_IMPLEMENTS nIMEnt
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/niment.h"
#include "aspect/nside.h"

nNebulaScriptClass(nIMEnt, "nim");

//------------------------------------------------------------------------------
nIMEnt::nIMEnt() {
}
//------------------------------------------------------------------------------
void nIMEnt::Initialize(){
    nIM::Initialize();
    //n_printf("nIMEnt::nIMEnt(%s)\n", this->fn);
}
//------------------------------------------------------------------------------
void nIMEnt::InitVars(){
    nIM::InitVars();
}
//------------------------------------------------------------------------------
nIMEnt::~nIMEnt(){
}
//------------------------------------------------------------------------------
void nIMEnt::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
//
/*
struct EntInfo {
    vector3 pos;
    vector3 coord;
    float value;
    float radius;
    float cradius;
};
*/
//-----------------------------------------------------------------------------//
void nIMEnt::calculateValues(void** v) {
    struct Info {
        nArray<EntInfo> entInfo;
    };
    Info* info = (Info*) (*v);
    if ( *v == NULL ) {
        info = new Info();
        this->clearVals();
        info->entInfo = this->GetEntInfo( this->func, this->who, this->radius );
        *v = info;
        return; //enough for now
    } 
    if ( info->entInfo.Size() > 0 ) {
        for( int step = 0; step < steps.GetI() && info->entInfo.Size() > 0; step++ ) {
            EntInfo ei = info->entInfo.Pop();
            //n_printf("applying entInfo [%s,%f,%f]\n", str(ei.pos), ei.value, ei.radius);
            int minX = (int)(ei.coord.x - ei.cradius -.5f);
            int minY = (int)(ei.coord.z - ei.cradius -.5f);
            int maxX = (int)(ei.coord.x + ei.cradius +1.5f);
            int maxY = (int)(ei.coord.z + ei.cradius +1.5f);
            //n_printf("%i,%i->%i,%i\n", minX, minY, maxX, maxY);

            minX = n_clamp(minX, 0, res);
            minY = n_clamp(minY, 0, res);
            maxX = n_clamp(maxX, 0, res);
            maxY = n_clamp(maxY, 0, res);
            //n_printf("%i,%i->%i,%i\n", minX, minY, maxX, maxY);

            for ( int x = minX; x < maxX; x ++ ) {
                for( int y = minY; y < maxY; y ++ ) {
                    vector3& point = points[x][y];
                    //n_printf("points[%i][%i]=%s\n", x,y,str(point));
                    float d = (point - ei.pos).len();
                    //n_printf("d:%f\n", d);
                    if ( d < ei.radius ) {
                        switch( this->ipol ) {
                            case FLAT:
                                vals[x][y] += ei.value;
                                break;
                            case LINEAR:
                                vals[x][y] += ei.value * (1-(d / ei.radius));
                                break;
                            case INV_LINEAR:
                                vals[x][y] += ei.value * (d / ei.radius);
                                break;
                        }
                    }
                    //n_printf("val:%f\n", vals[x][y]);
                }
            }
        } 
        if( this->displayed )
            this->calcNormVals();
    } else {
        this->calcNormVals();
        this->findMaxMinPoints();
        delete info;
        *v = NULL;
    }
}

//-----------------------------------------------------------------------------//
///STEP 1: DETERMINE WHICH ENTS I SHOULD BE LOOKING AT
//bounced to nside now
//-----------------------------------------------------------------------------//
EntArray nIMEnt::GetEnts( WHO who ) {
    EntArray ents;
    nSide* mySide = (nSide*) ent->Find("side");
    n_assert( mySide );
    switch( who ){
        case FRIENDS:
            return *(mySide->GetUnits());
        case ENEMIES:
            ents = *(mySide->GetHostileUnits());
            foreacht( nEnt*, ent, ents){
                if( ent->HasVar("stealthPoints") && ent->GetVarF("stealthPoints") > 0.0f ) {
                    //n_printf("not counting hidden enemy: %s\n", str(ent));
                    ents.Remove( ent );
                }
            }
            return ents;
        case NEUTRALS:
            return *(mySide->GetNeutralUnits());
        default:
            n_printf("warning nIMEnt(%s)::GetEnts called with invalid who(%i)\n", str(this), who);
            return *(mySide->GetUnits());
    }
}
//-----------------------------------------------------------------------------//
//convert the ents i want into the nice array of ent info
//-----------------------------------------------------------------------------//
nArray<nIMEnt::EntInfo> nIMEnt::GetEntInfo( FUNCS func, WHO who, RADII radius)  {
    //n_printf("%s calculateValues initially\n", this->fn);
    nArray<EntInfo> entInfo;
    EntArray ents = this->GetEnts( who );

    //nEnt* myGroup = this->myGroup.GetRef();
    //if ( myGroup == 0 )
        //return entInfo;
    //-----------------------------------------------------------------------------//
    //search for the shortest/longest range weapon in my group
    //-----------------------------------------------------------------------------//
    //float myGroupsShortestWeaponRange = -1;
    //float myGroupsLongestWeaponRange = -1;
    //if (radius == MY_WEAPON) {
        //foreachchild(nEnt, myGroupMember, myGroup){
            //myGroupMember = (nEnt*) kernelServer->Lookup(myGroupMember->GetVarS("path"));
            //n_assert(myGroupMember);
            //float range = myGroupMember->GetVarF("imWeaponRadius");
            //if( myGroupsShortestWeaponRange < 0 || range < myGroupsShortestWeaponRange )
                //myGroupsShortestWeaponRange = range;
            //if( myGroupsLongestWeaponRange < 0 || range > myGroupsLongestWeaponRange )
                //myGroupsLongestWeaponRange = range;
        //}
        //n_printf("myGroupsShortestWeaponRange: %f myGroupsLongestWeaponRange: %f\n", myGroupsShortestWeaponRange, myGroupsLongestWeaponRange);
    //}
    //-----------------------------------------------------------------------------//
    //FOREACH ENT -> PULL THE RELAVENT LOCATION / RADIUS / VALUE
    //-----------------------------------------------------------------------------//
    for( int i = 0; i < ents; i ++ ) {
        EntInfo& ei = entInfo.Push();
        ei.ent = ents[i];
        ei.pos = ents[i]->GetVarV("pos");
        ei.rot = ents[i]->GetVarQ("rot");
        float f1, f2;
        switch(func){
            case VALUE_OVER_THREAT:
                if ( ents[i]->HasVar("imValue"))                            f1 = ents[i]->GetVarF("imValue");
                else                                                        f1 = 1.0f;
                if ( ents[i]->HasVar("imThreat"))                           f2 = ents[i]->GetVarF("imThreat");
                else                                                        f2 = 1.0f;
                ei.value = f1 / f2;
                break;
            case POWER:
                if ( ents[i]->HasVar("imPower"))                            f1 = ents[i]->GetVarF("imPower");
                else                                                        f1 = 10;
                ei.value = f1;
                break;
        }
        switch(radius) {
            case AREA:
                if ( ents[i]->HasVar("imArea"))                             ei.radius = ents[i]->GetVarF("imArea");
                else                                                        ei.radius = 1000.0f;
                break;
            case WEAPON:
                if ( ents[i]->HasVar("imWeaponRadius"))                     ei.radius = ents[i]->GetVarF("imWeaponRadius");
                else
                    ei.radius = 200.0f;
                break;
            case COLLISION_AVOIDANCE_RADIUS:
                if ( ents[i]->HasVar("collisionAvoidanceRadius"))           ei.radius = ents[i]->GetVarF("collisionAvoidanceRadius");
                else                                                        ei.radius = 500.0f; //1000.0f sushil
                break;
            //case MY_WEAPON:
                //ei.radius = myGroupsShortestWeaponRange;
        }
        //n_printf("entInfo[%i] = [%s,%f,%f]\n", i, str(ei.pos), ei.value, ei.radius);
        vector3 wmin = worldMin.GetV();
        vector3 wmax = worldMax.GetV();
        vector3 range = wmax - wmin;
        n_assert(range.x>=0.0f && range.y >= 0.0f && range.z >= 0.0f && "worldmax is somehow less then worldmin");
        if (range.x < 1 ) range.x = 1;
        if (range.y < 1 ) range.y = 1;
        if (range.z < 1 ) range.z = 1;
        ei.coord.x = (ei.pos.x - wmin.x )/ range.x * res;
        ei.coord.y = (ei.pos.y - wmin.y )/ range.y * res;
        ei.coord.z = (ei.pos.z - wmin.z )/ range.z * res;

        ei.radius *= radiusCoef;
        ei.cradius = ei.radius * res / range.x;
        if ( ents[i]->HasVar("dimension"))
            ei.dimension = ents[i]->GetVarV("dimension");
    }
    return entInfo;
}
