#define N_IMPLEMENTS nIMFuser
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimfuser.h"
#include "enkiduo/neventserver.h"

nNebulaScriptClass(nIMFuser, "nim");

//------------------------------------------------------------------------------
nIMFuser::nIMFuser():
ref_eventServer( kernelServer, this ){
    this->imAssignEvent = 0;
}
//------------------------------------------------------------------------------
void nIMFuser::Initialize(){
    nIM::Initialize();
    ref_eventServer = "/sys/servers/event";
}
//------------------------------------------------------------------------------
void nIMFuser::InitVars(){
    nIM::InitVars();
}
//------------------------------------------------------------------------------
nIMFuser::~nIMFuser(){
}
//------------------------------------------------------------------------------
void nIMFuser::Tick( float time, float dtime ){
    nIM::Tick( time, dtime );
}
enum States {
    FIND_CHILD,
    TRIGGER_EVENT,
};
struct FuserInfo {
    States state;
    nIM* maxIM;
    nIM* minIM;
    FuserInfo(){
        state = FIND_CHILD;
        maxIM = 0;
        minIM = 0;
    }
};
//-----------------------------------------------------------------------------//
void nIMFuser::calculateValues(void** const v){
    FuserInfo* info = (FuserInfo*) (*v);
    //n_printf("calcVals:%p\n", v);
    if ( *v == NULL ) {
        info = new FuserInfo();
        *v = info;
    }
    //n_printf("nIMFuser::calculateValues() state=%i\n", info->state);
    if ( info->state == FIND_CHILD ) {
        //CALCULATE POINT
        float minValFound, maxValFound;
        int minxFound, minyFound, maxxFound, maxyFound;

        bool first = true;
        foreachchild(nIM, im, this){
            int minx, miny, maxx, maxy;
            im->getMinMaxCoords(minx, miny, maxx, maxy);
            float minVal = im->getFinalVal(minx, miny);
            float maxVal = im->getFinalVal(maxx, maxy);
            //n_printf("child:%s\n", im->fn);
            //n_printf("    min:[%i,%i]->%f\n", minx, miny, minVal);
            //n_printf("    max:[%i,%i]->%f\n", maxx, maxy, maxVal);
            if ( info->minIM == 0 || minVal < minValFound ) {
                minValFound = minVal;
                minxFound = minx;
                minyFound = miny;
                info->minIM = im;
            }
            if ( info->maxIM == 0 || maxVal < maxValFound ) {
                maxValFound = maxVal;
                maxxFound = maxx;
                maxyFound = maxy;
                info->maxIM = im;
            }
        }
        //n_printf("min:[%i,%i]->%f\n", minxFound, minyFound, minValFound);
        //n_printf("max:[%i,%i]->%f\n", maxxFound, maxyFound, maxValFound);
        this->clearVals();
        this->vals[minxFound][minyFound] = minValFound;
        this->vals[maxxFound][maxyFound] = maxValFound;
        this->calcNormVals();
        this->findMaxMinPoints();
        info->state = TRIGGER_EVENT;
    } else if (info->state == TRIGGER_EVENT ) {
        //now we have to actually assign the variables to our classes / determine the behavior
        bool takeMax = true;
        if ( takeMax ) {
            const char* behavior = info->maxIM->getBehavior();
            //n_printf("taking behavior(%s) from maxIM(%s)\n", behavior, maxIM->fn);
            vector3 point = info->maxIM->getPoint(maxx, maxy);
            //n_printf("point:%s\n", str(point));
            ifvalid(ref_eventServer){
                nString event;
                event.PrintF("%s;%s;%s", ent->fn, behavior, str(point));
                ref_eventServer->pull(imAssignEvent, "imAssign", event.Get());
            }
        }
        delete info;
        *v = NULL;
    }
}
