#define N_IMPLEMENTS nIMRadial
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimradial.h"

nNebulaScriptClass(nIMRadial, "niment");

//------------------------------------------------------------------------------
nIMRadial::nIMRadial() {
    this->thetaOffset = 0;
    this->thetaWidth = 30;
}
//------------------------------------------------------------------------------
void nIMRadial::Initialize(){
    nIMEnt::Initialize();
}
//------------------------------------------------------------------------------
void nIMRadial::InitVars(){
    nIMEnt::InitVars();
}
//------------------------------------------------------------------------------
nIMRadial::~nIMRadial(){
}
//------------------------------------------------------------------------------
void nIMRadial::Tick( float time, float dtime ){
    nIMEnt::Tick( time, dtime );
}

void nIMRadial::calculateValues(void** v) {
    struct Info {
        nArray<EntInfo> fromEnts;
        nArray<EntInfo> toEnts;
        nArray<EntInfo> tosLeft;
        EntInfo from;
        bool fromDone;
    };
    Info* info = (Info*) (*v);
    if ( *v == NULL ) {
        info = new Info();
        this->clearVals();
        info->fromEnts = this->GetEntInfo( this->func, this->who, this->radius );
        if( this->to < numWhoStrings )
            info->toEnts = this->GetEntInfo( this->func, this->to, this->radius );
        *v = info;
        info->fromDone = true;
        return;                         //enough for now
    }
    if( info->fromEnts.Size() > 0 || info->fromDone == false ) {
        if( info->fromDone ) {
            info->from = info->fromEnts.Pop();
            info->fromDone = false;
            info->tosLeft = info->toEnts;
        }
        float thetaMax;
        if( to == (WHO) ABSOLUTE ) {
            thetaMax = thetaOffset;
        }
        else if ( to == (WHO) RELATIVE ) {
            n_printf("nIMRadial(%s) does not support relative yet\n", str(this));
            thetaMax = thetaOffset;
        }
        else if ( info->toEnts.Size() > 0 ) {
            EntInfo to = info->toEnts.Pop();
            //n_printf("calculating radials from:%s to %ws\n", str(from.pos), str(to.pos));
            vector3 dt = to.pos - info->from.pos;
            thetaMax = atan2( dt.x, dt.z );
        }
        if( info->toEnts.Size() == 0 )
            info->fromDone = true;
        for( int x = 0; x < res; x ++ ) {
            for(int  y = 0; y < res; y ++ ) {
                vector3 dt = points[x][y] - info->from.pos;
                float theta = atan2(dt.x, dt.z);
                float dtheta = n_rad2deg(fabs(theta - thetaMax));
                float dist = dt.len();
                //n_printf("dt:%s theta:%f dtheta:%f\n", str(dt), theta, dtheta);
                if( dtheta < thetaWidth && dist < info->from.radius)
                    vals[x][y] += (1.0f - (dtheta / thetaWidth)) * (1.0f - dist / info->from.radius);
            }
        }
        if( this->displayed )
            this->calcNormVals();
    } else {
        this->calcNormVals();
        this->findMaxMinPoints();
        delete info;
        *v = NULL;
    }
}
