#define N_IMPLEMENTS nIMVisibility
//------------------------------------------------------------------------------
//  (C) 2006	Chris Miles
//------------------------------------------------------------------------------
#include "im/nimvisibility.h"

nNebulaScriptClass(nIMVisibility, "niment");

//------------------------------------------------------------------------------
nIMVisibility::nIMVisibility() {
}
//------------------------------------------------------------------------------
void nIMVisibility::Initialize(){
    nIMEnt::Initialize();
}
//------------------------------------------------------------------------------
void nIMVisibility::InitVars(){
    nIMEnt::InitVars();
}
//------------------------------------------------------------------------------
nIMVisibility::~nIMVisibility(){
}
//------------------------------------------------------------------------------
void nIMVisibility::Tick( float time, float dtime ){
    nIMEnt::Tick( time, dtime );
}

void nIMVisibility::calculateValues(void** v) {
    struct Info {
        nArray<EntInfo> fromEnts;
        nArray<EntInfo> middleEnts;
        nArray<EntInfo> middleEntsLeft;
        EntInfo from;
        EntInfo middle;
        bool fromDone;
        bool minMaxsCalculated;
        int x;
        nArray<float> minThetas;
        nArray<float> maxThetas;
        nArray<float> distances;
    };
    Info* info = (Info*) (*v);
    if ( *v == NULL ) {
        info = new Info();
        this->clearVals();
        info->fromEnts   = this->GetEntInfo( this->func, this->who, this->radius );
        info->middleEnts = this->GetEntInfo( this->func, NEUTRALS, this->radius );
        *v = info;
        info->fromDone = true;
        return; //enough for now
    }
    if( info->fromEnts.Size() > 0 || info->fromDone == false ) { //we have from ents left
        if( info->fromDone ) { //pop a new from off
            info->from = info->fromEnts.Pop();
            info->fromDone = false;
            info->minMaxsCalculated = false;
            info->middleEntsLeft = info->middleEnts;
            if( info->from.ent->Find("radar") == 0 ) { //skip this enemy he doesn't have radar
                //n_printf("%s has no radar skipping\n", str(info->from.ent) );
                info->fromDone = true;
            }
            info->minThetas.Clear();
            info->maxThetas.Clear();
            return;
        }
        if( info->minMaxsCalculated == false ) {
            while( true ) {
                if ( info->middleEntsLeft.Size() == 0 ) {
                    info->minMaxsCalculated = true;
                    info->x = 0;
                    return;
                } else {
                    info->middle = info->middleEntsLeft.Pop();
                    if( info->middle.ent->GetSelectable() == true && info->middle.ent != info->from.ent ) {
                        break;
                    } 
                }
            } 
            //n_printf("fromEnt:%s middleEnt:%s\n", str(info->from.ent), str(middleEnt.ent));
            float& minTheta = info->minThetas.Push();
            float& maxTheta = info->maxThetas.Push();
            float& distance = info->distances.Push();
            bool first = true;
            float theta;
            vector3 dx;
            dx = info->middle.pos - info->from.pos;
            distance = dx.len();
            for( int k = 0; k < 4; k ++ ) {
                vector3 point = vector3(info->middle.dimension.x * (k / 2 == 0 ? 1:-1), 0, info->middle.dimension.z * (k % 2 == 0 ? 1 : -1));
                point = info->middle.pos + info->middle.rot.rotate( point );
                dx = point - info->from.pos;
                theta = atan2( dx.x, dx.z );
                if ( first || theta < minTheta ) {
                    minTheta = theta;
                }
                if ( first || theta > maxTheta ) { 
                    maxTheta = theta;
                }
                first = false;
            }
            if( maxTheta - minTheta > 3.1415 ) {
                n_swap(minTheta, maxTheta);
            }
            //n_printf("minTheta:%f maxTheta:%f\n", minTheta, maxTheta);
        } else {
            for(int y = 0; y < res; y ++ ) {
                vector3 dt = points[info->x][y] - info->from.pos;
                float distance = dt.len();
                float theta = atan2(dt.x, dt.z);
                //n_printf("x:%i y:%i theta:%f minTheta:%f maxTheta:%f\n", x, y, theta, minTheta, maxTheta );
                for( int i = 0; i < info->minThetas; i ++ ) {
                    if( distance > info->distances[i] ) {
                        float minTheta = info->minThetas[i];
                        float maxTheta = info->maxThetas[i];
                        if ( (theta < maxTheta && theta > minTheta) || ( theta > maxTheta && theta < minTheta) ) {
                            float dtheta = n_min( fabs(maxTheta - theta), fabs( minTheta - theta));
                            vals[info->x][y] += ( dtheta / ((maxTheta - minTheta)/ 2.0f));
                        }
                    }
                }
            }
            info->x++;
            if( info->x >= res )
                info->fromDone = true;
            if( this->displayed )
                this->calcNormVals();
        }
    } else {
        this->calcNormVals();
        this->findMaxMinPoints();
        delete info;
        *v = NULL;
    }
}
