#define N_IMPLEMENTS nDefaultLogHandler
#define N_KERNEL
//------------------------------------------------------------------------------
//  ndefaultloghandler.cc
//  (C) 2003 RadonLabs GmbH
//------------------------------------------------------------------------------
#include "kernel/ndefaultloghandler.h"
#include <string.h>

//------------------------------------------------------------------------------
/**
*/
nDefaultLogHandler::nDefaultLogHandler()
{
    // empty
}

//------------------------------------------------------------------------------
/**
*/
nDefaultLogHandler::~nDefaultLogHandler()
{
    // empty
}

//------------------------------------------------------------------------------
/**
*/
void
nDefaultLogHandler::Print(const char* msg, va_list argList)
{
    vprintf(msg, argList);
    this->PutLineBuffer(msg, argList);
}

//------------------------------------------------------------------------------
/**
*/
void
nDefaultLogHandler::Message(const char* msg, va_list argList)
{
    vprintf(msg, argList);
    this->PutLineBuffer(msg, argList);
}

//------------------------------------------------------------------------------
/**
*/
void
nDefaultLogHandler::Error(const char* msg, va_list argList)
{
    vprintf(msg, argList);
    this->PutLineBuffer(msg, argList);
}

//------------------------------------------------------------------------------
/**
    Return a pointer to the internal line buffer.
*/
nLineBuffer*
nDefaultLogHandler::GetLineBuffer()
{
    return &(this->lineBuffer);
}

//------------------------------------------------------------------------------
/**
    Put a message into the argbuffer.

    @param  prefix  a short message which will be put in front of the actual message
    @param  msg     the actual message
    @param  argList a var args list
*/
void
nDefaultLogHandler::PutLineBuffer(const char* msg, va_list argList)
{
    n_assert(msg);
    int n, size = 100;

    static char* staticArray = new char [10000];

#ifdef __WIN32__
        n = _vsnprintf	(staticArray, 10000, msg, argList);
#else
		n = vsnprintf	(staticArray, 10000, msg, argList);
#endif
    
	
	if( n > -1 && n < 10000 ) {
        this->lineBuffer.Put( staticArray );
        return;
    }
    return;
    char *p = 0;
    if ((p = (char*) n_malloc (size)) != NULL) {
        while (1) {
            /* Try to print in the allocated space. */
#ifdef __WIN32__
			n = _vsnprintf (p, size, msg, argList);
#else
			n = vsnprintf (p, size, msg, argList);
#endif            
            /* If that worked, return the string. */
            if (n > -1 && n < size)
	break;
            /* Else try again with more space. */
            if (n > -1)    /* glibc 2.1 */
	size = n+1; /* precisely what is needed */
            else           /* glibc 2.0 */
	size *= 2;  /* twice the old size */
            if ((p = (char*) realloc (p, size)) == NULL) { //try to reallocate more space
	printf("failed to realloc %s\n", msg);
	free( p );
	p = 0;
	break;
            }
        }
    }
    if( p ) {
        this->lineBuffer.Put(p);
        free( p );
    } else {
        fprintf(stderr, "failed to allocate memory for n_printf\n");
    }
}
