#define N_IMPLEMENTS nBoatMoveTo
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "lagoon/nboatmoveto.h"

nNebulaScriptClass(nBoatMoveTo, "nboatai");

//------------------------------------------------------------------------------
nBoatMoveTo::nBoatMoveTo() {
}
//------------------------------------------------------------------------------
void nBoatMoveTo::Initialize(){
    nBoatAI::Initialize();
    this->AddToDisplayList();
}
//------------------------------------------------------------------------------
void nBoatMoveTo::InitVars(){
    nBoatAI::InitVars();
    destination.Connect(ent, "destination");
    destination.DefaultV(vector3(0,0,0));
}
//------------------------------------------------------------------------------
nBoatMoveTo::~nBoatMoveTo(){
}
//------------------------------------------------------------------------------
void nBoatMoveTo::Tick( float time, float dtime ){
    nBoatAI::Tick( time, dtime );
    vector3 p = pos.GetV();
    vector3 d = destination.GetV();
    if ( d.len() < 5.0f ) { //set to 0.0 -> stop
        desiredSpeed.SetF(0.0f);
        return;
    }
    vector3 dx = d - p;
    dx.y = 0.0f;
    float dist = dx.len();
    if( dist > 5.0f ) { 
        float heading = atan2(dx.x, dx.z);
        desiredHeading.SetF(heading);
        desiredSpeed.SetF(10000.0f);
    } else {
        desiredSpeed.SetF(0.0f);
    }
    this->DrawLine( p, d, white );
}
//-----------------------------------------------------------------------------//
