#define N_IMPLEMENTS nDefensabilityIM
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "map/ndefensabilityim.h"
#include "enkiduo/nent.h"

nNebulaScriptClass(nDefensabilityIM, "ninfluencemap");

//------------------------------------------------------------------------------
/**
*/
nDefensabilityIM::nDefensabilityIM()
{
}

void nDefensabilityIM::Initialize(){
    nInfluenceMap::Initialize();
    this->exp = "[sum (closeness target #myrange) * #value]";
}

nDefensabilityIM::~nDefensabilityIM(){
}
//------------------------------------------------------------------------------
/**
*/

void nDefensabilityIM::Tick( float time, float dtime ){
    nInfluenceMap::Tick( time, dtime );
}

//cmd.PrintF("InfluenceMap::calc defensability {[sum closeness target %f]}", range);
bool nDefensabilityIM::Calculate( ){
    float range = A;

    this->Clear();
    nRoot* root = kernelServer->Lookup("/game/ents/target");
    int r = (int)(range / squareSize) + 1;
    log("r:%i", r );
    foreachchild( nEnt, e, root ) {
        vector3 p = e->GetVarV("pos");
        float value = e->GetVarF("value");
        int pi = (int)(p.x / squareSize);
        int pj = (int)(p.z / squareSize);
        int mini = pi - r;
        int maxi = pi + r;
        int minj = pj - r;
        int maxj = pj + r;
        mini = n_clamp( mini, 0, size-1 );
        maxi = n_clamp( maxi, 0, size-1 );
        minj = n_clamp( minj, 0, size-1 );
        maxj = n_clamp( maxj, 0, size-1 );
        log("e:%s p:%6.2f,%6.2f,%6.2f pi:%4i,pj:%4i (%4i->%4i,%4i->%4i)", e->fn, p.x, p.y, p.z, pi, pj, mini, maxi, minj, maxj );
        for( int i = mini; i < maxi; i ++ ) {
            vector3 p1( i * squareSize, p.y, minj*squareSize );
            for( int j = minj; j < maxj; j ++ ) {
	float l= (p1 - p).len();
	float val = (1.0 - l / range ) * value;
	//log("i:%i j:%i l:%f val:%f", i, j, l, val );
	if( val > 0 )
	    grid[i][j] += val;
	p1.z += squareSize;
            }
        }
    }
    this->Normalize();
    return true;
}
