#define N_IMPLEMENTS nGroundColl
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/ngroundcoll.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nGroundColl*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( addpoint ){
    vector3 p, n;
    p.x = inf(); 
    p.y = inf(); 
    p.z = inf();
    n.x = inf(); 
    n.y = inf(); 
    n.z = inf();
    self->AddPoint( p,n );
}
command( getpoint ){
    vector3 v = self->GetPoint( ini() );
    outf( v.x );
    outf( v.y );
    outf( v.z );
}
command( setpoint ){
    int i = ini();
    float x = inf();
    float y = inf();
    float z = inf();
    self->SetPoint( i, vector3(x,y,z) );
}
void
n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("v_addpoint_ffffff", 'AP', addpoint );
    clazz->AddCmd("fff_getpoint_i", 'GP', getpoint );
    clazz->AddCmd("v_setpoint_ifff", 'SP', setpoint );
    clazz->EndCmds();
}

bool
nGroundColl::SaveCmds(nPersistServer* ps)
{
    if (nPhysicalAspect::SaveCmds(ps))
    {
        nCmd* cmd;
        for( int i = 0; i < points.Size(); i ++ ){
            cmd = ps->GetCmd( this, 'AP' );
            cmd->In()->SetF( points[i].x );
            cmd->In()->SetF( points[i].y );
            cmd->In()->SetF( points[i].z );
            cmd->In()->SetF( normals[i].x );
            cmd->In()->SetF( normals[i].y );
            cmd->In()->SetF( normals[i].z );
            ps->PutCmd( cmd );
        }
        return true;
    }
    return false;
}

