#define N_IMPLEMENTS nODECollisionResponse
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "physics/nodecollisionresponse.h"

nNebulaScriptClass(nODECollisionResponse, "ncollisionresponse");

//------------------------------------------------------------------------------
/**
*/
nODECollisionResponse::nODECollisionResponse():
    odeServer( kernelServer, this ),
    physics( kernelServer, this )
{
    odeServer = "/sys/servers/ode";
}

void nODECollisionResponse::Initialize(){
    nCollisionResponse::Initialize();
}

void nODECollisionResponse::InitVars(){
    nCollisionResponse::InitVars();
    physics = ent->ChildPath("physics").Get();
    this->AddToDisplayList();
    collisionForce.Connect( ent, "collisionforce" );
}

nODECollisionResponse::~nODECollisionResponse(){
}
//------------------------------------------------------------------------------
/**
*/

void nODECollisionResponse::Tick( float time, float dtime ){
    nCollisionResponse::Tick( time, dtime );
}

void nODECollisionResponse::Collision( nEnt* other, vector3 contact, vector3 normal, vector3 otherNormal ){
    //n_printf("nODECollisionResponse::Collision( %s, (%f,%f,%f), (%f,%f,%f) )\n", other->fn, contact.x, contact.y, contact.z, normal.x, normal.y, normal.z );
    ifvalid( odeServer ) {
        ifvalid( physics ) {
            vector3 pos = ent->GetVarV("pos");
            pos -= normal * .01f;
            ent->SetVarV("pos", pos );
            //physics->ApplyForce( otherNormal * collisionForce.GetF() );
            //this->DrawLine( contact, contact + (otherNormal * 10), yellow );
            dBodyID myBody = physics->GetBody();
            dBodyID otherBody = 0;
            n_printf("%i %i\n", myBody, otherBody );
            float depth = 1.0;
            vector3 fdir1(0,0,1); //doesn't matter
            //this->DrawPoint( contact, red );
            odeServer->AddContact( myBody, otherBody, contact, normal, depth, fdir1 );
        }
    }
}
