#define N_IMPLEMENTS nArbiter
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/narbiter.h"

nNebulaScriptClass(nArbiter, "nai");

//------------------------------------------------------------------------------
/**
*/
nArbiter::nArbiter()
{
    velocityVotes.initialize( 4 );
    bearingVotes.initialize( 4 );
}

void nArbiter::Initialize(){
    nAI::Initialize();
}

void nArbiter::InitVars(){
    nAI::InitVars();
    veldesired.Connect( ent, "veldesired" );
    bearingdesired.Connect( ent, "bearingdesired" );
}

nArbiter::~nArbiter(){
}
//------------------------------------------------------------------------------
/**
*/

void nArbiter::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
    //n_printf("num votes: %i\n", velocityVotes.length() );
    if( velocityVotes.length() > 0 ) {
        float val = velocityVotes.topValue();
        float weightSum = 0;
        vector3 weightedVectorSum;
        VelocityVote velocityVote;
        while( velocityVotes.length() > 0 && velocityVotes.topValue() == val ) {
            velocityVote = velocityVotes.pop();
            if( weightSum == 0 ) {
	weightedVectorSum = velocityVote.vel;
            }
            else {
	float& w = velocityVote.weight;
	weightedVectorSum = (weightedVectorSum * (weightSum / (weightSum + w))) + velocityVote.vel * (w / weightSum + w);
            }
            weightSum += velocityVote.weight;
        }
        //veldesired.SetV( velocityVotes.pop() );
        weightedVectorSum.norm();
        veldesired.SetV( weightedVectorSum );
    }
    else
        veldesired.SetV( 0,0,0 );
    if( bearingVotes.length() > 0 )
        bearingdesired.SetF( bearingVotes.pop() );
    else
        bearingdesired.SetF( -1.0f );
    velocityVotes.clear();
    bearingVotes.clear();
}
