#define N_IMPLEMENTS nHoverAI
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nhoverai.h"
#include "rts/nhovermove.h"
#include "rts/nhovermelee.h"
#include "rts/nhoverstandoff.h"
#include "util/nheap.h"
#include "enkiduo/nprofserver.h"

#include "aspect/nside.h"
#include "rts/nhoverattacklegion.h"

#include "rts/nhoverlegionmove.h"
#include "rts/nhoverlegionattacklegion.h"
nNebulaScriptClass(nHoverAI, "ncontroller");

//------------------------------------------------------------------------------
/**
*/
nHoverAI::nHoverAI()
{
}

void nHoverAI::Initialize(){
    nController::Initialize();
    stateNames.Append( "holdfire" );
    stateNames.Append( "holdformation" );
    stateNames.Append( "melee" );
}

void nHoverAI::InitVars(){
    nController::InitVars();
    target.Connect( ent, "target" );
    target.DefaultRef("");
    side.Connect( ent, "side" );
    entname = ent->FullNameString();
    hp.Connect( ent, "hp" );
    pos.Connect( ent, "pos");
    sensorRange.Connect( ent, "sensorrange");
    sensorRange.DefaultF( 100.0f );
}

nHoverAI::~nHoverAI(){
}
//------------------------------------------------------------------------------
/**
*/

bool nHoverAI::States( StateMachineEvent event, uint state, float time, float dtime ) {
    nController::States( event, state, time, dtime );
    BeginStateMachine
        State( HoldFire )
            OnEnter
	SetState( HoldFormation );
        State( HoldFormation )
            OnTick
            /*
            if( target.isvalid() )
	if( GetHead() == NULL ) {
//	    if( parentLegion.isvalid() )
//	        parentLegion.GetRef()->ReallocateChild( this );
	    Standoff( FindTarget() );
	}
	*/
        State( MeleeAll )
            OnTick
            /*
	if( target.isvalid() == false && roll(.01) )
	    Melee( FindTarget() );
	    */
    EndStateMachine
}

void nHoverAI::Message( nMessage* message ){
    if( message->to == entname ){
        if( message->title == "damage" ) { //ahhh ive been hit...going down
            float h = hp.GetF();
            float damage = message->f0;
            float range  = message->f1;
            nString from = message->from; //the bastard who shot me
            h -= damage;
            hp.SetF( h );
            if( h < 0 )
	ent->Die();
        }
        else if( message->title == "command" ){ //i have beeen right clicked on something
            int i = 0;
            char name[1024];
            if( message->data == "none" ) { //it was over a blank area - just move
	nHoverMove* ai = 0;
	if( message->string == "push" )
	    ai = (nHoverMove*) this->PushChild( "nhovermove" );
	else if( message->string == "queue" )
	    ai = (nHoverMove*) this->QueueChild( "nhovermove" );
	else
	    ai = (nHoverMove*) this->ReplaceChildren( "nhovermove" );
	n_assert( ai );
	ai->InitVars();
	ent->SetStackedVarV("destination", message->v.x, message->v.y, message->v.z );
	ent->SetStackedVarF("bearing", message->f0 );
            } else { //over an entity
	//is it friendly?
	static nRoot* legionRoot 	= kernelServer->Lookup("/game/ents/legion");
	nEnt* e 		= (nEnt*) kernelServer->Lookup( message->data.Get() );
	if( e && e->GetSideHandle() == ent->GetSideHandle() ) { //friendly unit
	    if( e->GetParent() == legionRoot ) { } 	//join friendly legion - handled elsewhere
	} else {
	    if( e->GetParent() == legionRoot ) {  	//attack enemy legion
	        nHoverAttackLegion* hal = 0;

	        if( message->string == "push" )		hal = (nHoverAttackLegion*) this->PushChild( "nhoverattacklegion" );
	        else if( message->string == "queue" )		hal = (nHoverAttackLegion*) this->QueueChild( "nhoverattacklegion" );
	        else				hal = (nHoverAttackLegion*) this->ReplaceChildren( "nhoverattacklegion" );

	        n_assert( hal );
	        hal->InitVars();
	        ent->SetStackedVarRef("targetlegion", message->data.Get() );
	    } else {			//attack enemy unit
	        nHoverStandoff* ai = 0;

	        if( message->string == "push" )		ai = (nHoverStandoff*) this->PushChild( "nhoverstandoff" );
	        else if( message->string == "queue" )		ai = (nHoverStandoff*) this->QueueChild( "nhoverstandoff" );
	        else				ai = (nHoverStandoff*) this->ReplaceChildren( "nhoverstandoff" );
	        n_assert( ai );

	        ai->InitVars();
	        ent->SetStackedVarRef("mytarget", message->data.Get() );
	    }
	}
            }
        } else if ( message->title == "legionmove" ) {
            n_printf("%s commanded to do a legionmove\n", this->fn );
            nHoverLegionMove* hlm = (nHoverLegionMove*) this->PushChild( "nhoverlegionmove" );
            hlm->SetProxyParent( message->data.Get() );
        } else if ( message->title == "legionattacklegion" ) {
            n_printf("%s command to do a legionatacklegion\n", this->fn );
            nHoverLegionAttackLegion* hlal = (nHoverLegionAttackLegion*) this->PushChild( "nhoverlegionattacklegion" );
            hlal->SetProxyParent( message->data.Get() );
        }
    }
}

nEnt* nHoverAI::FindTarget(){
    //n_printf("FindTarget()\n");
    //prof->Begin("HoverAI::FindTarget");
    nHeap<nEnt*> heap;
    heap.initialize( 128 );
    float dist;
    vector3 p = pos.GetV();
    //new way..pull the list of enemy factions
    //then pull their list of units, and scan them
    nEnt* sideEnt = (nEnt*) side.GetRef();
    n_assert( sideEnt );
    nSide* sidePtr = (nSide*) sideEnt->Find("side");
    n_assert( sidePtr );

    const SideArray* hostiles = sidePtr->GetHostiles();
    n_assert( hostiles );
    nSide* hs = 0;
    nEnt* e = 0;
    //n_printf("se:%s sp:%s host:%i\n", sideEnt->fn, sidePtr->fn, hostiles->Size() );
    static nRoot* frigateRoot = kernelServer->Lookup("/game/ents/frigate");
    static nRoot* cruiserRoot = kernelServer->Lookup("/game/ents/cruiser");
    for( int i = 0; i < hostiles->Size(); i ++ ) {
        hs = hostiles->Get(i);
        //n_printf("hostile:%s\n", hs->fn );
        const EntArray* units = hs->GetUnits();
        for( int i = 0; i < units->Size(); i ++ ) {
            e = units->Get(i);
            nRoot* parent  = e->GetParent();
            if( parent == frigateRoot || parent == cruiserRoot ) {
	vector3 tp = e->GetVarV("pos");
	vector3 dx = tp - p;
	dist = dx.len();
	if( dist < sensorRange.GetF() ) {
	    dist *= randF( .8, 1.2 );
	    heap.add( dist, e );
	}
            } 
        }
    }
    if( heap.length() > 0 ) {
        heap.pop( dist, e );
        //prof->End("HoverAI::FindTarget");
        return e;
    }
    //prof->End("HoverAI::FindTarget");
    return 0;
}

