#define N_IMPLEMENTS nHoverLegionAttackLegion
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nhoverlegionattacklegion.h"
#include "rts/nlegionattacklegion.h"
#include "ai/ncontroller.h"

nNebulaScriptClass(nHoverLegionAttackLegion, "nlegionbehaviorproxy");

//------------------------------------------------------------------------------
/**
*/
nHoverLegionAttackLegion::nHoverLegionAttackLegion():
ai( kernelServer, this )
{
}

void nHoverLegionAttackLegion::Initialize(){
    nLegionBehaviorProxy::Initialize();
    ai = ent->ChildPath("ai");
}

void nHoverLegionAttackLegion::InitVars(){
    nLegionBehaviorProxy::InitVars();
    attackbehavior.Connect( ent, "attackbehavior" );
    attackbehavior.DefaultS("standoff");
}

nHoverLegionAttackLegion::~nHoverLegionAttackLegion(){
}
//------------------------------------------------------------------------------
/**
*/

void nHoverLegionAttackLegion::Tick( float time, float dtime ){
    nLegionBehaviorProxy::Tick( time, dtime );
}

///okay so we are a hoverlegionattacklegion
///it is our job to attack our opponents group
///todo this -> we can 1) do things in house -> push individual behaviors relating to attacking each opponent
///unallocated -> I have no target, ask my behavior parent to find me a target
///push the appropriate attack on that target based upon my current behavior
bool nHoverLegionAttackLegion::States( StateMachineEvent event, uint state, float time, float dtime ){
    nAspect::Tick(0,0);
    n_assert( ai.get() == this->GetParent() );
    BeginStateMachine
        State(Unallocated)
            OnTick
	//n_printf("nHoverLegionAttackLegion::Unallocated\n");
	nEnt* target = ((nLegionAttackLegion*)(proxyParent.get()))->Allocate( this );
	if( target ) {
	    nString ab = attackbehavior.GetS();
	    n_printf("%s told to target: %s beh:%s\n", this->fn, target->fn, ab.Get() );
	    nAI* behavior;
	    n_assertisa( ai, ncontroller );
	    if( ab == "melee" )
	        behavior = (nAI*) ai->PushChild("nhovermelee");
	    else if( ab == "standoff")
	        behavior = (nAI*) ai->PushChild("nhoverstandoff");
	    else if( ab == "skirmish")
	        behavior = (nAI*) ai->PushChild("nhoverskirmish");
	    else
	        n_error("unknown attack behavior: %s\n", ab.Get() );
	    n_assertisa( behavior, nai );

	    //n_printf("%s->InitVars()\n", behavior->fn );
	    //n_printf("ent->DefaultStackedVarRef(\"mytarget\", %s )\n", target->fn );
	    ent->DefaultStackedVarRef("mytarget", target->fn );
	    behavior->InitVars();
	    this->SetState( Idle );
	} else
	    this->Die();
        State(Idle)
            OnTick
	//n_printf("nHoverLegionAttackLegion::Idle\n");
	this->SetState( Unallocated );
    EndStateMachine
}
