#define N_IMPLEMENTS nHoverLegionMove
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nhoverlegionmove.h"
#include "rts/nlegionmove.h"
#include "rts/narbiter.h"
nNebulaScriptClass(nHoverLegionMove, "nlegionbehaviorproxy");

//------------------------------------------------------------------------------
/**
*/
nHoverLegionMove::nHoverLegionMove()
{
    stateNames.Append( "Move" );
}

void nHoverLegionMove::Initialize(){
    nLegionBehaviorProxy::Initialize();
}

void nHoverLegionMove::InitVars(){
    nLegionBehaviorProxy::InitVars();
    bearing.Connect	( ent, "bearing" );
    bearing.DefaultF	( -1.0f );
}

nHoverLegionMove::~nHoverLegionMove(){
}
//------------------------------------------------------------------------------
/**
*/
///moves the unit to follow this order
///pulls its formation point from the legion
///goes to the point if close enough, otherwise straight to target
void nHoverLegionMove::Tick( float time, float dtime ){
    nLegionBehaviorProxy::Tick( time, dtime );
    ///n_printf("nHoverLegionMove->%s\n", proxyParent->fn );
}
bool nHoverLegionMove::States( StateMachineEvent event, uint state, float time, float dtime ){
    BeginStateMachine
        State(Move)
            OnTick
	ifvalid( arbiter ) {
	    vector3 p = pos.GetV();
	    vector3 d = formationpos.GetV();
	    vector3 dx = d - p;
	    dx.y = 0;
	    float l = dx.len();
	    if( l > 4 ) {
	        dx.norm();
	        arbiter->VoteVelocity( dx, 10, l  );
	    }
	    if( dx.len() < 20 && bearing.GetF() != -1.0f ) 
	        arbiter->VoteBearing( bearing.GetF(), 10, 1 );
	}
    EndStateMachine
}
