#define N_IMPLEMENTS nHoverWander
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nhoverwander.h"

nNebulaScriptClass(nHoverWander, "nai");

//------------------------------------------------------------------------------
/**
*/
nHoverWander::nHoverWander()
{
}

void nHoverWander::Initialize(){
    nAI::Initialize();
}

void nHoverWander::InitVars(){
    nAI::InitVars();
    pos.Connect( ent, "pos" );
    heading.Connect( ent, "heading" );
    heading.DefaultF( -1.0f );
    speed.Connect( ent, "speed" );
    speed.DefaultF( 0.0f );
    destination.Connect( ent, "destination" );
}

nHoverWander::~nHoverWander(){
}
//------------------------------------------------------------------------------
/**
*/

void nHoverWander::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
}

bool nHoverWander::States( StateMachineEvent event, uint state, float time, float dtime ){
    BeginStateMachine
        State(FindDestination)
            OnEnter
	destination.SetV( randF( 500, 4500 ), 0, randF(500, 4500) );
	this->SetState( Move );
        State(Move)
            OnTick
	vector3 p = pos.GetV();
	vector3 d = destination.GetV();
	vector3 dx = d - p;
	dx.y = 0;
	if( dx.len() < 1.0 )
	    this->SetState( FindDestination );
	dx.norm();
	heading.SetF( atan2( dx.x, dx.z ) );
	speed.SetF( 1.0f );
	//veldesired.SetV( veldesired.GetV() + dx );
    EndStateMachine
}
