#define N_IMPLEMENTS nLegionAssault
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nlegionassault.h"
#include "aspect/nside.h"

nNebulaScriptClass(nLegionAssault, "nlegionattacklegion");

//------------------------------------------------------------------------------
/**
*/
nLegionAssault::nLegionAssault()
{
}

void nLegionAssault::Initialize(){
    nLegionAttackLegion::Initialize();
}

void nLegionAssault::InitVars(){
    nLegionAttackLegion::InitVars();
    side.Connect( ent, "side" );
}

nLegionAssault::~nLegionAssault(){
}
//------------------------------------------------------------------------------
/**
*/

void nLegionAssault::Tick( float time, float dtime ){
    nLegionAttackLegion::Tick( time, dtime );
}


/////////////////////////////////////////////////////////////////////////////////
///our goal here is to build a list of enemies corresponding to every entity in our opponents sides
///todo this just walk the list and create things, shouldn't be terribly difficult
///problems come in with having to rebuild the list, but thats okay
/////////////////////////////////////////////////////////////////////////////////
void nLegionAssault::BuildEnemiesList() {
    nAspect::Tick(0,0);
    //n_printf("%s->BuildEnemiesList()\n", this->fn );
    for( int i = 0; i < enemies; i ++ ) //mark them all unfound 
        enemies[i].found = false;

    nEnt* sideEnt = (nEnt*) side.GetRef();
    n_assert( sideEnt );
    nSide* sidePtr = (nSide*) sideEnt->Find("side");
    n_assert( sidePtr );
    const SideArray* hostiles = sidePtr->GetHostiles();
    n_assert( hostiles );

    nSide* hs = 0;
    nEnt* e = 0;
    for( int i = 0; i < hostiles->Size(); i ++ ) { //foreach enemy side
        hs = hostiles->Get(i);
        const EntArray* units = hs->GetUnits(); //units belonging to that side
        for( int i = 0; i < units->Size(); i ++ ) {
            bool found = false;
            e = units->Get(i);
            n_assert( e && e->IsAlive() );
            if( e->Find("armor") ) {
	//n_printf("adding %s to enemies\n", e->fn );
	for( int j = 0; j < enemies; j ++ ) {
	    if( enemies[j].ent == e) {
	        enemies[j].found = true;
	        found = true;
	        //printf("found existing enemy: %s\n", enemies[j].ent->fn );
	        break;
	    }
	}
	if( found == false ) {
	    //printf("adding new enemy: %s\n", e->fn );
	    EnemyInfo& ei = enemies.Push();
	    ei.ent = e;
	    ei.name = e->fn;
	    ei.numAllocatedToo = 0;
	    ei.found = true;
	}
            }
        }
    }
    for( int i = 0; i < enemies; i++ ) { ///take enemies out of the list that are no longer there
        if( enemies[i].found == false || enemies[i].ent->IsAlive() == false ) {
            //n_printf("enemy[%i](%s) being erased\n", i, enemies[i].name.Get() );
            enemies.Erase( i-- );
        }
    }
    if( enemies.Size() == 0 ) {
        this->Die();
    }
}
