#define N_IMPLEMENTS nLegionBehavior
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nlegionbehavior.h"
#include "enkiduo/nent.h"
#include "enkiduo/ngameserver.h"
#include "rts/nlegionbehaviorproxy.h"

nNebulaScriptClass(nLegionBehavior, "nai");

//------------------------------------------------------------------------------
/**
*/
nLegionBehavior::nLegionBehavior()
{
}

void nLegionBehavior::Initialize(){
    nAI::Initialize();
}

void nLegionBehavior::InitVars(){
    nAI::InitVars();
    width.Connect( ent, "width" );
    depth.Connect( ent, "depth" );
    legionN.Connect( ent, "legionn");
    legionN.DefaultRef("");
    lnpos.Connect( legionN, "pos" );
    lnrot.Connect( legionN, "rot" );
    lnwidth.Connect( legionN, "width");
    lndepth.Connect( legionN, "depth");

    legion0.Connect( ent, "legion0" );
    legion0.DefaultRef("");
    l0pos.Connect( legion0, "pos" );
    l0rot.Connect( legion0, "rot" );
}

nLegionBehavior::~nLegionBehavior(){
}
//------------------------------------------------------------------------------
/**
*/

void nLegionBehavior::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
    ifvalid( legionN ) {
        lnwidth.SetF( width.GetF() );
        lndepth.SetF( depth.GetF() );
    }
}

///called when im created to pass me the message that created me - to get start location for ent
void nLegionBehavior::CreationMessage( nMessage* m ) {
    nAspect::Tick( 0,0 );
    legionN.SetRef( game->GenEnt("legionn"));
    vector3 p = pos.GetV();
    quaternion q = rot.GetQ();
    
    if( legionN.isvalid() ) {
        lnpos.SetV( p );
        lnrot.SetQ( q );
    }
    else
        n_error("failed to create legionN\n");

}
///we have a new child proxy
void nLegionBehavior::AddProxy( nLegionBehaviorProxy* proxy ) {
    //n_printf("%s adding proxy: %s\n", this->fn, proxy->fn );
    proxies.Append( proxy );
}
//one of our proxies is dead
void nLegionBehavior::RemoveProxy( nLegionBehaviorProxy* proxy ){
    for( int i = 0; i < proxies; i ++ )
        if( proxies[i] == proxy )
            proxies.Erase( i-- );
}
//i am dying - kill legionn + any proxies
bool nLegionBehavior::BlockDeath( bool urgent ) {
    //n_printf("nLegionBehavior::BlockDeath()\n");
    for( int i =0; i < proxies; i ++ )
        proxies[i]->Die();
    ifvalid( legionN )
        legionN.GetRef()->Die();
    return false;
}

