#define N_IMPLEMENTS nLegionBehaviorProxy
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nlegionbehaviorproxy.h"
#include "rts/nlegionbehavior.h"

nNebulaScriptClass(nLegionBehaviorProxy, "nai");

//------------------------------------------------------------------------------
/**
*/
nLegionBehaviorProxy::nLegionBehaviorProxy():
arbiter( kernelServer, this )
{
}

void nLegionBehaviorProxy::Initialize(){
    nAI::Initialize();
}

void nLegionBehaviorProxy::InitVars(){
    nAI::InitVars();
    formationpos.Connect( ent, "formationpos" );
    arbiter = ent->ChildPath("arbiter");
}

nLegionBehaviorProxy::~nLegionBehaviorProxy(){
}
//------------------------------------------------------------------------------
/**
*/

void nLegionBehaviorProxy::Tick( float time, float dtime ){
    nAI::Tick( time, dtime );
}

void nLegionBehaviorProxy::SetProxyParent( const char* p ) { 
    nLegionBehavior* b = (nLegionBehavior*) kernelServer->Lookup( p );
    classVar(nlegionbehavior, behaviorClass);
    if( b == 0 || b->IsA( behaviorClass ) == false ){ 
        n_error("%s Setting proxy parent to invalid behavior at %s\n", this->fn, p );
        return;
    }
    proxyParent = b; 
    b->AddProxy( this );
}
bool nLegionBehaviorProxy::BlockDeath( bool urgent ) {
    ifvalid( proxyParent )
        proxyParent->RemoveProxy( this );
    return false;
}
