#define N_IMPLEMENTS nLegionLegionAttackLegion
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nlegionlegionattacklegion.h"

nNebulaScriptClass(nLegionLegionAttackLegion, "nlegionbehaviorproxy");

//------------------------------------------------------------------------------
/**
*/
nLegionLegionAttackLegion::nLegionLegionAttackLegion()
{
}

void nLegionLegionAttackLegion::Initialize(){
    nLegionBehaviorProxy::Initialize();
    stateNames.Append("Moving");
    this->AddToDisplayList();
}

void nLegionLegionAttackLegion::InitVars(){
    //n_printf("nLegionLegionAttackLegion::InitVars()\n");
    nLegionBehaviorProxy::InitVars();

    formationPos.Connect( ent, "formationpos" );
    formationPos.DefaultV( 0,0,0 );
    formationRot.Connect( ent, "formationrot" );
    formationRot.DefaultQ( 0,0,0,1 );
    parentLegion.Connect( ent, "parentlegion" );
    parentLegion.DefaultRef("");

    legion0.Connect( ent, "legion0" );
    //legion0.DefaultRef("");
    l0pos.Connect( legion0, "pos" );
    l0rot.Connect( legion0, "rot" );

    legionLocked.Connect( ent, "legionlocked" );
    legionLocked.DefaultI( 0 );
}

nLegionLegionAttackLegion::~nLegionLegionAttackLegion(){
}
//------------------------------------------------------------------------------
/**
*/

void nLegionLegionAttackLegion::Tick( float time, float dtime ){
    //n_printf("nLegionLegionAttackLegion::Tick()\n");
    nLegionBehaviorProxy::Tick( time, dtime );
}

bool nLegionLegionAttackLegion::States( StateMachineEvent event, uint state, float time, float dtime ){ 
    //n_printf("nLegionLegionAttackLegion::States()\n");
    nAspect::Tick( 0,0 );
    BeginStateMachine
        State(Moving)
            OnTick
	//n_printf("nLegionLegionAttackLegion::Tick()\n");
	legionLocked.SetI( 1 );
	n_assert( parentLegion.isvalid() && legion0.isvalid() );
	//n_printf("legion0:%30s p:%s np:%s\n", legion0.GetRef()->fn, str(pos.GetV()), str(l0pos.GetV()) );
	pos.SetV( formationPos.GetV() );
	rot.SetQ( formationRot.GetQ() );
	l0pos.SetV( pos.GetV() );
	l0rot.SetQ( rot.GetQ() );
    EndStateMachine
}

bool nLegionLegionAttackLegion::BlockDeath( bool urgent ) {
    printf("nLegionLegionAttackLegion::BlockDeath()\n");
    if( !urgent )
        legionLocked.SetI ( 0 );
    return nLegionBehaviorProxy::BlockDeath( urgent );
}
