#define N_IMPLEMENTS nLegionMove
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nlegionmove.h"
#include "enkiduo/ngameserver.h"
#include "rts/nhoverlegionmove.h"
#include "rts/nlegionaspect.h"
nNebulaScriptClass(nLegionMove, "nlegionbehavior");

//------------------------------------------------------------------------------
/**
*/
nLegionMove::nLegionMove()
{
}

void nLegionMove::Initialize(){
    nLegionBehavior::Initialize();
    this->AddToDisplayList();
}

void nLegionMove::InitVars(){
    nLegionBehavior::InitVars();
}

nLegionMove::~nLegionMove(){
}
//------------------------------------------------------------------------------
/**
*/

void nLegionMove::Tick( float time, float dtime ){
    nLegionBehavior::Tick( time, dtime );
    //this->DrawLine( p0, p1, white );
}
///called when im created to pass me the message that created me - to get start location for ent
void nLegionMove::CreationMessage( nMessage* m ) {
    nLegionBehavior::CreationMessage( m );
    p0 = pos.GetV();
    p1 = m->v;
    vector3 dx = p1 - p0;
    float bearing = atan2( dx.x, dx.z );

    vector3 pos = m->v;
    quaternion q;
    q.set_rotate_y( bearing );
    ifvalid( legionN ) {
        lnpos.SetV( pos );
        lnrot.SetQ( q );
    }
}
bool nLegionMove::States( StateMachineEvent event, uint state, float time, float dtime ) {
    BeginStateMachine
        State(Moving)
            OnTick
	vector3 p = pos.GetV();
	vector3 tp = lnpos.GetV();
	vector3 dx = tp - p;
	dx.y = 0;
	float len = dx.len();
	//n_printf("len:%f\n", len );
	if( len < 3 )
	    this->Die(); //close enough to goal - finish
	if( len > 1.0f )
    	    dx.norm();
	const float leadAmount = 10.0f;
	l0pos.SetV( p + dx * leadAmount );	
	
	quaternion tr = lnrot.GetQ();
	if( dx.len() > 25.0f ) {
	    quaternion r = rot.GetQ();    
	    quaternion dr;
	    dr.slerp( r, tr, .2 ); //90% r 10% tr
	    l0rot.SetQ( dr );
	} else {
	    l0rot.SetQ( tr );
	}

	/*
	EntArray units;
	legion->BuildMyUnitsList( &units );
	float distanceTotal = 0.0f;
	for( int i = 0; i < units; i ++ ) {
	    vector3 p = units[i]->GetVarV("pos");
	    vector3 fp = units[i]->GetVarV("formationpos");
	    vector3 dx = fp - p;
	    float d = dx.len();
	    distanceTotal += d;	    
	}	
	float averageDistanceTotal = distanceTotal / units.Size();
	n_printf("distanceTotal: %f average: %f\n", distanceTotal, averageDistanceTotal );
	*/
   EndStateMachine
}
