#define N_IMPLEMENTS nMineAspect
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nmineaspect.h"

nNebulaScriptClass(nMineAspect, "naspect");

//------------------------------------------------------------------------------
/**
*/
nMineAspect::nMineAspect()
{
}

void nMineAspect::Initialize(){
    nAspect::Initialize();
}

void nMineAspect::InitVars(){
    nAspect::InitVars();
    efficiency.Connect( ent, "efficiency");
    efficiency.DefaultF( 1.0f );
    supplier.Connect( ent, "supplier");
    supplier.DefaultRef("");

    int numResources = 3;				//FIXME
    for( int i = 0; i < numResources; i ++ ) {
        ResourceProduced* rp = &resourcesProduced.Push();
        nString name;
        name.PrintF("productionrate%i", i );
        rp->productionrate.Connect	( ent, name.get() );
        rp->productionrate.DefaultF	( 0.0f );
        name.PrintF("rawresource%i", i );
        rp->rawresource.Connect		( supplier, name.Get() );
    }
}

nMineAspect::~nMineAspect(){
}
//------------------------------------------------------------------------------
/**
*/

void nMineAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( supplier.isvalid() ) {
        float e = efficiency.GetF() * dtime;
        foreachp( ResourceProduced*, rp, resourcesProduced )
            rp->rawresource.SetF( rp->rawresource.GetF() + e * rp->productionrate.GetF() );
    }
}


