#define N_IMPLEMENTS nPlantAspect
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nplantaspect.h"

nNebulaScriptClass(nPlantAspect, "naspect");

//------------------------------------------------------------------------------
/**
*/
nPlantAspect::nPlantAspect()
{
}

void nPlantAspect::Initialize(){
    nAspect::Initialize();
}

void nPlantAspect::InitVars(){
    nAspect::InitVars();
    efficiency.Connect( ent, "efficiency" );
    efficiency.DefaultF( 1.0f );
    supplier.Connect( ent, "supplier");
    supplier.DefaultRef("");

    int numResources = 3;				//FIXME
    for( int i = 0; i < numResources; i ++ ) {
        ResourceProduced* rp = &resourcesProduced.Push();
        nString name;
        name.PrintF("productionrate%i", i );
        rp->productionrate.Connect	( ent, name.get() );
        rp->productionrate.DefaultF	( 1.0f );		//process 50% of store per second
        
        name.PrintF("rawresource%i", i );
        rp->rawresource.Connect		( ent, name.Get() );
        rp->rawresource.DefaultF	( 0.0f );

        name.PrintF("slagresource%i", i );
        rp->slagresource.Connect	( supplier, name.Get() );
    }
}

nPlantAspect::~nPlantAspect(){
}
//------------------------------------------------------------------------------
/**
*/

void nPlantAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( supplier.isvalid() ) {
        float e = efficiency.GetF() * dtime;
        foreachp( ResourceProduced*, rp, resourcesProduced ) {
            float amountProcessed = rp->rawresource.GetF() * rp->productionrate.GetF() * e;	//amount in store * productionrate * e
            rp->rawresource .SetF( rp->rawresource.GetF()  - amountProcessed );
            rp->slagresource.SetF( rp->slagresource.GetF() + amountProcessed );
        }
    }
}

