#define N_IMPLEMENTS nRefineryAspect
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nrefineryaspect.h"

nNebulaScriptClass(nRefineryAspect, "naspect");

//------------------------------------------------------------------------------
/**
*/
nRefineryAspect::nRefineryAspect()
{
}

void nRefineryAspect::Initialize(){
    nAspect::Initialize();
}

void nRefineryAspect::InitVars(){
    nAspect::InitVars();
    side.Connect( ent, "side");
    efficiency.Connect( ent, "efficiency" );
    efficiency.DefaultF( 1.0f );

    int numResources = 3;				//FIXME
    for( int i = 0; i < numResources; i ++ ) {
        ResourceProduced* rp = &resourcesProduced.Push();
        nString name;
        name.PrintF("productionrate%i", i );
        rp->productionrate.Connect	( ent, name.get() );
        rp->productionrate.DefaultF	( 1.0f );		//refiny everything in 1 second
        
        name.PrintF("slagresource%i", i );
        rp->slagresource.Connect	( ent, name.Get() );
        rp->slagresource.DefaultF	( 0.0f );

        name.PrintF("resource%i", i );
        rp->resource.Connect		( side, name.Get() );
        rp->resource.DefaultF		( 0.0f );
    }
}

nRefineryAspect::~nRefineryAspect(){
}
//------------------------------------------------------------------------------
/**
*/

void nRefineryAspect::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    ifvalid( side ) {
        float e = efficiency.GetF() * dtime;
        foreachp( ResourceProduced*, rp, resourcesProduced ) {
            float amountProcessed = rp->slagresource.GetF() * rp->productionrate.GetF() * e;	//amount in store * productionrate * e
            rp->slagresource.SetF( rp->slagresource.GetF()  - amountProcessed );
            rp->resource.SetF( rp->resource.GetF()      + amountProcessed );
        }
    }
}
