#define N_IMPLEMENTS nSupplierLink
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "rts/nsupplierlink.h"
#include "enkiduo/ngameserver.h"

nNebulaScriptClass(nSupplierLink, "naspect");

//------------------------------------------------------------------------------
/**
*/
nSupplierLink::nSupplierLink():
gameServer( kernelServer, this )
{
}

void nSupplierLink::Initialize(){
    nAspect::Initialize();
    gameServer = "/sys/servers/game";
}

void nSupplierLink::InitVars(){
    nAspect::InitVars();
    pos.Connect( ent, "pos");
    supplier.Connect( ent, "supplier");
    supplier.DefaultRef("");
    supplierPos.Connect( supplier, "pos");
    supplierType.Connect( ent, "suppliertype");
    supplierType.DefaultS("none");
}

nSupplierLink::~nSupplierLink(){
}
//------------------------------------------------------------------------------
/**
*/

void nSupplierLink::Tick( float time, float dtime ){
    nAspect::Tick( time, dtime );
    if( pos.isdirty() )
        this->BuildSupplyChain();
    if( supplier.isvalid() ) {
        if( supplierPos.isdirty() ) {
            this->BuildSupplyChain();
        }
    } else
        if( roll(.1))
            this->BuildSupplyChain();
}

void nSupplierLink::BuildSupplyChain(){
    nString supplierPath = "/game/ents/" + supplierType.GetS();
    nRoot* suppliers = kernelServer->Lookup( supplierPath.Get() );
    int sideHandle = ent->GetSideHandle();
    float minDist = -1.0f;
    nEnt* closest = 0;
    vector3 p = pos.GetV();
    foreachchild( nEnt, e, suppliers ) {
        int refSideHandle = e->GetSideHandle();
        //n_printf("myside:%i ref side:%i\n", sideHandle, refSideHandle );
        if( refSideHandle == sideHandle ) { //they are on my side
            vector3 tp = e->GetVarV("pos");
            float dist = (tp-p).len();
            if( dist < minDist || minDist < 0 ) {
	minDist = dist;
	closest = e;
            }
        }
    }
    if( closest ) {
        //n_printf("%s getting supplies from %s\n", this->fn, closest->fn );
        supplier.SetRef( closest );
        if( supplyLine.isvalid() == false ) {
            supplyLine = gameServer->GenEnt("supplyline");
        }
        supplyLine->SetVarV("pos", p );
        vector3 tp = closest->GetVarV("pos");
        vector3 dx = tp - p;
        supplyLine->SetVarF("distance", dx.len() );
        dx.norm();
        quaternion q;
        q.set_from_axes( vector3(0,0,-1), dx );
        supplyLine->SetVarQ("rot", q );
    } else {
        supplier.SetRef("");
        if( supplyLine.isvalid() )
            supplyLine->SetVarF("distance", 0 );
    }

}
bool nSupplierLink::BlockDeath( bool urgent ) {
    if( !urgent )
        ifvalid( supplyLine )
            supplyLine->Die();
    return false;
}
