#include "tnl/ganetinterface.h"
#include "tnl/gaconnection.h"
#include "ga/nga.h"
using namespace TNL;

//-----------------------------------------------------------------------------//
GANetInterface::GANetInterface( GAConnection* connection, const TNL::Address &bindAddress ):
    NetInterface( bindAddress ) {
    static int id                       = 0;
    this->connection                    = connection;
    this->id                            = id++;
}
//-----------------------------------------------------------------------------//
void GANetInterface::handleInfoPacket( const Address & remoteAddress, U8 packetType, BitStream* stream){
    printf("%i.GAConnection.handleInfoPacket(%i, %s)\n", this->id, packetType, remoteAddress.toString());
    Nonce clientNonce;
    char string[1024];
    Nonce theNonce;
    U32 token;
    PacketStream response;
    switch( packetType ) {
        case PING:
           printf("recieved ping\n");
            clientNonce.read(stream);
            stream->readString(string);
            printf("string:%s\n", string);

            token = computeClientIdentityToken( remoteAddress, clientNonce );
            response.write((U8) PING_RESPONSE);
            clientNonce.write(&response);
            response.write(token);
            response.sendto( this->mSocket, remoteAddress );

            if( this->connection->GetGA()->GetStateI() == nGA::SLAVE_WAITING_FOR_MASTER )
                this->connection->GetGA()->ConnectToServer( remoteAddress.toString() );
            break;
        case PING_RESPONSE:
            printf("recieved ping response\n");
            theNonce.read(stream);
            stream->read(&token);
            printf("got ping response(%i)\n", token);
            break;
    }
}
//-----------------------------------------------------------------------------//
void GANetInterface::sendPing(const Address &theAddress, const Nonce &clientNonce){
    //printf("%i.GANetInterface.sendPing(%s)\n", this->id, theAddress.toString());
    PacketStream packet;
    packet.write((U8) PING);
    clientNonce.write(&packet);
    packet.writeString("Im pinging ya");
    packet.sendto(this->mSocket, theAddress);
}
//-----------------------------------------------------------------------------//
