#include <stdio.h>
#include "tnl/ntnlplayer.h"
#include "tnl/ntnlconnection.h"
#include "tnl/ntnl.h"
using namespace TNL;
//------------------------------------------------------------------------------
//		TNLPlayer STUFF	
//------------------------------------------------------------------------------
TNL_IMPLEMENT_NETOBJECT(nTNLPlayer); 

nTNLPlayer::nTNLPlayer(){
    printf("nTNLPlayer()\n");
    mNetFlags.set( Ghostable );
}
void nTNLPlayer::performScopeQuery(TNL::GhostConnection *gc){
    nTNLConnection* connection = (nTNLConnection*) gc;
    Parent::performScopeQuery( connection );
    nTNL* tnl = connection->getTNL();
    tnl->SetScopeAll( connection );
    /*
    printf("nTNLPlayer::performScopeQuery() ents in scope:%i\n", tnl->ents.Size() );

    for( int i = 0; i < tnl->ents; i ++ ) {
        printf("ent in scope: %s\n", tnl->ents[i]->GetEnt()->fn );
        connection->objectInScope( tnl->ents[i] );
    }
    */
}
TNL::U32 nTNLPlayer::packUpdate(TNL::GhostConnection *connection, TNL::U32 updateMask, TNL::BitStream *stream) {
    printf("nTNLPlayer::packUpdate()\n");
    Parent::packUpdate( connection, updateMask, stream );
    /*
    if( stream->writeFlag( updateMask & InitialMask ) ) {
    }
    if( stream->writeFlag( updateMask & MapMask ) ) {
        //nScriptServer* script = kernelServer->Lookup("/sys/servers/script");
        char heightmap[1024];
        char texture[1024];
        char textureDetail[1024];
        char skybox[1024];
        float worldsize;
        float maxheight;
        float error;
        nScriptServer* script = (nScriptServer*) kernelServer->Lookup("/sys/servers/script");
        const char* err = 0;
        script->Run("return $Map::heightmap", 		err );        		sscanf( err, "%s", &heightmap );
        script->Run("return $Map::terrain_texture", 	err );        		sscanf( err, "%s", &texture );
        script->Run("return $Map::terrain_detail", 	err );        		sscanf( err, "%s", &textureDetail );
        script->Run("return $Map::skybox", 		err );        		sscanf( err, "%s", &skybox );
        script->Run("return $Map::worldsize", 		err );        		sscanf( err, "%f", &worldsize );
        script->Run("return $Map::maxheight", 		err );        		sscanf( err, "%f", &maxheight );
        script->Run("return $Map::error", 		err );        		sscanf( err, "%f", &error );
        stream->writeString( heightmap );
        stream->writeString( texture );
        stream->writeString( textureDetail );
        stream->writeString( skybox );
        stream->write( worldsize );
        stream->write( maxheight );
        stream->write( error );
    }
    */
    return 0;
}
/// unpackUpdate reads the data the server wrote in packUpdate from the packet.
void nTNLPlayer::unpackUpdate(TNL::GhostConnection *connection, TNL::BitStream *stream){
    printf("nTNLPlayer::unpackUpdate()\n");
    Parent::unpackUpdate( connection, stream );
    /*
    if( stream->readFlag() ) { //inital flag

    }
    if( stream->readFlag() ) { //mapmask
        char heightmap[1024];
        char texture[1024];
        char textureDetail[1024];
        char skybox[1024];
        float worldSize;
        float maxHeight;
        float error;
        stream->readString( heightmap );
        stream->readString( texture );
        stream->readString( textureDetail );
        stream->readString( skybox );
        stream->read( &worldSize );
        stream->read( &maxHeight );
        stream->read( &error );
        char script[1024];
        sprintf( script, "set Map::heightmap %s", 	heightmap ); 		RUNSCRIPTD( script );
        sprintf( script, "set Map::terrain_texture %s", 	texture );		RUNSCRIPTD( script );
        sprintf( script, "set Map::terrain_detail %s", 	textureDetail );	RUNSCRIPTD( script );
        sprintf( script, "set Map::skybox %s", 		skybox );		RUNSCRIPTD( script );
        sprintf( script, "set Map::worldsize %f",	worldSize );		RUNSCRIPTD( script );
        sprintf( script, "set Map::maxheight %f",	maxHeight );		RUNSCRIPTD( script );
        sprintf( script, "set Map::error %.0f",		error );		RUNSCRIPTD( script );
        sprintf( script, "Map::gen"		);		RUNSCRIPTD( script );
        sprintf( script, "Map::gen_skybox"		);		RUNSCRIPTD( script );
    }
    */
}
void nTNLPlayer::onGhostAvailable(TNL::GhostConnection *theConnection){
    printf("nTNLPlayer::onGhostAvailable()\n");
    Parent::onGhostAvailable( theConnection );
}
bool nTNLPlayer::onGhostAdd(TNL::GhostConnection *theConnection)
{
    printf("nTNLPlayer::onGhostAdd()\n");
    Parent::onGhostAdd( theConnection );
    return true;
}
