#define N_IMPLEMENTS nBeamTurret
//------------------------------------------------------------------------------
//  (C) 2005	Chris Miles
//------------------------------------------------------------------------------
#include "turret/nbeamturret.h"
#include "enkiduo/ngameserver.h"

nNebulaScriptClass(nBeamTurret, "nturret");

//------------------------------------------------------------------------------
nBeamTurret::nBeamTurret() {
}
//------------------------------------------------------------------------------
void nBeamTurret::Initialize(){
    nTurret::Initialize();
}
//------------------------------------------------------------------------------
void nBeamTurret::InitVars(){
    nTurret::InitVars();
}
//------------------------------------------------------------------------------
nBeamTurret::~nBeamTurret(){
}
//------------------------------------------------------------------------------
void nBeamTurret::Tick( float time, float dtime ){
    nTurret::Tick( time, dtime );
}
//-----------------------------------------------------------------------------//
/**
 * fires the weapon, calculate pos/rot to aim at target + range too target, set them all on the created weapon ent.
 * pos
 * rot
 * vel
 * contactpoint
 * range
 * damage
 * */
void nBeamTurret::Fire(){
    if ( this->CanFire() == false ) return;
    nTurret::Fire();
    if(mother.isvalid()) {
        if ( fires.isdirty() && fires.GetS() != "") {            ///update our weapon vars if what we are firing has changed
            nString f = fires.GetS();
            weaponRange.Connect             ( mother, f + "range" );
            weaponPower.Connect             ( mother, f + "power" );
            weaponImpulse.Connect           ( mother, f + "impulse");
            weaponLevel.Connect             ( mother, f + "level" );
        }
        if ( mother.isdirty()){
            weaponRange.DefaultF(0.0f);
            weaponPower.DefaultF(0.0f);
            weaponImpulse.DefaultF(0.0f);
            weaponLevel.DefaultF(0.0f);
        }
    }
    else
        return;
    if( (weaponRange.isvalid() && weaponPower.isvalid() && weaponImpulse.isvalid() && weaponLevel.isvalid()) == false ) {
        n_printf("warning weapon paramters for beamTurret(%s) are invalid\n", this->fn);
        return;
    }
    if ( target.isvalid() == false ) {
        //n_printf("target is invalid\n");
        return;
    }
    if( (targetPos.GetV() - this->GetOffsetPos()).len() > weaponRange.GetF() ) { //target is out of range -- no firing
        target.SetRef("");
        return;
    }

    nEnt* e = game->GenEnt( fires.GetS().Get() );
    if ( e == 0 ) {
        n_printf("cannot find ent:%s to fire\n", fires.GetS().Get() );
        return;
    }
    //n_printf("firing: %s\n", e->fn );
    e->Tick( this->time, 0 );
    e->CreateVar("contactPoint");
    e->CreateVar("range");
    e->CreateVar("parentTurret")->SetRef(ent->FullNameString());
    vector3 p                           = this->GetOffsetPos();
    vector3 tp                          = targetPos.GetV();
    vector3 targetPoint                 = this->GetTargetPoint( target.GetRef() );
    tp                                  += targetPoint; //target one of the vertex's attached to the entity versus its center
    vector3 d                           = tp - p;
    float range                         = d.len();
    d.norm();
    quaternion q                        = this->GetOffsetRot();
    q.set_from_axes(vector3(0,0,-1), d);
    //n_printf("d:%s q:%s\n", str(d), str(q));
    e->SetVarV("pos",                   p );
    e->SetVarQ("rot",                   q );
    e->SetVarV("vel",                   vector3(0,0,0) );
    e->SetVarV("contactPoint",          tp );
    e->SetVarF("range",                 range);
    //e->SetVarRef("parentTurret",        this->fn);
}
