#define N_IMPLEMENTS nPlannerUI
//------------------------------------------------------------------------------
//  (C) 2004	Chris Miles
//------------------------------------------------------------------------------
#include "ui/nplannerui.h"
#include "kernel/npersistserver.h"
#define command(NAME) static void NAME( void* slf, nCmd* cmd )
#define self ((nPlannerUI*)slf)
#define ins cmd->In()->GetS
#define inf cmd->In()->GetF
#define ini cmd->In()->GetI
#define inb cmd->In()->GetB
#define outs cmd->Out()->SetS
#define outf cmd->Out()->SetF
#define outi cmd->Out()->SetI
#define outb cmd->Out()->SetB

command( getobjectselected ){
    const EntArray* objectsSelected = self->GetObjectsSelected();
    //nArray<nRef<nEnt> >* objectsSelected = self->GetObjectsSelected();
    if( objectsSelected->Size() == 0 ){
        outs( "none" );
    } else {
        char path[256];
        objectsSelected->Get(0)->GetFullName( path, 256 );
        outs( path );
    }
}
command( getobjectover ) {
    const EntArray* objectsOver = self->GetObjectsSelected();
    //nArray<nRef<nEnt> >* objectsOver = self->GetObjectsOver();
    if( objectsOver->Size() == 0 ){
        outs( "none" );
    } else {
        char path[256];
        objectsOver->Get(0)->GetFullName( path, 256 );
        outs( path );
    }
}
command( getobjectsselected ){
    outs( self->getObjectsSelectedString().Get() );
}
command( getobjectsover ) {
    outs( self->getObjectsOverString().Get() );
}
command( addplanner ) {
    self->AddPlanner( ins() );
}
command( placeent ) {
    self->PlaceEnt( ins() );
}
command( placemultipleents ) {
    self->PlaceMultipleEnts( ins() );
}
command( getnumobjectsover ) {
    outi( self->GetObjectsOver()->Size() );
}
command( clearselection ) {
    self->ClearSelection();
}
command ( addselectedent ) {
    self->AddSelectedEnt( ins() );
}
command ( clearcatselection ) {
    self->ClearCatSelection();
}
command( addcatselectedent ) {
    self->AddCatSelectedEnt( ins() );
}
command ( cleartargettedentities ) {
    self->ClearTargettedEntities();
}
command( addtarget ) {
    self->AddTarget( ins() );
}
//-----------------------------------------------------------------------------//
void n_initcmds(nClass* clazz)
{
    clazz->BeginCmds();
    clazz->AddCmd("s_getobjectselected_v",'GOS', 	getobjectselected );
    clazz->AddCmd("s_getobjectover_v",	'GOO', 	getobjectover );
    clazz->AddCmd("s_getobjectsselected_v",'GOSS', 	getobjectsselected );
    clazz->AddCmd("s_getobjectsover_v",	'GOSO', 	getobjectsover );
    clazz->AddCmd("i_getnumobjectsover_v",'GNOO', 	getnumobjectsover );
    clazz->AddCmd("v_addplanner_s", 	'AP', 	addplanner );
    clazz->AddCmd("v_placeent_s", 	'PE', 	placeent );
    clazz->AddCmd("v_placemultipleents_s",'PME', 	placemultipleents );
    clazz->AddCmd("v_clearselection_v",	'CS', 	clearselection );
    clazz->AddCmd("v_addselectedent_s", 'ASE',                                  addselectedent );
    clazz->AddCmd("v_clearcatselection_v", 'CCS',                               clearcatselection );
    clazz->AddCmd("v_addcatselectedent_s", 'ACSE',                              addcatselectedent );
    clazz->AddCmd("v_cleartargettedentities_v", 'CTAR',                         cleartargettedentities);
    clazz->AddCmd("v_addtarget_s", 'ATAR',                                      addtarget );
    clazz->EndCmds();
}
//-----------------------------------------------------------------------------//
bool
nPlannerUI::SaveCmds(nPersistServer* ps)
{
    if (nFSM::SaveCmds(ps))
    {
        nCmd* cmd;
        return true;
    }
    return false;
}

