namespace eval CaseBase {
    proc log { txt_casebase } {
        logto "all casebase" $txt_casebase
    }
    #load the casebase files
    proc build { } {
        log "<CaseBase::build>"
        global xmldir
        set filename $xmldir/casebase/red/cases.xml
        if { ![file exists $filename] } {
            log "cannot load file : $filename"
            return
        }
        variable casebase [file_to_string $xmldir/casebase/red/cases.xml]
        #now we need to parse the xml file, and construct cases from i
        /sys/servers/release.releasenow /casebase/genomes
        new nent /casebase
        new nthing /casebase/genomes
        pushsel
        puts "pre parse"
        parse_xmltoCases $casebase
        puts "post parse"
        popsel
        log "</CaseBase::build>"
    }
    proc gen_genome { name } {
        upvar genome genome
        if { $genome == "/casebase/genomes" } {
            sel /casebase/genomes
            set genome [new ngenome $name]
        } else {
            set genome [$genome.addv $name]
        }
    }
	
    proc parse_xmltoCases { plan } [XML::buildParser {
        init		{ set genome "/casebase/genomes" }
        genome		{ 
		    set genome [gen_genome $txt]
		}  { 
		    set genome [$genome.getparent]
		}
        enum		{ $genome.setenumproxy $txt }
        float		{ $genome.setf $txt }
        minf		{ $genome.minf $txt }
        maxf		{ $genome.maxf $txt }
        int		{ $genome.seti $txt }
        mini		{ $genome.mini $txt }
        maxi		{ $genome.maxi $txt }
    }]

    #displays the cases - i would like to use a tree for this..since they have this natural xml format to them anyways
    proc open { } {
        vars casebase
        TL "Case Base"
        pushf [gframe]
            packall -side left -expand yes -fill both
            XMLViewer::open $f.xml $casebase "side"
        popf
        pushf [gframe]
            packall -side left -expand yes -fill both
            set sw          [ScrolledWindow $f.sw -relief sunken -borderwidth 2]
	set tree        [Tree $sw.tree              		\
	    -relief        	 	flat  	  	\
	    -borderwidth    	0       		\
	    -highlightthickness 	0   		\
	    -redraw         	0       		\
	    -dropenabled    	0       		\
	    -dragenabled    	0       		\
	    -height 		30		\
	    -width 		30		\
	    -opencmd   		"CaseBase::moddir 1 $sw.tree" 	\
	    -closecmd  		"CaseBase::moddir 0 $sw.tree"
	]

            $sw setwidget $tree
            pack $sw -side top  -expand yes -fill both

            $tree bindText  <ButtonPress-1>        "CaseBase::select tree 1 $tree "
            $tree bindText  <Double-ButtonPress-1> "CaseBase:;select tree 2 $tree "

            $tree insert end root home -text "Cases" -open 1
            CaseBase::buildTree $tree home "/game/ents"
            $tree configure -redraw 1
        popf
    }

    proc moddir { index tree node } {
    }
    proc select { where num tree node } {
    }
#*******************************************************************************************************
#			PARSE all the objects I can control into tree view icons
#*******************************************************************************************************
    proc buildTree { tree node path } {
        set sep "_"
        pushsel
        sel /casebase/genomes
        foreach genome [dir] {
            set string [$genome.tostring]
            set strings [split $string "\n"]
            log "genome:$genome = $string"
            set i 0
            foreach s $strings {
	set s [string trim $s]
	    if { $s == "" } {continue}
	if { $i == 0 } {
	    $tree insert end root $genome -text $s -open 1
	} else {
	    $tree insert end $genome $genome$sep$i -text $s -open 1
	}
               	incr i
            }
        }
    }
    proc clear { } {
        log "CaseBase::clear"
        global xmldir
        stringToFile  $xmldir/casebase/red/cases.xml ""
    }
    proc extract { path } {
        log "Extract($path)"
        set xml [$path.toxml]
        global xmldir
        log "appendToFile $xmldir/casebase/red/cases.xml $xml"
        appendToFile $xmldir/casebase/red/cases.xml $xml
    }
#okay we wnat to load this human plan..and convert it into a case
    proc reverseEngineer { } {
        pushsel
        global xmldir
        set humanPlan [fileToString $xmldir/plans/blue/defaultblue.xml]
        XMLWindow .humanplan "Human Plan" $humanPlan
        set hp [new ngenome /casebase/humanplan]
#first load the allocation
#we need to umm..go through the enums and figure it out
        if { 0 } {
            okay so we have to build the enums first..this is kind of a tricky one..but not too impossible
            identify the wapons in the allocation...--- actually the casting system should handle most of it we should just be bale to add nodes for each weapon - each target and go from there

        }

    }
}
