global defaults
array set defaults { }
namespace eval Defaults {
    variable startupScript "none"
    variable registeredWindows ""
    variable windowDefaults 
    proc parseDefaults { plan } [XML::buildParser {
        init		{ global defaults; vars windowDefaults }
        windows		{ }
        window		{ set window $txt } { set window "" }
        geometry	{ set windowDefaults($window) $txt } 
        defaults	{ }
        default		{ set defaults($tag) $txt}
    } ]
    proc load { } {
        global xmldir
        set xml [of $xmldir/misc/defaults.xml]
        parseDefaults $xml
    }
    proc save { } {
        global defaults
        vars startupScript registeredWindows windowDefaults
        puts "Save Windows: $registeredWindows"
        XML::clear
        XML::open defaults
        foreach v [array names defaults] {
            puts "saving defaults($v)=$defaults($v)"
            XML::wrap $v $defaults($v)
        }
        XML::open windows
            foreach window $registeredWindows {
	catch {
	XML::open window $window
	XML::wrap geometry [wm geometry $window]
	XML::close window
	} 
            }
            foreach windowName [array names windowDefaults] {
	if {[lsearch $registeredWindows $windowName] == -1 } {
	    XML::open window $windowName
	    XML::wrap geometry $windowDefaults($windowName)
	    XML::close window
	}
            }
            XML::close defaults
        XML::close windows
        global xmldir
        wf $xmldir/misc/defaults.xml $::XML::lines
        #puts "wf $xmldir/misc/defaults.xml $::XML::lines"
    }
    proc registerWindow { winpath } {
        vars registeredWindows
        lappend registeredWindows $winpath
    }
    proc getWindowDefaults { winpath } {
        vars windowDefaults
        if {[info exists windowDefaults($winpath)]} {
            puts "getWindowDefaults $winpath : $windowDefaults($winpath)"  
            return $windowDefaults($winpath)
        } else {
            puts "no defaults for window: $winpath"
            return "none"
        }
    }
}
