opt speedup { return }
#manages the info stuff
#namely the weapon / target allocation stuff
#okay so the weapon target is a big matrix
namespace eval Info {
#the effectiveness matrix
    variable em
    variable xml
    proc open { } {
        TL Info
        pushf [frame $f.buttons]
            pack $f
            gbutton -text "build" -command Info::build
            gbutton -text "To XML" -command Info::toXml
            gbutton -text "Save" -command Info::save
            packall -side left
        popf
        variable matrixFrame $f.matrixFrame
        build
    }
    proc save { } {
        vars xml xmldir
        stringToFile $xmldir/misc/info.xml $xml
    }
    proc toEm { val } {
        return [expr int($val * 100)]
    }
    proc toVal { em } {
        return [expr $em / 100.0]
    }
    proc build  { } {
        variable em
        pushsel
        sel /info/weapon
        variable weapons [dir]
        sel /info/armor
        variable armors [dir]
        puts "weapons: $weapons armors: $armors"
        popsel
        foreach weapon $weapons {
            foreach armor $armors {
	if { [/info/weapon/$weapon.hasvar $armor] } {
	    set e [/info/weapon/$weapon.gf $armor]
	    set em($weapon,$armor) [toEm $e]
	} else {
	    set em($weapon,$armor) 0
	}
            }
        }
        foreach weapon $weapons {
            foreach armor $armors {
	if { [/info/armor/$armor.hasvar $weapon] } {
	    set e [/info/armor/$armor.gf $weapon]
	    set em($weapon,$armor) [toEm $e]
	}
            }
        }
        updateMatrix
    }
    proc toXml { } {
        variable em
        variable xml
        variable weapons
        variable armors
        XML::clear
        XML::open INFO
        foreach armor $armors {
            XML::open ARMORCLASS $armor
            foreach weapon $weapons {
	XML::open WEAPONCLASS $weapon 
	XML::wrap PROBDESTRUCTION [toVal $em($weapon,$armor)]
	XML::close WEAPONCLASS
            }
            XML::close ARMORCLASS
        }
        XML::close INFO
        set xml $::XML::lines
        XMLWindow .infoxml "Info" $xml
    }
    proc updateMatrix { } {
        variable matrixFrame
        variable weapons
        variable armors
        destroy $matrixFrame
        pushf [frame $matrixFrame]
            pack $f
            Table $f.table $armors $weapons Info::TableEntry
        popf
    }
    proc TableEntry { p row col } {
        entry $p -textvariable ::Info::em($col,$row) -width 2
    }
}
