namespace eval Car {
    variable pending ""
    proc view { v } {
        variable pending
        pushsel
        sel /game/camera
        foreach id $pending {
            after cancel $id
        }
        set pending ""
        /game/camera.sf ptightness 0.01
        /game/camera.sf rtightness 0.03
        switch $v {
            1st {   transition 1000 "0 0 0" "0 0 0"   1.0 1.0 }
            3rd {   transition 1000 "0 1 2" "-30 0 0" 0.3 0.1 }
            above { transition 1000 "0 3 1" "-60 0 0" 0.5 0.5 }
            map	{   transition 5000 "0 200 0" "-90 0 0" .001 .001 }
        }
        popsel
    }
    proc pop { } {
        vars car
        set p [$car.gv pos]
        puts "Map::point [lindex $p 0] [lindex $p 2]"
        set p [Map::point [lindex $p 0] [lindex $p 2]]
        set y [lindex $p 2]
        $car.sv pos [lindex $p 0] [expr [lindex $p 1] + 2] [lindex $p 2]
    }
    proc flip { } {
        vars car
        $car.sr rot 0 0 0
        $car.halt
    }
    proc import { } {
        vars car p
        puts "Car::import"
        set p(frame.width)	[$car.gf width]
        set p(frame.height)	[$car.gf height]
        set p(frame.depth)	[$car.gf depth]
        set p(wheel.f.radius) 	[$car.gf wheelradiusf]
        set p(wheel.f.width) 	[$car.gf wheelwidthf]
        set p(wheel.f.density) 	[$car.gf wheeldensityf]
        set p(wheel.r.radius) 	[$car.gf wheelradiusr]
        set p(wheel.r.width) 	[$car.gf wheelwidthr]
        set p(wheel.r.density) 	[$car.gf wheeldensityr]
        set p(engine.power)	[$car.gf enginepower]
        set p(engine.resistance) [$car.gf engineresistance]
        set p(engine.maxspeed)	[$car.gf maxspeed]
    }
    proc export { { a a } } {
        vars car p
        if { [$car.gf width]  != $p(frame.width) } { $car.sf width  $p(frame.width) }
        if { [$car.gf height] != $p(frame.height)} { $car.sf height $p(frame.height)}
        if { [$car.gf depth]  != $p(frame.depth) } { $car.sf depth  $p(frame.depth) }
        if { [$car.gf wheelradiusf]  != $p(wheel.f.radius)  } { $car.sf wheelradiusf  $p(wheel.f.radius) }
        if { [$car.gf wheelwidthf]   != $p(wheel.f.width)   } { $car.sf wheelwidthf   $p(wheel.f.width)   }
        if { [$car.gf wheeldensityf] != $p(wheel.f.density) } { $car.sf wheeldensityf $p(wheel.f.density) }
        if { [$car.gf wheelradiusr]  != $p(wheel.r.radius)  } { $car.sf wheelradiusr  $p(wheel.r.radius) }
        if { [$car.gf wheelwidthr]   != $p(wheel.r.width)   } { $car.sf wheelwidthr   $p(wheel.r.width)   }
        if { [$car.gf wheeldensityr] != $p(wheel.r.density) } { $car.sf wheeldensityr $p(wheel.r.density) }
        if { [$car.gf enginepower] != $p(engine.power) } { $car.sf enginepower $p(engine.power) }
        if { [$car.gf engineresistance] != $p(engine.resistance) } { $car.sf engineresistance $p(engine.resistance) }
        if { [$car.gf maxspeed] != $p(engine.maxspeed) } { $car.sf maxspeed $p(engine.maxspeed) }
    }
    proc open { } {
        vars car p
        set car /game/ents/car/car0
        array unset p
        TL car
        pushf [PW $f.help "Commands"]
            gbutton -text "Drive" -command	Car::drive
            gbutton -text "AI"	-command Car::ai
            gbutton -text "Pop" -command	Car::pop
            gbutton -text "Flip" -command	Car::flip
            gbutton -text "Export" -command Car::export
            packall -side left
        popf
        pushf [PW $f.maps "Maps"]
            gbutton -text "flat" -command		{Car::map flat}
            gbutton -text "bumpy" -command		{Car::map bumpy}
            gbutton -text "course" -command		{Car::map course}
            gbutton -text "course_thresholded" -command 	{Car::map course_thresholded}
            packall -side left
        popf
        pushf [PW $f.view "View"]
            gbutton -text "1st" -command 	{Car::view 1st}
            gbutton -text "3rd" -command 	{Car::view 3rd}
            gbutton -text "Above" -command 	{Car::view above}
            gbutton -text "Map" -command 	{Car::view map}
            packall -side left
        popf
        pushf [PW $f.frame frame]
            glabel -text "Density"
            gscale -variable ::Car::p(frame.density) 	-from .1 -to 20.0 -resolution .1 -command Car::export
            glabel -text "Dimensions"
            gscale -variable ::Car::p(frame.width) 	-from .1 -to 150.0 -resolution .1 -command Car::export
            gscale -variable ::Car::p(frame.height) 	-from .1 -to 150.0 -resolution .1 -command Car::export
            gscale -variable ::Car::p(frame.depth) 	-from .1 -to 150.0 -resolution .1 -command Car::export
            packall -anchor w
        popf
        pushf [PW $f.rcs "AI Params"]
            glabel -text "rangeToHeading:"
            for { set i 0 } { $i < 8 } { incr i } {
	gbutton -text "$i" -command "$car.editrc rangetoheading$i"
            }
            packall -side left
        popf
        pushf [PW $f.wheels Wheels]
            pushf [frame $f.left]
	pack $f -side left
	gc 0 0 glabel -text "Radius"
	gc 1 0 glabel -text "Width"
	gc 2 0 glabel -text "Density"
	gc 0 1 gscale -variable ::Car::p(wheel.f.radius)  -from 0.5 -to 20.0 -resolution .1 -command Car::export
	gc 0 2 gscale -variable ::Car::p(wheel.r.radius)  -from 0.5 -to 20.0 -resolution .1 -command Car::export
	gc 1 1 gscale -variable ::Car::p(wheel.f.width)   -from 0.5 -to 20.0 -resolution .1 -command Car::export
	gc 1 2 gscale -variable ::Car::p(wheel.r.width)   -from 0.5 -to 20.0 -resolution .1 -command Car::export
	gc 2 1 gscale -variable ::Car::p(wheel.f.density) -from .05 -to 10.0 -resolution .05 -command Car::export
	gc 2 2 gscale -variable ::Car::p(wheel.r.density) -from .05 -to 10.0 -resolution .05 -command Car::export
            popf
        popf
        pushf [PW $f.engine Engine]
            glabel -text "Power"
            gscale -variable ::Car::p(engine.power)      -from 10 -to 10000 -resolution 10 -command Car::export
            glabel -text "Resistance"
            gscale -variable ::Car::p(engine.resistance) -from 0 -to 1000 -resolution 10 -command Car::export
            glabel -text "Max Speed"
            gscale -variable ::Car::p(engine.maxspeed)   -from 10 -to 1000 -resolution 10 -command Car::export
            packall -anchor w
        popf
        Car::import
    }
    proc drive { } {
        vars car
        catch {delete $car/ai}
        /ui/interface.setstate controlcar
    }
    proc ai { } {
        vars car
        catch { new ncarai $car/ai }
        /ui/interface.setstate controloffset
    }
    proc map { m } {
        switch $m { 
            flat {
	set Map::heightmap 	flat.bmp
	set Map::maxheight	1.0
            }
            bumpy {
	set Map::heightmap 	bumpy.bmp
	set Map::maxheight	50.0
            }
            course {
	set Map::heightmap 	course.bmp
	set Map::maxheight	50.0
            }
            course_thresholded {
	set Map::heightmap	course_contrast.bmp
	set Map::maxheight	50.0
            }
        }
        Map::gen
    }
}
