#displays all the info on the ga
#it should have the log output
#show the numgens / popsize
#have progress bars for generations
#check bars for which indivdiuals are being evaulated
namespace eval GALog {
#****************************************************************************************************************************************************************************************
    variable popsize
    variable numgens
    variable log "none"
    variable logdata ""
    variable initialized "false"
    variable missiondata ""
    variable missionLog "none"
    variable genomePlanData ""
    variable genomePlanLog "none"
    variable generation 0
    variable numEvaluated 0
#****************************************************************************************************************************************************************************************
    proc open { } {
        variable popsize [/ga.gi popsize]
        variable numgens [/ga.gi numgens]
        variable log
        variable logdata
        variable missionLog
        variable missiondata
        variable genomePlanLog
        variable genomePlanData
        TL "GA Log"
        pushf [frame $tl.f -relief sunken -borderwidth 1]
            pack $f -side top -expand 1 -fill both
            pushf [frame $f.progress]
	pack $f -side top -expand 1 -fill x
	ProgressBar::create $f.prg -width 400 -height 20 -background white -variable GALog::generation -maximum $numgens
	ProgressBar::create $f.prg1 -width 400 -height 20 -background white -variable GALog::numEvaluated -maximum [expr $numgens * $popsize]
	pack $f.prg $f.prg1
            popf
            pushf [frame $f.scales]
	pack $f -side top -expand 1 -fill x
	scale $f.popsize \
	    -length 400 \
	    -orient horizontal \
	    -from 1 -to 100 \
	    -resolution 1 \
	    -showvalue 1 \
	    -label "Population Size:" \
	    -variable ::GALog::popsize \
	    -command { ::GALog::setpopsize }
	pack $f.popsize -fill x
	scale $f.numgens\
	    -length 400 \
	    -orient horizontal \
	    -from 1 -to 100 \
	    -resolution 1 \
	    -showvalue 1 \
	    -label "Number of Generations:" \
	    -variable ::GALog::numgens \
	    -command { ::GALog::setnumgens }
	pack $f.numgens -fill x
            popf
            pushf [frame $f.log]
	pack $f -expand 1 -fill both -anchor n
	set log [
	    text $f.text -height 20 -width 40 -wrap none\
	    -xscrollcommand "$f.xscroll set" \
	    -yscrollcommand "$f.yscroll set" \
	    -setgrid 1 -highlightthickness 0 -pady 2 -padx 3
	]
	$log insert end $logdata
	scrollbar $f.xscroll -command "$f.text xview" -highlightthickness 0 -orient horizontal
	scrollbar $f.yscroll -command "$f.text yview" -highlightthickness 0 -orient vertical
#grid config $f.text -row 0 -column 0 -sticky nsew
#	grid config $f.yscroll -row 0 -column 1 -sticky ns
	pack $f.text -side left -expand 1 -fill both -anchor n
	pack $f.yscroll -side right -fill y -anchor n
#	grid config $f.xscroll -row 1 -column 0 -sticky ew
            popf
            if { 0 } {
            pushf [frame $f.missionLog]
	puts "pack $f -expand 1"
	pack $f -expand 1
	set missionLog [
	    text $f.text -height 20 -width 40 -wrap none\
	    -xscrollcommand "$f.xscroll set" \
	    -yscrollcommand "$f.yscroll set" \
	    -setgrid 1 -highlightthickness 0 -pady 2 -padx 3
	]
	$missionLog insert end $missiondata
	scrollbar $f.xscroll -command "$f.text xview" -highlightthickness 0 -orient horizontal
	scrollbar $f.yscroll -command "$f.text yview" -highlightthickness 0 -orient vertical
	grid config $f.text -row 0 -column 0 -sticky nsew
	grid config $f.yscroll -row 0 -column 1 -sticky ns
	grid config $f.xscroll -row 1 -column 0 -sticky ew
            popf
            pushf [frame $f.genomePlanLog]
	puts "pack $f -expand 1"
	pack $f -expand 1
	set genomePlanLog [
	    text $f.text -height 20 -width 40 -wrap none\
	    -xscrollcommand "$f.xscroll set" \
	    -yscrollcommand "$f.yscroll set" \
	    -setgrid 1 -highlightthickness 0 -pady 2 -padx 3
	]
	$genomePlanLog insert end $genomePlanData
	scrollbar $f.xscroll -command "$f.text xview" -highlightthickness 0 -orient horizontal
	scrollbar $f.yscroll -command "$f.text yview" -highlightthickness 0 -orient vertical
	grid config $f.text -row 0 -column 0 -sticky nsew
	grid config $f.yscroll -row 0 -column 1 -sticky ns
	grid config $f.xscroll -row 1 -column 0 -sticky ew
            popf
            }
        popf
    }
#****************************************************************************************************************************************************************************************
    proc setpopsize { popsize } {
    }
#****************************************************************************************************************************************************************************************
    proc setnumgens { numgens } {
    }
#****************************************************************************************************************************************************************************************
    proc log { data } {
        variable log
        variable logdata
        if { $log == "none" } {
            append logdata "$data\n"
        } else {
            $log insert end "$data\n"
        }
    }

#****************************************************************************************************************************************************************************************
    proc loadMission { mission } {
        variable missionLog
        variable missionData $mission
        if { $missionLog != "none" } {  
            $missionLog insert end $missionData
        }
        Plan::load $mission yes
        return
    }
#****************************************************************************************************************************************************************************************
    proc loadGenomePlan { genomePlan } {
        variable genomePlanLog
        variable genomePlanLogData $genomePlan
        if { $genomePlanLog != "none" } {
            $genomePlanLog insert end $genomePlan
        }
        Plan::load $genomePlan
        return
    }
#****************************************************************************************************************************************************************************************
    proc setCurrentGeneration { gen } {
        variable generation $gen
        return
    }
    proc setNumEvaluated { num } {
        variable numEvaluated $num
        return
    }
}
