#want
#sliders for thresholds
#edgecostthreshold
#edgelengththreshold
#draw coords
#draw edges
#rc control

namespace eval pathfinder {

    proc open { } {
        global pathfinder
        variable rc			[$pathfinder.getrc]
        variable cost			[$pathfinder.getedgecostthreshold]
        variable length			[$pathfinder.getedgelengththreshold]
        variable drawcoords		[$pathfinder.getdrawcoords]
        variable drawedges		[$pathfinder.getdrawedges]
        variable drawpath		[$pathfinder.getdrawpath]
        variable drawspheres 		[$pathfinder.getdrawspheres]
        variable usedetectionrange 		[$pathfinder.getusedetectionrange]
        variable useeffectiverange 		[$pathfinder.getuseeffectiverange]
        variable coorddensity		[$pathfinder.getcoorddensity]

        set tl [toplevel .pathfinder]
        wm title $tl "Pathfinder"
        wm resizable $tl 1 1
#set f [frame $tl.f -relief sunken -borderwidth 1]
        pushf [frame $tl.f -relief sunken -borderwidth 1]
        pack $f -side top -expand 1
        pushf [frame $f.data]
        pack $f -side top
        pushf [frame $f.buttons]
        pack $f -side top
        grid config [\
        checkbutton $f.useeffectiverange			\
        -text 		"Use Effective Range"       \
        -onvalue  	true						\
        -offvalue 	false                       \
        -variable 	::pathfinder::useeffectiverange \
        -command  	{ $::pathfinder.setuseeffectiverange $::pathfinder::useeffectiverange } \
        ]	-row 0 -column 0 -sticky "snew"

        grid config [\
        checkbutton $f.usedetectionrange			\
        -text 		"Use Detection Range"       \
        -onvalue  	true						\
        -offvalue 	false                       \
        -variable 	::pathfinder::usedetectionrange	\
        -command  	{ $::pathfinder.setusedetectionrange $::pathfinder::usedetectionrange }\
        ]	-row 0 -column 1 -sticky "snew"

        grid config [\
        checkbutton $f.drawcoords					\
        -text 		"Draw Coords"               \
        -onvalue  	true						\
        -offvalue 	false                       \
        -variable 	::pathfinder::drawcoords	\
        -command  	{ $::pathfinder.setdrawcoords	$::pathfinder::drawcoords }\
        ]	-row 1	-column 0 -sticky "snew"
        grid config [\
        checkbutton $f.drawedges					\
        -text 		"Draw Edges"				\
        -onvalue  	true						\
        -offvalue 	false						\
        -variable 	::pathfinder::drawedges		\
        -command  	{ $::pathfinder.setdrawedges	$::pathfinder::drawedges  }\
        ]	-row 1 -column 1 -sticky "snew" 
        grid config [\
        checkbutton $f.drawpath						\
        -text 		"Draw Path"					\
        -onvalue  	true						\
        -offvalue 	false						\
        -variable 	::pathfinder::drawpath		\
        -command  	{ $::pathfinder.setdrawpath		$::pathfinder::drawpath }\
        ]	-row 1 -column 2 -sticky "snew" 
        grid config [\
        checkbutton $f.drawspheres					\
        -text 		"Draw Sphere"				\
        -onvalue  	true						\
        -offvalue 	false						\
        -variable 	::pathfinder::drawspheres	\
        -command  	{ $::pathfinder.setdrawspheres $::pathfinder::drawspheres }\
        ]	-row 1 -column 3 -sticky "snew"
        popf
        scale $f.rc \
        -length 400 \
        -orient horizontal \
        -from 0.0 -to 5.0 \
        -resolution .025 \
        -showvalue 1 \
        -label "rc:" \
        -variable ::pathfinder::rc \
        -command { $::pathfinder.setrc }
    scale $f.coorddensity \
        -length 400 \
        -orient horizontal \
        -from 100.0 -to 0.0 \
        -resolution 0.1 \
        -showvalue 1 \
        -label "Coord Density:" \
        -variable ::pathfinder::coorddensity \
        -command { $::pathfinder.setcoorddensity }
    scale $f.cost \
        -length 400 \
        -orient horizontal \
        -from 0.0 -to 10000.0 \
        -resolution 10 \
        -showvalue 1 \
        -label "edge cost threshold:" \
        -variable ::pathfinder::cost \
        -command { $::pathfinder.setedgecostthreshold }
    scale $f.length \
        -length 400 \
            -orient horizontal \
            -from 0.0 -to 1000.0 \
            -resolution 10 \
            -showvalue 1 \
            -label "edge length threshold:" \
            -variable pathfinder::length \
            -command { $::pathfinder.setedgelengththreshold }
        button $f.cacheall -text "Cache All"	-command { $::pathfinder.cacheall }
        button $f.calc_coords -text "Calculate Coords"	-command { $::pathfinder.calculate_coords }
        pack $f $f.rc $f.coorddensity $f.cost $f.length $f.cacheall $f.calc_coords
        popf
            popf
    }
}
