#displays profiling info on the slaves
#idea - foreach slave, each variable create a progress bar showing relative speed - reallly pretty
#then a row across the bottom showing time distribution (on mode values)
namespace eval SlaveInfo {
    variable slaves 	""
    variable rows	""
    variable columns	"ip ready busy sent evals routing loadingMission loadingPlan genomeToPlan parsingFitness loading running evaluation"
    variable updating 	no
    variable open 	no
    proc open { } {
        variable slaves
        variable rows $slaves
        variable columns
        variable updating
        variable open
        variable tableframe
        if { $open == "no" } {
            TL slaves
            set open yes
            set tableframe $f
        } else {
            destroy $tableframe.table
        }
        Table $tableframe.table $rows $columns SlaveInfo::TableEntry
        if { !$updating } {
            SlaveInfo::updateSlaves
            set updating yes
        }
    }
    proc TableEntry { p row col } {
        switch $col {
            Working 	{ checkbutton $p -variable SlaveInfo::busy($row) 	}
            default	{ 
	if { $col == "ip" } { set w 15 } else { set w 8 }
	set cmd "entry $p -width $w -textvariable SlaveInfo::$col"
	append cmd "($row)"
	eval $cmd
            }
        }
    }
    proc updateSlaves { } {
        variable slaves 
        variable id
        variable ip
        variable ready
        variable busy
        variable sent
        variable evals
        variable numEvaluated
        variable routing
        variable loadingMission
        variable loadingPlan
        variable genomeToPlan
        variable parsingFitness
        variable loading
        variable evaluation
        variable running
        variable eStarted
        variable eStopped
        variable rStarted
        variable rStopped
        variable eTime
        variable rTime
        set newslaves ""

        set slaveInfo ""
        catch { set slaveInfo [/ga/ga.getslaveinfo] }
        set lines [split $slaveInfo "\n"]
        foreach line $lines {
            set id 		[lindex $line 0]
            if { $id == "" } { continue }
            lappend newslaves $id
            set ip($id) 		[lindex $line 1]
            set ready($id)		[lindex $line 2]
            set busy($id)		[lindex $line 3]
            set sent($id)  		[lindex $line 4]
            set evals($id)		[lindex $line 5]
            set routing($id)         	[lindex $line 6]
            set loadingMission($id)  	[lindex $line 7]
            set loadingPlan($id)     	[lindex $line 8]
            set genomeToPlan($id)    	[lindex $line 9]
            set parsingFitness($id)  	[lindex $line 10]
            set loading($id)         	[lindex $line 11]
            set evaluation($id)      	[lindex $line 12]
            set running($id)         	[lindex $line 13]
            set eStarted($id)		[lindex $line 14]
            set eStopped($id)		[lindex $line 15]
            set rStarted($id)		[lindex $line 16]
            set rStopped($id)		[lindex $line 17]
            set eTime($id)		[expr $eStopped($id) - $eStarted($id)]
            set rTime($id)		[expr $rStopped($id) - $rStarted($id)]
        }
        if { $newslaves != $slaves } {
            set slaves $newslaves
            open
        }
        after 1000 { SlaveInfo::updateSlaves }
    }
}
