#shows a treeview list of all available units
namespace eval UnitList {
    variable count 0
    variable side
    variable childrenToIgnore "vars hardpoints wp"
    variable selectCallbacks ""
    proc moddir { index tree node } {
        set data [$tree itemcget $node -data]
    }
#now what
#well we want to be able to select things..besides the basic entity
#so if we click on a wp
    proc select { where num tree node } {
        variable selectCallbacks
        puts "select"
        puts "Where:$where"
        puts "num:$num"
        puts "tree:$tree"
        puts "node:$node"
        set tag [lindex $node 0]
        set txt [lindex $node 1]
        set text [$tree itemcget $node -text]
        set data [$tree itemcget $node -data]
        puts "text:$text"
        puts "data:$data"
        switch $tag {
            ent {
	Selection::setSelected $data
	UnitInfo::update
            }
            default {
	foreach callback $selectCallbacks {
	    $callback $where $num $tree $node
	}
            }
        }
    }
#*******************************************************************************************************
#			PARSE all the objects I can control into tree view icons
#*******************************************************************************************************
    proc build { tree node path } {
        variable count
        variable side
        variable childrenToIgnore
        pushsel
        sel $path
        set children [dir]
        set items [dir]
        foreach item $items { 
            set class [$item.getclass]
            switch $class {
	nthing {
	    if { [lsearch $childrenToIgnore $item] == -1 } {
	       $tree insert end $node "nthing $count" 	-text $item -data "$path/$item" -open 1 -font {Arial 10 bold} 
	       incr count
	       }
	    }
	nent {
	    set entside [file tail [$item.gref side]]
	    if { $entside == $side } {
	       $tree insert end $node "ent $count" 	-text $item -data "$path/$item" -open 0 -font {Arial 10}
	       incr count
	    }
	}
            }
        }
        set children [$tree nodes $node]
        set empty false
        if { $children == "" } {
#puts "$node has empty children"
            if { [[$tree itemcget $node -data].getclass] == "nthing" } {
	$tree delete $node
             	set empty true
            }
        }
        if { $empty == false } {
            foreach child $children {
	UnitList::build $tree $child [$tree itemcget $child -data]
            }
        }
        popsel
    }
    proc open { path s {treeRef "none"} } {
        variable side $s
        upvar f f
        if { $treeRef != "none" } {
            upvar $treeRef tree 
        }
        UnitInfo::open
        pushf [frame $path]
            set sw          [ScrolledWindow $f.sw -relief sunken -borderwidth 2]
            set tree        [Tree $sw.tree              		\
	-relief        	 	flat  	  	\
	-borderwidth    	0       		\
	-highlightthickness 	0   		\
	-redraw         	0       		\
	-dropenabled    	1       		\
	-dragenabled    	1       		\
	-height 		30		\
	-width 		30		\
	-opencmd   		"UnitList::moddir 1 $sw.tree" 	\
	-closecmd  		"UnitList::moddir 0 $sw.tree"	\
	-dropcmd		UnitList::dropCmd	\
	-deltay		18


            ]

            $sw setwidget $tree
            pack $sw -side top  -expand yes -fill both

            $tree bindText  <ButtonPress-1>        "UnitList::select tree 1 $tree "
            $tree bindText  <Double-ButtonPress-1> "UnitList::select tree 2 $tree "

            $tree insert end root "null units" -text "Units" -data "Units" -open 1 -font {Times 12 bold}
            UnitList::build $tree "null units" "/game/ents"
            $tree configure -redraw 1
        popf
        return $path
    }
    proc addDropCallback { callback } {
        variable dropCallbacks
        lappend dropCallbacks $callback
    }
    proc dropCmd { tree srcpath drop op type data } {
        puts "tree	:$tree"
        puts "srcpath	:$srcpath"
        puts "drop	:$drop"
        puts "op	:$op"
        puts "type	:$type"
        puts "data	:$data"
        
        set from [$tree itemcget $data -data]
        set toType [lindex $drop 0]
        switch $toType {
            position { return; $tree move [lindex $drop 1] $data [lindex $drop 2] }
            node {
	set to   [$tree itemcget [lindex $drop 1] -data]
	puts "from:$from to:$to"
	variable dropCallbacks
	    foreach callback $dropCallbacks {
	    $callback $from $to $data $drop
	}
            }
            default {
	puts "unrecognized toType: $toType"
            }
        }
    }
    proc addSelectCallback { callback } {
        variable selectCallbacks
        lappend selectCallbacks $callback
    }
}
