proc edit_n3dnode { node } {
	#################################
	# variables
	global posx
	global posy
	global posz

	global act_posx
	global act_posy
	global act_posz

	global rx
	global ry
	global rz
	
	global act_rx
	global act_ry
	global act_rz

	global scalefactor
	global cur_node

	set posx [lindex [$node.gett] 0]
	set posy [lindex [$node.gett] 1]
	set posz [lindex [$node.gett] 2]

	set act_posx $posx
	set act_posy $posy
	set act_posz $posz

	set rx [lindex [$node.getr] 0]
	set ry [lindex [$node.getr] 1]
	set rz [lindex [$node.getr] 2]

	set act_rx rx
	set act_ry ry
	set act_rz rz

	set scalefactor 1
	set cur_node $node

	###################################
	toplevel .c
	wm title .c "Nebula Leveleditor"
	wm geometry .c 200x688+817+0

	frame	.c.ed -relief sunken
	pack	.c.ed -side top

	#positions
	label	.c.ed.desct -text "Position:"
	entry	.c.ed.posx -textvariable act_posx
	entry	.c.ed.posy -textvariable act_posy
	entry	.c.ed.posz -textvariable act_posz
	pack	.c.ed.desct .c.ed.posx .c.ed.posy .c.ed.posz -side top -expand 1 -fill x -padx 3

	#angles
	label	.c.ed.descr -text "Rotation:"
	entry	.c.ed.rotx -textvariable act_rx
	entry	.c.ed.roty -textvariable act_ry
	entry	.c.ed.rotz -textvariable act_rz
	pack	.c.ed.descr .c.ed.rotx .c.ed.roty .c.ed.rotz -side top -expand 1 -fill x -padx 3

	label	.c.ed.scalef	-text "scalefactor for positioning $scalefactor"
	entry	.c.ed.scalefactor -textvariable scalefactor

	pack	.c.ed.scalef .c.ed.scalefactor -side top -expand 1

	####################################
	#translation
	scale	.c.ed.movex -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
        -label "move X" -resolution 0.01 \
   	    -command { move_x }
	scale	.c.ed.movey -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
        -label "move Y" -resolution 0.01 \
   	    -command { move_y }
	scale	.c.ed.movez -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
        -label "move Z" -resolution 0.01 \
   	    -command { move_z }

	pack	.c.ed.movex .c.ed.movey .c.ed.movez -side top -expand 1

	####################################
	#rotation
	scale	.c.ed.rx -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
        -label "rotate X" -resolution 0.001 \
   	    -command {r_x }
	scale	.c.ed.ry -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
        -label "rotate Y" -resolution 0.001 \
   	    -command { r_y }
	scale	.c.ed.rz -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
        -label "rotate Z" -resolution 0.001 \
   	    -command { r_z }

	pack	.c.ed.rx .c.ed.ry .c.ed.rz -side top -expand 1
}

proc move_x { amount } {
	global posx
	global act_posx
	global scalefactor
	global cur_node

	$cur_node.tx [expr {$posx + $amount*$scalefactor}]

	set act_posx [lindex [$cur_node.gett] 0]

	update
}

proc move_y { amount } {
	global posy
	global act_posy
	global scalefactor
	global cur_node

	$cur_node.ty [expr {$posy + $amount*$scalefactor}]

	set act_posy [lindex [$cur_node.gett] 1]

	update
}
proc move_z { amount } {
	global posz
	global act_posz
	global scalefactor
	global cur_node

	$cur_node.tz [expr {$posz + $amount*$scalefactor}]

	set act_posz [lindex [$cur_node.gett] 2]

	update
}

proc r_x { amount } {
	global rx
	global act_rx
	global scalefactor
	global cur_node

	$cur_node.rx [expr {$rx + $amount*$scalefactor}]

	set act_rx [lindex [$cur_node.getr] 0]

	update
}

proc r_y { amount } {
	global ry
	global act_ry
	global scalefactor
	global cur_node

	$cur_node.ry [expr {$ry + $amount*$scalefactor}]

	set act_ry [lindex [$cur_node.getr] 1]

	update
}

proc r_z { amount } {
	global rz
	global act_rz
	global scalefactor
	global cur_node

	$cur_node.rz [expr {$rz + $amount*$scalefactor}]

	set act_rz [lindex [$cur_node.getr] 2]

	update
}
