namespace eval nent_editor { }

proc lbl { text row column {cspan 1} } {
    upvar counter counter f f
    set lbl [label $f.label$counter -text $text]
    incr counter 1
    grid config $lbl -column $column -row $row -sticky w -columnspan $cspan
    return $lbl
}
proc sldr { path length command column row { columnspan 1 } value } {
    upvar var var
    grid config [\
        scale   $path                       \
        -length $length                     \
        -orient horizontal                  \
        -from -100.0 -to 100.0              \
        -resolution .000001                 \
        -showvalue 1                        \
        -command $command 
    ] -column $column -row $row -columnspan $columnspan 
    $path set $value
}

proc edit_nent_seti { varname value } {
    global browser_node
    $browser_node.si $varname $value
}
proc edit_nent_setf { varname value } {
    global browser_node
    $browser_node.sf $varname $value
}
proc edit_nent_setvx { varname value } {
    global browser_node
    $browser_node.svx $varname $value
}
proc edit_nent_setvy { varname value } {
    global browser_node
    $browser_node.svy $varname $value
}
proc edit_nent_setvz { varname value } {
    global browser_node
    $browser_node.svz $varname $value
}
proc edit_nent_setqx { varname value } {
    global browser_node
#   $browser_node.svz $varname $value
}
proc edit_nent_setqy { varname value } {
    global browser_node
#   $browser_node.svz $varname $value
}
proc edit_nent_setqz { varname value } {
    global browser_node
#   $browser_node.svz $varname $value
}
proc edit_nent_setqw { varname value } {
    global browser_node
#$browser_node.svz $varname $value
}

proc edit_nent { node } {
	###################################CREATE WINDOW
    global browser_node
    set browser_node $node

    set tl [toplevel .c]
	wm title $tl $node.getname
	wm resizable $tl 1 1

    pushf [frame $tl.f -relief sunken]
        pack $f

        pushsel
            sel $node/vars
            set vars [dir]
        popsel

        grid config [frame $f.sep1 -bd 1 -relief solid] -column 1 -row 0 -rowspan 1000 -sticky ns
        pack [label $f.sep1.lbl -text "" -width 0]
        grid config [frame $f.sep2 -bd 1 -relief solid] -column 3 -row 0 -rowspan 1000 -sticky ns
        pack [label $f.sep2.lbl -text "" -width 0]

        set counter 0
        set vc 0
        foreach var $vars {
            set var     
            set type    [$node/vars/$var.gettype]

            lbl $var        $vc 0
            lbl $type       $vc 2
            switch $type {

                void { }
                int { 
                    set i [$node.gi $var]
                    sldr $f.int$var 300 "edit_nent_seti $var" 4 $vc $i
                }
                float { 
                    set v       [$node.gf $var]
                    set flt($var)   [$node.gf $var]
                    sldr $f.float$var 300 "edit_nent_setf $var" 4 $vc 4 $v
                }
                vector3 { 
                    set     v  [$node.gv $var]
                    set     valuex($var) [lindex $v 0]
                    set     valuey($var) [lindex $v 1]
                    set     valuez($var) [lindex $v 2]
                    sldr $f.vectorx$var 100 "edit_nent_setvx $var" 4 $vc 1 $valuex($var)
                    sldr $f.vectory$var 100 "edit_nent_setvy $var" 5 $vc 1 $valuey($var)
                    sldr $f.vectorz$var 100 "edit_nent_setvz $var" 6 $vc 1 $valuez($var)
                }
                quaternion { 
                    set     v  [$node.gq $var]
                    set     valuex($var) [lindex $v 0]
                    set     valuey($var) [lindex $v 1]
                    set     valuez($var) [lindex $v 2]
                    set     valuew($var) [lindex $v 3]
                    sldr $f.quatx$var 100 "edit_nent_setqx $var" 4 $vc 1 $valuex($var)
                    sldr $f.quaty$var 100 "edit_nent_setqy $var" 5 $vc 1 $valuey($var)
                    sldr $f.quatz$var 100 "edit_nent_setqz $var" 6 $vc 1 $valuez($var)
                    sldr $f.quatw$var 100 "edit_nent_setqw $var" 7 $vc 1 $valuew($var)
                }
                rc          { }
                string      { lbl [$node.gs   $var]         $vc 4 5 }
                ref         { lbl [$node.gref $var]         $vc 4 5 }
                default     { puts "type:$type not recognized" }
            }
            incr vc 1
        }
    popf
    if { 0 } {
        #positions
        label	$tl.ed.desct    -text "Position:"
        entry	$tl.ed.posx     -textvariable act_posx
        entry	$tl.ed.posy     -textvariable act_posy
        entry	$tl.ed.posz     -textvariable act_posz
        pack	$tl.ed.desct $tl.ed.posx $tl.ed.posy $tl.ed.posz -side top -expand 1 -fill x -padx 3

        #angles
        label	$tl.ed.descr -text "Rotation:"
        entry	$tl.ed.rotx -textvariable act_rx
        entry	$tl.ed.roty -textvariable act_ry
        entry	$tl.ed.rotz -textvariable act_rz
        pack	$tl.ed.descr $tl.ed.rotx $tl.ed.roty $tl.ed.rotz -side top -expand 1 -fill x -padx 3

        label	$tl.ed.scalef	-text "scalefactor for positioning $scalefactor"
        entry	$tl.ed.scalefactor -textvariable scalefactor

        pack	$tl.ed.scalef $tl.ed.scalefactor -side top -expand 1

        ####################################
        #translation
        scale	$tl.ed.movex -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
            -label "move X" -resolution 0.01 \
            -command { move_x }
        scale	$tl.ed.movey -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
            -label "move Y" -resolution 0.01 \
            -command { move_y }
        scale	$tl.ed.movez -length 550 -orient horizontal -from -100.0 -to 100.0 -showvalue 0 \
            -label "move Z" -resolution 0.01 \
            -command { move_z }

        pack	$tl.ed.movex $tl.ed.movey $tl.ed.movez -side top -expand 1

        ####################################
        #rotation
        scale	$tl.ed.rx -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
            -label "rotate X" -resolution 0.001 \
            -command {r_x }
        scale	$tl.ed.ry -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
            -label "rotate Y" -resolution 0.001 \
            -command { r_y }
        scale	$tl.ed.rz -length 550 -orient horizontal -from -90.0 -to 90.0 -showvalue 0 \
            -label "rotate Z" -resolution 0.001 \
            -command { r_z }

        pack	$tl.ed.rx $tl.ed.ry $tl.ed.rz -side top -expand 1
    }
}

proc move_x { amount } {
    global posx
    global act_posx
    global scalefactor
    global cur_node

    $cur_node.tx [expr {$posx + $amount*$scalefactor}]

    set act_posx [lindex [$cur_node.gett] 0]

    update
}

proc move_y { amount } {
    global posy
    global act_posy
    global scalefactor
    global cur_node

    $cur_node.ty [expr {$posy + $amount*$scalefactor}]

    set act_posy [lindex [$cur_node.gett] 1]

    update
}
proc move_z { amount } {
    global posz
    global act_posz
    global scalefactor
    global cur_node

    $cur_node.tz [expr {$posz + $amount*$scalefactor}]

    set act_posz [lindex [$cur_node.gett] 2]

    update
}

proc r_x { amount } {
    global rx
    global act_rx
    global scalefactor
    global cur_node

    $cur_node.rx [expr {$rx + $amount*$scalefactor}]

    set act_rx [lindex [$cur_node.getr] 0]

    update
}

proc r_y { amount } {
global ry
global act_ry
global scalefactor
global cur_node

$cur_node.ry [expr {$ry + $amount*$scalefactor}]

set act_ry [lindex [$cur_node.getr] 1]

update
}

proc r_z { amount } {
global rz
global act_rz
global scalefactor
global cur_node

$cur_node.rz [expr {$rz + $amount*$scalefactor}]

set act_rz [lindex [$cur_node.getr] 2]

update
}
