namespace eval RTSParser {
    namespace export clear load save
    variable levels { numrowscolumns sbeamlevel mbeamlevel lbeamlevel smisslelevel mmisslelevel lmisslelevel armorlevel speedlevel }
#////////////////////////////////////////////////////////////////////////////////
    proc log { txt } {
        logto "all rtsplanner" $txt
    }
#////////////////////////////////////////////////////////////////////////////////
    proc clear { } {
        log "clear"
        pushsel
        sel /game/ents
        foreach type [dir] {
            sel /game/ents/$type
            foreach ent [dir] {
	log "/sys/servers/release.releasenow /game/ents/$type/$ent"
	/sys/servers/release.releasenow /game/ents/$type/$ent
            }
        }
        popsel
    }
#////////////////////////////////////////////////////////////////////////////////
#parse xml into gamestate
#////////////////////////////////////////////////////////////////////////////////
    proc addent { txt } {
        upvar side side
        upvar ent ent
        log "addent: $txt side: $side"
        if { $side != "/game/sides/neutral" } { 
            set ent [gen_ent [lindex $txt 0] [lindex $txt 1]]; 
            $ent.cref side $side 
        }
    }
    proc defaulttag { tag txt } {
        vars levels
        upvar ent ent
        if {[strfind $tag $levels] } {
            $ent.ci $tag $txt
        }
    }
    proc parse { plan } [XML::buildParser {
        init		{ pushsel; set ent ""; set side "";} { popsel }
        scenario	{ }
        scenarioname	{ }
        brief		{ }
        description	{ }
        side		{ set side $txt }
        ent		{ addent $txt } { set ent "" }
            pos		{ $ent.sv pos [lindex $txt 0] [lindex $txt 1] [lindex $txt 2]}
            rot		{ $ent.sq rot [lindex $txt 0] [lindex $txt 1] [lindex $txt 2] [lindex $txt 3] }
            parentlegion	{ $ent.cref parentlegion $txt }
            numrowscolumns	{ $ent.ci numrowscolumns $txt }
            default	{ defaulttag $tag $txt }
    } ]
#////////////////////////////////////////////////////////////////////////////////
#load a file
#////////////////////////////////////////////////////////////////////////////////
    proc load { filename } {
        global xmldir
        set plan [fileToString $xmldir/rts/levels/$filename.xml]
        RTSParser::parse $plan
    }
#////////////////////////////////////////////////////////////////////////////////
#saves the current state to xml
#/////////////////////////////////////////////////////////////////////////////////
    proc save { filename } {
        pushsel
        global ::XML::lines
        vars levels
        XML::clear
        sel /game/sides
        foreach side [dir] { lappend sides [$side.getfullname] }
        foreach side $sides {
            XML::open side $side
            set units [$side/side.units]
            foreach unit $units {
	set type [[$unit.getparent].getname]
	set name [$unit.getname]
	XML::open ent "$type $name"
	XML::wrap pos [$unit.gv pos]
	XML::wrap rot [$unit.gq rot]
	foreach v $levels { 
	    if { [$unit.hasvar $v] } { XML::wrap $v [$unit.gi $v] }
	}
	if { [$unit.hasvar parentlegion] } 	{ XML::wrap parentlegion   [$unit.gref parentlegion] }
	XML::close ent
            }
            XML::close side
        }
        global xmldir
        stringToFile $xmldir/rts/levels/$filename.xml $::XML::lines
        popsel
    }
}
